/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;

using System.Drawing;
using System.IO;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Base;
using Digita.Tustena.Database;
using Digita.Tustena.Localize;
using Lucene.Net.Parsing;

namespace Digita.Tustena
{
	public class AdminCompany : G
	{
		protected Label CompanyName;
		protected TextBox PhoneNumber;
		protected TextBox Fax;
		protected TextBox Email;
		protected TextBox WebSite;
		protected TextBox AddressInvoice;
		protected TextBox CityInvoice;
		protected TextBox ProvinceInvoice;
		protected TextBox RegionInvoice;
		protected TextBox CountryInvoice;
		protected TextBox ZipInvoice;
		protected TextBox LeadDays;
		protected TextBox CompanyTextboxID;
		protected TextBox CompanyTextbox;
		protected TextBox WebGate_OwnerID;
		protected TextBox WebGate_Owner;
		protected TextBox WebGate_GroupID;
		protected TextBox WebGate_Group;
		protected TextBox WebGate_NotifyID;
		protected TextBox WebGate_Notify;
		protected TextBox WebGate_WebSite;
		protected TextBox WebService_pin;
		protected Label WebService_guid;
		protected TextBox WebService_OwnerID;
		protected TextBox WebService_Owner;
		protected Label Info;
		protected LinkButton Submit;

		protected TextBox Voip;
		protected TextBox InterPrefix;

		protected Label PermittedKb;
		protected Label BusyKb;
		protected Label FileIndexes;

		protected HtmlTableCell tdTab1;
		protected HtmlTableCell tdTab2;
		protected HtmlTableCell tdTab3;
		protected HtmlTableCell tdTab4;
		protected HtmlTable ContactForm;
		protected LocalizedLiteral LocalizedLiteral1;
		protected LocalizedLiteral LocalizedLiteral2;
		protected LocalizedLiteral LocalizedLiteral3;
		protected LocalizedLiteral LocalizedLiteral4;
		protected LocalizedLiteral LocalizedLiteral5;
		protected LocalizedLiteral LocalizedLiteral6;
		protected LocalizedLiteral LocalizedLiteral7;
		protected LocalizedLiteral LocalizedLiteral8;
		protected LocalizedLiteral LocalizedLiteral9;
		protected LocalizedLiteral LocalizedLiteral10;
		protected LocalizedLiteral LocalizedLiteral11;
		protected LocalizedLiteral LocalizedLiteral12;
		protected LocalizedLiteral Localizedliteral31;
		protected LocalizedLiteral LocalizedLiteral13;
		protected LocalizedLiteral LocalizedLiteral14;
		protected LocalizedLiteral LocalizedLiteral15;
		protected LocalizedLiteral LocalizedLiteral16;
		protected LocalizedLiteral LocalizedLiteral17;
		protected LocalizedLiteral LocalizedLiteral18;
		protected LocalizedLiteral LocalizedLiteral19;
		protected LocalizedLiteral LocalizedLiteral20;
		protected LocalizedLiteral LocalizedLiteral21;
		protected LocalizedLiteral LocalizedLiteral22;
		protected LocalizedLiteral LocalizedLiteral23;
		protected LocalizedLiteral LocalizedLiteral24;
		protected LocalizedLiteral LocalizedLiteral25;
		protected LocalizedLiteral LocalizedLiteral26;
		protected LocalizedLiteral LocalizedLiteral27;
		protected LocalizedLiteral LocalizedLiteral28;
		protected LocalizedLiteral LocalizedLiteral29;
		protected LocalizedLiteral LocalizedLiteral30;
		protected HtmlInputHidden activeTab;

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				DeleteGoBack();
				if (!Page.IsPostBack)
				{
					Submit.Text = rm.GetString("Save");
					activeTab.Value = "tabCompany";
					FillForm();
				}
				else
				{
					if (activeTab.Value.Length > 0)
						Page.RegisterStartupScript("activeTab", "<script>ViewHideTabs('" + activeTab.Value + "')</script>");
				}
			}
		}

		private void FillForm()
		{
			string sqlString;
			sqlString = "select * from Admin_Customer_View";
			IDataReader dataReader = DatabaseConnection.CreateReader(sqlString);
			if (dataReader.Read())
			{
				CompanyName.Text = (string) dataReader["CompanyName"];
				PhoneNumber.Text = Convert.ToString(dataReader["Phone"]);
				Fax.Text = Convert.ToString(dataReader["Fax"]);
				Email.Text = Convert.ToString(dataReader["EMail"]);
				WebSite.Text = Convert.ToString(dataReader["WebSite"]);
				AddressInvoice.Text = Convert.ToString(dataReader["Address"]);
				CityInvoice.Text = Convert.ToString(dataReader["City"]);
				ProvinceInvoice.Text = Convert.ToString(dataReader["Province"]);
				RegionInvoice.Text = Convert.ToString(dataReader["Region"]);
				CountryInvoice.Text = Convert.ToString(dataReader["State"]);
				ZipInvoice.Text = Convert.ToString(dataReader["ZIPCode"]);
				LeadDays.Text = Convert.ToString(dataReader["EstimatedDateDays"]);
				Voip.Text = dataReader["LinkForVoIP"].ToString();
				InterPrefix.Text = dataReader["InternationalPrefix"].ToString();

				long kbc = (int) dataReader["DiskSpace"];
				long kbo = 0;
				try
				{
					kbo = Convert.ToInt64(DatabaseConnection.SqlScalar("select foldersize from FolderSize"))/1024/1024;
				}
				catch
				{
				}

				string pathTemplate;
				pathTemplate = ConfigSettings.DataStoragePath;
				string idxPath = Path.Combine(pathTemplate, "luceneIdx");
				int idxSize = 0;
				int fileCount = 0;
				if (Directory.Exists(idxPath))
				{
					LuceneParser lucene = new LuceneParser(idxPath);
					DirectoryInfo di = new DirectoryInfo(idxPath);
					foreach (FileInfo fi in di.GetFiles())
					{
						idxSize += (int) (fi.Length/1024);
						fileCount++;

					}
					FileIndexes.Text = lucene.checkIndex() + ", " + idxSize + " Kb";
				}
				else
					FileIndexes.Text = "n/a";
				PermittedKb.Text = dataReader["DiskSpace"].ToString() + " Mb";
				BusyKb.Text = fileCount + " files, " + kbo.ToString() + " Mb";
				if (kbo > kbc)
				{
					BusyKb.ForeColor = Color.Red;
				}
				if (dataReader["IDAgenda"] != DBNull.Value)
				{
					CompanyTextboxID.Text = Convert.ToString(dataReader["IDAgenda"]);
					CompanyTextbox.Text = DatabaseConnection.SqlScalar("select companyname from Base_Companies where id=" + uint.Parse(dataReader["IDAgenda"].ToString()));
				}

				WebService_pin.Text = dataReader["pin"].ToString();
				WebService_guid.Text = dataReader["guid"].ToString();

				WebService_OwnerID.Text = dataReader["DefaultWebUser"].ToString();
				if (WebService_OwnerID.Text.Length > 0)
				{
					WebService_Owner.Text = DatabaseConnection.SqlScalar("select isnull(Name,'')+' '+isnull(surname,'') as contact from account where uid=" + int.Parse(WebService_OwnerID.Text));
				}
				else
				{
					DataRow dr;
					dr = DatabaseConnection.CreateDataset("select top 1 isnull(Name,'')+' '+isnull(surname,'') as contact,uid from account left outer join Tustena_Data on Tustena_Companies.id=account.customerid where account.groupid=Tustena_Companies.AdminGroupid order by uid").Tables[0].Rows[0];
					WebService_Owner.Text = dr["contact"].ToString();
					WebService_OwnerID.Text = dr["uid"].ToString();
				}


				WebGate_OwnerID.Text = dataReader["WebGateOwnerID"].ToString();
				WebGate_Owner.Text = dataReader["WebGateOwner"].ToString();
				WebGate_GroupID.Text = dataReader["WebGateGroup"].ToString();
				WebGate_Group.Text = dataReader["WebGateGroupDescription"].ToString();
				WebGate_NotifyID.Text = dataReader["WebGateNotifyID"].ToString();
				WebGate_Notify.Text = dataReader["WebGateNotify"].ToString();
				WebGate_WebSite.Text = dataReader["WebGateWebSite"].ToString();
			}
			dataReader.Close();

			bool ws = false;
			if (WebService_pin.Text.Length == 0)
			{
				Random R = new Random();
				WebService_pin.Text = R.Next(30000).ToString();
				ws = true;
			}
			if (WebService_guid.Text.Length == 0)
			{
				WebService_guid.Text = Guid.NewGuid().ToString();
				ws = true;
			}
			string wsGuid = DatabaseConnection.FilterInjection(WebService_guid.Text);
			string wsPin = DatabaseConnection.FilterInjection(WebService_pin.Text);
			if (ws) DatabaseConnection.DoCommand(String.Format("update Tustena_Data set guid='{0}',pin='{1}'", wsGuid, wsPin));
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.Submit.Click += new EventHandler(this.Submit_Click);

		}

		#endregion

		public void Submit_Click(object sender, EventArgs e)
		{
			string sqlString;
			sqlString = String.Format("select active companyname from Tustena_Data");
			using (DigiDapter dg = new DigiDapter(sqlString))
			{
				dg.UpdateOnly();
				if (dg.HasRows)
				{
					dg.Add("Phone", PhoneNumber.Text);
					dg.Add("Fax", Fax.Text);
					dg.Add("EMail", Email.Text);
					dg.Add("WebSite", WebSite.Text);
					dg.Add("Address", AddressInvoice.Text);
					dg.Add("City", CityInvoice.Text);
					dg.Add("Province", ProvinceInvoice.Text);
					dg.Add("Region", RegionInvoice.Text);
					dg.Add("State", CountryInvoice.Text);
					dg.Add("ZIPCode", ZipInvoice.Text);
					dg.Add("EstimatedDateDays", LeadDays.Text);
					dg.Add("guid", WebService_guid.Text);
					dg.Add("pin", WebService_pin.Text);
					dg.Add("DefaultWebUser", WebService_OwnerID.Text);
					dg.Add("LinkForVoIP", Voip.Text);
					dg.Add("InternationalPrefix", InterPrefix.Text);

					if (CompanyTextboxID.Text.Length > 0)
						dg.Add("IDAgenda", CompanyTextboxID.Text);
					else
						dg.Add("IDAgenda", DBNull.Value);

					if (WebService_OwnerID.Text.Length > 0)
						WebService_Owner.Text = DatabaseConnection.SqlScalar("select isnull(Name,'')+' '+isnull(surname,'') as contact from account where uid=" + DatabaseConnection.FilterInjection(WebService_OwnerID.Text));
					dg.Execute("Tustena_Data", "active=1");
					}
			}

			Info.Text = rm.GetString("AComtxt14");

		}
	}
}
