/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Text;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Common;
using Digita.Tustena.Database;
using Digita.Tustena.Localize;

namespace Digita.Tustena.Admin
{
	public class Limbo : G
	{
		protected Repeater Repeater1;
		protected RepeaterPaging Repeaterpaging1;
		protected Label RepeaterInfo;

		protected Repeater Repeater2;
		protected RepeaterPaging Repeaterpaging2;
		protected Label RepeaterInfoC;
		protected HtmlGenericControl ContactContainer;
		protected HtmlGenericControl CompanyContainer;
		protected HtmlGenericControl LeadContainer;
		protected LinkButton BtnCompany;
		protected LinkButton BtnContact;
		protected LinkButton BtnLead;

		protected Repeater Repeater3;
		protected LocalizedLiteral LocalizedLiteral1;
		protected LocalizedLiteral LocalizedLiteral2;
		protected RepeaterPaging Repeater3Paging;


		private void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				DeleteGoBack();
				BtnCompany.Text = rm.GetString("Limtxt2");
				BtnContact.Text = rm.GetString("Limtxt3");
				BtnLead.Text = "Lead";



				if (!Page.IsPostBack)
				{
					ContactContainer.Visible = false;
					CompanyContainer.Visible = false;
					LeadContainer.Visible = false;
				}

			}
		}



		public void Btn_Click(object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "BtnCompany":
					ContactContainer.Visible = false;
					CompanyContainer.Visible = true;
					LeadContainer.Visible = false;
					FillRepeater();
					break;
				case "BtnContact":
					CompanyContainer.Visible = false;
					ContactContainer.Visible = true;
					LeadContainer.Visible = false;
					Repeater1.Visible = false;

					RepeaterInfo.Visible = false;
					FillRepeaterC();
					break;
				case "BtnLead":
					LeadContainer.Visible = true;
					CompanyContainer.Visible = false;
					ContactContainer.Visible = false;
					this.FillLeadRepeater();
					break;
			}
		}

		public void Repeater1_ItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton lk = (LinkButton) e.Item.FindControl("Delete");
					lk.Text = rm.GetString("CRMcontxt44");
					lk.Visible = true;
					lk.Attributes.Add("onclick", "return confirm('" + rm.GetString("Bcotxt44") + "');");
					lk = (LinkButton) e.Item.FindControl("Revert");
					lk.Text = rm.GetString("Limtxt0");
					break;
			}
		}

		public void Repeater1_Grid_ItemCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "Delete":
					DeleteCompany(int.Parse(((Literal) e.Item.FindControl("IDCat")).Text));
					break;
				case "Revert":
					RecoverCompany(int.Parse(((Literal) e.Item.FindControl("IDCat")).Text));
					break;
			}
		}

		private void DeleteCompany(int id)
		{
			string delSql = "delete from Base_Companies where id=" + id;
			DatabaseConnection.DoCommand(delSql);
			FillRepeater();
		}

		private void RecoverCompany(int id)
		{
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("LastActivity", 1); //MODIFICA
				dg.Add("LastModifiedDate", DateTime.UtcNow);
				dg.Add("LastModifiedByID", UC.UserId);
				dg.Add("Limbo", 0);
				dg.Execute("Base_Companies", "id=" + id);
			}

			FillRepeater();
		}

		private void FillRepeater()
		{
			StringBuilder sqlString = new StringBuilder();

			sqlString.Append("SELECT Base_Companies.*, ");
			sqlString.Append("(Account.Surname+' '+Account.Name) as Owner ");
			sqlString.Append("FROM Base_Companies ");
			sqlString.Append("LEFT OUTER JOIN Account ON Base_Companies.OwnerID = Account.UID");

			sqlString.Append(" where limbo=1");


			sqlString.Append(" ORDER BY Base_Companies.CompanyName");

			Repeaterpaging1.PageSize = UC.PagingSize;
			Repeaterpaging1.RepeaterObj = Repeater1;
			Repeaterpaging1.sqlRepeater = sqlString.ToString();
			Repeaterpaging1.CurrentPage=0;
			Repeaterpaging1.BuildGrid();


			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				RepeaterInfo.Visible = false;

			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Bcotxt41") + "</center>";
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}

		}

		public void Repeater2_ItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton lk = (LinkButton) e.Item.FindControl("Delete");
					lk.Text = rm.GetString("CRMcontxt44");
					lk.Visible = true;
					lk.Attributes.Add("onclick", "return confirm('" + rm.GetString("Bcotxt44") + "');");
					lk = (LinkButton) e.Item.FindControl("Revert");
					lk.Text = rm.GetString("Limtxt0");
					break;
			}
		}


		public void Repeater2_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "Delete":
					DeleteContact(int.Parse(((Literal) e.Item.FindControl("IDCon")).Text));
					break;
				case "Revert":
					RecoverContact(int.Parse(((Literal) e.Item.FindControl("IDCon")).Text));
					break;
			}
		}

		private void RecoverContact(int id)
		{
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("LastActivity", 1); //MODIFICA
				dg.Add("LastModifiedDate", DateTime.UtcNow);
				dg.Add("LastModifiedByID", UC.UserId);
				dg.Add("Limbo", 0);
				dg.Execute("Base_Contacts", "id=" + id);
			}
			FillRepeaterC();
		}

		private void DeleteContact(int id)
		{
			string sqlString = "delete from Base_Contacts where id=" + id;
			DatabaseConnection.DoCommand(sqlString);
			FillRepeaterC();
		}



		private void FillRepeaterC()
		{
			StringBuilder sqlString = new StringBuilder();


			sqlString.Append("SELECT Base_Contacts.*, Base_Companies.CompanyName AS CompanyName2,(Account.Surname+' '+Account.Name) as NameOwner ");
			sqlString.Append("FROM Base_Contacts LEFT OUTER JOIN Base_Companies ON Base_Contacts.CompanyID = Base_Companies.ID ");
			sqlString.Append("LEFT OUTER JOIN Account ON Base_Contacts.OwnerID = Account.UID ");


			sqlString.Append("where Base_Contacts.Limbo = 1 order by Base_Contacts.Surname");

			Repeaterpaging2.PageSize = UC.PagingSize;
			Repeaterpaging2.RepeaterObj = Repeater2;
			Repeaterpaging2.sqlRepeater = sqlString.ToString();
			Repeaterpaging2.CurrentPage=0;
			Repeaterpaging2.BuildGrid();

			if (Repeater2.Items.Count > 0)
			{
				Repeater2.Visible = true;
				RepeaterInfoC.Visible = false;
			}
			else
			{
				RepeaterInfoC.Text = "<center>" + rm.GetString("Reftxt1") + "</center>";
				Repeater2.Visible = false;
				RepeaterInfoC.Visible = true;
			}
		}




		private void FillLeadRepeater()
		{
			Repeater3Paging.PageSize = UC.PagingSize;
			Repeater3Paging.RepeaterObj = Repeater3;
			Repeater3Paging.sqlRepeater = "select id,Name,surname,companyname,phone,mobilephone from crm_leads where limbo=1";
			Repeater3Paging.CurrentPage=0;
			Repeater3Paging.BuildGrid();
		}

		public void Repeater3_ItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton lk = (LinkButton) e.Item.FindControl("Delete");
					lk.Text = rm.GetString("CRMcontxt44");
					lk.Visible = true;
					lk.Attributes.Add("onclick", "return confirm('" + rm.GetString("Bcotxt44") + "');");
					lk = (LinkButton) e.Item.FindControl("Revert");
					lk.Text = rm.GetString("Limtxt0");
					break;
			}
		}


		public void Repeater3_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "Delete":
					DeleteLead(int.Parse(((Literal) e.Item.FindControl("IDCon")).Text));
					break;
				case "Revert":
					RecoverLead(int.Parse(((Literal) e.Item.FindControl("IDCon")).Text));
					break;
			}
		}

		private void RecoverLead(int id)
		{
			using (DigiDapter dg = new DigiDapter())
			{
				dg.UpdateOnly();
				dg.Add("LastActivity", 1); //MODIFICA
				dg.Add("LastModifiedDate", DateTime.UtcNow);
				dg.Add("LastModifiedByID", UC.UserId);
				dg.Add("Limbo", 0);
				dg.Execute("crm_leads", "id=" + id);
			}
			FillLeadRepeater();
		}

		private void DeleteLead(int id)
		{
			string delSql = "delete from crm_leads where id=" + id;
			DatabaseConnection.DoCommand(delSql);
			FillLeadRepeater();
		}


		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.BtnCompany.Click += new EventHandler(this.Btn_Click);
			this.BtnContact.Click += new EventHandler(this.Btn_Click);
			this.BtnLead.Click += new EventHandler(this.Btn_Click);
			this.Repeater1.ItemCommand += new RepeaterCommandEventHandler(this.Repeater1_Grid_ItemCommand);
			this.Repeater2.ItemCommand += new RepeaterCommandEventHandler(this.Repeater2_Command);
			this.Repeater3.ItemCommand += new RepeaterCommandEventHandler(this.Repeater3_Command);
			this.Repeater1.ItemDataBound += new RepeaterItemEventHandler(this.Repeater1_ItemDataBound);
			this.Repeater2.ItemDataBound += new RepeaterItemEventHandler(this.Repeater2_ItemDataBound);
			this.Repeater3.ItemDataBound += new RepeaterItemEventHandler(this.Repeater3_ItemDataBound);

		}

		#endregion
	}
}
