/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;
using System.IO;
using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Base;
using Digita.Tustena.Database;
using Digita.Tustena.Localize;
using Win32;

namespace Digita.Tustena
{
	public class NewUser : G
	{
		protected Label Header;
		protected Repeater Repeater1;
		protected Table RubricForm;
		protected HtmlTable tabControl;
		protected Table WorkTimeForm;
		protected TextBox Mode;
		protected TextBox F_UID;
		protected TextBox Name;
		protected TextBox Surname;
		protected DropDownList F_Officeso;
		protected TextBox F_WorkStart;
		protected TextBox EndWork;
		protected TextBox F_WorkStart2;
		protected TextBox EndWork2;
		protected CheckBoxList RecurrenceWeeklyDays;
		protected TextBox F_UserName;
		protected TextBox F_Password;
		protected TextBox EMail;
		protected TextBox F_IdRubrica;
		protected TextBox F_usr;
		protected TextBox Find;
		protected TextBox Paging;
		protected TextBox SessionTimeout;
		protected CheckBox Responsable;
		protected CheckBox Subaltern;
		protected DropDownList IdResponsable;
		protected DropDownList F_Group;
		protected DropDownList Select;
		protected DropDownList TimeZoneNew;
		protected DropDownList DropCulture;

		protected DropDownList DropFirstDay;
		protected LinkButton ExistRubric;
		protected Button Assign;
		protected Button Annul;
		protected LinkButton Rubric;
		protected LinkButton Rubric2;
		protected LinkButton ExistRubric2;

		protected Button Btn_FwwAllU;
		protected Button Btn_FwwU;
		protected Button Btn_RwwU;
		protected Button Btn_RwwAllU;
		protected LinkButton BtnFind;

		protected LinkButton Submit2;
		protected Label LabelInfo;
		protected Label LabelInfoX;

		protected ListBox OfficesAll;
		protected ListBox OfficesSel;
		protected CheckBox PersonalContact;
		protected Literal LtrNewUser;
		protected Label LblNewUser;
		protected TableRow TROfficeTitle;
		protected TableRow TROfficeFields;
		protected HtmlContainerControl BtnStartWork;
		protected HtmlContainerControl BtnEndWork;
		protected HtmlContainerControl BtnStartWork2;
		protected HtmlContainerControl BtnEndWork2;
		protected Label TitlePage;
		protected Label TitlePageRight;
		protected CheckBox FlagModifyAppointment;
		protected CheckBox FullScreen;
		protected CheckBox ViewBirthDate;
		protected Literal HelpLabel;
		protected GroupControl GroupControl;
		protected SelectOffice Office;

		protected TextBox MailServer;
		protected TextBox MailUser;
		protected TextBox MailPassword;
		protected Repeater RepGroup;
		protected HtmlTableRow SecondaryGroup;
		protected Repeater RepHomePage;
		protected DropDownList ListGroups;
		protected Label Repeater1Info;
		protected Label LblCSSGuid;
		protected TextBox CSSGuid;

		public DataSet groups;
		public DataSet responsableDs;

		private bool freeUsers;
		protected LocalizedLiteral LocalizedLiteral1;
		protected LocalizedLiteral LocalizedLiteral2;
		protected LocalizedLiteral LocalizedLiteral3;
		protected LocalizedLiteral LocalizedLiteral4;
		protected LocalizedLiteral LocalizedLiteral5;
		protected LocalizedLiteral LocalizedLiteral6;
		protected LocalizedLiteral LocalizedLiteral7;
		protected Table CardConfig;
		protected Table CardWebMail;
		protected Table CardAgenda;
		protected Table CardHomePage;
		protected Table CardGroups;
		protected HtmlInputHidden activeTab;
		protected HtmlTableCell tdTab1;
		protected HtmlTableCell tdTab2;
		protected HtmlTableCell tdTab3;
		protected HtmlTableCell tdTab4;
		protected HtmlTableCell tdTab5;
		protected HtmlTableCell tdTab6;
		protected HtmlGenericControl visConfig;
		protected HtmlGenericControl visWebMail;
		protected HtmlGenericControl visAgenda;
		protected HtmlGenericControl visHomePage;
		protected HtmlGenericControl visGroups;
		private int freeAccount = 0;

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				DeleteGoBack();

				int activeAccount;
				activeAccount = (int) DatabaseConnection.SqlScalartoObj("select count(*) from Account where active=1");
				freeAccount = ((int) DatabaseConnection.SqlScalartoObj("select top 1 MaxUser from Tustena_Data") - activeAccount);

				if (freeAccount > 0)
				{
					LtrNewUser.Text = "<span class=\"ContactHeader\">" + rm.GetString("Usrtxt54") + "&nbsp;" + freeAccount.ToString() + "</span>";
					LblNewUser.Text = "<span class=\"ContactHeader\" onclick=\"location.href='NewUser.aspx?m=7&si=8&action=NEW'\">" + StaticFunctions.Capitalize(rm.GetString("Usrtxt10")) + "</span>";
					freeUsers = true;
				}
				else
				{
					LtrNewUser.Text = "<span class=\"normal\">" + StaticFunctions.Capitalize(rm.GetString("Usrtxt55")) + "</span>";
					LblNewUser.Text = "<span class=\"ContactHeader\" onclick=\"location.href='NewUser.aspx?m=7&si=8&action=NEW'\">" + StaticFunctions.Capitalize(rm.GetString("Usrtxt10")) + "</span>";
					freeUsers = false;
				}

				if (!Page.IsPostBack)
				{
					tabControl.Visible = false;
					HelpLabel.Text = FillHelp("HelpUser");
					TitlePage.Text = rm.GetString("Usrtxt9");
					TitlePageRight.Text = rm.GetString("Usrtxt9");
					BtnFind.Text = rm.GetString("Usrtxt8");
					Rubric2.Text = rm.GetString("Usrtxt18");
					ExistRubric2.Text = rm.GetString("Usrtxt19");
					Submit2.Text = rm.GetString("Usrtxt20");


					Btn_FwwAllU.ToolTip = rm.GetString("Usrtxt45");
					Btn_FwwU.ToolTip = rm.GetString("Usrtxt46");
					Btn_RwwU.ToolTip = rm.GetString("Usrtxt47");
					Btn_RwwAllU.ToolTip = rm.GetString("Usrtxt48");
					Rubric.Text = rm.GetString("Usrtxt18");
					ExistRubric.Text = rm.GetString("Usrtxt52");


					int itemValue = 1;
					for (int liv = 0; liv < 7; liv++)
					{
						ListItem li = new ListItem();
						li.Value = itemValue.ToString();
						li.Text = rm.GetString("Usrtxt" + (31 + liv).ToString());
						RecurrenceWeeklyDays.Items.Add(li);
						itemValue = itemValue*2;
					}

					CRM_Companies.FillListGroups(UC,this.ListGroups);

				}
				else if (activeTab.Value.Length > 0)
					Page.RegisterStartupScript("activeTab", "<script>ViewHideTabs('" + activeTab.Value + "')</script>");

				FillHeader();
				if (!Page.IsPostBack)
				{
					F_WorkStart.Attributes.Add("onkeyup", "HourCheck(this,event)");
					EndWork.Attributes.Add("onkeyup", "HourCheck(this,event)");


					if (Request.Params["List"] != null)
					{
						FillRepeater(Request.Params["List"].ToString());
					}
					if (Request.Params["Del"] != null)
					{
						Delete(int.Parse(Request.Params["Del"].ToString()));
					}
					if (Request.Params["action"] != null)
					{
						if (Request.Params["action"] == "NEW")
						{
							Header.Visible = false;
							RubricForm.Visible = true;
							LabelInfo.Text = String.Empty;
							Mode.Text = "NEW";
							FillDropDown();
							FillOffices();
							F_WorkStart.Text = new DateTime(2000, 1, 1, 9, 0, 0).ToShortTimeString();
							EndWork.Text = new DateTime(2000, 1, 1, 13, 0, 0).ToShortTimeString();
							F_WorkStart2.Text = new DateTime(2000, 1, 1, 14, 0, 0).ToShortTimeString();
							EndWork2.Text = new DateTime(2000, 1, 1, 18, 0, 0).ToShortTimeString();
							foreach (ListItem li in RecurrenceWeeklyDays.Items)
							{
								li.Selected = true;
							}

							this.FillRepGroups("");
							this.tabControl.Visible = true;
							HtmlTableCell tdTab5 = (HtmlTableCell) Page.FindControl("tdTab5");
							tdTab5.Attributes.Add("style", "display:none");
						}
						if (Request.Params["action"] == "MOD")
						{
							tabControl.Visible = true;
							Mode.Text = "MOD";
							F_UID.Text = Request.Params["full"];
							if (!Page.IsPostBack)
							{
								FillDropDown();
								FillForm(int.Parse(F_UID.Text).ToString());
							}
						}
					}

					if (Request.QueryString["mo"] == "1")
					{
						ModUserAccount();
					}
					else
					{
						Session.Remove("mo");
					}
				}
				else
				{
					try
					{
						if (Request.QueryString["mo"] == "1" || Session["mo"].ToString() == "1")
						{
							Session["mo"] = "1";
							Header.Visible = false;
							Find.Visible = false;
							LtrNewUser.Text = String.Empty;
							LblNewUser.Text = String.Empty;
						}
						else
						{
							Session.Remove("mo");
						}
					}
					catch
					{
					}

					if (F_Password.Text.Length > 0)
						F_Password.Attributes.Add("value", F_Password.Text);
				}
			}
		}

		private void SetRssGiud()
		{
			bool ws = false;
			if (CSSGuid.Text.Length == 0)
			{
				Random R = new Random();
				CSSGuid.Text = R.Next(30000).ToString();
				ws = true;
			}
			if (LblCSSGuid.Text.Length == 0)
			{
				LblCSSGuid.Text = Guid.NewGuid().ToString();
				ws = true;
			}
			string wsGuid = DatabaseConnection.FilterInjection(CSSGuid.Text);
			string wsPin = DatabaseConnection.FilterInjection(LblCSSGuid.Text);
			if (ws) DatabaseConnection.DoCommand(String.Format("update Account set RSSguid='{0}',RSSpin='{1}'", wsGuid, wsPin));
		}


		private void ModUserAccount()
		{
			Session["mo"] = "1";
			FillDropDown();
			FillForm(UC.UserId.ToString());
			Header.Visible = false;
			Find.Visible = false;
			BtnFind.Visible = false;
			LtrNewUser.Text = String.Empty;
			LblNewUser.Text = String.Empty;
			F_UserName.Enabled = false;
			PersonalContact.Enabled = false;
			Name.Enabled = false;
			Surname.Enabled = false;
			F_Officeso.Enabled = false;
			F_WorkStart.Enabled = false;
			F_WorkStart2.Enabled = false;
			EndWork.Enabled = false;
			EndWork2.Enabled = false;
			RecurrenceWeeklyDays.Enabled = false;
			F_Group.Enabled = false;
			Responsable.Enabled = false;
			Subaltern.Enabled = false;
			OfficesAll.Visible = false;
			Btn_FwwAllU.Visible = false;
			Btn_FwwU.Visible = false;
			Btn_RwwU.Visible = false;
			Btn_RwwAllU.Visible = false;
			OfficesSel.Visible = false;
			tabControl.Visible = true;
			TROfficeTitle.Visible = false;
			TROfficeFields.Visible = false;
			BtnStartWork.InnerHtml = "&nbsp;&nbsp;";
			BtnEndWork.InnerHtml = "&nbsp;&nbsp;";
			BtnStartWork2.InnerHtml = "&nbsp;&nbsp;";
			BtnEndWork2.InnerHtml = "&nbsp;&nbsp;";
			TitlePage.Text = rm.GetString("Usrtxt53");
			TitlePageRight.Text = rm.GetString("Usrtxt53");
			SecondaryGroup.Visible = false;
		}

		private void FillDropDown()
		{
			string[] arryD = UC.GroupDependency.Split('|');
			string query = String.Empty;
			foreach (string ut in arryD)
			{
				query += "id=" + ut + " or ";
			}
			query = query.Substring(7, query.Length - 17);
			groups = DatabaseConnection.CreateDataset("Select id, Description from Groups where " + query);
			F_Group.DataSource = groups;
			F_Group.DataTextField = "Description";
			F_Group.DataValueField = "ID";
			F_Group.DataBind();
			F_Group.Items.Insert(0, new ListItem(rm.GetString("Usrtxt6"), "-1"));
			F_Group.SelectedIndex = 0;
			responsableDs = DatabaseConnection.CreateDataset("Select UID, Name + ' ' + Surname as Description from Account where IsManager=1");
			IdResponsable.DataSource = responsableDs;
			IdResponsable.DataTextField = "Description";
			IdResponsable.DataValueField = "UID";
			IdResponsable.DataBind();
			IdResponsable.Items.Insert(0, rm.GetString("Usrtxt7"));
			IdResponsable.SelectedIndex = 0;
			IdResponsable.Items[0].Value = "0";
			DataSet Rubrica;
			Rubrica = DatabaseConnection.CreateDataset("Select id, Surname + ' ' + Name as Description from Base_Contacts order by Surname asc");
			Select.DataSource = Rubrica;
			Select.DataTextField = "Description";
			Select.DataValueField = "id";
			Select.DataBind();

			F_Officeso.DataSource = DatabaseConnection.CreateDataset("Select * from Offices order by Office asc");
			F_Officeso.DataTextField = "Office";
			F_Officeso.DataValueField = "id";
			F_Officeso.DataBind();
			F_Officeso.Items.Insert(0, rm.GetString("Usrtxt5"));
			F_Officeso.SelectedIndex = 0;
			F_Officeso.Items[0].Value = "0";

			Win32TimeZone[] tz = TimeZones.GetTimeZones();
			TimeZoneNew.Items.Clear();
			foreach (Win32TimeZone x in tz)
			{
				ListItem li = new ListItem(x.DisplayName, x.Index.ToString());
				if(li.Value==UC.Culture)
					li.Selected=true;
				TimeZoneNew.Items.Add(li);
			}


			string[] items = ConfigSettings.SupportedLanguagesDescription.Split(';');
			foreach(string i in items)
			{
				DropCulture.Items.Add(new ListItem(i.Split('|')[0], i.Split('|')[1]));
			}


			DropFirstDay.Items.Add(new ListItem(rm.GetString("Caltxt18"), "1"));
			DropFirstDay.Items.Add(new ListItem(rm.GetString("Caltxt24"), "0"));
		}

		private void FillHeader()
		{
			Header.Text = CRM_Companies.ABCHeaderHtml(Request.Params["List"]);

		}


		private void FillRepeater(string query)
		{
			FillRepeater(query, "");
		}

		private void FillRepeater(string query, string group)
		{
			LabelInfo.Text = String.Empty;
			string[] arryD = UC.GroupDependency.Split('|');
			string qGroup = String.Empty;
			foreach (string ut in arryD)
			{
				qGroup += "GroupID=" + ut + " or ";
			}
			qGroup = qGroup.Substring(11, qGroup.Length - 26);
			Trace.Warn(qGroup);
			if (query == "*")
			{
				Repeater1.DataSource = DatabaseConnection.CreateDataset("select Account.*,Offices.Office as OfficesoN from Account left outer join Offices on Account.OfficeID=Offices.id where (" + qGroup + ")");
			}
			else
			{
				if (group.Length > 0)
				{
					Repeater1.DataSource = DatabaseConnection.CreateDataset(String.Format("select Account.*,Offices.Office as OfficesoN from Account left outer join Offices on Account.OfficeID=Offices.id where (UserAccount like '{0}%' or NAme like '{0}%' or Surname like '{0}%' or Offices.Office like '{0}%' and ({1})) and GroupID={2} order by Surname asc", query, qGroup, group));
				}
				else
				{
					Repeater1.DataSource = DatabaseConnection.CreateDataset(String.Format("select Account.*,Offices.Office as OfficesoN from Account left outer join Offices on Account.OfficeID=Offices.id where (UserAccount like '{0}%' or NAme like '{0}%' or Surname like '{0}%' or Offices.Office like '{0}%' and ({1})) order by Surname asc", query, qGroup));
				}
			}
			Repeater1.DataBind();
			if (Repeater1.Items.Count > 0)
			{
				Repeater1Info.Visible = false;
				Repeater1.Visible = true;
			}
			else
			{
				Repeater1Info.Text = rm.GetString("Usrtxt81");
				Repeater1Info.Visible = true;
				Repeater1.Visible = false;
			}
			RubricForm.Visible = false;
			tabControl.Visible = false;
		}

		public void Submit_Click(Object sender, EventArgs e)
		{
			if (Mode.Text == "NEW")
			{
				Header.Visible = false;
				ModifyDataSet(-1);
				LabelInfo.Text = rm.GetString("Usrtxt4");
				tabControl.Visible = false;

				int activeAccount;
				activeAccount = (int) DatabaseConnection.SqlScalartoObj("select count(*) from Account where active=1");
				freeAccount = ((int) DatabaseConnection.SqlScalartoObj("select top 1 MaxUser from Tustena_Data") - activeAccount);

				if (freeAccount > 0)
				{
					LtrNewUser.Text = "<span class=\"ContactHeader\">" + rm.GetString("Usrtxt54") + "&nbsp;" + freeAccount.ToString() + "</span>";
					LblNewUser.Text = "<span class=\"ContactHeader\" onclick=\"location.href='NewUser.aspx?m=7&si=8&action=NEW'\"><b>" + rm.GetString("Usrtxt10") + "</b></span>";
				}
				else
				{
					LtrNewUser.Text = "<span class=\"normal\"><b>" + rm.GetString("Usrtxt55") + "</b></span>";
					LblNewUser.Text = "<span class=\"ContactHeader\" onclick=\"location.href='NewUser.aspx?m=7&si=8&action=NEW'\"><b>" + rm.GetString("Usrtxt10") + "</b></span>";
				}

				Mode.Text = "MOD";
			}
			else
			{
				ModifyDataSet(int.Parse(F_UID.Text));
				LabelInfo.Text = rm.GetString("Usrtxt3");
				tabControl.Visible = false;
			}

		}

		private void FillForm(string id)
		{
			DataSet dsUser;
			if (id == "-1")
			{
				dsUser = DatabaseConnection.CreateDataset("select top 1 * from Account order by UID desc");
			}
			else
			{
				dsUser = DatabaseConnection.CreateDataset("select * from Account where UID = " + id);
			}

			if (dsUser.Tables[0].Rows.Count == 0)
				HackLock(UC.UserId + ">" + id);
			DataRow drUser = dsUser.Tables[0].Rows[0];
			F_UID.Text = drUser["UID"].ToString();
			Name.Text = drUser["Name"].ToString();
			Surname.Text = drUser["Surname"].ToString();
			F_WorkStart.Text = Convert.ToDateTime(drUser["WorkStart_1"]).ToString("HH':'mm");
			EndWork.Text = Convert.ToDateTime(drUser["WorkEnd_1"]).ToString("HH':'mm");
			F_WorkStart2.Text = Convert.ToDateTime(drUser["WorkStart_2"]).ToString("HH':'mm");
			EndWork2.Text = Convert.ToDateTime(drUser["WorkEnd_2"]).ToString("HH':'mm");
			F_UserName.Text = drUser["UserAccount"].ToString();
			F_Password.Attributes.Add("value", drUser["Password"].ToString());
			EMail.Text = drUser["NotifyEmail"].ToString();
			F_IdRubrica.Text = drUser["SelfContactID"].ToString();
			F_usr.Text = UC.UserName;
			Responsable.Checked = Convert.ToBoolean(drUser["IsManager"]);
			Subaltern.Checked = Convert.ToBoolean(drUser["IsEmployee"]);
			PersonalContact.Checked = Convert.ToBoolean(drUser["EnablePersContact"]);
			FullScreen.Checked = Convert.ToBoolean(drUser["FullScreen"]);
			ViewBirthDate.Checked = Convert.ToBoolean(drUser["ViewBirthDate"]);
			Paging.Text = drUser["Paging"].ToString();
			SessionTimeout.Text = drUser["SessionTimeout"].ToString();

			MailServer.Text = drUser["MailServer"].ToString();
			MailUser.Text = drUser["MailUser"].ToString();
			MailPassword.Attributes.Add("value", drUser["MailPassword"].ToString());


			IdResponsable.SelectedItem.Selected = false;
			foreach (ListItem li in IdResponsable.Items)
			{
				if (li.Value == drUser["ManagerID"].ToString())
				{
					li.Selected = true;
				}
			}
			F_Group.SelectedItem.Selected = false;
			foreach (ListItem li in F_Group.Items)
			{
				if (li.Value == drUser["GroupID"].ToString())
				{
					li.Selected = true;
				}
			}
			F_Officeso.SelectedItem.Selected = false;
			foreach (ListItem li in F_Officeso.Items)
			{
				if (li.Value == drUser["OfficeID"].ToString())
				{
					li.Selected = true;
				}
			}

			try
			{
				if (drUser["InsertGroups"].ToString().Length > 0)
					GroupControl.SetGroups(drUser["InsertGroups"].ToString());
				else
					GroupControl.SetGroups("|" + drUser["GroupID"].ToString() + "|");
			}
			catch
			{
				GroupControl.SetGroups("|" + drUser["GroupID"].ToString() + "|");
			}

			DropCulture.SelectedItem.Selected = false;
			foreach (ListItem li in DropCulture.Items)
			{
				if (li.Value.Substring(0, 2) == drUser["Culture"].ToString().Substring(0, 2))
				{
					li.Selected = true;
				}
			}

			DropFirstDay.SelectedItem.Selected = false;
			if ((bool) drUser["FirstDayOfWeek"])
				DropFirstDay.SelectedIndex = 1;
			else
				DropFirstDay.SelectedIndex = 0;

			TimeZoneNew.SelectedItem.Selected = false;
			foreach (ListItem li in TimeZoneNew.Items)
			{
				if (li.Value == drUser["TimeZoneIndex"].ToString())
				{
					li.Selected = true;
				}
			}


			RecurrenceWeeklyDays.SelectedIndex = -1;
			for (int i = 0; i < 7; i++)
				if ((Convert.ToInt32(drUser["WorkDays"]) & (0x01 << i)) != 0)
				{
					RecurrenceWeeklyDays.Items[i].Selected = true;
				}

			F_IdRubrica.Text = drUser["SelfContactID"].ToString();

			if (drUser["DiaryAccount"].ToString().Length > 1)
			{
				Office.SetAccount(drUser["DiaryAccount"].ToString());
			}

			if (drUser["OfficeAccount"].ToString().Length > 1)
			{
				string[] arryUff = drUser["OfficeAccount"].ToString().Split('|');
				string query = String.Empty;
				foreach (string ut in arryUff)
				{
					query += "id=" + ut + " or ";
				}
				query = query.Substring(6, query.Length - 17);
				OfficesSel.DataTextField = "Description";
				OfficesSel.DataValueField = "id";
				StringBuilder sqlString = new StringBuilder();
				sqlString.Append("select id, Office as Description ");
				sqlString.AppendFormat("from Offices where {0} order by Office", query);
				OfficesSel.DataSource = DatabaseConnection.CreateDataset(sqlString.ToString());
				OfficesSel.DataBind();
			}
			FillOffices();
			FillRepGroups(drUser["OtherGroups"].ToString());

			DataSet dsTitles;
			if (mode == "0" && !UC.DebugMode)
			{
				dsTitles = DatabaseConnection.CreateDataset("select *, MenuMap.NewHomePageID from TustenaMenu_View left outer join MenuMap on MenuMap.menuid=TustenaMenu_View.id and (MenuMap.userid=" + id + ") where TustenaMenu_View.id<>12) and (MenuTitle=1" + QuerySecurityGroups(int.Parse(this.F_Group.SelectedValue)) + ") and (Mode=" + mode + ") order by SortOrder");
			}
			else
			{
				dsTitles = DatabaseConnection.CreateDataset("select *, MenuMap.NewHomePageID from TustenaMenu_View left outer join MenuMap on MenuMap.menuid=TustenaMenu_View.id and (MenuMap.userid=" + id + ") where (TustenaMenu_View.id<>12) and (MenuTitle=1" + QuerySecurityGroups(int.Parse(this.F_Group.SelectedValue)) + ") order by SortOrder");
			}
			this.RepHomePage.DataSource = dsTitles;
			this.RepHomePage.DataBind();
		}

		public void CreateVoice_Click(Object sender, EventArgs e)
		{
			if ((F_IdRubrica.Text != null && F_IdRubrica.Text.Length == 0) || F_IdRubrica.Text == "-1")
			{
				Response.Redirect("Rubrica.aspx?action=NEW");
			}
			else
			{
				Response.Redirect("Rubrica.aspx?action=MOD&full=" + F_IdRubrica.Text + "&user=" + F_UID.Text);
			}
		}

		public void ExistVoice_Click(Object sender, EventArgs e)
		{
			ExistRubric.Visible = false;
			Rubric.Visible = false;
			Select.Visible = true;
			Assign.Visible = true;
			Annul.Visible = true;
			Select.SelectedItem.Selected = false;
			foreach (ListItem li in Select.Items)
			{
				if (li.Value == F_IdRubrica.Text)
				{
					li.Selected = true;
				}
			}
		}

		public void Assign_Click(Object sender, EventArgs e)
		{
			F_IdRubrica.Text = Select.Items[Select.SelectedIndex].Value;
			ModifyAddrBook(int.Parse(F_IdRubrica.Text), int.Parse(F_UID.Text));
			Cancel_Click(sender, e);
			LabelInfo.Text = rm.GetString("Usrtxt3");
		}

		public void Cancel_Click(Object sender, EventArgs e)
		{
			ExistRubric.Visible = true;
			Rubric.Visible = true;
			Select.Visible = false;
			Assign.Visible = false;
			Annul.Visible = false;
		}

		private void ModifyAddrBook(int id, int idusr)
		{
			string sqlString;
			sqlString = "update BaseReferring set dipendente=" + idusr + " where ID = " + id;
			DatabaseConnection.DoCommand(sqlString);
		}

		private void ModifyDataSet(int id)
		{
			bool isNew = false;
			using (DigiDapter dg = new DigiDapter())
			{
				if (freeAccount > 0)
					dg.Add("Active", 1, 'I');
				else
					dg.Add("Active", 0, 'I');


				dg.Add("Name", Name.Text);
				dg.Add("Surname", Surname.Text);
				dg.Add("NotifyEmail", EMail.Text);

				dg.Add("WorkStart_1", Convert.ToDateTime(DateTime.Now.ToShortDateString() + " " + F_WorkStart.Text));

				dg.Add("WorkEnd_1", Convert.ToDateTime(DateTime.Now.ToShortDateString() + " " + EndWork.Text));

				dg.Add("WorkStart_2", Convert.ToDateTime(DateTime.Now.ToShortDateString() + " " + F_WorkStart2.Text));

				dg.Add("WorkEnd_2", Convert.ToDateTime(DateTime.Now.ToShortDateString() + " " + EndWork2.Text));


				if (PersonalContact.Checked)
					dg.Add("EnablePersContact", 1);
				if (FlagModifyAppointment.Checked)
					dg.Add("FlagNotifyAppointment", 1);
				int gglav = 0;
				foreach (ListItem li in RecurrenceWeeklyDays.Items)
				{
					if (li.Selected) gglav += Convert.ToInt32(li.Value);
				}
				dg.Add("WorkDays", gglav);
				dg.Add("UserAccount", F_UserName.Text);
				dg.Add("Password", F_Password.Text);
				if ((F_IdRubrica.Text != null && F_IdRubrica.Text.Length == 0))
				{
					F_IdRubrica.Text = "-1";
				}
				if (Paging.Text.Length > 0) dg.Add("Paging", Paging.Text);
				if (SessionTimeout.Text.Length > 0) dg.Add("SessionTimeout", SessionTimeout.Text);
				dg.Add("SelfContactID", Convert.ToInt32(F_IdRubrica.Text));
				dg.Add("IsManager", Responsable.Checked);
				dg.Add("IsEmployee", Subaltern.Checked);
				dg.Add("FullScreen", FullScreen.Checked);
				dg.Add("ViewBirthDate", ViewBirthDate.Checked);
				dg.Add("ManagerID", IdResponsable.SelectedItem.Value);
				dg.Add("GroupID", F_Group.SelectedItem.Value);

				string cat = "|";
				foreach (RepeaterItem it in RepGroup.Items)
				{
					CheckBox Check = (CheckBox) it.FindControl("Check");
					if (Check.Checked)
						cat += ((Literal) it.FindControl("IDGr")).Text + "|";
				}
				if (cat.Length > 1)
					dg.Add("OtherGroups", cat);
				else
					dg.Add("OtherGroups", DBNull.Value);

				dg.Add("InsertGroups", GroupControl.GetValue);
				dg.Add("OfficeID", F_Officeso.SelectedItem.Value);
				dg.Add("TimeZoneIndex", TimeZoneNew.SelectedItem.Value);
				dg.Add("Culture", DropCulture.SelectedItem.Value);
				dg.Add("FirstDayOfWeek", (DropFirstDay.SelectedItem.Value == "0"));

				dg.Add("MailServer", MailServer.Text);
				dg.Add("MailUser", MailUser.Text);
				if (MailPassword.Text.Length > 0)
					dg.Add("MailPassword", MailPassword.Text);
				else
					dg.Add("MailPassword", DBNull.Value);


				dg.Add("DiaryAccount", Office.GetValue);
				string arryStr = String.Empty;
				foreach (ListItem im in OfficesSel.Items)
				{
					arryStr += "|" + im.Value.ToString();
				}
				dg.Add("OfficeAccount", arryStr + "|");
				dg.Execute("Account", "UID=" + id);
				isNew = dg.RecordInserted;
			}
			if (!isNew)
			{
				foreach (RepeaterItem it in RepHomePage.Items)
				{
					using (DigiDapter dgp = new DigiDapter())
					{
						DropDownList DropMenuDefault = (DropDownList) it.FindControl("DropMenuDefault");
						Literal menuid = (Literal) it.FindControl("MenuID");
						if (DropMenuDefault.SelectedIndex == 0)
						{
							dgp.Add("UserID", id);
							dgp.Add("MenuID", menuid.Text);
							dgp.Add("FirstTime", 0);
							dgp.Add("NewHomePage", DBNull.Value);
							dgp.Add("NewHomePageID", DBNull.Value);
						}
						else
						{
							if (menuid.Text == "25" && DropMenuDefault.SelectedValue == "2")
							{
								dgp.Add("UserID", id);
								dgp.Add("MenuID", 25);
								dgp.Add("FirstTime", 1);
								dgp.Add("NewHomePage", "/Calendar/agenda.aspx?m=25&si=2");
								dgp.Add("NewHomePageID", 2);
							}
							else
							{
								DataRow dr = DatabaseConnection.CreateDataset("select id,'/'+folder+'/'+link+'&si='+cast(id as varchar) as pagedefault from newmenu where id=" + int.Parse(DropMenuDefault.SelectedValue)).Tables[0].Rows[0];
								dgp.Add("UserID", id);
								dgp.Add("MenuID", menuid.Text);
								dgp.Add("FirstTime", 1);
								dgp.Add("NewHomePage", dr["pagedefault"].ToString());
								dgp.Add("NewHomePageID", (int) dr["id"]);
							}
						}
						dgp.Execute("MenuMap", "UserID=" + id + " and menuid=" + menuid.Text);
					}
				}

			}

			if (id == Convert.ToInt32(UC.UserId))
			{
				UserConfig UCupload;
				UCupload = UserData.LoadPersonalData(F_UserName.Text, F_Password.Text, -1);
				Session["UserConfig"] = UCupload;
			}
		}

		public void BtnFindClick(Object sender, EventArgs e)
		{
			if (ListGroups.SelectedIndex > 0)
				FillRepeater(DatabaseConnection.FilterInjection(this.Find.Text), ListGroups.SelectedValue);
			else
				FillRepeater(DatabaseConnection.FilterInjection(Find.Text));
		}

		private void Delete(int id)
		{
			object retActive = DatabaseConnection.SqlScalartoObj(String.Format("select Active from Account where UID ={0}", id));
			if (retActive != null)
				DatabaseConnection.DoCommand(String.Format("update Account set Active={1} where uid={0}", id, (((int)retActive) == 0) ? 1 : 0));
			if (Request.Params["List"] != null)
				FillRepeater(Request.Params["List"].ToString());
			else
				FillRepeater("*");

			LabelInfoX.Text = "<p><div align=\"center\" style=\"font-family: verdana; font-size: 12px; color: red;\">" + rm.GetString("Usrtxt1") + "</div>";
		}

		public void Transfer_Listbox(ListBox fromListBox, ListBox toListBox)
		{
			foreach (ListItem li in fromListBox.Items)
			{
				if (li.Selected)
				{
					toListBox.Items.Add(li);
				}
			}
			toListBox.SelectedItem.Selected = false;
		}

		public void Remove_ListBox(ListBox fromListBox)
		{
			ListBox MyLB = new ListBox();
			foreach (ListItem li in fromListBox.Items)
			{
				if (li.Selected)
				{
					MyLB.Items.Add(li);
				}
			}
			foreach (ListItem li in MyLB.Items)
			{
				fromListBox.Items.Remove(li);
			}
		}



		public void Btn_Fww_ClickU(Object sender, EventArgs e)
		{
			if (OfficesAll.SelectedIndex > -1)
			{
				Transfer_Listbox(OfficesAll, OfficesSel);
			}
		}

		public void Btn_FwwAll_ClickU(Object sender, EventArgs e)
		{
			foreach (ListItem li in OfficesAll.Items)
			{
				li.Selected = true;
			}
			Transfer_Listbox(OfficesAll, OfficesSel);
		}

		public void Btn_Rww_ClickU(Object sender, EventArgs e)
		{
			if (OfficesSel.SelectedIndex > -1)
			{
				Remove_ListBox(OfficesSel);
			}
		}

		public void Btn_RwwAll_ClickU(Object sender, EventArgs e)
		{
			foreach (ListItem li in OfficesSel.Items)
			{
				li.Selected = true;
			}
			Remove_ListBox(OfficesSel);
		}


		private void FillOffices()
		{
			OfficesAll.DataTextField = "Office";
			OfficesAll.DataValueField = "id";
			OfficesAll.DataSource = DatabaseConnection.CreateDataset("select id, Office from Offices order by Office asc");
			OfficesAll.DataBind();
		}

		public void Repeater1DataBound(object source, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Label td1 = (Label) e.Item.FindControl("td1");
					td1.Attributes.Add("onclick", "location.href='NewUser.aspx?m=7&si=8&action=MOD&full=" + Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "UID")) + "'");
					td1.Text = (string) DataBinder.Eval((DataRowView) e.Item.DataItem, "UserAccount");
					Label td2 = (Label) e.Item.FindControl("td2");
					td2.Text = (string) DataBinder.Eval((DataRowView) e.Item.DataItem, "Surname") + "&nbsp;" + (string) DataBinder.Eval((DataRowView) e.Item.DataItem, "Name");

					LinkButton DelAC = (LinkButton) e.Item.FindControl("Delete");
					if (Convert.ToBoolean(DataBinder.Eval((DataRowView) e.Item.DataItem, "Active")))
					{
						td1.CssClass = "normal linked";
						td2.CssClass = "normal";
						DelAC.Text = rm.GetString("Usrtxt15");
						DelAC.Attributes.Add("onclick", "return confirm('" + G.ParseJSString(rm.GetString("Usrtxt59")) + "');");
					}
					else
					{
						td1.CssClass = "LinethroughGray linked";
						td2.CssClass = "LinethroughGray";
						if (freeUsers)
						{
							DelAC.Text = rm.GetString("Usrtxt63");
							DelAC.Attributes.Add("onclick", "return confirm('" + G.ParseJSString(rm.GetString("Usrtxt64")) + "');");
						}
						else
							DelAC.Visible = false;
					}
					break;
			}
		}

		public void Repeater1Command(Object sender, RepeaterCommandEventArgs e)
		{
			Trace.Warn("commandname", e.CommandName);
			switch (e.CommandName)
			{
				case "Delete":
					Literal IDUID = (Literal) e.Item.FindControl("IDUID");
					Trace.Warn("deleteid", IDUID.Text);
					Delete(int.Parse(IDUID.Text));
					break;
			}
		}

		private void FillRepGroups(string dependency)
		{
			DataTable dt;
			dt = DatabaseConnection.CreateDataset("select id,Description,'0' as tocheck from Groups").Tables[0];
			if (dt.Rows.Count > 0)
			{
				foreach (DataRow dr in dt.Rows)
				{
					if (dependency.IndexOf("|" + dr["id"].ToString() + "|") > -1)
						dr["tocheck"] = "1";

					if (dr["id"].ToString() == F_Group.SelectedValue)
					{
						dr["tocheck"] = "2";
					}


				}
			}
			RepGroup.DataSource = new DataView(dt, "", "tocheck desc", DataViewRowState.CurrentRows);
			RepGroup.DataBind();
		}

		#region Web Form Designer generated code

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.RepHomePage.ItemDataBound += new RepeaterItemEventHandler(RepHomePage_ItemDataBound);
			this.RepGroup.ItemDataBound += new RepeaterItemEventHandler(RepGroup_ItemDataBound);			this.Rubric2.Click += new EventHandler(this.CreateVoice_Click);
			this.ExistRubric2.Click += new EventHandler(this.ExistVoice_Click);
			this.Btn_FwwAllU.Click += new EventHandler(this.Btn_FwwAll_ClickU);
			this.Btn_FwwU.Click += new EventHandler(this.Btn_Fww_ClickU);
			this.Btn_RwwU.Click += new EventHandler(this.Btn_Rww_ClickU);
			this.Btn_RwwAllU.Click += new EventHandler(this.Btn_RwwAll_ClickU);
			this.Assign.Click += new EventHandler(this.Assign_Click);
			this.Annul.Click += new EventHandler(this.Cancel_Click);
			this.Rubric.Click += new EventHandler(this.CreateVoice_Click);
			this.ExistRubric.Click += new EventHandler(this.ExistVoice_Click);

		}

		#endregion

		private void RepGroup_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:

					CheckBox Check = (CheckBox) e.Item.FindControl("Check");
					switch (Convert.ToByte(DataBinder.Eval((DataRowView) e.Item.DataItem, "tocheck")))
					{
						case 0:
							Check.Checked = false;
							break;
						case 1:
							Check.Checked = true;
							break;
						case 2:
							Check.Enabled = false;
							break;
					}

					break;
			}
		}

		private DataTable CreateMenuHelp(string parent, string query)
		{

			DataSet dsSecondary;
			if (mode == "0" && !UC.DebugMode)
			{
				dsSecondary = DatabaseConnection.CreateDataset("select * from TustenaMenu_View where ParentMenu=" + parent + query + " and Mode=0 order by SortOrder");
			}
			else
			{
				dsSecondary = DatabaseConnection.CreateDataset(String.Format("select * from TustenaMenu_View where ParentMenu={0}{1} order by SortOrder", parent, query));
			}
			return dsSecondary.Tables[0];
		}

		public string QuerySecurityGroups(int gruid)
		{
			string sqlString = "select id,dependency from Groups where id=" + gruid + " or dependency like '%|" + gruid + "|%'";

			DataSet dsGroup = DatabaseConnection.CreateDataset(sqlString);
			string dependency = "|";
			if (dsGroup.Tables[0].Rows.Count > 0)
			{
				foreach (DataRow drdip in dsGroup.Tables[0].Rows)
				{
					dependency += drdip["id"].ToString() + "|";
				}
			}

			string query = String.Empty;
			if (dependency.Length > 1)
			{
				string[] dep = dependency.Split('|');
				foreach (string group in dep)
				{
					if (group.Length > 0) query += " accessgroup like '%|" + group + "|%' or ";
				}
				query = " and (" + query.Substring(0, query.Length - 4) + ")";

				return query;
			}
			else
			{
				return "";
			}
		}

		private void RepHomePage_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					DropDownList DropMenuDefault = (DropDownList) e.Item.FindControl("DropMenuDefault");
					DataTable menus = CreateMenuHelp(((Literal) e.Item.FindControl("MenuID")).Text, QuerySecurityGroups(int.Parse(F_Group.SelectedValue)));
					DataTable dtParent;
					int qId = int.Parse(((Literal) e.Item.FindControl("MenuID")).Text);
					dtParent = DatabaseConnection.CreateDataset("select id,Voice,link,rmvalue from TustenaMenu_View where id=" + qId).Tables[0];
					Literal MenuTitle = (Literal) e.Item.FindControl("MenuTitle");
					MenuTitle.Text = rm.GetString("Menutxt" + dtParent.Rows[0]["rmvalue"]).ToUpper();

					int menuId = int.Parse(((Literal) e.Item.FindControl("MenuID")).Text);
					DataTable dtHelp = DatabaseConnection.CreateDataset("select * from HelpMenu where MenuID=" + menuId).Tables[0];
					if (dtHelp.Rows.Count > 0)
					{
						if (File.Exists(Request.PhysicalApplicationPath + Path.DirectorySeparatorChar + "help" + Path.DirectorySeparatorChar + UC.Culture.Substring(0, 2) + Path.DirectorySeparatorChar + dtHelp.Rows[0]["HelpFile"].ToString()))
							DropMenuDefault.Items.Add(new ListItem(rm.GetString("Menutxt" + dtParent.Rows[0]["rmvalue"]).ToUpper() + " HELP", dtParent.Rows[0]["id"].ToString()));
						else
							DropMenuDefault.Items.Add(new ListItem(rm.GetString("Menutxt" + dtParent.Rows[0]["rmvalue"]).ToUpper(), dtParent.Rows[0]["id"].ToString()));
					}
					else
						DropMenuDefault.Items.Add(new ListItem(rm.GetString("Menutxt" + dtParent.Rows[0]["rmvalue"]).ToUpper(), dtParent.Rows[0]["id"].ToString()));


					string selectedMenu = (DataBinder.Eval((DataRowView) e.Item.DataItem, "NewHomePageID")).ToString();
					foreach (DataRow dr in menus.Rows)
					{
						DropMenuDefault.Items.Add(new ListItem(rm.GetString("Menutxt" + dr["rmvalue"]), dr["id"].ToString()));
					}
					DropMenuDefault.SelectedIndex = -1;
					foreach (ListItem li in DropMenuDefault.Items)
					{
						if (li.Value == selectedMenu)
						{
							li.Selected = true;
							break;
						}
					}
					break;
			}
		}


	}
}
