/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System.Resources;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

namespace Digita.Tustena.Localize
{

	public class LocalizedButton : Button
	{
		protected override void Render(HtmlTextWriter writer)
		{
			Text = G.rm.GetString(Text);
			base.Render(writer);
		}
	} // end class LocalizedButton

	public class LocalizedLinkButton : LinkButton
	{
		protected override void Render(HtmlTextWriter writer)
		{
			Text = G.rm.GetString(Text);
			base.Render(writer);
		}
	} // end class LocalizedButton

	public class LocalizedHtmlInputButton : HtmlInputButton
	{
		protected override void Render(HtmlTextWriter writer)
		{
			Value = G.rm.GetString(Value);
			base.Render(writer);
		}
	} // end class LocalizedHtmlInputButton

	[ToolboxData("<{0}:LocalizedLabel runat=server></{0}:LocalizedLabel>")]
	public class LocalizedLabel : Label
	{
		protected override void Render(HtmlTextWriter writer)
		{
			Text = G.rm.GetString(Text);
			base.Render(writer);
		}
	} // end class LocalizedLabel

	public class LocalizedHtmlAnchor : HtmlAnchor
	{
		protected override void Render(HtmlTextWriter writer)
		{
			InnerText = G.rm.GetString(InnerText);
			base.Render(writer);
		}
	} // end class LocalizedHtmlAnchor

	public class LocalizedLiteral : Literal
	{
		protected override void Render(HtmlTextWriter writer)
		{
			Text = G.rm.GetString(Text);
			base.Render(writer);
		}
	} // end class LocalizedLiteral
}
