/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Collections;
using System.Data;

using System.IO;
using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Ajax;
using Digita.Tustena.Base;
using Digita.Tustena.Common;
using Digita.Tustena.Database;
using Digita.Tustena.WorkingCRM;

namespace Digita.Tustena
{
	public class Base_Contacts : G
	{
		protected Repeater ViewForm;
		protected Repeater Repeater1;
		protected RepeaterPaging Repeater1Paging;
		protected Label abcHeader;
		protected TextBox Search;
		protected Literal Tab1Text;
		protected HtmlTable ReferenceForm;
		protected GroupControl Groups;
		protected Label RepeaterInfo;
		protected CheckBox Personal;
		protected CheckBox Global;
		protected LinkButton BtnNew;
		protected LinkButton BtnSearch;
		protected LinkButton SubmitRef;
		protected LinkButton Submit2;
		protected Label LblTitle;

		protected HtmlInputHidden activeTab;
		protected HtmlTable tabControl;
		protected Literal SomeJS;
		protected Label RequiredFieldValidatorCognome;
		protected TextBox RapRagSoc;
		protected TextBox RapPhone;
		protected TextBox RapEmail;
		protected Label RapInfo;
		protected LinkButton RapSubmit;
		protected LinkButton BtnGroup;
		protected DropDownList ListGroups;
		protected LinkButton Back;
		protected LinkButton BackCo;
		protected Label RepeaterActivityInfo;
		protected Repeater FileRep;
		protected LinkButton NewDoc;
		protected Label DateFormat;
		protected Label FileRepInfo;
		protected HtmlTableCell tdTab1;
		protected HtmlTableCell tdTab2;

		protected HtmlTableCell tdTab3;
		protected Literal ViewFreeFields;
		protected Literal FreeFields;
		protected Repeater RepCategories;
		protected LinkButton RefreshRepCategories;

		protected TextBox Referring_ID;
		protected TextBox Referring_CompanyID;
		protected TextBox Referring_Name;
		protected TextBox Referring_Surname;
		protected TextBox Referring_Title;
		protected TextBox Referring_Address_1;
		protected TextBox Referring_Address_2;
		protected TextBox Referring_City_1;
		protected TextBox Referring_City_2;
		protected TextBox Referring_Province_1;
		protected TextBox Referring_Province_2;
		protected TextBox Referring_ZIPCode_1;
		protected TextBox Referring_ZIPCode_2;
		protected TextBox Referring_State_1;
		protected TextBox Referring_State_2;
		protected TextBox Referring_VatID;
		protected TextBox Referring_TaxIdentificationNumber;
		protected TextBox Referring_EMail;
		protected TextBox Referring_Phone_1;
		protected TextBox Referring_Phone_2;
		protected TextBox Referring_Fax;
		protected TextBox Referring_MobilePhone_1;
		protected TextBox Referring_MobilePhone_2;
		protected TextBox Referring_BusinessRole;
		protected TextBox Referring_Notes;
		protected TextBox Referring_BirthDay;
		protected TextBox Referring_BirthPlace;
		protected TextBox Referring_Categories;
		protected TextBox Referring_MLEmail;
		protected CheckBox Referring_MLFlag;
		protected RadioButtonList Referring_Sex;
		protected TextBox Referring_CompanyTX;

		private string repSqlString;

		protected ActivityChronology AcCrono;
		protected LinkButton NewActivityPhone;
		protected LinkButton NewActivityLetter;
		protected LinkButton NewActivityFax;
		protected LinkButton NewActivityMemo;
		protected LinkButton NewActivityEmail;
		protected LinkButton NewActivityVisit;
		protected LinkButton NewActivityGeneric;
		protected LinkButton NewActivitySolution;

		protected SheetPaging SheetP;
		protected DropDownList ListCategory;
		protected Literal GroupDescription;

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				if (Request["Ajax"] != null)
					InitAjax();
				DeleteGoBack();
				GroupDescription.Text = " (" + G.GetGroupDescription(UC.UserGroupId) + ")";
				Repeater1Paging.Visible = false;
				Back.Click += new EventHandler(BtnBack_Click);
				BackCo.Click += new EventHandler(BtnBack_Click);

				DateFormat.Text = "[" + UC.myDTFI.ShortDatePattern.ToString() + "]";
				if (!isGoBack)
				{
					Back.Visible = false;
				}
				else
				{
					Stack ba = new Stack();
					ba = (Stack) Session["goback1"];
					GoBack gb = new GoBack();
					gb = (GoBack) ba.Peek(); //[ba.Count - 1];
					if (!(gb.sheet.ToLower().IndexOf("base_contacts.aspx") > 0))
						Back.Visible = false;
				}

				RapSubmit.Text = rm.GetString("Bcotxt4");
				BtnGroup.Text = rm.GetString("Bcotxt2");
				NewDoc.Text = rm.GetString("CRMrubtxt4");


				if (Session["CurrentActiveMenu"] != null)
				{
					if (Convert.ToInt16(Session["CurrentActiveMenu"]) == 1)
					{
						LblTitle.Text = rm.GetString("Reftxt5");
					}
					else
					{
						LblTitle.Text = rm.GetString("Reftxt44");
					}
				}
				else
				{
					LblTitle.Text = rm.GetString("Reftxt5");
				}

				try
				{
					repSqlString = ViewState["RepSQLString"].ToString();
				}
				catch
				{
					repSqlString = String.Empty;
				}
				abcHeader.Text = CRM_Companies.ABCHeaderHtml(Request.Params["List"]);

				if (!Page.IsPostBack)
				{
					AcCrono.ParentID = 0;
					AcCrono.OpportunityID = 0;
					AcCrono.AcType = (byte) AType.Contacts;
					NewActivityPhone.Text = rm.GetString("Wortxt6");
					NewActivityLetter.Text = rm.GetString("Wortxt7");
					NewActivityFax.Text = rm.GetString("Wortxt8");
					NewActivityMemo.Text = rm.GetString("Wortxt9");
					NewActivityEmail.Text = rm.GetString("Wortxt10");
					NewActivityVisit.Text = rm.GetString("Wortxt11");
					NewActivityGeneric.Text = rm.GetString("Wortxt12");
					NewActivitySolution.Text = rm.GetString("Wortxt13");

					CRM_Companies.FillListGroups(UC, this.ListGroups);
					FillListCategories();

					ReferenceForm.Visible = false;
					tabControl.Visible = false;
					Tab1Text.Text = "&nbsp;<span class=\"normal Mul\" onclick=\"ViewHideTabs('visContact');\">&nbsp;" + rm.GetString("CRMrubtxt1") + "&nbsp;</span>";


					if (Request.Params["List"] != null)
					{
						FillRepeater(Request.Params["List"].ToString(), "Base_Contacts.Surname");
					}
					if (Request.Params["action"] != null)
					{
						if (Request.Params["action"] == "NEW")
						{
							BackCo.Visible = true;

							FillRepCategories();
							CheckFreeFields(-1);

							if (Session["contact"] != null)
							{
								Referring_CompanyID.Text = Session["contact"].ToString();
								Referring_CompanyTX.Text = DatabaseConnection.SqlScalar("select companyname from Base_Companies where id=" + Session["contact"]);

								string groups = DatabaseConnection.SqlScalar("select groups from Base_Companies where id=" + Session["contact"]);
								Session["GroupsSetGroup"] = groups;
								tdTab2.Visible = false;
								tdTab3.Visible = false;
							}
							this.SheetP.Visible = false;
							Tab1Text.Text = "<span class=\"normal Mul\">&nbsp;" + rm.GetString("CRMrubtxt1") + "&nbsp;</span>";
							ReferenceForm.Visible = true;
							tabControl.Visible = true;
							Repeater1.Visible = false;
							ViewForm.Visible = false;
						}
						if (Request.Params["action"] == "MOD")
						{
							ViewForm.Visible = false;

							Repeater1.Visible = false;
							ReferenceForm.Visible = true;
							FillForm(int.Parse(Request.Params["full"]));
						}
						if (Request.Params["action"] == "VIEW")
						{
							Back.Visible = true;
							if (Session["Contactarray"] != null)
							{
								string[] tempArray = (string[]) Session["Contactarray"];
								this.SheetP.IDArray = tempArray;
								for (int i = 0; i < tempArray.Length; i++)
								{
									if (tempArray[i].Split('|')[0].CompareTo(Request.Params["full"]) == 0)
									{
										this.SheetP.CurrentPosition = i;
										this.SheetP.enabledisable();
										break;
									}
								}
								Session.Remove("Contactarray");
							}
							FillView(int.Parse(Request.Params["full"]));
						}
					}
					if (Request.Params["gb"] != null && isGoBack)
					{
						Stack ba = new Stack();
						ba = (Stack) Session["goback1"];
						GoBack gb = new GoBack();
						gb = (GoBack) ba.Pop(); //[ba.Count - 1];
						string[] par = gb.parameter.Split('|');

						if (par[1].Length > 0) FillView(int.Parse(par[1]));
						if (par[2].Length > 0)
						{
							switch (par[2])
							{
								case "a":
									SomeJS.Text = "<script>ViewHideTabs(\"visActivity\");</script>";
									break;
								case "d":
									SomeJS.Text = "<script>ViewHideTabs(\"VisDocuments\");</script>";
									break;
							}
							activeTab.Value = String.Empty;
						}
						Session["goback1"] = ba;
					}

					if (Request.Form["searchcontact"] != null)
					{
						Search.Text = Request.Form["searchcontact"];
						SearchClick("btnSearch");
					}

				}
				else
				{
					if (activeTab.Value.Length > 0)
					{
						SomeJS.Text = "<script>ViewHideTabs(\"" + activeTab.Value + "\");</script>";
						activeTab.Value = String.Empty;
					}
				}
			}
			BtnNew.Text = rm.GetString("Reftxt40");
			BtnSearch.Text = rm.GetString("Reftxt41");

			SubmitRef.Text = rm.GetString("Reftxt43");
			Submit2.Text = rm.GetString("Reftxt43");

		}



		private void FillListCategories()
		{
			ListCategory.DataTextField = "Description";
			ListCategory.DataValueField = "id";
			ListCategory.DataSource = DatabaseConnection.CreateDataset("select id,Description from CRM_ReferrerCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + "))");
			ListCategory.DataBind();
			ListCategory.Items.Insert(0, rm.GetString("CRMcontxt53"));
			ListCategory.Items[0].Value = "0";
		}

		private void ClearTextBox(IEnumerator i)
		{
			while (i.MoveNext())
			{
				if (i.Current.GetType().Name == "TextBox")
				{
					TextBox t = (TextBox) i.Current;
					if (t.ID == "Referring_ID")
						t.Text = "-1";
					else
						t.Text = String.Empty;
				}
				else
				{
					Control y = (Control) i.Current;
					ClearTextBox(y.Controls.GetEnumerator());
				}
			}
		}

		public void NewContact(object sender, EventArgs e)
		{
			InitAjax();
			tabControl.Visible = true;
			ReferenceForm.Visible = true;
			Repeater1.Visible = false;
			ViewForm.Visible = false;
			ClearTextBox(ReferenceForm.Controls.GetEnumerator());
			CheckFreeFields(-1);
			FillRepCategories();
			Tab1Text.Text = "<span class=\"normal Mul\">&nbsp;" + rm.GetString("CRMrubtxt1") + "&nbsp;</span>";
			tdTab2.Visible = false;
			tdTab3.Visible = false;
			if (UC.InsertGroups.Length > 0) Groups.SetGroups(UC.InsertGroups);

			this.SheetP.Visible = false;
		}


		public void BtnSearch_Click(object sender, EventArgs e)
		{
			Search.Text=StaticFunctions.RemoveSpecialChar(Search.Text);
			SearchClick(((LinkButton) sender).ID);
			SomeJS.Text = String.Empty;
			DeleteGoBack(true);
		}

		private void SearchClick(string sender)
		{
			Session["searchsender"] = sender;
			string queryType2 = String.Empty;
			string queryGroup = GroupsSecure("Base_Contacts.Groups");
			string findString = DatabaseConnection.FilterInjection(Search.Text);

			switch (Request.Form["visualizationType"])
			{
				case "0":
				case "1":
					queryType2 = string.Empty;
					break;
				case "2":
					queryType2 = " and ((Base_Contacts.FlagGlobalORPersonal<>2) and (Base_Contacts.Groups like '%|" + UC.UserGroupId.ToString() + "|%'))";
					break;
			}
			StringBuilder sqlString = new StringBuilder();


			sqlString.Append("SELECT Base_Contacts.ID,Base_Contacts.Name, Base_Contacts.Surname, Base_Contacts.Phone_1, Base_Contacts.MobilePhone_1, Base_Companies.CompanyName AS CompanyName2,(Account.Surname+' '+Account.Name) as NameOwner ");
			sqlString.Append("FROM Base_Contacts LEFT OUTER JOIN Base_Companies ON Base_Contacts.CompanyID = Base_Companies.ID ");
			sqlString.Append("LEFT OUTER JOIN Account ON Base_Contacts.OwnerID = Account.UID ");
			sqlString.AppendFormat("where Base_Contacts.Limbo=0 and (Base_Contacts.Surname like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.Name like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.Phone_1 like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.Phone_2 like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.MobilePhone_1 like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.MobilePhone_2 like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.Email like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.City_1 like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.City_2 like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.Province_1 like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.Province_2 like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Contacts.Notes like '%{0}%' or ", findString);
			sqlString.AppendFormat("Base_Companies.CompanyName like '%{0}%') ", findString);
			sqlString.Append(queryType2);


			if (sender == "btnGroup")
			{
				if (ListGroups.SelectedItem.Value != "0")
				{
					string dep = GroupDependency(Convert.ToInt32(ListGroups.SelectedItem.Value));
					if (dep.Length > 1)
					{
						string[] arryD = dep.Split('|');
						string qGroup = String.Empty;
						foreach (string ut in arryD)
						{
							if (ut.Length > 0) qGroup += "Base_Contacts.Groups like '%|" + ut + "|%' or ";
						}
						if (qGroup.Length > 0) qGroup = qGroup.Substring(0, qGroup.Length - 3);
						sqlString.AppendFormat(" and ({0})", qGroup);

					}
					else
					{
						sqlString.AppendFormat(" and (Base_Contacts.Groups like '%|{0}|%')", ListGroups.SelectedItem.Value);

					}
				}
				if (this.ListCategory.SelectedIndex > 0)
				{
					sqlString.AppendFormat(" and (Base_Contacts.Categories like '%|{0}|%')", ListCategory.SelectedValue);

				}
			}
			else
			{
				if (queryGroup.Length > 0)
				{
					sqlString.AppendFormat(" and ({0})", queryGroup);

				}
			}

			ViewState["RepSQLString"] = sqlString;
			try
			{
				sqlString.AppendFormat(" order by {0}", ViewState["orderby"].ToString());
			}
			catch
			{
				sqlString.Append(" order by Base_Contacts.Surname;");
			}


			Repeater1Paging.PageSize = UC.PagingSize;
			Repeater1Paging.RepeaterObj = Repeater1;
			InitSheetPaging(sqlString.ToString());
			Repeater1Paging.sqlRepeater = sqlString.ToString();
			Repeater1Paging.BuildGrid();


			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				RepeaterInfo.Visible = false;

			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Reftxt1");
				if (Search.Text.Length > 0)
				{
					RepeaterInfo.Text += "<br><br><span style=\"cursor:pointer;color:#000000;text-decoration:underline;\" onclick=\"SubmitContact();\">" +
						rm.GetString("Reftxt50") + "</span></center>";
				}
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}

			ViewForm.Visible = false;
			ReferenceForm.Visible = false;
			tabControl.Visible = false;
		}

		public void ReferenceFormSubmit(object sender, EventArgs e)
		{
			if (Referring_Surname.Text.Length > 0)
			{
				ModifyForm(int.Parse(Referring_ID.Text));
				tdTab2.Style.Add("display", "");
				tdTab3.Style.Add("display", "");
				SheetP.Visible = true;
			}
			else
			{
				Page.RegisterStartupScript("", "<script>alert('" + rm.GetString("Reftxt54") + "');</script>");
				RequiredFieldValidatorCognome.Visible = true;
			}
		}

		private void FillRepeater(string query, string orderby)
		{
			Session.Remove("searchsender");
			string queryType = String.Empty;
			string queryGroup = GroupsSecure("Base_Contacts.Groups");
			switch (Request.Params["type"])
			{
				case "0":
					queryType = " and ((Base_Contacts.FlagGlobalORPersonal=2 and  Base_Contacts.OwnerID=" + UC.UserId.ToString() + ") or (Base_Contacts.FlagGlobalORPersonal<>2))";
					break;
				case "1":
					queryType = " and ((Base_Contacts.FlagGlobalORPersonal=2 and  Base_Contacts.OwnerID=" + UC.UserId.ToString() + "))";
					break;
				case "2":
					queryType = " and ((Base_Contacts.FlagGlobalORPersonal<>2) and (Base_Contacts.Groups like '%|" + UC.UserGroupId.ToString() + "|%'))";
					break;
			}
			StringBuilder sqlString = new StringBuilder();

			if (query != "order")
			{
				sqlString.AppendFormat("SELECT TOP {0} Base_Contacts.ID,Base_Contacts.Name, Base_Contacts.Surname, Base_Contacts.Phone_1, Base_Contacts.MobilePhone_1, Base_Companies.CompanyName AS CompanyName2,(Account.Surname+' '+Account.Name) as NameOwner ", DatabaseConnection.MaxResult);
				sqlString.Append("FROM Base_Contacts LEFT OUTER JOIN Base_Companies ON Base_Contacts.CompanyID = Base_Companies.ID ");
				sqlString.Append("LEFT OUTER JOIN Account ON Base_Contacts.OwnerID = Account.UID ");

				switch (query)
				{
					case "*":
						sqlString.AppendFormat("where (Base_Contacts.Limbo = 0) {0}", queryType);

						break;
					default:
						sqlString.AppendFormat("where ((Base_Contacts.Limbo = 0) and (Base_Contacts.Surname like '{0}%')) {1}", query, queryType);

						break;
				}
				if (queryGroup.Length > 0)
				{
					sqlString.AppendFormat(" and ({0})", queryGroup);
				}


				repSqlString = sqlString.ToString();

				ViewState["RepSQLString"] = sqlString.ToString();

			}


			if (repSqlString.IndexOf("order by") <= 0) repSqlString += " order by " + orderby + " asc";


			Repeater1Paging.PageSize = UC.PagingSize;
			Repeater1Paging.RepeaterObj = Repeater1;
			InitSheetPaging(repSqlString);
			Repeater1Paging.sqlRepeater = repSqlString;
			Repeater1Paging.BuildGrid();

			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				RepeaterInfo.Visible = false;

			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Reftxt1") + "</center>";
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}
		}

		private void InitAjax()
		{
			Manager.Register(this, "Ajax.Contacts", Debug.None);
		}

		[Method]
		public string CheckDuplicatedContacts(string name, string surname)
		{
			if (name.Length == 0)
				return DatabaseConnection.SqlScalar("select name+'|'+surname as ret from Base_Contacts where surname = '" + DatabaseConnection.FilterInjection(surname) + "'");
			else
				return DatabaseConnection.SqlScalar("select name+'|'+surname as ret from Base_Contacts where name =  '" + DatabaseConnection.FilterInjection(name) + "' and surname = '" + DatabaseConnection.FilterInjection(surname) + "'");
		}


		public void Repeater1_ItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton IMB = (LinkButton) e.Item.FindControl("Delete");
					IMB.Text = rm.GetString("CRMcontxt44");
					;
					IMB.Attributes.Add("onclick", "return confirm('" + rm.GetString("Bcotxt44") + "');");

					break;
				case ListItemType.Footer:
					Literal RepCounter = (Literal) e.Item.FindControl("RepCounter");
					RepCounter.Text = this.Repeater1Paging.RowCount.ToString();
					if (this.Repeater1Paging.RowCount >= 100)
						RepCounter.Text += " (" + string.Format(rm.GetString("top100"), DatabaseConnection.MaxResult) + ")";
					break;
			}
		}


		public void Repeater1_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "View":
					if (this.SheetP.IDArray.Length > 0)
					{
						string[] tempArray = this.SheetP.IDArray;
						for (int i = 0; i < tempArray.Length; i++)
						{
							if (tempArray[i].Split('|')[0].CompareTo(((Label) e.Item.FindControl("ID")).Text) == 0)
							{
								this.SheetP.CurrentPosition = i;
								this.SheetP.enabledisable();
								break;
							}
						}
					}
					FillView(int.Parse(((Label) e.Item.FindControl("ID")).Text));
					break;
				case "OrderByName":
					ViewState["orderby"] = "Base_Contacts.Surname";
					FillRepeater("order", "Base_Contacts.Surname");
					break;
				case "OrderByCompany":
					ViewState["orderby"] = "Base_Companies.CompanyName";
					FillRepeater("order", "Base_Companies.CompanyName");
					break;
				case "Delete":
					Delete(int.Parse(((Label) e.Item.FindControl("ID")).Text), UC.UserId, "Base_Contacts");
					FillRepeater("order", "Base_Contacts.Surname");
					break;
			}
		}

		internal static void Delete(int id, int userId, string table)
		{
			using (DigiDapter dg = new DigiDapter("select ID,Limbo,LastActivity,LastModifiedDate,LastModifiedByID from " + table + " where ID =" + id))
			{
				dg.UpdateOnly();
				dg.Add("limbo", 1);
				dg.Add("LastActivity", 2);
				dg.Add("LastModifiedDate", DateTime.UtcNow);
				dg.Add("LastModifiedByID", userId);
				dg.Execute(table, "ID =" + id);
			}
		}

		private void FillView(int id)
		{
			Session["CurrentRefId"] = id;
			string sqlString = "SELECT Base_Contacts.*, (modby.Name+' '+modby.Surname) as LastModifiedBy, Base_Companies.CompanyName AS CompanyName2, Base_Companies.Phone as AzPhone ";
			sqlString += "FROM Base_Contacts LEFT OUTER JOIN Base_Companies ON Base_Contacts.CompanyID = Base_Companies.ID ";
			sqlString += "LEFT OUTER JOIN Account as modby ON Base_Contacts.LastModifiedByID = modby.UID";

			ViewForm.DataSource = DatabaseConnection.CreateDataset(sqlString + " where Base_Contacts.id=" + id);
			ViewForm.DataBind();

			tabControl.Visible = true;
			ViewForm.Visible = true;
			Repeater1.Visible = false;
			ReferenceForm.Visible = false;

			try
			{
				if (this.SheetP.IDArray.Length <= 0)
				{
					this.SheetP.CurrentPosition = 0;
					this.SheetP.enabledisable();
				}
			}
			catch
			{
				this.SheetP.IDArray = new string[0];
				this.SheetP.CurrentPosition = -1;
				this.SheetP.enabledisable();
			}
		}

		public void ViewFormOnItemDatabound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:

					Literal ViewFreeFields = (Literal) e.Item.FindControl("ViewFreeFields");
					ViewFreeFields.Text = String.Empty;
					string query = GroupsSecure("groups");
					if (query.Length == 0)
						query = " groups like '%|" + UC.UserGroupId + "|%'";
					string sqlString;
					sqlString = "select * from addedfields where tablename=" + (byte) CRMTables.Base_Contacts + " and (" + query + ") order by vieworder";

					DataSet ds = DatabaseConnection.CreateDataset(sqlString);
					if (ds.Tables[0].Rows.Count > 0)
					{
						StringBuilder S = new StringBuilder();
						S.AppendFormat("<table width=\"100%\"><tr><td class=\"normal Bbot\"><br><b>{0}</b></td></tr></table>", rm.GetString("Bcotxt50"));
						S.Append("<table width=\"45%\" class=\"normal\">");
						foreach (DataRow dr in ds.Tables[0].Rows)
						{
							bool isParentCrossed = true;
							DataSet Q = DatabaseConnection.CreateDataset("select ParentField,ParentFieldValue from AddedFields where id=" + dr["id"].ToString());
							string pf = Q.Tables[0].Rows[0][0].ToString();
							string pfv = Q.Tables[0].Rows[0][1].ToString();
							if (pf.Length > 0)
							{
								IDataReader sqlDr = DatabaseConnection.CreateReader("select " + pf + " from Base_Contacts where id=" + int.Parse(Session["CurrentRefId"].ToString()));
								sqlDr.Read();
								isParentCrossed = (sqlDr[0].ToString() == pfv);
								sqlDr.Close();
							}

							if (isParentCrossed)
							{
								S.AppendFormat("<tr><td width=\"40%\">{0}</td>", dr["name"]);
								DataSet afCross = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + dr["id"] + " and id=" + (Int64) DataBinder.Eval((DataRowView) e.Item.DataItem, "id"));
								if (afCross.Tables[0].Rows.Count > 0)
								{
									S.AppendFormat("<td bgcolor=\"#FFFFFF\" class=\"VisForm\">{0}&nbsp;</td></tr>", afCross.Tables[0].Rows[0][0]);
								}
								else
								{
									S.Append("<td bgcolor=\"#FFFFFF\" class=\"VisForm\">&nbsp;</td></tr>");
								}

								afCross.Clear();
							}
						}
						S.Append("</table>");
						ViewFreeFields.Text = S.ToString();
					}


					if (DataBinder.Eval((DataRowView) e.Item.DataItem, "FromLead") != DBNull.Value)
					{
						Literal LeadInfo = (Literal) e.Item.FindControl("LeadInfo");
						LeadInfo.Text = "<img src=/i/lookup.gif alt=\"" + rm.GetString("Ledtxt28") + "\" style=\"CURSOR:pointer\" onclick=\"CreateBox('/Common/LeadInfo.aspx?render=no&si=31&id=" + Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "FromLead")) + "',event,380,350)\">";
					}


					LinkButton ModCon = (LinkButton) e.Item.FindControl("ModCon");
					ModCon.Text = rm.GetString("Reftxt42");

					LinkButton BackToSearch = (LinkButton) e.Item.FindControl("BackToSearch");
					BackToSearch.Text = rm.GetString("CRMrubtxt6");


					LinkButton PrintButton = (LinkButton) e.Item.FindControl("PrintButton");
					PrintButton.Text = "<img src=/i/printer.gif border=0>";
					PrintButton.Attributes.Add("onclick", "window.open('/report/htmlreport.aspx');");

					Session["report"] = null;
					ArrayList report = new ArrayList();
					CompanyReport cr = new CompanyReport();
					cr.idfield = Convert.ToInt32(DatabaseConnection.SqlScalartoObj("select id from qb_customerquery where title='Fixed2'")); //ex 42;
					Hashtable HtParams = new Hashtable();
					HtParams.Add("ID", Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "id")));
					cr.Params = HtParams;
					cr.Finalize = true;
					cr.Type = 0;
					cr.itemPage = 10;
					report.Add(cr);
					Session["report"] = report;

					FillRepeaterActivity(Convert.ToInt32(DataBinder.Eval((DataRowView) e.Item.DataItem, "id")));
					Session["review"] = "0";
					FillFileRep(Convert.ToInt32(DataBinder.Eval((DataRowView) e.Item.DataItem, "id")));
					string azPhone = Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "AzPhone"));
					if (azPhone.Length > 0)
					{
						Literal AZph = (Literal) e.Item.FindControl("CompanyPhone");
						AZph.Text = azPhone;
					}

					Literal Title = (Literal) e.Item.FindControl("Title");
					Title.Text = (Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Title")).Length > 0) ? Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Title")) + "&nbsp;" : "";

					LinkButton CompanyLink = (LinkButton) e.Item.FindControl("CompanyLink");
					CompanyLink.Text = Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName2"));

					LinkButton CompanyContacts = (LinkButton) e.Item.FindControl("CompanyContacts");
					CompanyContacts.Text = rm.GetString("Reftxt55");
					CompanyContacts.Visible = (CompanyLink.Text.Length > 0);

					if (Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Categories")).Length > 0)
					{
						string[] cats = ((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "Categories")).Split('|');
						string queryCat = String.Empty;
						foreach (string ca in cats)
						{
							if (ca.Length > 0) queryCat += " id=" + int.Parse(ca) + " or ";
						}
						queryCat = queryCat.Substring(0, queryCat.Length - 4);
						Repeater RepCategoriesView = (Repeater) e.Item.FindControl("RepCategoriesView");
						RepCategoriesView.DataSource = DatabaseConnection.CreateDataset("select Description from CRM_ReferrerCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + ")) and (" + queryCat + ")");
						RepCategoriesView.DataBind();
					}


					LinkButton BtnMailAuth = (LinkButton) e.Item.FindControl("BtnMailAuth");
					BtnMailAuth.Text = "<img src=/images/email.gif alt='" + rm.GetString("Bcotxt55") + "' border=0>";

					BtnMailAuth.Visible = !(bool) DataBinder.Eval((DataRowView) e.Item.DataItem, "MLFlag");

					Literal Sexlbl = (Literal) e.Item.FindControl("Sexlbl");

					if (DataBinder.Eval((DataRowView) e.Item.DataItem, "Sex") == DBNull.Value)
						Sexlbl.Text = rm.GetString("Bcotxt60");
					else if ((bool) DataBinder.Eval((DataRowView) e.Item.DataItem, "Sex"))
						Sexlbl.Text = "M";
					else
						Sexlbl.Text = "F";

					Literal VoipCallPhone_1 = (Literal) e.Item.FindControl("VoipCallPhone_1");
					Literal VoipCallPhone_2 = (Literal) e.Item.FindControl("VoipCallPhone_2");
					Literal VoipCallMobilePhone_1 = (Literal) e.Item.FindControl("VoipCallMobilePhone_1");
					Literal VoipCallMobilePhone_2 = (Literal) e.Item.FindControl("VoipCallMobilePhone_2");

						if ((DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE_1")).ToString().Length > 0)
						{
							string ph = StaticFunctions.FixPhoneNumber((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE_1"));
							VoipCallPhone_1.Text = MakeVoipString(ph);
						}
						if ((DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE_2")).ToString().Length > 0)
						{
							string ph = StaticFunctions.FixPhoneNumber((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE_2"));
							VoipCallPhone_2.Text = MakeVoipString(ph);
						}
						if ((DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone_1")).ToString().Length > 0)
						{
							string ph = StaticFunctions.FixPhoneNumber((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone_1"));
							VoipCallMobilePhone_1.Text = MakeVoipString(ph);
						}
						if ((DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone_2")).ToString().Length > 0)
						{
							string ph = StaticFunctions.FixPhoneNumber((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone_2"));
							VoipCallMobilePhone_2.Text = MakeVoipString(ph);
						}


					Literal BirthDay = (Literal) e.Item.FindControl("BirthDay");
					string birth = (DataBinder.Eval((DataRowView) e.Item.DataItem, "Birthday")).ToString();
					if (birth.Length > 0)
					{
						if (Convert.ToDateTime(birth).Year > 1900)
							BirthDay.Text = birth.Substring(0, 10);
						else
							BirthDay.Text = birth.Substring(0, 5);
					}
					else
						BirthDay.Text = "";
					break;
			}
		}

		public void ViewForm_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "ModCon":
					FillForm(int.Parse(((Literal) e.Item.FindControl("IdRef")).Text));

					string strScript = "<SCRIPT>" + Environment.NewLine +
						"needsave('" + rm.GetString("CRMcontxt77") + "');" + Environment.NewLine +
						"</SCRIPT>";

					Page.RegisterStartupScript("anything", strScript);

					SubmitRef.Attributes.Add("onclick", "needsave('no')");
					Submit2.Attributes.Add("onclick", "needsave('no')");
					RefreshRepCategories.Attributes.Add("onclick", "needsave('no')");

					ViewForm.Visible = false;
					Repeater1.Visible = false;
					ReferenceForm.Visible = true;
					tdTab2.Style.Add("display", "none");
					tdTab3.Style.Add("display", "none");
					SheetP.Visible = false;
					break;
				case "CompanyContacts":
					Literal CompanyIdForLinkC = (Literal) e.Item.FindControl("CompanyIdForLink");
					SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[] {CompanyIdForLinkC.Text, "c"});
					Response.Redirect("/crm/crm_companies.aspx?m=25&si=29&gb=1");
					break;
				case "CompanyLink":
					Literal CompanyIdForLink = (Literal) e.Item.FindControl("CompanyIdForLink");
					SetGoBack("/crm/base_contacts.aspx?m=25&si=31&gb=1", new string[] {CompanyIdForLink.Text, "|d|"});
					Response.Redirect("/crm/crm_companies.aspx?m=25&si=29&gb=1");
					break;
				case "BackToSearch":
					tabControl.Visible = false;
					Repeater1.Visible = true;

					break;
				case "BtnMailAuth":
					TemplateAdmin ta = new TemplateAdmin();
					ta.TemplateName = "MailAuthContacts";
					ta.Language = UC.CultureSpecific;
					ta.ApplicationPath = Request.PhysicalApplicationPath;
					string template = ta.GetTemplate();
					if (template == "0" || template == "1")
					{
						Page.RegisterStartupScript("", "<script>alert('" + rm.GetString("Bcotxt58") + "');</script>");
					}
					else
					{
						Guid gu = Guid.NewGuid();
						template = template.Replace("[guid]", gu.ToString());
						template = template.Replace("[Tustena.Account]", UC.UserRealName);
						template = template.Replace("[Tustena.CompanyName]", DatabaseConnection.SqlScalar("select companyname from Tustena_Data"));
						template = template.Replace("[Tustena.Email]", ((Literal) e.Item.FindControl("LtrEmail")).Text);
						DatabaseConnection.DoCommand("insert into ml_auth (id,tableid,fieldid) values ('" + gu.ToString() + "',1," + ((Literal) e.Item.FindControl("IdRef")).Text + ")");
						MessagesHandler.SendMail(((Literal) e.Item.FindControl("LtrEmail")).Text, UC.MailingAddress,
						         "[Tustena] " + rm.GetString("Bcotxt56"), template);
						Page.RegisterStartupScript("", "<script>alert('" + rm.GetString("Bcotxt57") + "');</script>");
					}
					break;
			}
		}


		private void FillForm(int id)
		{
			DataSet ds;
			DataRow myDataRow;
			string sqlString;
			sqlString = "SELECT Base_Contacts.*, Base_Companies.CompanyName AS CompanyName2 ";
			sqlString += "FROM Base_Contacts LEFT OUTER JOIN Base_Companies ON Base_Contacts.CompanyID = Base_Companies.ID ";
			sqlString += "where Base_Contacts.id=" + id;
			ds = DatabaseConnection.CreateDataset(sqlString);
			if (ds.Tables[0].Rows.Count > 0)
			{
				myDataRow = ds.Tables[0].Rows[0];

				Referring_ID.Text = myDataRow["Id"].ToString();
				Referring_Name.Text = myDataRow["Name"].ToString();
				Referring_Surname.Text = myDataRow["Surname"].ToString();
				Referring_Title.Text = myDataRow["Title"].ToString();
				Referring_Address_1.Text = myDataRow["Address_1"].ToString();
				Referring_Address_2.Text = myDataRow["Address_2"].ToString();
				Referring_City_1.Text = myDataRow["City_1"].ToString();
				Referring_City_2.Text = myDataRow["City_2"].ToString();
				Referring_Province_1.Text = myDataRow["Province_1"].ToString();
				Referring_Province_2.Text = myDataRow["Province_2"].ToString();
				Referring_ZIPCode_1.Text = myDataRow["ZIPCode_1"].ToString();
				Referring_ZIPCode_2.Text = myDataRow["ZIPCode_2"].ToString();
				Referring_State_1.Text = myDataRow["State_1"].ToString();
				Referring_State_2.Text = myDataRow["State_2"].ToString();
				Referring_VatID.Text = myDataRow["VatID"].ToString();
				Referring_TaxIdentificationNumber.Text = myDataRow["TaxIdentificationNumber"].ToString();
				Referring_EMail.Text = myDataRow["EMail"].ToString();
				Referring_Phone_1.Text = myDataRow["Phone_1"].ToString();
				Referring_Phone_2.Text = myDataRow["Phone_2"].ToString();
				Referring_Fax.Text = myDataRow["Fax"].ToString();
				Referring_MobilePhone_1.Text = myDataRow["MobilePhone_1"].ToString();
				Referring_MobilePhone_2.Text = myDataRow["MobilePhone_2"].ToString();
				Referring_BusinessRole.Text = myDataRow["BusinessRole"].ToString();
				Referring_Notes.Text = myDataRow["Notes"].ToString();
				Groups.SetGroups(myDataRow["Groups"].ToString());
				if (myDataRow["Birthday"].ToString().Length > 0)
				{
					if (Convert.ToDateTime(myDataRow["Birthday"]).Year > 1900)
						Referring_BirthDay.Text = myDataRow["Birthday"].ToString().Substring(0, 10);
					else
						Referring_BirthDay.Text = myDataRow["Birthday"].ToString().Substring(0, 5);
				}
				else
					Referring_BirthDay.Text = "";

				Referring_BirthPlace.Text = myDataRow["BirthPlace"].ToString();
				Referring_Categories.Text = myDataRow["Categories"].ToString();
				Referring_MLEmail.Text = myDataRow["MLEmail"].ToString();
				Referring_MLFlag.Checked = (bool) myDataRow["MLFlag"];
				if (myDataRow["Sex"] != DBNull.Value)
					if ((bool) myDataRow["Sex"])
						Referring_Sex.Items[0].Selected = true;
					else
						Referring_Sex.Items[1].Selected = true;
				Referring_CompanyTX.Text = myDataRow["CompanyName2"].ToString();
				Referring_CompanyID.Text = myDataRow["CompanyID"].ToString();
				switch (Convert.ToInt16(myDataRow["FlagGlobalORPersonal"]))
				{
					case 0:
						Personal.Checked = false;
						Global.Checked = false;
						break;
					case 1:
						Personal.Checked = false;
						Global.Checked = true;
						break;
					case 2:
						Personal.Checked = true;
						Global.Checked = false;
						break;
				}

				FillRepCategories();
				CheckFreeFields(id);
				AddKeepAlive();
			}
			else
				HackLock("Rubrica:" + UC.UserId + ">" + id);

		}


		private void ModifyForm(int id)
		{
			using (DigiDapter dg = new DigiDapter("select id from Base_Contacts where id=" + id))
			{
				if (!dg.HasRows)
				{
					dg.Add("OwnerID", UC.UserId, 'I');
				}

				dg.Add("CompanyID", (Referring_CompanyID.Text.Length > 0) ? int.Parse(Referring_CompanyID.Text) : 0);
				dg.Add("Name", Referring_Name.Text);
				dg.Add("Surname", Referring_Surname.Text);
				dg.Add("Title", Referring_Title.Text);
				dg.Add("Address_1", Referring_Address_1.Text);
				dg.Add("Address_2", Referring_Address_2.Text);
				dg.Add("City_1", Referring_City_1.Text);
				dg.Add("City_2", Referring_City_2.Text);
				dg.Add("Province_1", Referring_Province_1.Text);
				dg.Add("Province_2", Referring_Province_2.Text);
				dg.Add("ZIPCode_1", Referring_ZIPCode_1.Text);
				dg.Add("ZIPCode_2", Referring_ZIPCode_2.Text);
				dg.Add("State_1", Referring_State_1.Text);
				dg.Add("State_2", Referring_State_2.Text);
				dg.Add("VatID", Referring_VatID.Text);
				dg.Add("TaxIdentificationNumber", Referring_TaxIdentificationNumber.Text);
				dg.Add("EMail", Referring_EMail.Text);
				dg.Add("Phone_1", Referring_Phone_1.Text);
				dg.Add("Phone_2", Referring_Phone_2.Text);
				dg.Add("Fax", Referring_Fax.Text);
				dg.Add("MobilePhone_1", Referring_MobilePhone_1.Text);
				dg.Add("MobilePhone_2", Referring_MobilePhone_2.Text);
				dg.Add("BusinessRole", Referring_BusinessRole.Text);
				dg.Add("Notes", Referring_Notes.Text, false);
				if (Referring_BirthDay.Text.Length > 0)
					try
					{
						if (Referring_BirthDay.Text.Length == 10)
						{
							DateTime birth = Convert.ToDateTime(Referring_BirthDay.Text, UC.myDTFI);
							if (birth >= new DateTime(1753, 1, 1) && birth <= new DateTime(9999, 12, 31))
								dg.Add("Birthday", birth);
						}
						else
						{
							if (Referring_BirthDay.Text.Length == 5) Referring_BirthDay.Text += "/1900";
							if (Referring_BirthDay.Text.Length == 6) Referring_BirthDay.Text += "1900";
							DateTime birth = Convert.ToDateTime(Referring_BirthDay.Text, UC.myDTFI);
							if (birth >= new DateTime(1753, 1, 1) && birth <= new DateTime(9999, 12, 31))
								dg.Add("Birthday", birth);
						}
					}
					catch
					{
					}
				dg.Add("BirthPlace", Referring_BirthPlace.Text);
				StringBuilder cat = new StringBuilder("|");
				foreach (RepeaterItem it in RepCategories.Items)
				{
					CheckBox Check = (CheckBox) it.FindControl("Check");
					if (Check.Checked)
						cat.AppendFormat("{0}|", ((Literal) it.FindControl("IDCat")).Text);
				}
				if (cat.Length > 1)
					dg.Add("Categories", cat.ToString());
				else
					dg.Add("Categories", DBNull.Value);

				if (Groups.GetValue.Length > 0)
					dg.Add("Groups", Groups.GetValue);
				else
					dg.Add("Groups", "|" + UC.UserGroupId.ToString() + "|");

				dg.Add("MLEmail", Referring_MLEmail.Text);
				dg.Add("MLFlag", Referring_MLFlag.Checked);
				RadioButtonList Sex = Referring_Sex;
				if (Sex.Items[0].Selected || Sex.Items[1].Selected)
					if (Sex.Items[0].Selected)
						dg.Add("Sex", true);
					else
						dg.Add("Sex", false);
				dg.Add("CreatedById", UC.UserId);

				int globpers = 0;
				if (Global.Checked && !Personal.Checked) globpers = 1;
				if (!Global.Checked && Personal.Checked) globpers = 2;
				dg.Add("FlagGlobalORPersonal", globpers);

				if (dg.HasRows)
				{
					dg.Add("Lastactivity", 1); //MODIFICA
					dg.Add("LastmodifiedDate", DateTime.UtcNow);
					dg.Add("LastmodifiedByID", UC.UserId);
				}

				object newId = dg.Execute("Base_Contacts", "ID=" + id, DigiDapter.Identities.Identity);

				if (id == -1)
				{
					int newIdInt = int.Parse(newId.ToString());
					FillFreeFields(newIdInt);
					DatabaseConnection.CommitTransaction();
					FillView(newIdInt);
				}
				else
				{
					FillFreeFields(id);
					DatabaseConnection.CommitTransaction();
					FillView(id);
				}
				tdTab2.Visible = true;
				tdTab3.Visible = true;
			} // il dispose distrugge oggetto e chiude le connessioni
			Tab1Text.Text = "&nbsp;<span class=\"normal Mul\" onclick=\"ViewHideTabs('visContact');\">&nbsp;" + rm.GetString("CRMrubtxt1") + "&nbsp;</span>";
		}

		private void FillFreeFields(int id)
		{

			string sqlStringQuery;
			sqlStringQuery = "select * from addedfields where tablename=" + (byte) CRMTables.Base_Contacts + " order by vieworder";
			DataSet ds = DatabaseConnection.CreateDataset(sqlStringQuery);
			if (ds.Tables[0].Rows.Count > 0)
			{
				foreach (DataRow dr in ds.Tables[0].Rows)
				{
					if (Request.Form["Free_" + dr["name"]]!=null)
					{
						string sqlString;
						sqlString = "select id from addedfields_cross where id = " + id + " and idrif=" + dr["id"];
						using (DigiDapter dg = new DigiDapter(sqlString))
						{
								dg.Add("ID", id);
								dg.Add("IDRif", dr["id"]);

							dg.Add("FIELDVAL", Request.Form["Free_" + dr["name"]]);
							if(dg.HasRows)
								dg.Execute("addedfields_cross", "id = " + id + " and idrif=" + dr["id"]);
							else
								dg.Execute("addedfields_cross", "pkey = -1");
						}
					}
					else
					{
						DatabaseConnection.DoCommand("delete from addedfields_cross where id = " + id + " and idrif=" + dr["id"]);
					}
				}
			}

		}

		public void NewActivity_Click(Object sender, EventArgs e)
		{
			Session["AcContactID"] = Session["CurrentRefId"].ToString();
			switch (((LinkButton) sender).ID)
			{
				case "NewActivityPhone":
					Session["AType"] = 1;
					break;
				case "NewActivityLetter":
					Session["AType"] = 2;
					break;
				case "NewActivityFax":
					Session["AType"] = 3;
					break;
				case "NewActivityMemo":
					Session["AType"] = 4;
					break;
				case "NewActivityEmail":
					Session["AType"] = 5;
					break;
				case "NewActivityVisit":
					Session["AType"] = 6;
					break;
				case "NewActivityGeneric":
					Session["AType"] = 7;
					break;
				case "NewActivitySolution":
					Session["AType"] = 8;
					break;
			}
			Response.Redirect("/WorkingCRM/AllActivity.aspx?m=25&si=38");
		}

		public void btn_Click(Object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "NewDoc":
					SetGoBack("/crm/base_contacts.aspx?m=25&si=31&gb=1", new string[2] {Session["CurrentRefId"].ToString(), "d"});
					Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=r");
					break;
				case "RefreshRepCategories":
					FillRepCategories();
					Page.RegisterClientScriptBlock("initJS", "<script>g_fFieldsChanged=1;</script>");
					break;
			}
		}


		public void RapSubmit_Click(Object sender, EventArgs e)
		{
			if (RapRagSoc.Text.Length > 0)
			{
				using (DigiDapter dg = new DigiDapter())
				{
					dg.Add("CreatedByID", UC.UserId);

					dg.Add("CompanyName", RapRagSoc.Text);
					dg.Add("Phone", RapPhone.Text);
					dg.Add("EMail", RapEmail.Text.Trim(' '));
					dg.Add("OwnerID", UC.UserId);
					dg.Add("Groups", "|" + UC.AdminGroupId + "|" + UC.UserGroupId + "|");

					object newId = dg.Execute("Base_Companies", "ID=-1", DigiDapter.Identities.Identity);

					SetGoBack("/crm/crm_companies.aspx?m=25&si=29&gb=1", new string[2] {newId.ToString(), "d"});
					RapInfo.Text = "\"<a href=/crm/crm_companies.aspx?m=25&si=29&gb=1><span class=divautoformRequired>" + RapRagSoc.Text + "</span></a>\" " + rm.GetString("Bcotxt43");
					RapRagSoc.Text = String.Empty;
					RapPhone.Text = String.Empty;
					RapEmail.Text = String.Empty;

				}
			}
			else
			{
				RapInfo.Text = rm.GetString("Bcotxt48");
			}
		}


		private void FillRepeaterActivity(int refID)
		{
			AcCrono.ParentID = refID;
			AcCrono.OpportunityID = 0;
			AcCrono.AcType = (byte) AType.Contacts;


			AcCrono.FromSheet = "c";
			AcCrono.Refresh();

			if (AcCrono.ItemCount > 0)
				AcCrono.Visible = true;
			else
			{
				AcCrono.Visible = false;
				RepeaterActivityInfo.Text = rm.GetString("CRMcontxt24");
			}
		}


		public void FileRepCommand(object source, RepeaterCommandEventArgs e)
		{
			Trace.Warn(e.CommandName);
			Literal FileId = (Literal) e.Item.FindControl("FileId");
			switch (e.CommandName)
			{
				case "Down":

					DataSet ds = DatabaseConnection.CreateDataset("select * from filemanager where id=" + int.Parse(FileId.Text));


					string filename;
					filename = ConfigSettings.DataStoragePath + Path.DirectorySeparatorChar + ds.Tables[0].Rows[0]["guid"];
					string realFileName = ds.Tables[0].Rows[0]["filename"].ToString();
					string downFile = filename + Path.GetExtension(realFileName);
					if (File.Exists(downFile))
					{
						Response.AddHeader("Content-Disposition", "attachment; filename=" + realFileName);
						Response.ContentType = "application/octet-stream";
						Response.TransmitFile(downFile);
						Response.Flush();
						Response.End();
						return;
					}
					else if (File.Exists(filename))
					{
						File.Move(filename, downFile);
						Response.AddHeader("Content-Disposition", "attachment; filename=" + realFileName);
						Response.ContentType = "application/octet-stream";
						Response.TransmitFile(downFile);
						Response.Flush();
						Response.End();
						return;
					}
					else
					{
						G.SendError("File lost", downFile);
					}


					break;
				case "Modify":
				case "Revision":
					Session["IdDoc"] = FileId.Text;
					SetGoBack("/crm/base_contacts.aspx?m=25&si=31&gb=1", new string[2] {Session["CurrentRefId"].ToString(), "d"});
					if (e.CommandName == "Modify")
						Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=m");
					else
						Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=e");
					break;
				case "ReviewNumber":
					Session["review"] = "1";

					int fileId = int.Parse(((Literal) e.Item.FindControl("FileId")).Text);

					string sqlString = "select filemanager.*, filescategories.description as catdesc,(Account.Name+' '+Account.Surname) as owner from filemanager ";
					sqlString += "left outer join filescategories on filemanager.type=filescategories.id ";
					sqlString += "left outer join Account on filemanager.OwnerID=Account.uid ";
					sqlString += "where (filemanager.ownerid=" + UC.UserId + " or " + GroupsSecure("FileManager.Groups") + ") ";
					sqlString += "and (filemanager.id=" + fileId + " or filemanager.IsReview=" + fileId + ") ";
					sqlString += "order by ReviewNumber desc";

					FileRep.DataSource = DatabaseConnection.CreateDataset(sqlString);
					FileRep.DataBind();
					break;
			}
		}

		public void FileRepDatabound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton Mod = (LinkButton) e.Item.FindControl("Modify");
					Mod.Text = rm.GetString("Dsttxt16");
					LinkButton Rev = (LinkButton) e.Item.FindControl("Revision");
					Rev.Text = rm.GetString("Dsttxt13");

					LinkButton RN = (LinkButton) e.Item.FindControl("ReviewNumber");
					Literal LRN = (Literal) e.Item.FindControl("LbReviewNumber");

					if (Session["review"].ToString() == "0")
					{
						RN.Visible = (RN.Text != "0");
						Rev.Visible = true;
						LRN.Visible = false;
					}
					else
					{
						RN.Visible = false;
						Rev.Visible = false;
						LRN.Visible = (LRN.Text != "0");
					}

					LinkButton Down = (LinkButton) e.Item.FindControl("Down");
					string ext = Path.GetExtension(Down.Text);
					Image FileImg = (Image) e.Item.FindControl("FileImg");
					FileImg.ImageUrl = FileFunctions.GetFileImg(ext);
					break;
			}
		}


		public void FillFileRep(int id)
		{
			string sqlString = "select filemanager.*, filescategories.description as catdesc,(Account.Name+' '+Account.Surname) as owner from filemanager ";
			sqlString += "left outer join filescategories on filemanager.type=filescategories.id ";
			sqlString += "left outer join FileCrossTables on filemanager.id=FileCrossTables.IDFile ";
			sqlString += "left outer join Account on filemanager.OwnerID=Account.uid ";
			sqlString += "where IsReview=0 and FileCrossTables.TableName='Base_Contacts' and FileCrossTables.IDRif=" + id;

			FileRep.DataSource = DatabaseConnection.CreateDataset(sqlString);
			FileRep.DataBind();
			if (FileRep.Items.Count > 0)
			{
				FileRepInfo.Visible = false;
				FileRep.Visible = true;
			}
			else
			{
				FileRepInfo.Visible = true;
				FileRep.Visible = false;
				FileRepInfo.Text = rm.GetString("CRMcontxt61");
			}
		}

		private void CheckFreeFields(int id)
		{
			string query = GroupsSecure("groups");
			if (query.Length == 0)
				query = " groups like '%|" + UC.UserGroupId + "|%'";

			string sqlString;
			sqlString = "select * from addedfields where tablename=" + (byte) CRMTables.Base_Contacts + " and (" + query + ") order by vieworder";

			DataSet ds = DatabaseConnection.CreateDataset(sqlString);
			if (ds.Tables[0].Rows.Count > 0)
			{
				StringBuilder S = new StringBuilder();
				S.AppendFormat("<table width=\"100%\"><tr><td class=\"normal Bbot\"><br><b>{0}</b></td></tr></table>", rm.GetString("Bcotxt50"));
				S.Append("<table width=\"45%\" class=\"normal\">");
				foreach (DataRow dr in ds.Tables[0].Rows)
				{
					S.Append(FreeFieldType(dr["type"].ToString(), dr["name"].ToString(), int.Parse(dr["id"].ToString()), id, dr["Items"].ToString()));
				}
				S.Append("</table>");
				FreeFields.Text = S.ToString();
			}
		}


		public string FreeFieldType(string type, string name, int did, int id, string items)
		{
			StringBuilder S = new StringBuilder();
			string pf = String.Empty;
			string pfv = String.Empty;
			bool isParentCrossed = false;
			DataSet Q = DatabaseConnection.CreateDataset("select ParentField,ParentFieldValue from AddedFields where id=" + did);
			pf = Q.Tables[0].Rows[0][0].ToString();
			pfv = Q.Tables[0].Rows[0][1].ToString();
			if (pf.Length > 0 && id != -1)
			{
				IDataReader sqlDr = DatabaseConnection.CreateReader("select " + pf + " from Base_Contacts where id=" + Session["CurrentRefId"].ToString());
				sqlDr.Read();
				Trace.Warn("PF-PFV", pf + "-" + pfv);
				isParentCrossed = (sqlDr[0].ToString() == pfv);
				Trace.Warn("IsParentCrossed", isParentCrossed.ToString());
				sqlDr.Close();
			}

			if (pf.Length > 0)
			{
				if (isParentCrossed)
					S.AppendFormat("<tr ParentField=\"{1}\" ParentFieldValue=\"{2}\"><td width=\"40%\">{0}</td>", name, pf, pfv);
				else
					S.AppendFormat("<tr ParentField=\"{1}\" ParentFieldValue=\"{2}\" style=\"display:none;\"><td width=\"40%\">{0}</td>", name, pf, pfv);
			}
			else
				S.AppendFormat("<tr><td width=\"40%\">{0}</td>", name);
			switch (type)
			{
				case "1":
				case "2":
				case "3":
					if (id != -1)
					{
						DataSet afCross = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + did + " and id=" + id);
						if (afCross.Tables[0].Rows.Count > 0)
						{
							S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\" value=\"{1}\"></td></tr>", name, afCross.Tables[0].Rows[0][0]);
						}
						else
						{
							S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\"></td></tr>", name);
						}
						afCross.Clear();
					}
					else
					{
						S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\"></td></tr>", name);
					}
					break;
				case "4":
					string[] it = items.Split('|');
					DataSet afCrossS = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + did + " and id=" + id);
					S.AppendFormat("<td><select old=true name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\">", name);

					foreach (string op in it)
					{
						try
						{
							if (op == afCrossS.Tables[0].Rows[0][0].ToString())
							{
								if (op.Length > 0) S.AppendFormat("<option selected>{0}</option>", op);
							}
							else
							{
								if (op.Length > 0) S.AppendFormat("<option>{0}</option>", op);
							}
						}
						catch
						{
							if (op.Length > 0) S.AppendFormat("<option>{0}</option>", op);
						}
					}
					S.Append("</select></td></tr>");
					break;
			}
			return S.ToString();
		}

		private void FillRepCategories()
		{
			DataTable dt;
			dt = DatabaseConnection.CreateDataset("select id,Description,'0' as tocheck from CRM_ReferrerCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + ")) order by FlagPersonal desc").Tables[0];
			if (dt.Rows.Count > 0)
			{
				foreach (DataRow dr in dt.Rows)
				{
					if (Referring_Categories.Text.IndexOf("|" + dr["id"].ToString() + "|") > -1)
						dr["tocheck"] = "1";
				}
			}
			RepCategories.DataSource = new DataView(dt, "", "tocheck desc", DataViewRowState.CurrentRows);

			RepCategories.DataBind();
		}

		public void RepCategories_DataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Literal IDCat = (Literal) e.Item.FindControl("IDCat");
					if (Referring_Categories.Text.IndexOf("|" + IDCat.Text + "|") > -1)
					{
						CheckBox Check = (CheckBox) e.Item.FindControl("Check");
						Check.Checked = true;
					}

					DataSet ds = DatabaseConnection.CreateDataset("select id from Base_Contacts where Categories like '%|" + IDCat.Text + "|%'");
					if (ds.Tables[0].Rows.Count < 1)
					{
						LinkButton DeleteCat = (LinkButton) e.Item.FindControl("DeleteCat");
						DeleteCat.Text = "<img src='/i/erase.gif' border=0 alt='" + rm.GetString("CRMcontxt49") + "'>";
						DeleteCat.Attributes.Add("onclick", "g_fFieldsChanged=0;return confirm('" + rm.GetString("CRMcontxt50") + "');");
					}
					break;
			}
		}

		public void RepCategories_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "DeleteCat":
					string count = "select count(*) from Base_Contacts where Categories like '|" + ((Literal) e.Item.FindControl("IDCat")).Text + "|'";

					int empty = (int) DatabaseConnection.SqlScalartoObj(count);

					if (empty < 1)
					{
						string sqlString = "delete from CRM_ReferrerCategories where ID =" + int.Parse(((Literal) e.Item.FindControl("IDCat")).Text);
						DatabaseConnection.DoCommand(sqlString);
					}
					FillRepCategories();
					Page.RegisterClientScriptBlock("xxx", "<script>g_fFieldsChanged=1;</script>");
					break;
			}
		}

		public bool NoLength(string tx)
		{
			return false;
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.SheetP.NextClick += new EventHandler(SheetP_NextClick);
			this.SheetP.PrevClick += new EventHandler(SheetP_PrevClick);
			this.BtnNew.Click += new EventHandler(this.NewContact);
			this.BtnSearch.Click += new EventHandler(this.BtnSearch_Click);
			this.BtnGroup.Click += new EventHandler(this.BtnSearch_Click);
			this.RapSubmit.Click += new EventHandler(this.RapSubmit_Click);
			this.SubmitRef.Click += new EventHandler(this.ReferenceFormSubmit);
			this.RefreshRepCategories.Click += new EventHandler(this.btn_Click);
			this.Submit2.Click += new EventHandler(this.ReferenceFormSubmit);
			this.NewActivityPhone.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityLetter.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityFax.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityMemo.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityEmail.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityVisit.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityGeneric.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivitySolution.Click += new EventHandler(this.NewActivity_Click);
			this.NewDoc.Click += new EventHandler(this.btn_Click);
			this.Repeater1.ItemCommand += new RepeaterCommandEventHandler(this.Repeater1_Command);
			this.ViewForm.ItemCommand += new RepeaterCommandEventHandler(this.ViewForm_Command);
			this.RepCategories.ItemCommand += new RepeaterCommandEventHandler(this.RepCategories_Command);
			this.FileRep.ItemCommand += new RepeaterCommandEventHandler(this.FileRepCommand);
			this.Repeater1.ItemDataBound += new RepeaterItemEventHandler(this.Repeater1_ItemDataBound);
			this.ViewForm.ItemDataBound += new RepeaterItemEventHandler(this.ViewFormOnItemDatabound);
			this.RepCategories.ItemDataBound += new RepeaterItemEventHandler(this.RepCategories_DataBound);
			this.FileRep.ItemDataBound += new RepeaterItemEventHandler(this.FileRepDatabound);

		}

		#endregion

		private void InitSheetPaging(string sqlString)
		{
			DataTable dt = DatabaseConnection.CreateDataset(sqlString).Tables[0];
			string[] myarray = new string[dt.Rows.Count];
			if (dt.Rows.Count > 0)
			{
				for (int i = 0; i < dt.Rows.Count; i++)
				{
					myarray[i] = dt.Rows[i]["ID"] + "|" + dt.Rows[i]["Surname"] + " " + dt.Rows[i]["Name"];
				}
			}

			SheetP.IDArray = myarray;
		}

		private void SheetP_NextClick(object sender, EventArgs e)
		{
			FillView(this.SheetP.GetCurrentID);
		}

		private void SheetP_PrevClick(object sender, EventArgs e)
		{
			FillView(this.SheetP.GetCurrentID);
		}
	}
}

