/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>


using System;
using System.Data;

using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Base;
using Digita.Tustena.Common;
using Digita.Tustena.Database;

namespace Digita.Tustena
{
	public class Messages : G
	{
		protected Repeater RepMessagges;
		protected RepeaterPaging Repeaterpaging1;
		protected Repeater RepMessagesSent;
		protected RepeaterPaging Repeaterpaging2;
		protected Literal SomeJS;
		protected Label RepMessagesInfo;
		protected LinkButton Deletebtn;
		protected LinkButton ViewMessagesRicevuti;
		protected LinkButton ViewMessagesInviati;
		protected Literal HeaderMessages;

		protected LinkButton DelChecked;
		protected LinkButton DeleteAllSent;
		protected LinkButton DeleteAllReceived;
		private int messageToOpen=0;

		#region Web Form Designer generated code

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.ViewMessagesRicevuti.Click += new EventHandler(this.ViewMessages_Click);
			this.ViewMessagesInviati.Click += new EventHandler(this.ViewMessages_Click);
			this.DelChecked.Click += new EventHandler(this.DelChecked_Click);
			this.RepMessagges.ItemCommand += new RepeaterCommandEventHandler(this.ItemCommandRep);
			this.RepMessagesSent.ItemCommand += new RepeaterCommandEventHandler(this.ItemCommandRepInviati);
			this.RepMessagges.ItemDataBound += new RepeaterItemEventHandler(this.ItemDataBound_Repeater);
			this.RepMessagesSent.ItemDataBound += new RepeaterItemEventHandler(this.ItemDataBound_RepeaterInviati);
			this.DeleteAllSent.Click+=new EventHandler(DeleteAllSent_Click);
			this.DeleteAllReceived.Click+=new EventHandler(DeleteAllReceived_Click);
		}

		#endregion

		public void DelChecked_Click(object sender, EventArgs e)
		{
			DeleteChecked.Delete(RepMessagges,"IDMess","DelCheck","Base_Messages");
			DeleteChecked.Delete(RepMessagesSent,"IDMess","DelCheck","Base_Messages");

			if (RepMessagges.Visible)
				FillRep();
			else
				FillRepInviati();
		}


		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				DeleteGoBack();
				this.Repeaterpaging1.Visible=false;
				this.Repeaterpaging2.Visible=false;


				if (!Page.IsPostBack)
				{
					this.DeleteAllSent.Text = rm.GetString("Mestxt17");
					this.DeleteAllReceived.Text = rm.GetString("Mestxt16");
					DelChecked.Text = rm.GetString("Mestxt15");
					ViewMessagesRicevuti.Text = rm.GetString("Mestxt13");
					ViewMessagesInviati.Text = rm.GetString("Mestxt14");
					if (Request.QueryString["r"] == "1" || Request.QueryString["r"] == null)
					{
						HeaderMessages.Text = "<span class=\"divautoform\"><b>" + rm.GetString("Mestxt13").ToUpper() + "</b></span>";

						FillRep();
					}
					else
					{
						HeaderMessages.Text = "<span class=\"divautoform\"><b>" + rm.GetString("Mestxt14").ToUpper() + "</b></span>";

						FillRepInviati();

					}
				}

			}
		}

		public void ViewMessages_Click(object sender, EventArgs e)
		{
			if (((LinkButton) sender).ID == "ViewMessagesRicevuti")
			{
				FillRep();
				HeaderMessages.Text = "<span class=\"divautoform\"><b>" + rm.GetString("Mestxt13").ToUpper() + "<br></b></span>";
			}
			else
			{
				FillRepInviati();
				HeaderMessages.Text = "<span class=\"divautoform\"><b>" + rm.GetString("Mestxt14").ToUpper() + "<br></b></span>";
			}
		}

		private void FillRep()
		{
			RepMessagges.Visible = true;
			RepMessagesSent.Visible = false;
			RepMessagesInfo.Text = String.Empty;

			StringBuilder sqlString = new StringBuilder();

			sqlString.Append("select *, (Account.Surname + ' ' + Account.Name) AS UserName ");
			sqlString.Append("FROM Base_Messages INNER JOIN Account ON Base_Messages.FromAccount = Account.UID ");
			sqlString.AppendFormat("where ToAccount={0} and InOut=0 order by Base_Messages.CreatedDate desc", UC.UserId.ToString());

			Repeaterpaging1.PageSize = UC.PagingSize;
			Repeaterpaging1.RepeaterObj = this.RepMessagges;
			Repeaterpaging1.sqlRepeater = sqlString.ToString();
			Repeaterpaging1.CurrentPage=0;
			Repeaterpaging1.BuildGrid();

			if (RepMessagges.Items.Count == 0)
			{
				RepMessagesInfo.Text = rm.GetString("Mestxt3");
				RepMessagesInfo.Visible = true;
				RepMessagges.Visible = false;
			}

			DeleteAllSent.Visible=false;
			DeleteAllReceived.Visible=true;
		}

		private void FillRepInviati()
		{
			RepMessagesSent.Visible = true;
			RepMessagges.Visible = false;
			RepMessagesInfo.Text = String.Empty;

			StringBuilder sqlString = new StringBuilder();

			sqlString.Append("select *, (Account.Surname + ' ' + Account.Name) AS UserName ");
			sqlString.Append("FROM Base_Messages INNER JOIN Account ON Base_Messages.ToAccount = Account.UID ");
			sqlString.AppendFormat("where FromAccount={0} and InOut=1 order by Base_Messages.CreatedDate desc", UC.UserId.ToString());

			Repeaterpaging2.PageSize = UC.PagingSize;
			Repeaterpaging2.RepeaterObj = this.RepMessagesSent;
			Repeaterpaging2.sqlRepeater = sqlString.ToString();
			Repeaterpaging2.CurrentPage=0;
			Repeaterpaging2.BuildGrid();

			if (RepMessagesSent.Items.Count == 0)
			{
				RepMessagesInfo.Text = rm.GetString("Mestxt3");
				RepMessagesInfo.Visible = true;
				RepMessagesSent.Visible = false;
			}
			DeleteAllSent.Visible=true;
			DeleteAllReceived.Visible=false;
		}



		public void ItemDataBound_Repeater(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton lk = (LinkButton) e.Item.FindControl("Deletebtn");
					lk.Text = rm.GetString("Mestxt9");
					lk.Attributes.Add("onclick", "return confirm('" + rm.GetString("Mestxt1") + "');");
					if (messageToOpen > 0)
					{
						if (messageToOpen == int.Parse(((Literal) e.Item.FindControl("IDMess")).Text))
						{
							Literal Mess = (Literal) e.Item.FindControl("ViewText");
							Mess.Text = "<tr><td colspan=\"5\" class=\"ListResult\" style=\"padding-top: 1px\">";
							Mess.Text += StaticFunctions.FixCarriage(((Literal) e.Item.FindControl("TextMess")).Text, false) + "</td></tr>";
						}
					}
					Literal ImgMessage = (Literal)e.Item.FindControl("ImgMessage");
					if((bool)DataBinder.Eval((DataRowView) e.Item.DataItem, "Readed"))
					{
						ImgMessage.Text="<img src=/i/buttonmessageread.gif>";
					}else
					{
						ImgMessage.Text="<img src=/i/buttonmessageunread.gif>";
					}
					break;
			}
		}

		public void ItemDataBound_RepeaterInviati(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton lk = (LinkButton) e.Item.FindControl("Deletebtn");
					lk.Text = rm.GetString("Mestxt9");
					lk.Attributes.Add("onclick", "return confirm('" + rm.GetString("Mestxt1") + "');");
					if (messageToOpen > 0)
					{
						if (messageToOpen == int.Parse(((Literal) e.Item.FindControl("IDMess")).Text))
						{
							Literal Mess = (Literal) e.Item.FindControl("ViewText");
							Mess.Text = "<tr><td colspan=\"5\" class=\"ListResult\" style=\"padding-top: 1px\">";
							Mess.Text += StaticFunctions.FixCarriage(((Literal) e.Item.FindControl("TextMess")).Text, false) + "</td></tr>";
						}
					}
					break;
			}
		}

		public void ItemCommandRep(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "Delete":
					Delete(int.Parse(((Literal) (e.Item.FindControl("IDMess"))).Text));
					FillRep();
					break;
				case "OpenMessage":
					messageToOpen=int.Parse(((Literal) (e.Item.FindControl("IDMess"))).Text);
					DatabaseConnection.DoCommand("update Base_Messages set readed=1 where id="+messageToOpen);
					FillRep();
					break;
			}
		}

		public void ItemCommandRepInviati(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "Delete":
					Delete(int.Parse(((Literal) (e.Item.FindControl("IDMess"))).Text));
					FillRepInviati();
					break;
				case "OpenMessage":
					messageToOpen=int.Parse(((Literal) (e.Item.FindControl("IDMess"))).Text);
					DatabaseConnection.DoCommand("update Base_Messages set readed=1 where id="+messageToOpen);
					FillRepInviati();
					break;
			}
		}

		private void Delete(int id)
		{
			DatabaseConnection.DoCommand("delete from Base_Messages where id="+id);
		}

		private void DeleteAllSent_Click(object sender, EventArgs e)
		{
			DatabaseConnection.DoCommand("delete from Base_Messages where InOut=1 and FromAccount=" + UC.UserId);
			this.FillRepInviati();
		}

		private void DeleteAllReceived_Click(object sender, EventArgs e)
		{
			DatabaseConnection.DoCommand("delete from Base_Messages where InOut=0 and ToAccount=" + UC.UserId);
			FillRep();
		}
	}



}
