/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data.SqlClient;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena.CRM
{
	public class NewToDo : G
	{
		protected TextBox TxtNewCatName;
		protected TextBox StartDate;
		protected TextBox ExpireDate;
		protected TextBox DateReminder;
		protected RadioButtonList Priority;
		protected LinkButton Submit;
		protected CheckBox CheckRecurrence;
		protected Literal SomeJS;
		protected DropDownList RecType;
		protected DropDownList RecMode;
		protected TextBox RecDatestart;
		protected TextBox RecDaTextFontp;
		protected TextBox RecDays;
		protected CheckBox RecWorkingDay;
		protected TextBox RecWeeks;
		protected CheckBoxList RecWeekDays;
		protected TextBox RecMonthlyDays;
		protected TextBox RecMonthlyMonths;
		protected DropDownList RecWeeklyDayPU;
		protected DropDownList recMonthDayDays;
		protected TextBox RecMonthDayMonths;
		protected TextBox RecYearDays;
		protected DropDownList RecYearlyMonths;
		protected DropDownList RecYearlyDayPU;
		protected DropDownList RecYearlyDayDays;
		protected DropDownList RecYearlyDayMonths;


			#region Codice generato da Progettazione Web Form

			protected override void OnInit(EventArgs e)
			{
				InitializeComponent();
				base.OnInit(e);
			}

			private void InitializeComponent()
			{
				this.Load += new EventHandler(this.Page_Load);
			this.Submit.Click += new EventHandler(this.Submit_Click);

			}
		#endregion

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				SomeJS.Text = "<script>opener.location = opener.location;window.close();</script>";
			}
			else
			{
				DeleteGoBack();
				if (!Page.IsPostBack)
				{
					Submit.Text = rm.GetString("Ntdtxt36");
					FillDropDownRec();
					FillRecType();
				}
			}
		}

		private void FillDropDownRec()
		{
			int i;

			for (i = 0; i < 3; i++)
			{
				ListItem lt = new ListItem();
				lt.Value = i.ToString();
				lt.Text = rm.GetString("Ntdtxt" + (2 + i).ToString());
				Priority.Items.Add(lt);
			}
			Priority.SelectedIndex = 0;

			for (i = 1; i < 7; i++)
			{
				ListItem lt = new ListItem();
				lt.Value = i.ToString();
				lt.Text = rm.GetString("Ntdtxt" + (11 + i).ToString());
				RecMode.Items.Add(lt);
			}

			for (i = 1; i < 6; i++)
			{
				ListItem lt = new ListItem();
				lt.Value = i.ToString();
				lt.Text = rm.GetString("Ntdtxt" + (26 + i).ToString());
				RecWeeklyDayPU.Items.Add(lt);
				RecYearlyDayPU.Items.Add(lt);
			}

			for (i = 8; i < 11; i++)
			{
				ListItem lt = new ListItem();
				lt.Value = i.ToString();
				lt.Text = rm.GetString("Ntdtxt" + (31 + i - 7).ToString());
				recMonthDayDays.Items.Add(lt);
				RecYearlyDayDays.Items.Add(lt);
			}


			DateTime day = new DateTime(2003, 8, 3);
			DateTime month = new DateTime(2003, 1, 1);
			for (i = 0; i < 7; i++)
			{
				ListItem lt = new ListItem();
				lt.Value = (i + 1).ToString();
				lt.Text = UC.myDTFI.GetDayName(day.AddDays(i).DayOfWeek);
				recMonthDayDays.Items.Add(lt);
				RecWeekDays.Items.Add(lt);
				RecYearlyDayDays.Items.Add(lt);
			}
			for (i = 0; i < 12; i++)
			{
				ListItem lt = new ListItem();
				lt.Value = (i + 1).ToString();
				lt.Text = UC.myDTFI.GetMonthName(month.AddMonths(i).Month);
				RecYearlyMonths.Items.Add(lt);
				RecYearlyDayMonths.Items.Add(lt);
			}
		}


		private void FillRecType()
		{
			RecType.DataTextField = "Description";
			RecType.DataValueField = "ID";
			RecType.DataSource = DatabaseConnection.CreateReader("select ID,Description from Recurrence where Standard=1 order by Standard desc;");
			RecType.DataBind();
			RecType.Items.Insert(0, rm.GetString("Ntdtxt37"));
			RecType.SelectedIndex = 0;
			RecType.Items[0].Value = "0";
			RecType.Items.Insert(1, rm.GetString("Ntdtxt38"));
			RecType.Items[1].Value = "99";
		}

		public void Submit_Click(object sender, EventArgs e)
		{
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("Description", TxtNewCatName.Text);
				dg.Add("OwnerID", UC.UserId);
				dg.Add("Priority", Priority.SelectedItem.Value);
				if (StartDate.Text.Length > 0)
				{
					dg.Add("StartDate", Convert.ToDateTime(StartDate.Text, UC.myDTFI));
				}
				if (ExpireDate.Text.Length > 0)
				{
					dg.Add("ExpirationDate", Convert.ToDateTime(ExpireDate.Text, UC.myDTFI));
				}
				if (DateReminder.Text.Length > 0)
				{
					dg.Add("ReminderDate", Convert.ToDateTime(DateReminder.Text, UC.myDTFI));
				}
				if (CheckRecurrence.Checked)
				{
					if (RecType.SelectedItem.Value == "99")
					{
						dg.Add("FlagRecurrence", NewRecurrence());
					}
					else
					{
						dg.Add("FlagRecurrence", RecType.SelectedItem.Value);
					}
				}
				dg.Execute("todolist");
			}

			SomeJS.Text = "<script>opener.location = opener.location;window.close();</script>";

		}

		private int NewRecurrence()
		{
			int newId = -1;
			using (DigiDapter dg = new DigiDapter())
			{
				if (RecDatestart.Text.Length > 0)
				{
					dg.Add("StartDate", Convert.ToDateTime(RecDatestart.Text, UC.myDTFI));
				}
				if (RecDaTextFontp.Text.Length > 0)
				{
					dg.Add("EndDate", Convert.ToDateTime(RecDaTextFontp.Text, UC.myDTFI));
				}
				dg.Add("Type", RecMode.SelectedItem.Value);
				switch (RecMode.SelectedItem.Value)
				{
					case "1":
						dg.Add("Description", "Ric.personale Giornaliero");
						dg.Add("VAR1", RecDays.Text);
						dg.Add("VAR2", (RecWorkingDay.Checked) ? 1 : 0);
						break;
					case "2":
						dg.Add("Description", "Ric.personale Weekle");
						dg.Add("VAR1", RecWeeks.Text);
						int var2 = 0;
						int var3 = 0;
						foreach (ListItem i in RecWeekDays.Items)
						{
							if (i.Selected)
							{
								var2 += Convert.ToInt32(i.Value);
								var3++;
							}
						}

						dg.Add("VAR2", var2);
						dg.Add("VAR3", (var3 == 1) ? 0 : 1);

						break;
					case "3":
						dg.Add("Description", "Ric.personale Mensile");
						dg.Add("VAR1", RecMonthlyDays.Text);
						dg.Add("VAR2", RecMonthlyMonths.Text);
						break;
					case "4":
						dg.Add("Description", "Ric.personale Mensile giorno");
						dg.Add("VAR1", RecWeeklyDayPU.SelectedItem.Value);
						dg.Add("VAR2", recMonthDayDays.SelectedItem.Value);
						dg.Add("VAR2", RecMonthDayMonths.Text);
						break;
					case "5":
						dg.Add("Description", "Ric.personale Annuale");
						dg.Add("VAR1", RecYearDays.Text);
						dg.Add("VAR2", RecYearlyMonths.SelectedItem.Value);
						break;
					case "6":
						dg.Add("Description", "Ric.personale Annuale giorno");
						dg.Add("VAR1", RecYearlyDayPU.SelectedItem.Value);
						dg.Add("VAR2", RecYearlyDayDays.SelectedItem.Value);
						dg.Add("VAR3", RecYearlyDayMonths.SelectedItem.Value);
						break;
				}
				newId = (int)dg.Execute("Recurrence",DigiDapter.Identities.Identity);
			}
			return newId;
		}
	}
}
