/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Collections;
using System.Data;

using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.DomValidators;
using Ajax;
using Digita.Tustena.Base;
using Digita.Tustena.Common;
using Digita.Tustena.Database;
using Digita.Tustena.WorkingCRM;

namespace Digita.Tustena
{
	public class CRM_Companies : G
	{

		protected Repeater Repeater1;
		protected RepeaterPaging Repeater1Paging;
		protected Label LblHeader;
		protected HtmlTable ContactForm;
		protected HtmlTable AdvancedSearch;
		protected HtmlContainerControl personalView;
		protected Repeater ViewContact;
		protected TextBox CompanyName;
		protected TextBox CompanyCode;
		protected TextBox VatId;
		protected TextBox Employees;
		protected TextBox Phone;
		protected TextBox Fax;
		protected TextBox Email;
		protected TextBox WebSite;
		protected TextBox Description;
		protected TextBox OwnerId;
		protected TextBox OwnerName;
		protected TextBox Invoice_Address;
		protected TextBox Invoice_City;
		protected TextBox Invoice_StateProvince;
		protected TextBox Invoice_State;
		protected TextBox Invoice_Zip;

		protected TextBox Shipment_Address;
		protected TextBox Shipment_City;
		protected TextBox Shipment_StateProvince;
		protected TextBox Shipment_State;
		protected TextBox Shipment_Zip;
		protected TextBox Shipment_Phone;
		protected TextBox Shipment_Fax;
		protected TextBox Shipment_Email;

		protected TextBox Warehouse_Address;
		protected TextBox Warehouse_City;
		protected TextBox Warehouse_StateProvince;
		protected TextBox Warehouse_State;
		protected TextBox Warehouse_Zip;
		protected TextBox Warehouse_Phone;
		protected TextBox Warehouse_Fax;
		protected TextBox Warehouse_Email;

		protected TextBox TurnOver;
		protected TextBox RapCompanyName;
		protected TextBox RapTelephone;
		protected TextBox RapEmail;
		protected RegexDomValidator RapEmailRegexdomvalidator;
		protected GroupControl groups;
		protected Literal ContactId;
		protected DropDownList Sector;
		protected DropDownList ContactType;
		protected DropDownList Evaluation;
		protected TextBox Search;
		protected Label RapInfo;
		protected Label RepeaterInfo;
		protected Literal FreeFields;
		protected LinkButton BtnSearch;
		protected LinkButton RapSubmit;
		protected LinkButton CancelCon;
		protected LinkButton SubmitRef;
		protected LinkButton SubmitCon;
		protected LinkButton ViewAgenda;
		protected Literal SomeJS;
		protected HtmlInputHidden activeTab;
		protected HtmlInputHidden activeMode;

		protected HtmlTable tabControl;
		protected HtmlTableCell tdTab1;
		protected HtmlTableCell tdTab2;
		protected HtmlTableCell tdTab3;
		protected HtmlTableCell tdTab4;
		protected HtmlTableCell tdTab5;
		protected HtmlTableCell tdTab6;
		protected HtmlTableCell tdTab7;
		protected HtmlTableCell tdTab8;

		protected HtmlContainerControl visContact;
		protected HtmlContainerControl visReferrer;
		protected HtmlContainerControl visActivity;
		protected HtmlContainerControl visOpportunity;
		protected HtmlContainerControl visPurchase;
		protected HtmlContainerControl visEstimate;
		protected HtmlContainerControl visDocuments;
		protected HtmlContainerControl visProducts;

		protected Repeater ContactReferrer;
		protected Repeater RepeaterOpportunity;
		protected Literal Tab1Text;

		protected DropDownList ListGroups;
		protected DropDownList ListSector;
		protected DropDownList ListType;
		protected DropDownList ListCategory;
		protected DropDownList ListOwners;
		protected DropDownList Days;
		protected LinkButton AllActivity;
		protected Label RepeaterActivityInfo;
		protected Label RepeaterOpportunityInfo;
		protected Label ContactReferrerInfo;
		protected LinkButton Purchase_Exit;
		protected LinkButton Purchase_Submit;
		protected HtmlTable PurchaseForm;
		protected Repeater RepeaterPurchase;
		protected Label RepeaterPurchaseInfo;
		protected LinkButton GoBackProd;
		protected LinkButton GoBackPurc;
		protected LinkButton NewPurchase;
		protected Repeater RepeaterPurchaseProduct;

		protected HtmlControl pgPaste;

		protected Repeater RepCategories;
		protected Literal CategoriesRep;
		protected LinkButton BtnViewAdvanced;
		protected LinkButton Tab3Text;
		protected LinkButton Tab4Text;
		protected LinkButton Tab5Text;
		protected LinkButton Tab6Text;
		protected LinkButton Tab7Text;
		protected LinkButton Tab8Text;
		protected Repeater FileRep;
		protected LinkButton NewDoc;
		protected HtmlTable NewProduct;
		protected LinkButton SaveNewProduct;
		protected LinkButton InsertNewProduct;
		protected LinkButton ResetNewProduct;
		protected Repeater RepeaterProducts;
		protected TextBox CRM_CompetitorProducts_ProductName;
		protected TextBox CRM_CompetitorProducts_Price;
		protected TextBox CRM_CompetitorProducts_Description;
		protected TextBox CRM_CompetitorProducts_ID;
		protected TextBox CRM_CompetitorProducts_CompetitorID;
		protected TextBox CRM_CompetitorProducts_Package;
		protected TextBox CRM_CompetitorProducts_UnitPrice;

		protected Label RepeaterProductsInfo;
		protected Label FileRepInfo;
		protected LinkButton NewContact;

		protected RequiredDomValidator rvBillNumber;

		protected CompareDomValidator cvBillingDate;
		protected RequiredDomValidator rvBillingDate;
		protected RequiredDomValidator rvExpirationDate;

		protected LinkButton RefreshRepCategories;
		protected CheckBox MlCheck;
		protected TextBox EmailML;

		protected ActivityChronology acCrono;
		protected LinkButton NewActivityPhone;
		protected LinkButton NewActivityLetter;
		protected LinkButton NewActivityFax;
		protected LinkButton NewActivityMemo;
		protected LinkButton NewActivityEmail;
		protected LinkButton NewActivityVisit;
		protected LinkButton NewActivityGeneric;
		protected LinkButton NewActivitySolution;

		protected LinkButton BtnAddProduct;
		protected LinkButton BtnCalcPrice;

		protected SearchCompany srccomp;
		protected LinkButton SrcBtn;
		protected SheetPaging sheetP;

		protected LinkButton NewCompany;

		protected TextBox EstFreeProduct;
		protected TextBox EstFreeUm;
		protected TextBox EstFreeQta;
		protected TextBox EstFreeUp;
		protected TextBox EstFreeVat;
		protected TextBox EstFreePf;
		protected LinkButton BtnAddFreeProductOpp;

		protected TextBox Purchase_TextboxOwnerID;
		protected TextBox Purchase_TextboxOwner;
		protected Literal GroupDescription;

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				if (Request["Ajax"] != null)
					InitAjax();
				DeleteGoBack();
				GroupDescription.Text = " (" + G.GetGroupDescription(UC.UserGroupId) + ")";
				LblHeader.Text = CRM_Companies.ABCHeaderHtml(Request.Params["List"]);
				this.Repeater1Paging.Visible = false;
				NewDoc.Text = rm.GetString("CRMrubtxt4");
				NewContact.Text = rm.GetString("Bcotxt31");
				BtnAddProduct.Text = rm.GetString("CRMcontxt74");
				BtnCalcPrice.Text = rm.GetString("CRMcontxt75");
				BtnAddFreeProductOpp.Text = rm.GetString("CRMcontxt74");
				BtnAddFreeProductOpp.Attributes.Add("onclick", "return ValidateFreeProduct()");
				BtnAddProduct.Attributes.Add("onclick", "return ValidateProduct()");

				activeMode.Value = String.Empty;


				Label PurchaseDescription = (Label) Page.FindControl("PurchaseDescription");
				PurchaseDescription.Text = String.Format(rm.GetString("CRMcontxt80"), DatabaseConnection.SqlScalar("select CompanyName from Tustena_Data"));
				AdvancedSearch.Visible = false;

				if (!Page.IsPostBack)
				{
					NewCompany.Text = rm.GetString("CRMcontxt22");
					acCrono.ParentID = 0;
					acCrono.OpportunityID = 0;
					acCrono.AcType = (byte) AType.Company;
					NewActivityPhone.Text = rm.GetString("Wortxt6");
					NewActivityLetter.Text = rm.GetString("Wortxt7");
					NewActivityFax.Text = rm.GetString("Wortxt8");
					NewActivityMemo.Text = rm.GetString("Wortxt9");
					NewActivityEmail.Text = rm.GetString("Wortxt10");
					NewActivityVisit.Text = rm.GetString("Wortxt11");
					NewActivityGeneric.Text = rm.GetString("Wortxt12");
					NewActivitySolution.Text = rm.GetString("Wortxt13");

					Days.Items.Add(new ListItem(rm.GetString("Das2txt7"), "0"));
					Days.Items.Add(new ListItem("30 " + rm.GetString("Das2txt8"), "30"));
					Days.Items.Add(new ListItem("60 " + rm.GetString("Das2txt8"), "60"));
					Days.Items.Add(new ListItem("90 " + rm.GetString("Das2txt8"), "90"));
					Days.Items.Add(new ListItem("120 " + rm.GetString("Das2txt8"), "120"));
					Days.SelectedIndex = 0;

					Session["listfromsearch"] = "0";
					Fill_Sectors(ListSector);
					Fill_ContactType(ListType);
					Fill_Owners(ListOwners);


					BtnSearch.Text = rm.GetString("Bcotxt2");
					RapSubmit.Text = rm.GetString("CRMcontxt34");
					RapSubmit.Attributes.Add("onclick", "return CheckRapidMail()");
					CancelCon.Text = rm.GetString("Bcotxt40");
					SubmitCon.Text = rm.GetString("CRMcontxt34");
					SubmitRef.Text = rm.GetString("CRMcontxt34");
					Purchase_Submit.Text = rm.GetString("CRMcontxt34");
					Purchase_Exit.Text = rm.GetString("CRMcontxt43");
					NewPurchase.Text = rm.GetString("CRMcontxt38");


					BtnViewAdvanced.Text = rm.GetString("CRMcontxt52");
					Tab3Text.Text = rm.GetString("Bcotxt45");
					Tab4Text.Text = rm.GetString("Bcotxt46");
					Tab5Text.Text = rm.GetString("CRMcontxt23");
					Tab6Text.Text = rm.GetString("CRMcontxt58");
					Tab7Text.Text = rm.GetString("CRMcontxt59");
					Tab8Text.Text = rm.GetString("CRMcontxt76").ToUpper();

					SaveNewProduct.Text = rm.GetString("Bcotxt4");
					ResetNewProduct.Text = rm.GetString("Bcotxt40");
					InsertNewProduct.Text = rm.GetString("CRMComptxt7");
					NewProduct.Visible = false;

					FillListGroups(UC, ListGroups);

					ListCategory.DataTextField = "Description";
					ListCategory.DataValueField = "id";
					ListCategory.DataSource = DatabaseConnection.CreateDataset("select id,Description from CRM_ContactCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + "))");
					ListCategory.DataBind();
					ListCategory.Items.Insert(0, rm.GetString("CRMcontxt53"));
					ListCategory.Items[0].Value = "0";


					ContactForm.Visible = false;
					tabControl.Visible = false;
					RapInfo.Text = String.Empty;

					SrcBtn.Text = rm.GetString("Find");

					if (Request.Params["List"] != null)
					{
						FillRepeater(Request.Params["List"].ToString());
					}
					if (Request.Params["action"] != null)
					{
						if (Request.Params["action"] == "NEW")
						{
							PrepareForNewCompany();
						}
					}

					if (Request.Params["gb"] != null && isGoBack)
					{
						Stack ba = new Stack();
						ba = (Stack) Session["goback1"];
						GoBack gb = new GoBack();
						gb = (GoBack) ba.Pop(); //ba[ba.Count - 1];
						string[] par = gb.parameter.Split('|');
						if (par[1].Length > 0)
						{
							if (par[1] != "nn")
								FillView(int.Parse(par[1]));
						}
						if (par[2].Length > 0)
						{
							switch (par[2])
							{
								case "c":
									SomeJS.Text = "<script>ViewHideTabs(\"visReferrer\");</script>";
									break;
								case "a":
									FillRepeaterActivity(int.Parse(par[1].ToString()));
									SomeJS.Text = "<script>ViewHideTabs(\"visActivity\");</script>";
									break;
								case "o":
									FillRepeaterOpportunity(int.Parse(par[1].ToString()));
									SomeJS.Text = "<script>ViewHideTabs(\"visOpportunity\");</script>";
									break;
								case "r":
									SomeJS.Text = "<script>ViewHideTabs(\"visReminder\");</script>";
									break;
								case "p":
									FillPurchase(int.Parse(par[1].ToString()));
									SomeJS.Text = "<script>ViewHideTabs(\"visPurchase\");</script>";
									break;
								case "d":
									SomeJS.Text = "<script>ViewHideTabs(\"visContact\");</script>";
									break;
								case "e":
									SomeJS.Text = "<script>ViewHideTabs(\"visPurchase\");</script>";
									break;
								case "f":
									Session["review"] = "0";
									FillFileRep(int.Parse(par[1].ToString()));
									SomeJS.Text = "<script>ViewHideTabs(\"visDocuments\");</script>";
									break;
								case "g":
									SomeJS.Text = "<script>ViewHideTabs(\"visProducts\");</script>";
									break;
							}
							activeTab.Value = String.Empty;
						}
						Session["goback1"] = ba;
					}

					if (Request.Form["searchcontact"] != null)
					{
						Search.Text = Request.Form["searchcontact"];
						FillFromSearch();
					}

					if (Session["fromlead"] != null)
					{
						FillView(int.Parse(Session["fromlead"].ToString()));
						Session.Remove("fromlead");
					}


				}
				else
				{
					if (Request.Params["__EVENTTARGET"].Trim() != "viewAgenda")
					{
						if (activeTab.Value.Length > 0)
						{
							SomeJS.Text = "<script>ViewHideTabs(\"" + activeTab.Value + "\");</script>";
							activeTab.Value = String.Empty;
						}
					}
				}
			}
		}

		public static void FillListGroups(UserConfig UC, DropDownList ListGroups)
		{
			string[] arryD = UC.GroupDependency.Split('|');
			string query = String.Empty;
			foreach (string ut in arryD)
			{
				if (ut.Length > 0) query += "id=" + ut + " or ";
			}

			string groups;
			groups = "Select id, Description from Groups";

			if (query.Length > 0) groups += " where (" + query.Substring(0, query.Length - 3) + ")";
			ListGroups.DataSource = DatabaseConnection.CreateDataset(groups);
			ListGroups.DataTextField = "Description";
			ListGroups.DataValueField = "ID";
			ListGroups.DataBind();
			ListGroups.Items.Insert(0, rm.GetString("Usrtxt6"));
			ListGroups.SelectedIndex = 0;
			ListGroups.Items[0].Value = "0";
		}

		private void FillForm(int id)
		{
			Fill_Sectors(Sector);
			Fill_ContactType(ContactType);
			Fill_Evaluation(Evaluation);
			DataSet dsCompanies;
			dsCompanies = DatabaseConnection.CreateDataset("select * from Base_Companies where id = " + id);

			DataRow drCompanies = dsCompanies.Tables[0].Rows[0];
			ContactId.Text = id.ToString();
			CompanyName.Text = drCompanies["CompanyName"].ToString();
			CompanyCode.Text = drCompanies["CompanyCode"].ToString();
			VatId.Text = drCompanies["vatId"].ToString();
			Phone.Text = drCompanies["Phone"].ToString();
			Fax.Text = drCompanies["Fax"].ToString();
			Email.Text = drCompanies["EMail"].ToString();
			OwnerId.Text = drCompanies["OwnerID"].ToString();
			OwnerName.Text = DatabaseConnection.SqlScalar("select isnull(Surname,'')+' '+isnull(Name,'') from account where uid=" + drCompanies["OwnerID"].ToString());
			WebSite.Text = drCompanies["WebSite"].ToString();
			Invoice_Address.Text = drCompanies["InvoicingAddress"].ToString();
			Invoice_City.Text = drCompanies["InvoicingCity"].ToString();
			Invoice_StateProvince.Text = drCompanies["InvoicingStateProvince"].ToString();
			Invoice_State.Text = drCompanies["InvoicingState"].ToString();
			Invoice_Zip.Text = drCompanies["InvoicingZIPCode"].ToString();
			Shipment_Address.Text = drCompanies["ShipmentAddress"].ToString();
			Shipment_City.Text = drCompanies["ShipmentCity"].ToString();
			Shipment_StateProvince.Text = drCompanies["ShipmentStateProvince"].ToString();
			Shipment_State.Text = drCompanies["ShipmentState"].ToString();
			Shipment_Zip.Text = drCompanies["ShipmentZIPCode"].ToString();
			Shipment_Phone.Text = drCompanies["ShipmentPhone"].ToString();
			Shipment_Fax.Text = drCompanies["ShipmentFax"].ToString();
			Shipment_Email.Text = drCompanies["ShipmentEMail"].ToString();
			Warehouse_Address.Text = drCompanies["WarehouseAddress"].ToString();
			Warehouse_City.Text = drCompanies["WarehouseCity"].ToString();
			Warehouse_StateProvince.Text = drCompanies["WarehouseStateProvince"].ToString();
			Warehouse_State.Text = drCompanies["WarehouseState"].ToString();
			Warehouse_Zip.Text = drCompanies["WarehouseZIPCode"].ToString();
			Warehouse_Phone.Text = drCompanies["WarehousePhone"].ToString();
			Warehouse_Fax.Text = drCompanies["WarehouseFax"].ToString();
			Warehouse_Email.Text = drCompanies["WarehouseEMail"].ToString();

			Employees.Text = drCompanies["Employees"].ToString();
			TurnOver.Text = String.Format("{0:c}", drCompanies["Billed"].ToString());
			Description.Text = drCompanies["Description"].ToString();
			CategoriesRep.Text = drCompanies["Categories"].ToString();
			EmailML.Text = drCompanies["MLEmail"].ToString();
			MlCheck.Checked = (bool) drCompanies["MLFlag"];


			Sector.SelectedItem.Selected = false;
			foreach (ListItem li in Sector.Items)
			{
				if (li.Value == drCompanies["CompanyTypeID"].ToString())
				{
					li.Selected = true;
					break;
				}
			}
			ContactType.SelectedItem.Selected = false;
			foreach (ListItem li in ContactType.Items)
			{
				if (li.Value == drCompanies["ContactTypeID"].ToString())
				{
					li.Selected = true;
					break;
				}
			}

			Evaluation.SelectedItem.Selected = false;
			foreach (ListItem li in Evaluation.Items)
			{
				if (li.Value == drCompanies["Estimate"].ToString())
				{
					li.Selected = true;
					break;
				}
			}

			groups.SetGroups(drCompanies["Groups"].ToString());

			FillRepCategories();

			CheckFreeFields(id);

			ContactForm.Visible = true;
			Repeater1.Visible = false;
			ViewContact.Visible = false;
			SetFocus(CompanyName);

			SomeJS.Text = String.Empty;
			tdTab2.Visible = false;
			tdTab3.Visible = false;
			tdTab4.Visible = false;
			tdTab5.Visible = false;
			tdTab6.Visible = false;
			tdTab7.Visible = false;
			tdTab8.Visible = false;

			AddKeepAlive();
		}


		private void FillRepCategories()
		{
			if (ContactId.Text == "-1")
			{
				tdTab2.Visible = false;
				tdTab3.Visible = false;
				tdTab4.Visible = false;
				tdTab5.Visible = false;
				tdTab6.Visible = false;
			}
			DataTable dt;
			dt = DatabaseConnection.CreateDataset("select id,Description,'0' as tocheck from CRM_ContactCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + ")) order by FlagPersonal desc").Tables[0];
			if (dt.Rows.Count > 0)
			{
				foreach (DataRow dr in dt.Rows)
				{
					if (CategoriesRep.Text.IndexOf("|" + dr["id"].ToString() + "|") > -1)
						dr["tocheck"] = "1";
				}
			}
			RepCategories.DataSource = new DataView(dt, "", "tocheck desc", DataViewRowState.CurrentRows);
			RepCategories.DataBind();
		}

		public void RepCategories_DataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Literal IDCat = (Literal) e.Item.FindControl("IDCat");
					if (CategoriesRep.Text.IndexOf("|" + IDCat.Text + "|") > -1)
					{
						CheckBox Check = (CheckBox) e.Item.FindControl("Check");
						Check.Checked = true;
					}

					DataSet ds = DatabaseConnection.CreateDataset("select id from Base_Companies where Categories like '%|" + DatabaseConnection.FilterInjection(IDCat.Text) + "|%'");
					if (ds.Tables[0].Rows.Count < 1)
					{
						LinkButton DeleteCat = (LinkButton) e.Item.FindControl("DeleteCat");
						DeleteCat.Text = "<img src='/i/erase.gif' border=0 alt='" + rm.GetString("CRMcontxt49") + "'>";
						DeleteCat.Attributes.Add("onclick", "g_fFieldsChanged=0;return confirm('" + rm.GetString("CRMcontxt50") + "');");
					}
					break;
			}
		}

		public void RepCategories_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "deleteCat":
					string count = "select count(*) from Base_Companies where Categories like '|" + ((Literal) e.Item.FindControl("IDCat")).Text + "|'";

					int empty = (int) DatabaseConnection.SqlScalartoObj(count);

					if (empty < 1)
					{
						string sqlString = "delete from CRM_ContactCategories where ID =" + int.Parse(((Literal) e.Item.FindControl("IDCat")).Text);
						DatabaseConnection.DoCommand(sqlString);
					}
					FillRepCategories();
					Page.RegisterClientScriptBlock("xxx", "<script>g_fFieldsChanged=1;</script>");
					break;
			}
		}


		private void CheckFreeFields(int id)
		{
			string query = GroupsSecure("groups");
			if (query.Length > 0)
				query = " groups like '%|" + UC.UserGroupId + "|%'";

			string sqlString;
			sqlString = "select * from addedfields where tablename=" + (byte) CRMTables.Base_Companies + " and (" + query + ") order by vieworder";

			DataSet ds = DatabaseConnection.CreateDataset(sqlString);
			if (ds.Tables[0].Rows.Count > 0)
			{
				StringBuilder S = new StringBuilder();
				S.AppendFormat("<table width=\"100%\"><tr><td class=\"normal Bbot\"><br><b>{0}</b></td></tr></table>", rm.GetString("Bcotxt50"));
				S.Append("<table width=\"100%\"><tr><td width=\"45%\">");
				S.Append("<table width=\"100%\" class=\"normal\">");
				foreach (DataRow dr in ds.Tables[0].Rows)
				{
					S.Append(FreeFieldType(dr["type"].ToString(), dr["name"].ToString(), int.Parse(dr["id"].ToString()), id, dr["Items"].ToString()));
				}
				S.Append("</table>");
				S.AppendFormat("</td><td width=\"10%\">&nbsp;</td><td class=\"normal\" style=\"color:red\" valign=top>{0}</td></tr></table>", (ContactId.Text == "-1") ? rm.GetString("WarningFF") : "");
				FreeFields.Text = S.ToString();
			}
		}


		public string FreeFieldType(string type, string name, int did, int id, string items)
		{
			StringBuilder S = new StringBuilder();
			string pf = String.Empty;
			string pfv = String.Empty;
			bool isParentCrossed = false;
			DataSet Q = DatabaseConnection.CreateDataset("select ParentField,ParentFieldValue from AddedFields where id=" + did);
			pf = Q.Tables[0].Rows[0][0].ToString();
			pfv = Q.Tables[0].Rows[0][1].ToString();
			if (pf.Length > 0 && id != -1)
			{
				IDataReader sqlDr = DatabaseConnection.CreateReader("select " + pf + " from Base_Companies where id=" + Session["contact"].ToString());
				sqlDr.Read();
				Trace.Warn("PF-PFV", pf + "-" + pfv);
				if (pf.ToLower() != "categories")
					isParentCrossed = (sqlDr[0].ToString() == pfv);
				else
					isParentCrossed = (sqlDr[0].ToString().IndexOf("|" + pfv + "|") > -1);

				sqlDr.Close();
			}

			bool toPrint = true;
			if (pf.Length > 0)
			{
				if (isParentCrossed)
					S.AppendFormat("<tr ParentField=\"{1}\" ParentFieldValue=\"{2}\"><td width=\"40%\">{0}</td>", name, pf, pfv);
				else
					toPrint = false;
			}
			else
				S.AppendFormat("<tr><td width=\"40%\">{0}</td>", name);


			switch (type)
			{
				case "1":
				case "2":
				case "3":
					if (toPrint)
					{
						if (id != -1)
						{
							DataSet afCross = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + did + " and id=" + id);
							if (afCross.Tables[0].Rows.Count > 0)
							{
								S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\" value=\"{1}\"></td></tr>", name, afCross.Tables[0].Rows[0][0]);
							}
							else
							{
								S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\"></td></tr>", name);
							}
							afCross.Clear();
						}
						else
						{
							S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\"></td></tr>", name);
						}
					}
					break;
				case "4":
					if (toPrint)
					{
						string[] it = items.Split('|');
						DataSet afCrossS = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + did + " and id=" + id);
						S.AppendFormat("<td><select old=true name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\">", name);

						foreach (string op in it)
						{
							try
							{
								if (op == afCrossS.Tables[0].Rows[0][0].ToString())
								{
									if (op.Length > 0) S.AppendFormat("<option selected>{0}</option>", op);
								}
								else
								{
									if (op.Length > 0) S.AppendFormat("<option>{0}</option>", op);
								}
							}
							catch
							{
								if (op.Length > 0) S.AppendFormat("<option>{0}</option>", op);
							}
						}
						S.Append("</select></td></tr>");
					}
					break;
			}

			return S.ToString();
		}


		private void FillRepeater(string query)
		{
			string queryType = String.Empty;
			string queryGroup = GroupsSecure("Base_Companies.Groups");
			switch (Request.Params["type"])
			{
				case "0":
					queryType = " and ((Base_Companies.FlagGlobalORPersonal=2 and  Base_Companies.OwnerID=" + UC.UserId.ToString() + ") or (Base_Companies.FlagGlobalORPersonal<>2))";
					break;
				case "1":
					queryType = " and ((Base_Companies.FlagGlobalORPersonal=2 and  Base_Companies.OwnerID=" + UC.UserId.ToString() + "))";
					break;
				case "2":
					queryType = " and ((Base_Companies.FlagGlobalORPersonal<>2) and (Base_Companies.groups like '%|" + UC.UserGroupId.ToString() + "|%'))";
					break;
				case "3":
					queryType = " and ((Base_Companies.OwnerID=" + UC.UserId.ToString() + "))";
					break;
			}


			StringBuilder sqlString = new StringBuilder();

			sqlString.AppendFormat("SELECT TOP {0} Base_Companies.id, Base_Companies.Companyname, Base_Companies.Phone, Base_Companies.Fax, Base_Companies.Description, Base_Companies.groups ", DatabaseConnection.MaxResult);
			sqlString.Append("FROM Base_Companies ");

			switch (query)
			{
				case "*":
					sqlString.AppendFormat(" where limbo=0 {0} ", queryType);

					break;
				case "find":
					if (ListSector.SelectedIndex > 0)
					{
						sqlString.AppendFormat(" and (CompanyTypeID={0})", ListSector.SelectedValue);
					}
					if (ListType.SelectedIndex > 0)
					{
						sqlString.AppendFormat(" and (ContactTypeID={0})", ListType.SelectedValue);
					}

					if (ListGroups.SelectedIndex > 0)
					{
						if (ListGroups.SelectedItem.Value != "0")
						{
							string dep = GroupDependency(Convert.ToInt32(ListGroups.SelectedItem.Value));
							if (dep.Length > 1)
							{
								string qGroup = GroupsSecure("Base_Companies.Groups");
								sqlString.AppendFormat(" and ({0})", qGroup);
							}
							else
							{
								sqlString.AppendFormat(" and (Base_Companies.groups like '%|{0}|%')", ListGroups.SelectedItem.Value);
							}

						}
					}
					break;
				default:
					sqlString.AppendFormat(" where limbo=0 and (Base_Companies.CompanyName like '{0}%') {1} ", query, queryType);

					break;
			}

			if (queryGroup.Length > 0)
			{
				sqlString.AppendFormat(" and ({0})", queryGroup);
			}

			sqlString.Append(" ORDER BY Base_Companies.CompanyName");

			Repeater1Paging.PageSize = UC.PagingSize;
			Repeater1Paging.RepeaterObj = Repeater1;
			InitSheetPaging(sqlString.ToString());
			Repeater1Paging.sqlRepeater = sqlString.ToString();
			Repeater1Paging.BuildGrid();


			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				RepeaterInfo.Visible = false;

			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Bcotxt41") + "</center>";
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}

			ContactForm.Visible = false;
			ViewContact.Visible = false;
		}


		private void FillView(int id)
		{
			Session["contact"] = id;
			StringBuilder sqlString = new StringBuilder();
			sqlString.Append("SELECT top 1 Base_Companies.*, (Account.Name+' '+Account.Surname) as ownername, (modby.Name+' '+modby.Surname) as LastModifiedBy, ContactType.ContactType AS ContactType, CompanyType.Description AS CompanyType, ContactEstimate.Estimate AS Estimatedesc ");
			sqlString.Append("FROM Base_Companies LEFT OUTER JOIN CompanyType ON Base_Companies.CompanyTypeID = CompanyType.K_ID AND CompanyType.lang='" + UC.Culture.Substring(0, 2) + "' LEFT OUTER JOIN ");
			sqlString.Append("ContactType ON Base_Companies.ContactTypeID = ContactType.K_ID and ContactType.lang='" + UC.Culture.Substring(0, 2) + "' LEFT OUTER JOIN ");
			sqlString.Append("Account ON Base_Companies.OwnerID = Account.UID LEFT OUTER JOIN ");
			sqlString.Append("Account as modby ON Base_Companies.LastModifiedByID = modby.UID LEFT OUTER JOIN ");
			sqlString.AppendFormat("ContactEstimate ON Base_Companies.Estimate = ContactEstimate.K_ID and ContactEstimate.lang='" + UC.Culture.Substring(0, 2) + "' WHERE Base_Companies.ID={0}", id);

			ViewContact.DataSource = DatabaseConnection.CreateDataset(sqlString.ToString());
			ViewContact.DataBind();

			ViewContact.Visible = true;
			ContactForm.Visible = false;
			Repeater1.Visible = false;
			tabControl.Visible = true;

			tdTab2.Visible = true;
			tdTab3.Visible = true;
			tdTab4.Visible = true;
			tdTab5.Visible = true;
			tdTab6.Visible = true;
			tdTab7.Visible = true;
			tdTab8.Visible = true;

			visContact.Visible = true;
			visReferrer.Visible = true;
			visActivity.Visible = true;
			visOpportunity.Visible = true;
			visPurchase.Visible = true;
			visDocuments.Visible = true;
			visProducts.Visible = true;
			visEstimate.Visible = true;

			try
			{
				if (this.sheetP.IDArray.Length <= 0)
				{
					this.sheetP.CurrentPosition = 0;
					this.sheetP.enabledisable();
				}
			}
			catch
			{
				this.sheetP.IDArray = new string[0];
				this.sheetP.CurrentPosition = -1;
				this.sheetP.enabledisable();
			}
		}

		public void ContactReferrerItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton delete = (LinkButton) e.Item.FindControl("Delete");
					delete.Attributes.Add("onclick", "return confirm('" + rm.GetString("CRMrubtxt2") + "');");
					delete.Text = "<img src='/i/erase2.gif' border=0 alt='" + rm.GetString("CRMcontxt44") + "'>";

					LinkButton Activate = (LinkButton) e.Item.FindControl("Activate");

					if ((bool) DataBinder.Eval((DataRowView) e.Item.DataItem, "Active"))
					{
						Activate.Text = "<img border=0 alt=\"" + rm.GetString("CRMrubtxt9") + "\" src=/i/checkon.gif>";
						Activate.Attributes.Add("onclick", "return confirm('" + rm.GetString("CRMrubtxt7") + "');");
					}
					else
					{
						Activate.Text = "<img border=0 alt=\"" + rm.GetString("CRMrubtxt10") + "\" src=/i/checkoff.gif>";
						Activate.Attributes.Add("onclick", "return confirm('" + rm.GetString("CRMrubtxt8") + "');");
						LinkButton OpenContact = (LinkButton) e.Item.FindControl("OpenContact");
						OpenContact.CssClass = "LinethroughGray linked";
					}
					break;
			}
		}

		public void ContactReferrerCommand(Object sender, RepeaterCommandEventArgs e)
		{
			Literal IdRef = (Literal) e.Item.FindControl("IdRef");
			switch (e.CommandName)
			{
				case "activate":
					LinkButton Activate = (LinkButton) e.Item.FindControl("Activate");
					if (Activate.Text.IndexOf("checkon") > 0)
						DatabaseConnection.DoCommand("update Base_Contacts set active=0 where id=" + int.Parse(IdRef.Text));
					else
						DatabaseConnection.DoCommand("update Base_Contacts set active=1 where id=" + int.Parse(IdRef.Text));

					ReferrerDataSource(int.Parse(Session["contact"].ToString()));
					break;
				case "openContact":
					SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[] {Session["contact"].ToString(), "c"});
					Response.Redirect("/CRM/base_contacts.aspx?action=VIEW&m=25&si=31&full=" + IdRef.Text);
					break;
				case "delete":
					Base_Contacts.Delete(int.Parse(IdRef.Text), UC.UserId, "Base_Contacts");

					ReferrerDataSource(int.Parse(Session["contact"].ToString()));
					SomeJS.Text = "<script>ViewHideTabs(\"VisReferrer\");</script>";
					break;
			}
		}

		public void ViewContact_OnItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Literal ViewFreeFields = (Literal) e.Item.FindControl("ViewFreeFields");
					ViewFreeFields.Text = String.Empty;
					string query = GroupsSecure("groups");
					if (query.Length > 0)
						query = " groups like '%|" + UC.UserGroupId + "|%'";
					string sqlString;
					sqlString = "select * from addedfields where tablename=" + (byte) CRMTables.Base_Companies + " and (" + query + ") order by vieworder";

					DataSet ds = DatabaseConnection.CreateDataset(sqlString);
					if (ds.Tables[0].Rows.Count > 0)
					{
						StringBuilder S = new StringBuilder();
						S.AppendFormat("<table width=\"100%\"><tr><td class=\"normal Bbot\"><br><b>{0}</b></td></tr></table>", rm.GetString("Bcotxt50"));

						S.Append("<table width=\"45%\" class=\"normal\">");
						foreach (DataRow dr in ds.Tables[0].Rows)
						{
							bool isParentCrossed = true;
							DataSet Q = DatabaseConnection.CreateDataset("select ParentField,ParentFieldValue from AddedFields where id=" + dr["id"].ToString());
							string pf = Q.Tables[0].Rows[0][0].ToString();
							string pfv = Q.Tables[0].Rows[0][1].ToString();
							if (pf.Length > 0)
							{
								IDataReader sqlDr = DatabaseConnection.CreateReader("select " + pf + " from Base_Companies where id=" + Session["contact"].ToString());
								sqlDr.Read();
								if (pf.ToLower() != "categories")
									isParentCrossed = (sqlDr[0].ToString() == pfv);
								else
									isParentCrossed = (sqlDr[0].ToString().IndexOf("|" + pfv + "|") > -1);

								sqlDr.Close();
							}

							if (isParentCrossed)
							{
								S.AppendFormat("<tr><td width=\"40%\">{0}</td>", dr["name"]);
								DataSet afCross = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + dr["id"] + " and id=" + (Int64) DataBinder.Eval((DataRowView) e.Item.DataItem, "id"));
								if (afCross.Tables[0].Rows.Count > 0)
								{
									S.AppendFormat("<td bgColor=\"#FFFFFF\" class=\"VisForm\">{0}&nbsp;</td></tr>", afCross.Tables[0].Rows[0][0]);
								}
								else
								{
									S.Append("<td bgColor=\"#FFFFFF\" class=\"VisForm\">&nbsp;</td></tr>");
								}

								afCross.Clear();
							}
						}


						S.Append("</table>");

						ViewFreeFields.Text = S.ToString();
					}
					LinkButton ModCon = (LinkButton) e.Item.FindControl("ModCon");
					ModCon.Text = rm.GetString("Bcotxt16");

					LinkButton BackToSearch = (LinkButton) e.Item.FindControl("BackToSearch");
					BackToSearch.Text = rm.GetString("CRMrubtxt6");

					if (Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Categories")).Length > 0)
					{
						string[] cats = ((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "Categories")).Split('|');
						string queryCat = String.Empty;
						foreach (string ca in cats)
						{
							if (ca.Length > 0) queryCat += " id=" + int.Parse(ca) + " or ";
						}
						queryCat = queryCat.Substring(0, queryCat.Length - 4);
						Repeater RepCategoriesView = (Repeater) e.Item.FindControl("RepCategoriesView");

						RepCategoriesView.DataSource = DatabaseConnection.CreateDataset("select Description from CRM_ContactCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + ")) and (" + queryCat + ")");
						RepCategoriesView.DataBind();
					}


					ReferrerDataSource(Convert.ToInt32(DataBinder.Eval((DataRowView) e.Item.DataItem, "id")));

					PurchaseForm.Visible = false;

					string tabText = (string) DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName");
					tabText = (tabText.Length > 35) ? tabText.Substring(0, 32) + "..." : tabText;
					Tab1Text.Text = "&nbsp;<span class=\"normal Mul\" onclick=\"ViewHideTabs('visContact');\">" + tabText + "</span>";
					SomeJS.Text = "<script>ViewHideTabs(\"visContact\");</script>";

					if (DataBinder.Eval((DataRowView) e.Item.DataItem, "FromLead") != DBNull.Value)
					{
						Literal LeadInfo = (Literal) e.Item.FindControl("LeadInfo");
						LeadInfo.Text = "<img src=/i/lookup.gif alt=\"" + rm.GetString("Ledtxt28") + "\" style=\"CURSOR:pointer\" onclick=\"CreateBox('/Common/LeadInfo.aspx?render=no&si=29&id=" + Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "FromLead")) + "',event,380,350)\">";
					}

					LinkButton BtnMailAuth = (LinkButton) e.Item.FindControl("BtnMailAuth");
					BtnMailAuth.Text = "<img src=/images/email.gif alt='" + rm.GetString("Bcotxt55") + "' border=0>";

					BtnMailAuth.Visible = !(bool) DataBinder.Eval((DataRowView) e.Item.DataItem, "MLFlag");

					Literal VoipCall = (Literal) e.Item.FindControl("VoipCall");
					if ((DataBinder.Eval((DataRowView) e.Item.DataItem, "Phone")).ToString().Length > 0)
					{
							string ph = StaticFunctions.FixPhoneNumber((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "Phone"));
							VoipCall.Text = MakeVoipString(ph);
					}
					else
						VoipCall.Text = String.Empty;
					break;
			}
		}


		private void FillRepeaterActivity(int companyID)
		{
			acCrono.ParentID = companyID;
			acCrono.AcType = (byte) AType.Company;

			acCrono.FromSheet = "a";
			acCrono.Refresh();

			if (acCrono.ItemCount > 0)
			{
				acCrono.Visible = true;
			}
			else
			{
				acCrono.Visible = false;
				RepeaterActivityInfo.Text = rm.GetString("CRMcontxt24");
			}
		}

		public void RepeaterActivityDatabound(object source, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton openActivity = (LinkButton) e.Item.FindControl("openActivity");
					string type = DataBinder.Eval((DataRowView) e.Item.DataItem, "Type").ToString();
					switch (type)
					{
						case "1":
							openActivity.Text = rm.GetString("Acttxt23");
							break;
						case "2":
							openActivity.Text = rm.GetString("Acttxt24");
							break;
						case "3":
							openActivity.Text = rm.GetString("Acttxt25");
							break;
						case "4":
							openActivity.Text = rm.GetString("Acttxt26");
							break;
						case "5":
							openActivity.Text = rm.GetString("Acttxt27");
							break;
						case "6":
							openActivity.Text = rm.GetString("Acttxt28");
							break;
						case "7":
							openActivity.Text = rm.GetString("Acttxt37");
							break;
					}

					HtmlImage Incoming = (HtmlImage) e.Item.FindControl("Incoming");
					if (DataBinder.Eval((DataRowView) e.Item.DataItem, "InOut").ToString() == "True")
						Incoming.Src = "/i/incoming.gif";
					else
						Incoming.Src = "/i/outcoming.gif";

					break;
			}
		}

		private void FillRepeaterOpportunity(int companyID)
		{
			StringBuilder sqlString = new StringBuilder();
			sqlString.Append("SELECT Account.Name + ' ' + Account.Surname AS Owner, CRM_Opportunity.Title, CRM_Opportunity.ID ");
			sqlString.Append("FROM CRM_Opportunity INNER JOIN ");
			sqlString.Append("CRM_OpportunityContact ON CRM_Opportunity.ID = CRM_OpportunityContact.OpportunityID LEFT OUTER JOIN ");
			sqlString.Append("Account ON CRM_Opportunity.OwnerID = Account.UID ");
			sqlString.AppendFormat("where (CRM_OpportunityContact.ContactID={0} and CRM_OpportunityContact.ContactType=0) ", companyID);

			RepeaterOpportunity.DataSource = DatabaseConnection.CreateDataset(sqlString.ToString());
			RepeaterOpportunity.DataBind();
			if (RepeaterOpportunity.Items.Count > 0)
			{
				RepeaterOpportunity.Visible = true;
			}
			else
			{
				RepeaterOpportunity.Visible = false;
				RepeaterOpportunityInfo.Text = rm.GetString("CRMcontxt25");
			}
			RepeaterOpportunityInfo.Visible = RepeaterOpportunity.Visible;
		}

		protected void ReferrerDataSource(int id)
		{
			DataTable dt = DatabaseConnection.CreateDataset("select id,Surname,Name, Phone_1,MobilePhone_1,email,active from Base_Contacts where CompanyID=" + id + " and limbo=0 order by active desc").Tables[0];
			if (dt.Rows.Count > 0)
			{
				string[] myarray = new string[dt.Rows.Count];
				for (int i = 0; i < dt.Rows.Count; i++)
				{
					myarray[i] = dt.Rows[i]["ID"] + "|" + dt.Rows[i]["Surname"] + " " + dt.Rows[i]["Name"];
				}
				if (myarray.Length > 0)
					Session["Contactarray"] = myarray;
			}
			ContactReferrer.DataSource = dt;
			ContactReferrer.DataBind();
			if (ContactReferrer.Items.Count > 0)
				ContactReferrer.Visible = true;
			else
			{
				ContactReferrer.Visible = false;
				ContactReferrerInfo.Text = rm.GetString("CRMcontxt26");
			}
		}

		protected void FillPurchase(int companyID)
		{
			string sqlString = "select CRM_Bill.* from CRM_Bill ";
			sqlString += "where CRM_Bill.CompanyID=" + companyID + " order by CRM_Bill.BillingDate,CRM_Bill.BillNumber;";
			RepeaterPurchase.DataSource = DatabaseConnection.CreateDataset(sqlString);
			RepeaterPurchase.DataBind();
			if (RepeaterPurchase.Items.Count > 0)
			{
				RepeaterPurchase.Visible = true;
				RepeaterPurchaseInfo.Visible = false;
			}
			else
			{
				RepeaterPurchase.Visible = false;
				RepeaterPurchaseInfo.Text = rm.GetString("CRMcontxt35");
			}
			PurchaseForm.Visible = false;
		}

		public static string ABCHeaderHtml(string mylist)
		{
			StringBuilder abcHtml = new StringBuilder();
			string list = " ";
			string bgColor;
			if (mylist != null) list = mylist;
			abcHtml.Append("<div id=AlfabetoRow align=center>");
			for (int x = 65; x <= 90; x++)
			{
				char ch = (char) x;
				if (list.Substring(0, 1) == "*" || ch.ToString() == list.Substring(0, 1))
				{
					bgColor = "class=\"AlfabetoSelected\"";
				}
				else
				{
					bgColor = String.Empty;
				}
				abcHtml.AppendFormat("&nbsp;<SPAN {0} onclick=\"SelABCHeader('{1}')\">{1}</SPAN>&nbsp;|", bgColor, Convert.ToChar(x));
			}
			abcHtml.AppendFormat("&nbsp;<span onclick=\"SelABCHeader('*')\">{0}</span>", rm.GetString("Reftxt2"));
			abcHtml.Append("</div>");
			return abcHtml.ToString();
		}

		private void ModifyDataSet(int id)
		{
			using (DigiDapter dg = new DigiDapter("select * from Base_Companies where id = " + id))
			{
				if (!dg.HasRows)
				{
					dg.Add("CreatedByID", UC.UserId, 'I');
				}

				if (OwnerId.Text.Length > 0)
					dg.Add("OwnerID", OwnerId.Text);
				else
					dg.Add("OwnerID", UC.UserId);

				dg.Add("CompanyName", CompanyName.Text);
				dg.Add("CompanyCode", CompanyCode.Text);
				dg.Add("VatID", VatId.Text);
				dg.Add("Phone", Phone.Text);
				dg.Add("Fax", Fax.Text);
				dg.Add("EMail", Email.Text.Trim(' '));
				dg.Add("WebSite", WebSite.Text);
				if (TurnOver.Text.Length > 0)
					dg.Add("Billed", Decimal.Parse(TurnOver.Text, UC.myDTFI));
				else
					dg.Add("Billed", Decimal.Parse("0", UC.myDTFI));

				if (Employees.Text.Length > 0)
					dg.Add("Employees", Employees.Text);
				else
					dg.Add("Employees", 0);
				dg.Add("InvoicingAddress", Invoice_Address.Text);
				dg.Add("InvoicingCity", Invoice_City.Text);
				dg.Add("InvoicingStateProvince", Invoice_StateProvince.Text);
				dg.Add("InvoicingState", Invoice_State.Text);
				dg.Add("InvoicingZIPCode", Invoice_Zip.Text);
				dg.Add("ShipmentAddress", Shipment_Address.Text);
				dg.Add("ShipmentCity", Shipment_City.Text);
				dg.Add("ShipmentStateProvince", Shipment_StateProvince.Text);
				dg.Add("ShipmentState", Shipment_State.Text);
				dg.Add("ShipmentZIPCode", Shipment_Zip.Text);
				dg.Add("ShipmentPhone", Shipment_Phone.Text);
				dg.Add("ShipmentFax", Shipment_Fax.Text);
				dg.Add("ShipmentEMail", Shipment_Email.Text);
				dg.Add("WarehouseAddress", Warehouse_Address.Text);
				dg.Add("WarehouseCity", Warehouse_City.Text);
				dg.Add("WarehouseStateProvince", Warehouse_StateProvince.Text);
				dg.Add("WarehouseState", Warehouse_State.Text);
				dg.Add("WarehouseZIPCode", Warehouse_Zip.Text);
				dg.Add("WarehousePhone", Warehouse_Phone.Text);
				dg.Add("WarehouseFax", Warehouse_Fax.Text);
				dg.Add("WarehouseEMail", Warehouse_Email.Text);
				dg.Add("Description", Description.Text);
				dg.Add("MLEmail", EmailML.Text);
				dg.Add("MLFlag", MlCheck.Checked);

				dg.Add("CompanyTypeID", Sector.SelectedItem.Value);
				dg.Add("ContactTypeID", ContactType.SelectedItem.Value);
				dg.Add("Estimate", Evaluation.SelectedItem.Value);

				if (groups.GetValue.Length > 0)
				{
					dg.Add("Groups", groups.GetValue);
				}
				else
				{
					dg.Add("Groups", "|" + UC.UserGroupId.ToString() + "|");
				}

				dg.Add("LastActivity", 1, 'U'); //MODIFICA
				dg.Add("LastModifiedDate", DateTime.UtcNow, 'U');
				dg.Add("LastModifiedByID", UC.UserId, 'U');

				string cat = "|";
				foreach (RepeaterItem it in RepCategories.Items)
				{
					CheckBox Check = (CheckBox) it.FindControl("Check");
					if (Check.Checked)
						cat += ((Literal) it.FindControl("IDCat")).Text + "|";
				}
				if (cat.Length > 1)
					dg.Add("Categories", cat);
				else
					dg.Add("Categories", DBNull.Value);

				object newId = dg.Execute("Base_Companies", "ID=" + id, DigiDapter.Identities.Identity);

				if (dg.RecordInserted)
				{
					FillFreeFields(int.Parse(newId.ToString()));
					DatabaseConnection.CommitTransaction();
					FillView(int.Parse(newId.ToString()));
				}
				else
				{
					FillFreeFields(id);
					DatabaseConnection.CommitTransaction();
					FillView(id);
				}
			}

		}

		private void FillFreeFields(int id)
		{
			string sqlStringQuery;
			sqlStringQuery = "select * from addedfields where tablename=" + (byte) CRMTables.Base_Companies + " order by vieworder";
			DataSet ds = DatabaseConnection.CreateDataset(sqlStringQuery);
			if (ds.Tables[0].Rows.Count > 0)
			{
				foreach (DataRow dr in ds.Tables[0].Rows)
				{
					if (Request.Form["Free_" + dr["name"]] != null)
					{
						string sqlString;
						sqlString = "select * from addedfields_cross where id = " + id + " and idrif=" + dr["id"];
						using (DigiDapter dg = new DigiDapter(sqlString))
						{

								dg.Add("ID", id);
								dg.Add("IDRif", dr["id"]);

							dg.Add("FIELDVAL", Request.Form["Free_" + dr["name"]]);
							if(dg.HasRows)
								dg.Execute("addedfields_cross", "id = " + id + " and idrif=" + dr["id"]);
							else
								dg.Execute("addedfields_cross", "pkey = -1");
						}
					}
					else
					{
						DatabaseConnection.DoCommand("delete from addedfields_cross where id = " + id + " and idrif=" + dr["id"]);
					}
				}
			}
		}

		public void BtnSearch_Click(Object sender, EventArgs e)
		{
			this.Search.Text=StaticFunctions.RemoveSpecialChar(this.Search.Text);
			FillFromSearch();
			DeleteGoBack(true);
		}


		private void FillFromSearch()
		{
			string queryType = String.Empty;
			string queryGroup = GroupsSecure("Base_Companies.Groups");
			if (Session["listfromsearch"].ToString() == "0") this.Repeater1Paging.CurrentPage = 1;
			switch (Request.Form["visualizationType"])
			{
				case "0":
					queryType = " and ((Base_Companies.FlagGlobalORPersonal=2 and  Base_Companies.OwnerID=" + UC.UserId + ") or (Base_Companies.FlagGlobalORPersonal<>2))";
					break;
				case "1":
					queryType = " and ((Base_Companies.FlagGlobalORPersonal=2 and  Base_Companies.OwnerID=" + UC.UserId + "))";
					break;
				case "2":
					queryType = " and ((Base_Companies.FlagGlobalORPersonal<>2) and (Base_Companies.groups like '%|" + UC.UserGroupId + "|%'))";
					break;
				case "3":
					queryType = " and ((Base_Companies.OwnerID=" + UC.UserId + "))";
					break;
			}

			StringBuilder sqlString = new StringBuilder();

			sqlString.AppendFormat("SELECT TOP {0} Base_Companies.*, ", DatabaseConnection.MaxResult);
			sqlString.Append("(Account.Surname+' '+Account.Name) as Owner ");
			sqlString.Append("FROM Base_Companies ");
			sqlString.Append("LEFT OUTER JOIN Account ON Base_Companies.OwnerID = Account.UID ");

			string search = DatabaseConnection.FilterInjection(Search.Text);

			sqlString.AppendFormat("WHERE (Limbo=0) and (Base_Companies.CompanyName LIKE '%{0}%' OR Base_Companies.CompanyCode LIKE '%{0}%' OR Base_Companies.WebSite LIKE '%{0}%' OR Base_Companies.Phone LIKE '%{0}%' OR Base_Companies.InvoicingAddress LIKE '%{0}%' OR Base_Companies.InvoicingCity LIKE '%{0}%' OR Base_Companies.InvoicingStateProvince LIKE '%{0}%' OR Base_Companies.InvoicingZIPCode LIKE '%{0}%'){1}", search, queryType);


			if (ListSector.SelectedIndex > 0)
			{
				sqlString.AppendFormat(" and (CompanyTypeID={0})", ListSector.SelectedValue);
			}
			if (ListType.SelectedIndex > 0)
			{
				sqlString.AppendFormat(" and (ContactTypeID={0})", ListType.SelectedValue);
			}
			if (ListCategory.SelectedIndex > 0)
			{
				sqlString.AppendFormat(" and (Categories like '%|{0}|%')", ListCategory.SelectedValue);
			}

			if (ListOwners.SelectedIndex > 0)
			{
				sqlString.AppendFormat(" and (OwnerID={0})", ListOwners.SelectedValue);
			}

			if (ListGroups.SelectedIndex > 0)
			{
				if (ListGroups.SelectedItem.Value != "0")
				{
					string dep = GroupDependency(Convert.ToInt32(ListGroups.SelectedItem.Value));
					if (dep.Length > 1)
					{
						string[] arryD = dep.Split('|');
						string qGroup = String.Empty;
						foreach (string ut in arryD)
						{
							if (ut.Length > 0) qGroup += "Base_Companies.groups like '%|" + ut + "|%' or ";
						}
						if (qGroup.Length > 0) qGroup = qGroup.Substring(0, qGroup.Length - 3);
						sqlString.AppendFormat(" and ({0})", qGroup);
					}
					else
					{
						sqlString.AppendFormat(" and (Base_Companies.groups like '%|{0}|%')", ListGroups.SelectedItem.Value);
					}
				}
			}
			else
			{
				if (queryGroup.Length > 0)
				{
					sqlString.AppendFormat(" and ({0})", queryGroup);
				}
			}

			if (Days.SelectedIndex > 0)
			{
				sqlString.AppendFormat(" and (NoContact=0 and LastContact<getdate()-{0})", Days.SelectedValue);
			}


			Repeater1Paging.PageSize = UC.PagingSize;
			Repeater1Paging.RepeaterObj = Repeater1;
			InitSheetPaging(sqlString.ToString() + " ORDER BY Base_Companies.CompanyName");
			Repeater1Paging.sqlRepeater = sqlString.ToString() + " ORDER BY Base_Companies.CompanyName";
			Repeater1Paging.BuildGrid();


			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				RepeaterInfo.Visible = false;

			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Bcotxt41");

				if (Search.Text.Length > 0)
				{
					RepeaterInfo.Text += "<br><br><span style=\"cursor:pointer;color:#000000;text-decoration:underline;\" onclick=\"SubmitReferrer();\">" +
						rm.GetString("CRMcontxt63") + "</span>" +
						"<br><br><span style=\"cursor:pointer;color:#000000;text-decoration:underline;\" onclick=\"SubmitLead();\">" +
						rm.GetString("CRMcontxt79") + "</span></center>";
				}
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}


			tabControl.Visible = false;
			ContactForm.Visible = false;
			ViewContact.Visible = false;
			Session["listfromsearch"] = "1";
		}

		public void RapSubmit_Click(Object sender, EventArgs e)
		{
			if (RapCompanyName.Text.Length > 0)
			{
				using (DigiDapter dg = new DigiDapter())
				{
					dg.Add("CreatedByID", UC.UserId);
					dg.Add("CompanyName", RapCompanyName.Text);
					dg.Add("Phone", RapTelephone.Text);
					dg.Add("EMail", RapEmail.Text.Trim(' '));
					dg.Add("OwnerID", UC.UserId);
					dg.Add("Groups", "|" + UC.AdminGroupId + "|" + UC.UserGroupId + "|");

					object newId = dg.Execute("Base_Companies", "ID=-1", DigiDapter.Identities.Identity);

					SetGoBack("/crm/crm_companies.aspx?m=25&si=29&gb=1", new string[2] {newId.ToString(), "d"});

					RapInfo.Text = "\"<a href=/crm/crm_companies.aspx?m=25&si=29&gb=1><span class=divautoformRequired>" + RapCompanyName.Text + "</span></a>\" " + rm.GetString("Bcotxt43");
					RapCompanyName.Text = String.Empty;
					RapTelephone.Text = String.Empty;
					RapEmail.Text = String.Empty;

				}
			}
			else
			{
				RapInfo.Text = rm.GetString("Bcotxt48");
			}
		}

		public void ConSubmit_Click(Object sender, EventArgs e)
		{
			ModifyDataSet(int.Parse(ContactId.Text));
			sheetP.Visible = true;
		}

		public void ConCancel_Click(Object sender, EventArgs e)
		{
			if (ContactId.Text == "-1")
			{
				Response.Redirect("/CRM/crm_companies.aspx?m=1&si=3");
			}
			else
			{
				FillView(int.Parse(ContactId.Text));
				sheetP.Visible = true;
			}

		}


		public void Repeater1_Grid_ItemCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "modify":
					FillForm(int.Parse(((Literal) e.Item.FindControl("IDCat")).Text));
					break;
				case "delete":
					Base_Contacts.Delete(int.Parse(((Literal) e.Item.FindControl("IDCat")).Text), UC.UserId, "Base_Companies");
					if (Session["listfromsearch"].ToString() == "0")
						FillRepeater(Request.Params["List"].ToString());
					else
						FillFromSearch();
					break;
				case "view":
					Session["contact"] = ((Literal) e.Item.FindControl("IDCat")).Text;
					if (this.sheetP.IDArray.Length > 0)
					{
						string[] tempArray = this.sheetP.IDArray;
						for (int i = 0; i < tempArray.Length; i++)
						{
							if (tempArray[i].Split('|')[0].CompareTo(((Literal) e.Item.FindControl("IDCat")).Text) == 0)
							{
								this.sheetP.CurrentPosition = i;
								this.sheetP.enabledisable();
								break;
							}
						}
					}
					FillView(int.Parse(((Literal) e.Item.FindControl("IDCat")).Text));
					break;
			}
		}

		public void Repeater1_ItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					DataRowView drv = (DataRowView) e.Item.DataItem;
					LinkButton lk = (LinkButton) e.Item.FindControl("Delete");
					lk.Text = "<img src=/i/erase.gif border=0 alt=\"" + rm.GetString("CRMcontxt44") + "\">";
					string[] arryD = UC.GroupDependency.Split('|');
					string conGroup = drv["Groups"].ToString();
					lk.Visible = false;
					foreach (string ut in arryD)
					{
						if (ut.Length > 0)
						{
							if (conGroup.IndexOf("|" + ut + "|") >= 0)
							{
								lk.Visible = true;
								lk.Attributes.Add("onclick", "return confirm('" + rm.GetString("Bcotxt44") + "');");
								break;
							}
						}
					}

					Label sc = (Label) e.Item.FindControl("ShortDescription");
					string desc = drv["Description"].ToString();
					sc.Text = desc;
					if (sc.Text.Length > 30)
					{
						Regex r = new Regex(@"(?s)\b.{1,28}\b");
						sc.ToolTip = sc.Text;
						sc.Text = r.Match(sc.Text) + "&hellip;";
						sc.Attributes.Add("style", "cursor:help;");
					}

					LinkButton View = (LinkButton) e.Item.FindControl("View");
					if (View.Text.Length > 30)
					{
						Regex r = new Regex(@"(?s)\b.{1,28}\b");
						View.ToolTip = View.Text;
						View.Text = r.Match(View.Text) + "&hellip;";
						View.Attributes.Add("style", "cursor:help;");
					}
					break;
				case ListItemType.Footer:
					Literal RepCounter = (Literal) e.Item.FindControl("RepCounter");
					RepCounter.Text = this.Repeater1Paging.RowCount.ToString();
					if (this.Repeater1Paging.RowCount >= 100)
						RepCounter.Text += " (" + string.Format(rm.GetString("top100"), DatabaseConnection.MaxResult) + ")";
					break;
			}
		}

		public void ViewContact_Grid_ItemCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "modCon":
					FillForm(int.Parse(((Literal) e.Item.FindControl("IDCon")).Text));

					string strScript = "<SCRIPT>" + Environment.NewLine +
						"needsave('" + rm.GetString("CRMcontxt77") + "');" + Environment.NewLine +
						"</SCRIPT>";

					Page.RegisterStartupScript("anything", strScript);
					CancelCon.Attributes.Add("onclick", "needsave('no')");
					SubmitCon.Attributes.Add("onclick", "needsave('no');return ValidatecompanyName();");
					SubmitRef.Attributes.Add("onclick", "needsave('no');return ValidatecompanyName();");

					RefreshRepCategories.Attributes.Add("onclick", "needsave('no')");

					visReferrer.Visible = false;
					visActivity.Visible = false;
					visOpportunity.Visible = false;
					visPurchase.Visible = false;
					visDocuments.Visible = false;
					visProducts.Visible = false;
					visEstimate.Visible = false;
					activeMode.Value = "edit";
					sheetP.Visible = false;
					break;
				case "NewRef":
					Response.Redirect("/CRM/base_contacts.aspx?action=NEW");
					break;
				case "backToSearch":
					tabControl.Visible = false;
					Repeater1.Visible = true;
					this.Repeater1Paging.Visible = true;

					break;
				case "btnMailAuth":
					TemplateAdmin ta = new TemplateAdmin();
					ta.TemplateName = "MailAuthContacts";
					ta.Language = UC.CultureSpecific;
					ta.ApplicationPath = Request.PhysicalApplicationPath;
					string template = ta.GetTemplate();
					if (template == "0" || template == "1")
					{
						Page.RegisterStartupScript("", "<script>alert('" + rm.GetString("Bcotxt58") + "');</script>");
					}
					else
					{
						Guid gu = Guid.NewGuid();
						template = template.Replace("[guid]", gu.ToString());
						template = template.Replace("[Tustena.Account]", UC.UserRealName);

						int iDCon = int.Parse(((Literal) e.Item.FindControl("IDCon")).Text);
						template = template.Replace("[Tustena.Email]", ((Literal) e.Item.FindControl("LtrEmail")).Text);
						DatabaseConnection.DoCommand("insert into ml_auth (id,tableid,fieldid) values ('" + gu.ToString() + "',0," + iDCon + ")");
						MessagesHandler.SendMail(((Literal) e.Item.FindControl("LtrEmail")).Text,
						         UC.MailingAddress,
						         "[Tustena] " + rm.GetString("Bcotxt56"),
						         template);
						Page.RegisterStartupScript("", "<script>alert('" + rm.GetString("Bcotxt57") + "');</script>");
					}
					break;
			}
		}

		private void InitAjax()
		{
			Manager.Register(this, "Ajax.Companies", Debug.None);
		}

		[Method]
		public string CheckDuplicatedCompanies(string companyName)
		{
			return DatabaseConnection.SqlScalar("select CompanyName from Base_Companies where CompanyName like '" + DatabaseConnection.FilterInjection(companyName) + "%'");
		}

		public void RepeaterActivityCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "OpenAC":
					SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[2] {Session["contact"].ToString(), "a"});
					Response.Redirect("/CRM/CRM_Activity.aspx?a=" + ((Label) e.Item.FindControl("IDAc")).Text + "&t=" + ((Label) e.Item.FindControl("TypeAc")).Text);
					break;
			}
		}

		public void RepeaterOpportunityCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "openOP":
					SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[2] {Session["contact"].ToString(), "o"});
					Response.Redirect("/CRM/CRM_Opportunity.aspx?m=25&si=37&o=" + ((Literal) e.Item.FindControl("IdOp")).Text);
					break;
			}
		}

		private void Fill_Sectors(DropDownList st)
		{
			DataSet ds;
			ds = DatabaseConnection.CreateDataset("Select K_ID,Description from CompanyType where lang='" + UC.Culture.Substring(0, 2) + "' order by Description");
			st.DataSource = ds;
			st.DataTextField = "Description";
			st.DataValueField = "K_ID";
			st.DataBind();
			st.Items.Insert(0, rm.GetString("CRMcontxt13"));
			st.Items[0].Value = "0";
		}

		private void Fill_ContactType(DropDownList ct)
		{
			DataSet ds;
			ds = DatabaseConnection.CreateDataset("Select K_ID,ContactType from ContactType where lang='" + UC.Culture.Substring(0, 2) + "' order by ContactType");
			ct.DataSource = ds;
			ct.DataTextField = "ContactType";
			ct.DataValueField = "K_ID";
			ct.DataBind();
			ct.Items.Insert(0, rm.GetString("CRMcontxt14"));
			ct.Items[0].Value = "0";
		}

		private void Fill_Owners(DropDownList ct)
		{
			ct.DataTextField = "Utetx";
			ct.DataValueField = "uid";
			ct.DataSource = DatabaseConnection.CreateDataset("select uid,(Name+' '+Surname) as Utetx from Account");
			ct.DataBind();
			ct.Items.Insert(0, rm.GetString("Caltxt51"));
			ct.SelectedIndex = 0;
			ct.Items[0].Value = "0";
		}

		private void Fill_Evaluation(DropDownList ct)
		{
			DataSet ds;
			ds = DatabaseConnection.CreateDataset("Select K_ID,Estimate from ContactEstimate where lang='" + UC.Culture.Substring(0, 2) + "' order by FieldOrder");
			ct.DataSource = ds;
			ct.DataTextField = "Estimate";
			ct.DataValueField = "K_ID";
			ct.DataBind();
			ct.Items.Insert(0, rm.GetString("CRMcontxt15"));
			ct.Items[0].Value = "0";
		}

		public void NewActivity_Click(Object sender, EventArgs e)
		{
			SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[] {Session["contact"].ToString(), "a"});
			Session["AcCompanyID"] = Session["contact"].ToString();
			switch (((LinkButton) sender).ID)
			{
				case "NewActivityPhone":
					Session["AType"] = 1;
					break;
				case "NewActivityLetter":
					Session["AType"] = 2;
					break;
				case "NewActivityFax":
					Session["AType"] = 3;
					break;
				case "NewActivityMemo":
					Session["AType"] = 4;
					break;
				case "NewActivityEmail":
					Session["AType"] = 5;
					break;
				case "NewActivityVisit":
					Session["AType"] = 6;
					break;
				case "NewActivityGeneric":
					Session["AType"] = 7;
					break;
				case "NewActivitySolution":
					Session["AType"] = 8;
					break;
			}
			Response.Redirect("/WorkingCRM/AllActivity.aspx?m=25&si=38");
		}

		public void Btn_Click(Object sender, EventArgs e)
		{
			this.sheetP.Visible = false;
			switch (((LinkButton) sender).ID)
			{
				case "Purchase_Submit":
					rvBillNumber.Validate();
					cvBillingDate.Validate();
					rvBillingDate.Validate();
					rvExpirationDate.Validate();


					if (rvBillNumber.IsValid &&
						cvBillingDate.IsValid &&
						rvBillingDate.IsValid &&
						rvExpirationDate.IsValid)
					{
						if (((TextBox) PurchaseForm.FindControl("Purchase_ID")).Text == "-1")
						{
							InsertNewPurchase("-1");
						}
						else
						{
							InsertNewPurchase(((TextBox) PurchaseForm.FindControl("Purchase_ID")).Text);
						}

						PurchaseForm.Visible = false;
						RepeaterPurchase.Visible = true;
						tdTab1.Style.Add("display", "inline");
						tdTab2.Style.Add("display", "inline");
						tdTab3.Style.Add("display", "inline");
						tdTab4.Style.Add("display", "inline");
						tdTab5.Style.Add("display", "inline");
						tdTab6.Style.Add("display", "inline");
						tdTab7.Style.Add("display", "inline");
						tdTab8.Style.Add("display", "inline");
					}
					break;
				case "Purchase_Exit":
					PurchaseForm.Visible = false;
					RepeaterPurchase.Visible = true;
					tdTab1.Style.Add("display", "inline");
					tdTab2.Style.Add("display", "inline");
					tdTab3.Style.Add("display", "inline");
					tdTab4.Style.Add("display", "inline");
					tdTab5.Style.Add("display", "inline");
					tdTab6.Style.Add("display", "inline");
					tdTab7.Style.Add("display", "inline");
					tdTab8.Style.Add("display", "inline");
					break;
				case "NewPurchase":
					tdTab1.Style.Add("display", "none");
					tdTab2.Style.Add("display", "none");
					tdTab3.Style.Add("display", "none");
					tdTab4.Style.Add("display", "none");
					tdTab5.Style.Add("display", "none");
					tdTab6.Style.Add("display", "none");
					tdTab7.Style.Add("display", "none");
					tdTab8.Style.Add("display", "none");
					ClearTextBoxPurchase(PurchaseForm.Controls.GetEnumerator());
					Session.Remove("newprod");
					RepeaterPurchaseProduct.Visible = false;
					PurchaseForm.Visible = true;
					RepeaterPurchase.Visible = false;
					SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[] {Session["contact"].ToString(), "e"});
					NewPurchase.Visible = false;
					GoBackPurc.Text = "&nbsp;&uarr;&nbsp;";
					GoBackPurc.Visible = true;
					break;

				case "RefreshRepCategories":
					FillRepCategories();
					Page.RegisterClientScriptBlock("xxx", "<script>g_fFieldsChanged=1;</script>");
					break;
				case "BtnViewAdvanced":
					PrepareAdvanced();
					break;

				case "AllActivity":
					FillRepeaterActivity(int.Parse(Session["contact"].ToString()));
					SomeJS.Text = "<script>ViewHideTabs(\"visActivity\");</script>";
					break;
				case "NewDoc":
					SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[] {Session["contact"].ToString(), "f"});
					Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=c");
					break;
				case "SaveNewProduct":
					SaveProduct();
					NewProduct.Visible = false;
					RepeaterProducts.Visible = true;
					tdTab1.Style.Add("display", "inline");
					tdTab2.Style.Add("display", "inline");
					tdTab3.Style.Add("display", "inline");
					tdTab4.Style.Add("display", "inline");
					tdTab5.Style.Add("display", "inline");
					tdTab6.Style.Add("display", "inline");
					tdTab7.Style.Add("display", "inline");
					tdTab8.Style.Add("display", "inline");
					break;
				case "ResetNewProduct":
					CRM_CompetitorProducts_ProductName.Text = String.Empty;
					CRM_CompetitorProducts_Price.Text = String.Empty;
					CRM_CompetitorProducts_Description.Text = String.Empty;
					CRM_CompetitorProducts_UnitPrice.Text = String.Empty;
					CRM_CompetitorProducts_Package.Text = String.Empty;
					NewProduct.Visible = false;
					RepeaterProducts.Visible = true;
					tdTab1.Style.Add("display", "inline");
					tdTab2.Style.Add("display", "inline");
					tdTab3.Style.Add("display", "inline");
					tdTab4.Style.Add("display", "inline");
					tdTab5.Style.Add("display", "inline");
					tdTab6.Style.Add("display", "inline");
					tdTab7.Style.Add("display", "inline");
					tdTab8.Style.Add("display", "inline");
					break;
				case "InsertNewProduct":
					CRM_CompetitorProducts_ProductName.Text = String.Empty;
					CRM_CompetitorProducts_Price.Text = String.Empty;
					CRM_CompetitorProducts_Description.Text = String.Empty;
					CRM_CompetitorProducts_ID.Text = "-1";
					CRM_CompetitorProducts_UnitPrice.Text = String.Empty;
					CRM_CompetitorProducts_Package.Text = String.Empty;
					NewProduct.Visible = true;
					RepeaterProducts.Visible = false;
					tdTab1.Style.Add("display", "none");
					tdTab2.Style.Add("display", "none");
					tdTab3.Style.Add("display", "none");
					tdTab4.Style.Add("display", "none");
					tdTab5.Style.Add("display", "none");
					tdTab6.Style.Add("display", "none");
					tdTab7.Style.Add("display", "none");
					tdTab8.Style.Add("display", "none");
					SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[] {Session["contact"].ToString(), "g"});
					InsertNewProduct.Visible = false;
					GoBackProd.Text = "&nbsp;&uarr;&nbsp;";
					GoBackProd.Visible = true;
					break;
				case "NewContact":
					SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", new string[] {Session["contact"].ToString(), "c"});
					Response.Redirect("/CRM/base_contacts.aspx?m=25&si=31&action=NEW");
					break;
			}
		}

		private void SaveProduct()
		{
			int id = int.Parse(CRM_CompetitorProducts_ID.Text);
			string sqlString = "select id from CRM_CompetitorProducts where id=" + id;
			using (DigiDapter dg = new DigiDapter(sqlString))
			{
				if (!dg.HasRows)
				{
					dg.Add("CompetitorID", Session["Contact"].ToString(), 'I');
				}
				dg.Add("ProductName", (CRM_CompetitorProducts_ProductName.Text.Length > 0) ? CRM_CompetitorProducts_ProductName.Text : "");
				dg.Add("Price", (CRM_CompetitorProducts_Price.Text.Length > 0) ? StaticFunctions.FixDecimal(CRM_CompetitorProducts_Price.Text) : 0);
				dg.Add("ProductDescription", (CRM_CompetitorProducts_Description.Text.Length > 0) ? CRM_CompetitorProducts_Description.Text : "");
				if (CRM_CompetitorProducts_UnitPrice.Text.Length > 0)
					dg.Add("UnitPrice", StaticFunctions.FixDecimal(CRM_CompetitorProducts_UnitPrice.Text));
				if (CRM_CompetitorProducts_Package.Text.Length > 0)
					dg.Add("Package", CRM_CompetitorProducts_Package.Text);
				dg.Execute("CRM_CompetitorProducts", "id=" + id);
			}
			FillRepeaterProducts(int.Parse(Session["Contact"].ToString()));

		}


		private void PrepareAdvanced()
		{
			Repeater1.Visible = false;
			tabControl.Visible = false;
			AdvancedSearch.Visible = true;
		}


		private void ClearTextBoxPurchase(IEnumerator i)
		{
			while (i.MoveNext())
			{
				if (i.Current.GetType().Name == "TextBox")
				{
					TextBox t = (TextBox) i.Current;
					if (t.ID == "purchase_ID")
						t.Text = "-1";
					else if (t.ID == "purchase_RowsNumber")
						t.Text = "1";
					else
						t.Text = String.Empty;
				}
				else
				{
					Control y = (Control) i.Current;
					ClearTextBoxPurchase(y.Controls.GetEnumerator());
				}
			}
		}


		private void InsertNewPurchase(string id)
		{
			if(id.Length<=0)id="-1";
			decimal subTotal = 0;
			string billId;
			ArrayList pp = new ArrayList();
			using (DigiDapter dg = new DigiDapter())
			{
				if (Session["newprod"] != null)
				{
					pp = (ArrayList) Session["newprod"];
					foreach (PurchaseProduct Pprod in pp)
					{
						subTotal += Pprod.FinalPrice;
					}
				}

				dg.Add("BillingDate", Convert.ToDateTime(((TextBox) PurchaseForm.FindControl("Purchase_BillingDate")).Text, UC.myDTFI));
				dg.Add("ExpirationDate", Convert.ToDateTime(((TextBox) PurchaseForm.FindControl("Purchase_ExpirationDate")).Text, UC.myDTFI));
				dg.Add("BillNumber", ((TextBox) PurchaseForm.FindControl("Purchase_BillNumber")).Text);
				if (((TextBox) PurchaseForm.FindControl("Purchase_PaymentDate")).Text.Length > 0)
					dg.Add("PaymentDate", Convert.ToDateTime(((TextBox) PurchaseForm.FindControl("Purchase_PaymentDate")).Text, UC.myDTFI));
				dg.Add("Payment", (((CheckBox) PurchaseForm.FindControl("Purchase_Payment")).Checked) ? 1 : 0);
				dg.Add("TotalPrice", subTotal);

				dg.Add("Note", ((TextBox) PurchaseForm.FindControl("Purchase_Note")).Text);
				dg.Add("CreatedDate", DateTime.UtcNow);
				dg.Add("CreatedByID", UC.UserId);
				dg.Add("CompanyID", Session["contact"]);
				dg.Add("LastModifiedDate", DateTime.UtcNow);
				dg.Add("LastModifiedByID", UC.UserId);

				if (Purchase_TextboxOwnerID.Text.Length > 0 && Convert.ToInt32(Purchase_TextboxOwnerID.Text) > 0)
					dg.Add("OwnerID", Convert.ToInt32(this.Purchase_TextboxOwnerID.Text));
				else
					dg.Add("OwnerID", 0);

				object newId = dg.Execute("CRM_Bill", "ID=" + id, DigiDapter.Identities.Identity);

				billId = (id == "-1") ? newId.ToString() : id;
			}

			if (id != "-1")
			{
				DatabaseConnection.DoCommand("DELETE FROM CRM_BillRows where billId=" + id);

			}

			if (pp.Count > 0)
			{
				foreach (PurchaseProduct Pprod in pp)
				{
					using (DigiDapter dg = new DigiDapter())
					{
						dg.Add("CreatedDate", DateTime.UtcNow);
						dg.Add("CreatedByID", UC.UserId);
						dg.Add("LastModifiedDate", DateTime.UtcNow);
						dg.Add("LastModifiedByID", UC.UserId);

						dg.Add("BillID", billId);
						dg.Add("Description", Pprod.ShortDescription);
						dg.Add("UnitPrice", Pprod.UnitPrice);
						dg.Add("ListPrice", Pprod.ListPrice);
						dg.Add("FinalPrice", Pprod.FinalPrice);
						dg.Add("Tax", Pprod.Vat);
						dg.Add("ProductID", Pprod.id);
						dg.Add("UM", Pprod.UM);
						dg.Add("Qta", Pprod.Qta);
						dg.Execute("CRM_BillRows");
					}
				}

			}
			Session.Remove("newprod");
			FillPurchase(int.Parse(Session["contact"].ToString()));
		}


		public void RepeaterPurchaseCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "openPurchase":
					Literal PurchaseID = (Literal) e.Item.FindControl("PurchaseID");
					DataSet ds = DatabaseConnection.CreateDataset("select * from CRM_Bill where id=" + int.Parse(PurchaseID.Text));

					TextBox Purchase_BillingDate = (TextBox) PurchaseForm.FindControl("Purchase_BillingDate");
					TextBox Purchase_PaymentDate = (TextBox) PurchaseForm.FindControl("Purchase_PaymentDate");
					TextBox Purchase_ExpirationDate = (TextBox) PurchaseForm.FindControl("Purchase_ExpirationDate");
					TextBox Purchase_BillNumber = (TextBox) PurchaseForm.FindControl("Purchase_BillNumber");

					TextBox Purchase_Note = (TextBox) PurchaseForm.FindControl("Purchase_Note");
					CheckBox Purchase_Payment = (CheckBox) PurchaseForm.FindControl("Purchase_Payment");
					TextBox Purchase_ID = (TextBox) PurchaseForm.FindControl("Purchase_ID");

					Purchase_ID.Text = PurchaseID.Text;
					Purchase_BillingDate.Text = Convert.ToDateTime(ds.Tables[0].Rows[0]["BillingDate"]).ToShortDateString();
					Purchase_PaymentDate.Text = (ds.Tables[0].Rows[0]["PaymentDate"] != DBNull.Value) ? Convert.ToDateTime(ds.Tables[0].Rows[0]["PaymentDate"]).ToShortDateString() : "";
					Purchase_ExpirationDate.Text = Convert.ToDateTime(ds.Tables[0].Rows[0]["ExpirationDate"]).ToShortDateString();
					Purchase_BillNumber.Text = ds.Tables[0].Rows[0]["BillNumber"].ToString();

					Purchase_Note.Text = ds.Tables[0].Rows[0]["Note"].ToString();
					Purchase_Payment.Checked = (bool) ds.Tables[0].Rows[0]["Payment"];
					if ((long) ds.Tables[0].Rows[0]["OwnerID"] > 0)
					{
						this.Purchase_TextboxOwnerID.Text = ds.Tables[0].Rows[0]["OwnerID"].ToString();
						this.Purchase_TextboxOwner.Text = DatabaseConnection.SqlScalar("select isnull(Name,'')+' '+isnull(surname,'') as owner from account where uid=" + ds.Tables[0].Rows[0]["OwnerID"].ToString());
					}
					else
					{
						this.Purchase_TextboxOwnerID.Text = string.Empty;
						this.Purchase_TextboxOwner.Text = string.Empty;
					}

					ds.Clear();

					ds = DatabaseConnection.CreateDataset("select * from CRM_BillRows where billId=" + int.Parse(PurchaseID.Text));
					ArrayList pp = new ArrayList();
					foreach (DataRow d in ds.Tables[0].Rows)
					{
						PurchaseProduct Pprod = new PurchaseProduct();

						Pprod.id = Convert.ToInt64(d["ProductID"]);
						Pprod.ShortDescription = (Pprod.id > 0) ? DatabaseConnection.SqlScalar("select shortDescription from CatalogProducts where id=" + d["ProductID"].ToString()) : d["Description"].ToString();
						Pprod.LongDescription = d["Description"].ToString();
						Pprod.UM = (string) d["UM"];
						Pprod.Qta = (int) d["Qta"];
						Pprod.UnitPrice = (decimal) d["UnitPrice"];
						Pprod.Vat = Convert.ToInt32(d["Tax"]);
						Pprod.ListPrice = (decimal) d["ListPrice"];
						Pprod.FinalPrice = (decimal) d["FinalPrice"];
						Pprod.ObId = pp.Count;
						pp.Add(Pprod);

					}

					Session["newprod"] = pp;

					RepeaterPurchaseProduct.DataSource = pp;
					RepeaterPurchaseProduct.DataBind();
					RepeaterPurchaseProduct.Visible = true;

					PurchaseForm.Visible = true;
					RepeaterPurchase.Visible = false;

					tdTab1.Style.Add("display", "none");
					tdTab2.Style.Add("display", "none");
					tdTab3.Style.Add("display", "none");
					tdTab4.Style.Add("display", "none");
					tdTab5.Style.Add("display", "inline");
					tdTab6.Style.Add("display", "none");
					tdTab7.Style.Add("display", "none");
					tdTab8.Style.Add("display", "none");

					break;
			}
		}

		public void ViewAgenda_Click(object sender, EventArgs e)
		{
			string[] bparam = new string[2];
			if (tabControl.Visible && Session["contact"] != null)
			{
				bparam[0] = Session["contact"].ToString();
				Trace.Warn("activetab", activeTab.Value);
				switch (activeTab.Value)
				{
					case "visReferrer":
						bparam[1] = "c";
						break;
					case "visActivity":
						bparam[1] = "a";
						break;
					case "visOpportunity":
						bparam[1] = "o";
						break;
					case "visReminder":
						bparam[1] = "r";
						break;
					case "visPurchase":
						bparam[1] = "p";
						break;
					default:
						bparam[1] = "d";
						break;
				}
			}
			else
			{
				bparam[1] = "nn";
			}
			SetGoBack("/CRM/crm_companies.aspx?m=25&si=29&gb=1", bparam);
			Response.Redirect("/calendar/agenda.aspx?m=25&si=2");
		}

		public void TabControl_Click(object sender, EventArgs e)
		{
			Trace.Warn(((LinkButton) sender).ID);
			switch (((LinkButton) sender).ID)
			{
				case "Tab3Text":
					FillRepeaterActivity(int.Parse(Session["contact"].ToString()));
					SomeJS.Text = "<script>ViewHideTabs(\"visActivity\");</script>";
					break;
				case "Tab4Text":
					FillRepeaterOpportunity(int.Parse(Session["contact"].ToString()));
					SomeJS.Text = "<script>ViewHideTabs(\"visOpportunity\");</script>";
					break;
				case "Tab5Text":
					FillPurchase(int.Parse(Session["contact"].ToString()));
					SomeJS.Text = "<script>ViewHideTabs(\"visPurchase\");</script>";
					break;
				case "Tab6Text":
					Session["review"] = "0";
					FillFileRep(int.Parse(Session["contact"].ToString()));
					SomeJS.Text = "<script>ViewHideTabs(\"visDocuments\");</script>";
					break;
				case "Tab7Text":
					FillRepeaterProducts(int.Parse(Session["contact"].ToString()));
					SomeJS.Text = "<script>ViewHideTabs(\"visProducts\");</script>";
					break;
				case "Tab8Text":
					break;
			}
		}


		private void FillRepeaterProducts(int id)
		{
			RepeaterProducts.DataSource = DatabaseConnection.CreateDataset("select * from CRM_CompetitorProducts where CompetitorID=" + id);
			RepeaterProducts.DataBind();
			if (RepeaterProducts.Items.Count > 0)
			{
				RepeaterProductsInfo.Visible = false;
				RepeaterProducts.Visible = true;
			}
			else
			{
				RepeaterProductsInfo.Visible = true;
				RepeaterProducts.Visible = false;
				RepeaterProductsInfo.Text = rm.GetString("CRMcontxt62");
			}
		}

		public void RepeaterProductsCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "openProd":
					Literal IdProduct = (Literal) e.Item.FindControl("IdProduct");
					DataSet ProdDS = DatabaseConnection.CreateDataset("select * from CRM_CompetitorProducts where id=" + int.Parse(IdProduct.Text));
					CRM_CompetitorProducts_ID.Text = IdProduct.Text;
					CRM_CompetitorProducts_ProductName.Text = ProdDS.Tables[0].Rows[0]["ProductName"].ToString();
					CRM_CompetitorProducts_Price.Text = String.Format("{0:###00.00}", ProdDS.Tables[0].Rows[0]["Price"]);
					CRM_CompetitorProducts_Description.Text = ProdDS.Tables[0].Rows[0]["ProductDescription"].ToString();
					CRM_CompetitorProducts_UnitPrice.Text = String.Format("{0:###00.00}", ProdDS.Tables[0].Rows[0]["UnitPrice"]);
					CRM_CompetitorProducts_Package.Text = String.Format("{0:###00.00}", ProdDS.Tables[0].Rows[0]["Package"]);
					RepeaterProducts.Visible = false;
					NewProduct.Visible = true;
					tdTab1.Style.Add("display", "none");
					tdTab2.Style.Add("display", "none");
					tdTab3.Style.Add("display", "none");
					tdTab4.Style.Add("display", "none");
					tdTab5.Style.Add("display", "none");
					tdTab6.Style.Add("display", "none");
					tdTab7.Style.Add("display", "none");
					tdTab8.Style.Add("display", "none");
					break;
			}
		}

		public void FileRepCommand(object source, RepeaterCommandEventArgs e)
		{
			Trace.Warn(e.CommandName);
			Literal FileId = (Literal) e.Item.FindControl("FileId");
			switch (e.CommandName)
			{
				case "down":

					DataSet ds = DatabaseConnection.CreateDataset("select * from filemanager where id=" + int.Parse(FileId.Text));

					string fileName;
					fileName = ConfigSettings.DataStoragePath + Path.DirectorySeparatorChar + ds.Tables[0].Rows[0]["guid"];
					string realFileName = ds.Tables[0].Rows[0]["filename"].ToString();
					string downFile = fileName + Path.GetExtension(realFileName);
					if (File.Exists(downFile))
					{
						Response.AddHeader("Content-Disposition", "attachment; fileName=" + realFileName);
						Response.ContentType = "application/octet-stream";
						Response.TransmitFile(downFile);
						Response.Flush();
						Response.End();
						return;
					}
					else if (File.Exists(fileName))
					{
						File.Move(fileName, downFile);
						Response.AddHeader("Content-Disposition", "attachment; fileName=" + realFileName);
						Response.ContentType = "application/octet-stream";
						Response.TransmitFile(downFile);
						Response.Flush();
						Response.End();
						return;
					}
					else
					{
						G.SendError("File lost", downFile);
					}

					break;
				case "modify":
				case "revision":
					Session["IdDoc"] = FileId.Text;
					SetGoBack("crm_companies.aspx?m=25&si=29&gb=1", new string[2] {Session["contact"].ToString(), "f"});
					if (e.CommandName == "Modify")
						Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=m");
					else
						Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=e");
					break;
				case "reviewNumber":
					Session["review"] = "1";
					StringBuilder sqlString = new StringBuilder();
					int fileId = int.Parse(((Literal) e.Item.FindControl("FileId")).Text);
					sqlString.Append("select filemanager.*, filescategories.description as catdesc,(Account.Name+' '+Account.Surname) as owner from filemanager ");
					sqlString.Append("left outer join filescategories on filemanager.type=filescategories.id ");
					sqlString.Append("left outer join Account on filemanager.OwnerID=Account.uid ");
					sqlString.Append("where (filemanager.ownerid=" + UC.UserId + " or " + GroupsSecure("FileManager.Groups") + ") ");
					sqlString.Append("and (filemanager.id=" + fileId + " or filemanager.IsReview=" + fileId + ") ");
					sqlString.Append("order by ReviewNumber desc");

					FileRep.DataSource = DatabaseConnection.CreateDataset(sqlString.ToString());
					FileRep.DataBind();
					break;
			}
		}

		public void FileRepDatabound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton modify = (LinkButton) e.Item.FindControl("Modify");
					modify.Text = rm.GetString("Dsttxt16");
					LinkButton Revision = (LinkButton) e.Item.FindControl("Revision");
					Revision.Text = rm.GetString("Dsttxt13");

					LinkButton ReviewNumber = (LinkButton) e.Item.FindControl("ReviewNumber");
					Literal LbReviewNumber = (Literal) e.Item.FindControl("LbReviewNumber");
					if (Session["review"].ToString() == "0")
					{
						ReviewNumber.Visible = (ReviewNumber.Text != "0");
						Revision.Visible = true;
						LbReviewNumber.Visible = false;
					}
					else
					{
						ReviewNumber.Visible = false;
						Revision.Visible = false;
						LbReviewNumber.Visible = (LbReviewNumber.Text != "0");
					}
					LinkButton down = (LinkButton) e.Item.FindControl("Down");
					string ext = Path.GetExtension(down.Text);
					Image FileImg = (Image) e.Item.FindControl("FileImg");
					FileImg.ImageUrl = FileFunctions.GetFileImg(ext);
					break;
			}
		}


		public void FillFileRep(int id)
		{
			string sqlString = "select filemanager.*, filescategories.description as catdesc,(Account.Name+' '+Account.Surname) as owner from filemanager ";
			sqlString += "left outer join filescategories on filemanager.type=filescategories.id ";
			sqlString += "left outer join FileCrossTables on filemanager.id=FileCrossTables.IDFile ";
			sqlString += "left outer join Account on filemanager.OwnerID=Account.uid ";
			sqlString += "where IsReview=0 and FileCrossTables.TableName='Base_Companies' and FileCrossTables.IDRif=" + id;

			FileRep.DataSource = DatabaseConnection.CreateDataset(sqlString);
			FileRep.DataBind();
			if (FileRep.Items.Count > 0)
			{
				FileRepInfo.Visible = false;
				FileRep.Visible = true;
			}
			else
			{
				FileRepInfo.Visible = true;
				FileRep.Visible = false;
				FileRepInfo.Text = rm.GetString("CRMcontxt61");
			}

		}

		private void btnAddFreeProductOpp_Click(object sender, EventArgs e)
		{
			ArrayList np = new ArrayList();
			if (Session["newprod"] != null)
				np = (ArrayList) Session["newprod"];

			PurchaseProduct newprod = new PurchaseProduct();
			newprod.id = 0;
			newprod.ShortDescription = EstFreeProduct.Text;
			newprod.LongDescription = EstFreeProduct.Text;
			newprod.UM = EstFreeUm.Text;
			newprod.Qta = Convert.ToInt32(EstFreeQta.Text);
			newprod.UnitPrice = StaticFunctions.FixDecimal(EstFreeUp.Text);
			newprod.Vat = Convert.ToInt32(EstFreeVat.Text);
			newprod.ListPrice = StaticFunctions.FixDecimal(EstFreePf.Text);
			newprod.FinalPrice = StaticFunctions.FixDecimal(EstFreePf.Text);
			newprod.Reduction = 0;
			newprod.ObId = np.Count;
			np.Add(newprod);


			Session["newprod"] = np;
			RepeaterPurchaseProduct.DataSource = np;
			RepeaterPurchaseProduct.DataBind();
			RepeaterPurchaseProduct.Visible = true;

			EstFreeProduct.Text = string.Empty;
			EstFreeUm.Text = string.Empty;
			EstFreeQta.Text = string.Empty;
			EstFreeUp.Text = string.Empty;
			EstFreeVat.Text = string.Empty;
			EstFreePf.Text = string.Empty;
		}

		public void btnAddProduct_Click(object sender, EventArgs e)
		{
			PurchaseProduct newprod = new PurchaseProduct();
			newprod.id = Convert.ToInt64(((TextBox) Page.FindControl("Purchase_ProductID")).Text);
			newprod.ShortDescription = ((TextBox) Page.FindControl("Purchase_Product")).Text;
			newprod.LongDescription = ((TextBox) Page.FindControl("Purchase_Description2")).Text;
			newprod.UM = ((TextBox) Page.FindControl("Purchase_Um")).Text;
			newprod.Qta = Convert.ToInt32(((TextBox) Page.FindControl("Purchase_Qta")).Text);
			newprod.UnitPrice = StaticFunctions.FixDecimal(((TextBox) Page.FindControl("Purchase_Up")).Text);
			newprod.Vat = (((TextBox) Page.FindControl("Purchase_Vat")).Text.Length > 0) ? Convert.ToDecimal(((TextBox) Page.FindControl("Purchase_Vat")).Text) : 0;
			newprod.ListPrice = StaticFunctions.FixDecimal(((TextBox) Page.FindControl("Purchase_Pl")).Text);
			newprod.FinalPrice = StaticFunctions.FixDecimal(((TextBox) Page.FindControl("Purchase_Pf")).Text);

			ArrayList np = new ArrayList();
			if (Session["newprod"] != null)
				np = (ArrayList) Session["newprod"];

			newprod.ObId = np.Count;

			np.Add(newprod);
			Session["newprod"] = np;

			RepeaterPurchaseProduct.DataSource = np;
			RepeaterPurchaseProduct.DataBind();
			RepeaterPurchaseProduct.Visible = true;

		}


		public void PurchaseProductCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "DelPurPro":
					Literal ObjectID = (Literal) e.Item.FindControl("ObjectID");
					ArrayList np = new ArrayList();
					np = (ArrayList) Session["newprod"];
					np.RemoveAt(Convert.ToInt32(ObjectID.Text));
					Session["newprod"] = np;
					RepeaterPurchaseProduct.DataSource = np;
					RepeaterPurchaseProduct.DataBind();
					RepeaterPurchaseProduct.Visible = true;
					break;
			}
		}


		public void PurchaseProductDatabound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Label ShortDescription = (Label) e.Item.FindControl("ShortDescription");
					Label UM = (Label) e.Item.FindControl("UM");
					Label Qta = (Label) e.Item.FindControl("Qta");
					Label UnitPrice = (Label) e.Item.FindControl("UnitPrice");
					Label FinalPrice = (Label) e.Item.FindControl("FinalPrice");
					Literal ObjectID = (Literal) e.Item.FindControl("ObjectID");
					PurchaseProduct newprod = (PurchaseProduct) e.Item.DataItem;
					ShortDescription.Text = newprod.ShortDescription;
					UM.Text = newprod.UM.ToString();
					Qta.Text = newprod.Qta.ToString();
					UnitPrice.Text = newprod.UnitPrice.ToString("c");
					FinalPrice.Text = newprod.FinalPrice.ToString("c");
					ObjectID.Text = newprod.ObId.ToString();
					break;
			}
		}

		public void btnCalcPrice_Click(object sender, EventArgs e)
		{
			try
			{
				TextBox EstPl = (TextBox) Page.FindControl("Purchase_Pl");
				TextBox EstPf = (TextBox) Page.FindControl("Purchase_Pf");
				TextBox EstQta = (TextBox) Page.FindControl("Purchase_Qta");
				TextBox EstUp = (TextBox) Page.FindControl("Purchase_Up");
				EstPl.Text = Convert.ToString(Math.Round((Convert.ToDecimal(EstQta.Text)*Convert.ToDecimal(EstUp.Text)), 2));
				EstPf.Text = EstPl.Text;
			}
			catch
			{
			}

		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			GoBackPurc.Click += new EventHandler(BtnBack_Click);
			GoBackProd.Click += new EventHandler(BtnBack_Click);
			this.SrcBtn.Click += new EventHandler(Srcbtn_Click);
			this.sheetP.NextClick += new EventHandler(SheetP_NextClick);
			this.sheetP.PrevClick += new EventHandler(SheetP_PrevClick);
			this.NewCompany.Click += new EventHandler(NewCompany_Click);
			this.BtnAddFreeProductOpp.Click += new EventHandler(this.btnAddFreeProductOpp_Click);
			this.ViewAgenda.Click += new EventHandler(this.ViewAgenda_Click);
			this.BtnSearch.Click += new EventHandler(this.BtnSearch_Click);
			this.BtnViewAdvanced.Click += new EventHandler(Btn_Click);
			this.RapSubmit.Click += new EventHandler(this.RapSubmit_Click);
			this.Tab3Text.Click += new EventHandler(this.TabControl_Click);
			this.Tab4Text.Click += new EventHandler(this.TabControl_Click);
			this.Tab5Text.Click += new EventHandler(this.TabControl_Click);
			this.Tab8Text.Click += new EventHandler(this.TabControl_Click);
			this.Tab6Text.Click += new EventHandler(this.TabControl_Click);
			this.Tab7Text.Click += new EventHandler(this.TabControl_Click);
			this.SubmitRef.Click += new EventHandler(this.ConSubmit_Click);
			this.RefreshRepCategories.Click += new EventHandler(this.Btn_Click);
			this.CancelCon.Click += new EventHandler(this.ConCancel_Click);
			this.SubmitCon.Click += new EventHandler(this.ConSubmit_Click);
			this.NewContact.Click += new EventHandler(this.Btn_Click);
			this.AllActivity.Click += new EventHandler(this.Btn_Click);
			this.NewActivityPhone.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityLetter.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityFax.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityMemo.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityEmail.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityVisit.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityGeneric.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivitySolution.Click += new EventHandler(this.NewActivity_Click);
			this.NewPurchase.Click += new EventHandler(this.Btn_Click);
			this.BtnCalcPrice.Click += new EventHandler(this.btnCalcPrice_Click);
			this.BtnAddProduct.Click += new EventHandler(this.btnAddProduct_Click);
			this.Purchase_Exit.Click += new EventHandler(this.Btn_Click);
			this.Purchase_Submit.Click += new EventHandler(this.Btn_Click);
			this.NewDoc.Click += new EventHandler(this.Btn_Click);
			this.InsertNewProduct.Click += new EventHandler(this.Btn_Click);
			this.ResetNewProduct.Click += new EventHandler(this.Btn_Click);
			this.SaveNewProduct.Click += new EventHandler(this.Btn_Click);
			this.Repeater1.ItemCommand += new RepeaterCommandEventHandler(this.Repeater1_Grid_ItemCommand);
			this.ViewContact.ItemCommand += new RepeaterCommandEventHandler(this.ViewContact_Grid_ItemCommand);
			this.RepCategories.ItemCommand += new RepeaterCommandEventHandler(this.RepCategories_Command);
			this.ContactReferrer.ItemCommand += new RepeaterCommandEventHandler(this.ContactReferrerCommand);
			this.RepeaterOpportunity.ItemCommand += new RepeaterCommandEventHandler(this.RepeaterOpportunityCommand);
			this.RepeaterPurchase.ItemCommand += new RepeaterCommandEventHandler(this.RepeaterPurchaseCommand);
			this.RepeaterPurchaseProduct.ItemCommand += new RepeaterCommandEventHandler(this.PurchaseProductCommand);
			this.FileRep.ItemCommand += new RepeaterCommandEventHandler(this.FileRepCommand);
			this.RepeaterProducts.ItemCommand += new RepeaterCommandEventHandler(this.RepeaterProductsCommand);
			this.Repeater1.ItemDataBound += new RepeaterItemEventHandler(this.Repeater1_ItemDataBound);
			this.ViewContact.ItemDataBound += new RepeaterItemEventHandler(this.ViewContact_OnItemDataBound);
			this.RepCategories.ItemDataBound += new RepeaterItemEventHandler(this.RepCategories_DataBound);
			this.ContactReferrer.ItemDataBound += new RepeaterItemEventHandler(this.ContactReferrerItemDataBound);
			this.RepeaterPurchaseProduct.ItemDataBound += new RepeaterItemEventHandler(this.PurchaseProductDatabound);
			this.FileRep.ItemDataBound += new RepeaterItemEventHandler(this.FileRepDatabound);

		}

		#endregion

		private void Srcbtn_Click(object sender, EventArgs e)
		{
			srccomp.OnlyName = true;

			Repeater1Paging.PageSize = UC.PagingSize;
			Repeater1Paging.RepeaterObj = Repeater1;
			InitSheetPaging(srccomp.GetCompanyQuery());
			Repeater1Paging.sqlRepeater = srccomp.GetCompanyQuery();
			Repeater1Paging.BuildGrid();


			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				this.Repeater1Paging.Visible = true;
				RepeaterInfo.Visible = false;
				AdvancedSearch.Visible = false;
			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Bcotxt41") + "</center>";
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}

			tabControl.Visible = false;
			ContactForm.Visible = false;
			ViewContact.Visible = false;
		}


		private void InitSheetPaging(string sqlString)
		{
			DataTable dt = DatabaseConnection.CreateDataset(sqlString).Tables[0];
			string[] myarray = new string[dt.Rows.Count];
			if (dt.Rows.Count > 0)
			{
				for (int i = 0; i < dt.Rows.Count; i++)
				{
					myarray[i] = dt.Rows[i]["ID"] + "|" + dt.Rows[i]["CompanyName"];
				}
			}

			sheetP.IDArray = myarray;
		}

		private void SheetP_NextClick(object sender, EventArgs e)
		{
			FillView(int.Parse(this.sheetP.GetCurrentID.ToString()));
		}

		private void SheetP_PrevClick(object sender, EventArgs e)
		{
			FillView(int.Parse(this.sheetP.GetCurrentID.ToString()));
		}

		private void NewCompany_Click(object sender, EventArgs e)
		{
			InitAjax();
			PrepareForNewCompany();

		}

		private void PrepareForNewCompany()
		{
			if (UC.CultureSpecific.ToLower() != "it") pgPaste.Visible=false;

			Fill_Sectors(Sector);
			Fill_ContactType(ContactType);
			Fill_Evaluation(Evaluation);

			CompanyName.Text = String.Empty;
			CompanyCode.Text = String.Empty;
			VatId.Text = String.Empty;
			Phone.Text = String.Empty;
			Fax.Text = String.Empty;
			Email.Text = String.Empty;
			OwnerId.Text = String.Empty;
			OwnerName.Text = String.Empty;
			WebSite.Text = String.Empty;
			Invoice_Address.Text = String.Empty;
			Invoice_City.Text = String.Empty;
			Invoice_StateProvince.Text = String.Empty;
			Invoice_Zip.Text = String.Empty;
			Shipment_Address.Text = String.Empty;
			Shipment_City.Text = String.Empty;
			Shipment_StateProvince.Text = String.Empty;
			Shipment_Zip.Text = String.Empty;
			Shipment_Phone.Text = String.Empty;
			Shipment_Fax.Text = String.Empty;
			Shipment_Email.Text = String.Empty;
			Warehouse_Address.Text = String.Empty;
			Warehouse_City.Text = String.Empty;
			Warehouse_StateProvince.Text = String.Empty;
			Warehouse_Zip.Text = String.Empty;
			Warehouse_Phone.Text = String.Empty;
			Warehouse_Fax.Text = String.Empty;
			Warehouse_Email.Text = String.Empty;

			Employees.Text = String.Empty;
			TurnOver.Text = String.Empty;
			Description.Text = String.Empty;
			CategoriesRep.Text = String.Empty;
			EmailML.Text = String.Empty;
			MlCheck.Checked = true;

			tabControl.Visible = true;
			tdTab2.Visible = false;
			tdTab3.Visible = false;
			tdTab4.Visible = false;
			tdTab5.Visible = false;
			tdTab6.Visible = false;
			tdTab7.Visible = false;
			tdTab8.Visible = false;
			ContactForm.Visible = true;
			visContact.Visible = false;
			visReferrer.Visible = false;
			visActivity.Visible = false;
			visOpportunity.Visible = false;
			visPurchase.Visible = false;
			visDocuments.Visible = false;
			visProducts.Visible = false;
			visEstimate.Visible = false;
			PurchaseForm.Visible = false;
			Repeater1.Visible = false;
			ContactId.Text = "-1";
			Tab1Text.Text = "<span class=\"normal Mul\">&nbsp;" + rm.GetString("CRMcontxt18") + "&nbsp;</span>";
			FillRepCategories();
			CheckFreeFields(-1);
			SubmitCon.Attributes.Add("onclick", "return ValidatecompanyName();");
			SubmitRef.Attributes.Add("onclick", "return ValidatecompanyName();");
			if (UC.InsertGroups.Length > 0) groups.SetGroups(UC.InsertGroups);
			this.sheetP.Visible = false;
			this.activeMode.Value = "edit";
		}
	}


} 
