/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Collections;
using System.Data;

using System.Text;
using System.Text.RegularExpressions;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Ajax;
using Digita.Tustena.Base;
using Digita.Tustena.Common;
using Digita.Tustena.Database;
using Digita.Tustena.WorkingCRM;

namespace Digita.Tustena
{
	public class CRM_Lead : G
	{
		protected Repeater ViewForm;
		protected Repeater Repeater1;
		protected RepeaterPaging Repeater1Paging;
		protected Label abcHeader;
		protected TextBox Search;
		protected HtmlTable referenceForm;
		protected GroupControl Groups;
		protected Label RepeaterInfo;
		protected LinkButton LbnNew;
		protected LinkButton BtnSearch;
		protected LinkButton SubmitRef;
		protected LinkButton Submit2;

		protected TextBox CrossLead_AssociatedCompany;
		protected TextBox CrossLead_AssociatedContact;
		protected TextBox CrossLead_LeadOwner;
		protected DropDownList CrossLead_Status;
		protected DropDownList CrossLead_Rating;
		protected DropDownList CrossLead_ProductInterest;
		protected TextBox CrossLead_PotentialRevenue;
		protected TextBox CrossLead_EstimatedCloseDate;
		protected DropDownList CrossLead_LeadCurrency;
		protected DropDownList CrossLead_Source;
		protected TextBox CrossLead_Campaign;
		protected DropDownList CrossLead_Industry;
		protected TextBox CrossLead_SalesPerson;

		protected HtmlInputHidden activeTab;
		protected HtmlTable tabControl;
		protected Literal SomeJS;

		protected Label RequiredFieldValidatorCognome;
		protected TextBox RapRagSoc;
		protected TextBox RapPhone;
		protected TextBox RapEmail;
		protected Label RapInfo;
		protected LinkButton RapSubmit;
		protected LinkButton BtnGroup;
		protected DropDownList ListGroups;
		protected LinkButton Back;
		protected Label RepeaterActivityInfo;

		protected TextBox CRM_Leads_ID;
		protected TextBox CRM_Leads_CompanyID;
		protected TextBox CRM_Leads_CompanyName;
		protected TextBox CRM_Leads_Name;
		protected TextBox CRM_Leads_Surname;
		protected TextBox CRM_Leads_Title;
		protected TextBox CRM_Leads_Address;
		protected TextBox CRM_Leads_City;
		protected TextBox CRM_Leads_Province;
		protected TextBox CRM_Leads_ZIPCode;
		protected TextBox CRM_Leads_State;
		protected TextBox CRM_Leads_EMail;
		protected TextBox CRM_Leads_Phone;
		protected TextBox CRM_Leads_Fax;
		protected TextBox CRM_Leads_MobilePhone;
		protected TextBox CRM_Leads_BusinessRole;
		protected TextBox CRM_Leads_Notes;
		protected TextBox CRM_Leads_BirthPlace;
		protected TextBox CRM_Leads_Categories;
		protected TextBox CRM_Leads_BirthDay;
		protected TextBox CRM_Leads_WebSite;

		protected Label DateFormat;
		protected HtmlTableCell tdTab1;
		protected HtmlTableCell tdTab2;
		protected Literal ViewFreeFields;
		protected Literal FreeFields;
		protected Repeater RepCategories;
		protected LinkButton RefreshRepCategories;

		private string repSqlString;

		protected ActivityChronology AcCrono;
		protected LinkButton NewActivityPhone;
		protected LinkButton NewActivityLetter;
		protected LinkButton NewActivityFax;
		protected LinkButton NewActivityMemo;
		protected LinkButton NewActivityEmail;
		protected LinkButton NewActivityVisit;
		protected LinkButton NewActivityGeneric;
		protected LinkButton NewActivitySolution;
		protected SheetPaging SheetP;
		protected DropDownList ListCategory;

		protected SearchLead srcComp;
		protected LinkButton SrcBtn;
		protected HtmlTable advancedSearch;

		protected LinkButton BtnAdvanced;


		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				DeleteGoBack();
				if (Request["Ajax"] != null)
					InitAjax();

				Repeater1Paging.Visible = false;
				Back.Click += new EventHandler(BtnBack_Click);
				Back.CssClass = "Save";
				Back.Text = "&nbsp;&uarr;&nbsp;";

				tdTab2.Visible = true;
				DateFormat.Text = UC.myDTFI.ShortDatePattern.ToString();
				if (!isGoBack)
				{
					Back.Visible = false;
				}
				else
				{
					Stack ba = new Stack();
					ba = (Stack) Session["goback1"];
					GoBack gb = new GoBack();
					gb = (GoBack) ba.Peek(); //[ba.Count - 1];
					if (!(gb.sheet.ToLower().IndexOf("crm_leads.aspx") > 0))
						Back.Visible = false;
				}


				RapSubmit.Text = rm.GetString("Bcotxt4");
				BtnGroup.Text = rm.GetString("Bcotxt2");


				try
				{
					repSqlString = ViewState["RepSQLString"].ToString();
				}
				catch
				{
					repSqlString = String.Empty;
				}
				abcHeader.Text = CRM_Companies.ABCHeaderHtml(Request.Params["List"]);
				if (!Page.IsPostBack)
				{
					AcCrono.ParentID = 0;
					AcCrono.OpportunityID = 0;
					AcCrono.AcType = (byte) AType.Lead;
					NewActivityPhone.Text = rm.GetString("Wortxt6");
					NewActivityLetter.Text = rm.GetString("Wortxt7");
					NewActivityFax.Text = rm.GetString("Wortxt8");
					NewActivityMemo.Text = rm.GetString("Wortxt9");
					NewActivityEmail.Text = rm.GetString("Wortxt10");
					NewActivityVisit.Text = rm.GetString("Wortxt11");
					NewActivityGeneric.Text = rm.GetString("Wortxt12");
					NewActivitySolution.Text = rm.GetString("Wortxt13");

					BtnAdvanced.Text = rm.GetString("CRMcontxt52");
					advancedSearch.Visible = false;

					SrcBtn.Text = rm.GetString("Find");
					CRM_Companies.FillListGroups(UC, this.ListGroups);

					FillListCategories();
					referenceForm.Visible = false;
					tabControl.Visible = false;


					if (Request.Params["List"] != null)
					{
						FillRepeater(Request.Params["List"].ToString(), "CRM_Leads.Surname");
					}
					if (Request.Params["action"] != null)
					{
						if (Request.Params["action"] == "NEW")
						{
							TextBox txtfield = (TextBox) referenceForm.FindControl("CRM_Leads_ID");
							txtfield.Text = "-1";
							txtfield = (TextBox) referenceForm.FindControl("CRM_Leads_CompanyID");
							if (Session["contact"] != null)
							{
								txtfield.Text = Session["contact"].ToString();
								TextBox txtfieldContact = (TextBox) referenceForm.FindControl("CRM_Leads_CompanyName2");
								txtfieldContact.Text = DatabaseConnection.SqlScalar("select companyname from Base_Companies where id=" + Session["contact"]);

								string groups = DatabaseConnection.SqlScalar("select groups from Base_Companies where id=" + Session["contact"]);

								Session["GroupsSetGroup"] = groups;
								Session["contact"] = null;
							}

							referenceForm.Visible = true;
							tabControl.Visible = true;
							Repeater1.Visible = false;
							ViewForm.Visible = false;
						}
						if (Request.Params["action"] == "MOD")
						{
							ViewForm.Visible = false;
							Repeater1.Visible = false;
							referenceForm.Visible = true;
							FillForm(int.Parse(Request.Params["full"]));
						}
						if (Request.Params["action"] == "VIEW")
						{
							FillView(int.Parse(Request.Params["full"]));
						}
					}
					if (Request.Params["gb"] != null && Session["goback1"] != null && isGoBack)
					{
						Stack ba = new Stack();
						ba = (Stack) Session["goback1"];
						GoBack gb = new GoBack();
						gb = (GoBack) ba.Pop(); //[ba.Count - 1];
						string[] par = gb.parameter.Split('|');

						if (par[1].Length > 0) FillView(int.Parse(par[1]));
						if (par[2].Length > 0)
						{
							switch (par[2])
							{
								case "a":
									SomeJS.Text = "<script>ViewHideTabs(\"visActivity\",0);</script>";
									break;
								case "d":
									SomeJS.Text = "<script>ViewHideTabs(\"VisDocuments\",0);</script>";
									break;
							}
							activeTab.Value = String.Empty;
						}
						Session["goback1"] = ba;
					}

					if (Request.Form["searchcontact"] != null)
					{
						Search.Text = Request.Form["searchcontact"];
						SearchClick("btnSearch");
					}
				}
				else
				{
					if (activeTab.Value.Length > 0)
					{
						SomeJS.Text = "<script>ViewHideTabs(\"" + activeTab.Value + "\",0);</script>";
						activeTab.Value = String.Empty;
					}
				}
			}
			LbnNew.Text = rm.GetString("Ledtxt1");


			BtnSearch.Text = rm.GetString("Reftxt41");

			SubmitRef.Text = rm.GetString("Reftxt43");
			Submit2.Text = rm.GetString("Reftxt43");

		}



		private void FillListCategories()
		{
			ListCategory.DataTextField = "Description";
			ListCategory.DataValueField = "id";
			ListCategory.DataSource = DatabaseConnection.CreateDataset("select id,Description from CRM_ReferrerCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + "))");
			ListCategory.DataBind();
			ListCategory.Items.Insert(0, rm.GetString("CRMcontxt53"));
			ListCategory.Items[0].Value = "0";
		}

		private void ClearTextBox(IEnumerator i)
		{
			while (i.MoveNext())
			{
				if (i.Current.GetType().Name == "TextBox")
				{
					TextBox t = (TextBox) i.Current;
					if (t.ID == "CRM_Leads_ID")
						t.Text = "-1";
					else
						t.Text = String.Empty;
				}
				else
				{
					Control y = (Control) i.Current;
					ClearTextBox(y.Controls.GetEnumerator());
				}
			}
		}

		public void NewLeadFunction()
		{
			tabControl.Visible = true;
			referenceForm.Visible = true;
			Repeater1.Visible = false;
			ViewForm.Visible = false;
			ClearTextBox(referenceForm.Controls.GetEnumerator());
			FillCrossLeadDrop();

			SomeJS.Text = "<script>ViewHideTabs(\"visContact\",1);</script>";
			activeTab.Value = String.Empty;
			CheckFreeFields(-1);

			try
			{
				if (UC.InsertGroups.Length > 0) Groups.SetGroups(UC.InsertGroups);
			}
			catch
			{
			}

			this.SheetP.Visible = false;
			this.FillRepCategories(true);
		}

		public void NewLead(object sender, EventArgs e)
		{
			InitAjax();
			NewLeadFunction();
		}

		public void BtnSearch_Click(object sender, EventArgs e)
		{
			Search.Text=StaticFunctions.RemoveSpecialChar(Search.Text);
			SearchClick(((LinkButton) sender).ID);
			DeleteGoBack(true);
		}

		private void SearchClick(string sender)
		{
			Session["searchsender"] = sender;

			string queryType = String.Empty;
			string queryGroup = GroupsSecure("CRM_Leads.Groups");
			string findString = DatabaseConnection.FilterInjection(Search.Text);


			StringBuilder sqlString = new StringBuilder();
			StringBuilder sqlCount = new StringBuilder();

			sqlString.Append("SELECT CRM_Leads.ID,CRM_Leads.Name, CRM_Leads.Surname, CRM_Leads.Phone, CRM_Leads.MobilePhone, CRM_Leads.CompanyName ,(Account.Surname+' '+Account.Name) as NameOwner, CRM_Leads.CreatedDate ");
			sqlString.Append("FROM CRM_Leads LEFT OUTER JOIN Base_Companies ON CRM_Leads.CompanyID = Base_Companies.ID ");
			sqlString.Append("LEFT OUTER JOIN Account ON CRM_Leads.OwnerID = Account.UID ");
			sqlString.AppendFormat("where CRM_Leads.Limbo=0 and (CRM_Leads.Surname like '%{0}%' or ", findString);
			sqlString.AppendFormat("CRM_Leads.Name like '%{0}%' or ", findString);
			sqlString.AppendFormat("CRM_Leads.Phone like '%{0}%' or ", findString);
			sqlString.AppendFormat("CRM_Leads.Email like '%{0}%' or ", findString);
			sqlString.AppendFormat("CRM_Leads.City like '%{0}%' or ", findString);
			sqlString.AppendFormat("CRM_Leads.Province like '%{0}%' or ", findString);
			sqlString.AppendFormat("CRM_Leads.CompanyName like '%{0}%') ", findString);
			sqlString.Append(queryType);
			sqlCount.Append("select count(*) ");
			sqlCount.Append("FROM CRM_Leads LEFT OUTER JOIN Base_Companies ON CRM_Leads.CompanyID = Base_Companies.ID ");
			sqlCount.Append("LEFT OUTER JOIN Account ON CRM_Leads.OwnerID = Account.UID ");
			sqlCount.AppendFormat("where (CRM_Leads.Limbo=0) and (CRM_Leads.Surname like '%{0}%' or ", findString);
			sqlCount.AppendFormat("CRM_Leads.Name like '%{0}%' or ", findString);
			sqlCount.AppendFormat("CRM_Leads.Phone like '%{0}%' or ", findString);
			sqlCount.AppendFormat("CRM_Leads.Email like '%{0}%' or ", findString);
			sqlCount.AppendFormat("CRM_Leads.City like '%{0}%' or ", findString);
			sqlCount.AppendFormat("CRM_Leads.Province like '%{0}%' or ", findString);
			sqlCount.AppendFormat("CRM_Leads.CompanyName like '%{0}%') ", findString);
			sqlCount.Append(queryType);

			if (sender == "btnGroup")
			{
				if (ListGroups.SelectedItem.Value != "0")
				{
					string dep = GroupDependency(Convert.ToInt32(ListGroups.SelectedItem.Value));
					if (dep.Length > 1)
					{
						string[] arryD = dep.Split('|');
						string qGroup = String.Empty;
						foreach (string ut in arryD)
						{
							if (ut.Length > 0) qGroup += "CRM_Leads.Groups like '%|" + ut + "|%' or ";
						}
						if (qGroup.Length > 0) qGroup = qGroup.Substring(0, qGroup.Length - 3);
						sqlString.AppendFormat(" and ({0})", qGroup);
						sqlCount.AppendFormat(" and ({0})", qGroup);
					}
					else
					{
						sqlString.AppendFormat(" and (CRM_Leads.Groups like '%|{0}|%')", ListGroups.SelectedItem.Value);
						sqlCount.AppendFormat(" and (CRM_Leads.Groups like '%|{0}|%')", ListGroups.SelectedItem.Value);
					}
				}
				if (this.ListCategory.SelectedIndex > 0)
				{
					sqlString.AppendFormat(" and (CRM_Leads.Categories like '%|{0}|%')", ListCategory.SelectedValue);
					sqlCount.AppendFormat(" and (CRM_Leads.Categories like '%|{0}|%')", ListCategory.SelectedValue);
				}
			}
			else
			{
				if (queryGroup.Length > 0)
				{
					sqlString.AppendFormat(" and (({0}) or CRM_Leads.OwnerID={1})", queryGroup, UC.UserId);
					sqlCount.AppendFormat(" and (({0}) or CRM_Leads.OwnerID={1})", queryGroup, UC.UserId);
				}
			}

			ViewState["RepSQLString"] = sqlString;
			try
			{
				sqlString.AppendFormat(" order by {0}", ViewState["orderby"].ToString());
			}
			catch
			{
				sqlString.Append(" order by CRM_Leads.Surname;");
			}

			Repeater1Paging.PageSize = UC.PagingSize;
			Repeater1Paging.RepeaterObj = Repeater1;
			InitSheetPaging(sqlString.ToString());
			Repeater1Paging.sqlRepeater = sqlString.ToString();
			Repeater1Paging.BuildGrid();


			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				RepeaterInfo.Visible = false;
			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Reftxt1");
				if (Search.Text.Length > 0)
				{
					RepeaterInfo.Text += "<br><br><span style=\"cursor:pointer;color:#000000;\" onclick=\"SubmitContact();\">" +
						rm.GetString("Reftxt50") + "</span></center>";
				}
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}

			ViewForm.Visible = false;
			referenceForm.Visible = false;
			tabControl.Visible = false;
		}

		public void ReferenceFormSubmit(object sender, EventArgs e)
		{
			TextBox txtfield = (TextBox) referenceForm.FindControl("CRM_Leads_ID");
			if (((TextBox) referenceForm.FindControl("CRM_Leads_Name")).Text.Length > 0 || ((TextBox) referenceForm.FindControl("CRM_Leads_Surname")).Text.Length > 0)
			{
				ModifyForm(int.Parse(txtfield.Text));
				tdTab2.Style.Add("display", "inline");
				SheetP.Visible = true;
			}
			else
			{
				Page.RegisterStartupScript("", "<script>alert('" + rm.GetString("Reftxt54") + "');</script>");
				RequiredFieldValidatorCognome.Visible = true;
			}
		}

		private void FillRepeater(string query, string orderby)
		{
			Session.Remove("searchsender");
			string queryGroup = GroupsSecure("CRM_Leads.Groups");
			if (query != "order")
			{
				StringBuilder sqlString = new StringBuilder();
				StringBuilder sqlCount = new StringBuilder();

				sqlString.AppendFormat("SELECT TOP {0} CRM_Leads.ID,CRM_Leads.Name, CRM_Leads.Surname, CRM_Leads.Phone, CRM_Leads.MobilePhone, CRM_Leads.CompanyName ,(Account.Surname+' '+Account.Name) as NameOwner, CRM_Leads.CreatedDate ", DatabaseConnection.MaxResult);
				sqlString.Append("FROM CRM_Leads LEFT OUTER JOIN Base_Companies ON CRM_Leads.CompanyID = Base_Companies.ID ");
				sqlString.Append("LEFT OUTER JOIN Account ON CRM_Leads.OwnerID = Account.UID ");
				sqlCount.Append("select count(*) from CRM_Leads ");
				switch (query)
				{
					case "*":
						sqlString.Append("where (CRM_Leads.Limbo = 0)");
						sqlCount.Append("where (CRM_Leads.Limbo = 0)");
						break;
					default:
						sqlString.AppendFormat("where ((CRM_Leads.Limbo = 0) and (CRM_Leads.Surname like '{0}%'))", query);
						sqlCount.AppendFormat("where ((CRM_Leads.Limbo = 0) and (CRM_Leads.Surname like '{0}%'))", query);
						break;
				}
				if (queryGroup.Length > 0)
				{
					sqlString.AppendFormat(" and (({0}) or CRM_Leads.OwnerID={1})", queryGroup, UC.UserId);
					sqlCount.AppendFormat(" and (({0}) or CRM_Leads.OwnerID={1})", queryGroup, UC.UserId);
				}


				repSqlString = sqlString.ToString();
				ViewState["RepSQLString"] = sqlString.ToString();
				ViewState["RepCountSQLString"] = sqlCount.ToString();
			}

			if (repSqlString.Length == 0) repSqlString = ViewState["RepSQLString"].ToString();
			if (repSqlString.IndexOf("order by") < 0) repSqlString += " order by " + orderby + " asc";

			Repeater1Paging.PageSize = UC.PagingSize;
			Repeater1Paging.RepeaterObj = Repeater1;
			InitSheetPaging(repSqlString);
			Repeater1Paging.sqlRepeater = repSqlString;
			Repeater1Paging.BuildGrid();

			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				RepeaterInfo.Visible = false;

			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Reftxt1") + "</center>";
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}
		}

		public void Repeater1_ItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton IMB = (LinkButton) e.Item.FindControl("Delete");
					IMB.Text = rm.GetString("CRMcontxt44");

					IMB.Attributes.Add("onclick", "return confirm('" + rm.GetString("Bcotxt44") + "');");
					break;
				case ListItemType.Footer:
					Literal RepCounter = (Literal) e.Item.FindControl("RepCounter");
					RepCounter.Text = Repeater1Paging.RowCount.ToString();
					if (this.Repeater1Paging.RowCount >= 100)
						RepCounter.Text += " (" + string.Format(rm.GetString("top100"), DatabaseConnection.MaxResult) + ")";
					break;
			}
		}


		public void Repeater1_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "View":
					if (this.SheetP.IDArray.Length > 0)
					{
						string[] tempArray = this.SheetP.IDArray;
						for (int i = 0; i < tempArray.Length; i++)
						{
							if (tempArray[i].Split('|')[0].CompareTo(((Literal) e.Item.FindControl("ID")).Text) == 0)
							{
								this.SheetP.CurrentPosition = i;
								this.SheetP.enabledisable();
								break;
							}
						}
					}
					FillView(int.Parse(((Literal) e.Item.FindControl("ID")).Text));
					break;
				case "Delete":
					Delete(int.Parse(((Literal) e.Item.FindControl("ID")).Text));
					FillRepeater("order", "CRM_Leads.Surname");
					break;
			}
		}

		private void Delete(int id)
		{
			Base_Contacts.Delete(id, UC.UserId, "CRM_Leads");
		}

		private void FillView(int id)
		{
			Session["CurrentRefId"] = id;
			string sqlString = "SELECT CRM_Leads.*, Base_Companies.CompanyName AS CompanyName2, Base_Companies.Phone as AzPhone ";
			sqlString += "FROM CRM_Leads LEFT OUTER JOIN Base_Companies ON CRM_Leads.CompanyID = Base_Companies.ID ";
			ViewForm.DataSource = DatabaseConnection.CreateDataset(sqlString + "where CRM_Leads.id=" + id);
			ViewForm.DataBind();

			tabControl.Visible = true;
			ViewForm.Visible = true;
			Repeater1.Visible = false;
			referenceForm.Visible = false;

			try
			{
				if (this.SheetP.IDArray.Length <= 0)
				{
					this.SheetP.CurrentPosition = 0;
					this.SheetP.enabledisable();
				}
			}
			catch
			{
				this.SheetP.IDArray = new string[0];
				this.SheetP.CurrentPosition = -1;
				this.SheetP.enabledisable();
			}
		}

		public void ViewFormOnItemDatabound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:

					Repeater RepCrossLead = (Repeater) e.Item.FindControl("RepCrossLead");
					RepCrossLead.ItemDataBound += new RepeaterItemEventHandler(this.RepCrossLead_ItemDataBound);
					RepCrossLead.DataSource = getLeadInfo(Convert.ToInt32(DataBinder.Eval((DataRowView) e.Item.DataItem, "id").ToString()));
					RepCrossLead.DataBind();
					Literal ViewFreeFields = (Literal) e.Item.FindControl("ViewFreeFields");
					ViewFreeFields.Text = String.Empty;
					string query = GroupsSecure("groups");
					if (query.Length > 0)
						query = " groups like '%|" + UC.UserGroupId + "|%'";
					string sqlString;
					sqlString = "select * from addedfields where tablename=" + (byte) CRMTables.CRM_Leads + " and (" + query + ") order by vieworder";

					DataSet ds = DatabaseConnection.CreateDataset(sqlString);
					if (ds.Tables[0].Rows.Count > 0)
					{
						StringBuilder S = new StringBuilder();
						S.AppendFormat("<table width=\"100%\"><tr><td class=\"normal Bbot\"><br><b>{0}</b></td></tr></table>", rm.GetString("Bcotxt50"));
						S.Append("<table width=\"45%\" class=\"normal\">");
						foreach (DataRow dr in ds.Tables[0].Rows)
						{
							bool isParentCrossed = true;
							DataSet Q = DatabaseConnection.CreateDataset("select ParentField,ParentFieldValue from AddedFields where id=" + dr["id"].ToString());
							string pf = Q.Tables[0].Rows[0][0].ToString();
							string pfv = Q.Tables[0].Rows[0][1].ToString();
							if (pf.Length > 0)
							{
								IDataReader sqlDr = DatabaseConnection.CreateReader("select " + pf + " from CRM_Leads where id=" + int.Parse(Session["CurrentRefId"].ToString()));
								sqlDr.Read();
								isParentCrossed = (sqlDr[0].ToString() == pfv);
								sqlDr.Close();
							}

							if (isParentCrossed)
							{
								S.AppendFormat("<tr><td width=\"40%\">{0}</td>", dr["name"]);
								DataSet afCross = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + dr["id"] + " and id=" + (Int64) DataBinder.Eval((DataRowView) e.Item.DataItem, "id"));
								if (afCross.Tables[0].Rows.Count > 0)
								{
									S.AppendFormat("<td bgcolor=\"#FFFFFF\" class=\"VisForm\">{0}&nbsp;</td></tr>", afCross.Tables[0].Rows[0][0]);
								}
								else
								{
									S.Append("<td bgcolor=\"#FFFFFF\" class=\"VisForm\">&nbsp;</td></tr>");
								}

								afCross.Clear();
							}
						}
						S.Append("</table>");
						ViewFreeFields.Text = S.ToString();
					}


					LinkButton ModCon = (LinkButton) e.Item.FindControl("ModCon");
					ModCon.Text = rm.GetString("Reftxt42");

					LinkButton LeadConvert = (LinkButton) e.Item.FindControl("LeadConvert");
					LeadConvert.Text = rm.GetString("Ledtxt27");

					LinkButton BackToSearch = (LinkButton) e.Item.FindControl("BackToSearch");
					BackToSearch.Text = rm.GetString("CRMrubtxt6");

					LinkButton PrintButton = (LinkButton) e.Item.FindControl("PrintButton");
					PrintButton.Text = "<img src=/i/printer.gif border=0>";
					PrintButton.Attributes.Add("onclick", "window.open('/report/htmlreport.aspx');");

					Session["report"] = null;
					ArrayList report = new ArrayList();
					CompanyReport cr = new CompanyReport();
					cr.idfield = Convert.ToInt32(DatabaseConnection.SqlScalartoObj("select id from qb_customerquery where title='Fixed6'")); //ex222;
					Hashtable HtParams = new Hashtable();
					HtParams.Add("ID", Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "id")));
					cr.Params = HtParams;
					cr.Finalize = true;
					cr.Type = 0;
					cr.itemPage = 10;
					report.Add(cr);
					Session["report"] = report;

					FillRepeaterActivity(Convert.ToInt32(DataBinder.Eval((DataRowView) e.Item.DataItem, "id")));
					Session["review"] = "0";

					string azPhone = Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "AzPhone"));
					if (azPhone.Length > 0)
					{
						Literal AZph = (Literal) e.Item.FindControl("CompanyPhone");
						AZph.Text = "&nbsp;" + rm.GetString("Reftxt48") + "&nbsp;" + azPhone;
					}

					Literal Title = (Literal) e.Item.FindControl("Title");
					Title.Text = (Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Title")).Length > 0) ? Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Title")) + "&nbsp;" : "";

					Literal CompanyLabel = (Literal) e.Item.FindControl("CompanyLabel");
					CompanyLabel.Text = Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName"));

					if (Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Categories")).Length > 0)
					{
						string[] cats = ((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "Categories")).Split('|');
						string queryCat = String.Empty;
						foreach (string ca in cats)
						{
							if (ca.Length > 0) queryCat += " id=" + int.Parse(ca) + " or ";
						}
						queryCat = queryCat.Substring(0, queryCat.Length - 4);
						Repeater RepCategoriesView = (Repeater) e.Item.FindControl("RepCategoriesView");
						RepCategoriesView.DataSource = DatabaseConnection.CreateDataset("select Description from CRM_ReferrerCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + ")) and (" + queryCat + ")");
						RepCategoriesView.DataBind();
					}


					Literal VoipCallPhone = (Literal) e.Item.FindControl("VoipCallPhone");
					Literal VoipCallMobilePhone = (Literal) e.Item.FindControl("VoipCallMobilePhone");
						if ((DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE")).ToString().Length > 0)
						{
							string ph = Regex.Replace((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE"), @"[^0-9]", "");
							VoipCallPhone.Text = MakeVoipString(ph);
						}

						if ((DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone")).ToString().Length > 0)
						{
							string ph = Regex.Replace((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone"), @"[^0-9]", "");
							VoipCallMobilePhone.Text = MakeVoipString(ph);
						}
					break;
			}
		}

		public void ViewForm_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "ModCon":
					FillForm(int.Parse(((Literal) e.Item.FindControl("IDRef")).Text));
					string strScript = "<SCRIPT>" + Environment.NewLine +
						"needsave('" + rm.GetString("CRMcontxt77") + "');" + Environment.NewLine +
						"</SCRIPT>";

					Page.RegisterStartupScript("anything", strScript);

					SubmitRef.Attributes.Add("onclick", "needsave('no')");
					Submit2.Attributes.Add("onclick", "needsave('no')");
					RefreshRepCategories.Attributes.Add("onclick", "needsave('no')");

					ViewForm.Visible = false;
					Repeater1.Visible = false;
					referenceForm.Visible = true;
					tdTab2.Style.Add("display", "none");
					SheetP.Visible = false;
					break;
				case "CompanyLink":
					Literal CompanyIdForLink = (Literal) e.Item.FindControl("CompanyIdForLink");
					SetGoBack("/crm/CRM_Lead.aspx?m=25&si=53&gb=1", new string[2] {CompanyIdForLink.Text, "d"});
					Response.Redirect("/crm/crm_companies.aspx?m=25&si=29&gb=1");
					break;
				case "BackToSearch":
					tabControl.Visible = false;
					Repeater1.Visible = true;

					break;
				case "LeadConvert":
					ConvertLeadToContact(int.Parse(((Literal) e.Item.FindControl("IDRef")).Text));

					break;
			}
		}

		private void ConvertLeadToContact(int id)
		{
			bool newCompany = ((DatabaseConnection.SqlScalar("select companyname from crm_leads where id=" + id)).Length > 0);
			DataRow dr = DatabaseConnection.CreateDataset("select * from crm_leads where id=" + id).Tables[0].Rows[0];
			int NewCompanyID = 0;
			int NewContactID = 0;

			if (newCompany)
			{
				using (DigiDapter dg = new DigiDapter())
				{
					dg.Add("OwnerID", dr["OwnerID"]);
					dg.Add("CreatedByID", UC.UserId);
					dg.Add("CompanyName", dr["CompanyName"]);

					dg.Add("Phone", dr["Phone"]);
					dg.Add("Fax", dr["Fax"]);
					dg.Add("EMail", dr["email"].ToString().Trim(' '));

					dg.Add("InvoicingAddress", dr["Address"]);
					dg.Add("InvoicingCity", dr["City"]);
					dg.Add("InvoicingStateProvince", dr["Province"]);
					dg.Add("InvoicingState", dr["State"]);
					dg.Add("InvoicingZIPCode", dr["ZIPCode"]);
					dg.Add("Description", dr["Notes"]);
					dg.Add("Groups", dr["Groups"]);
					dg.Add("FromLead", id);

					string industry = DatabaseConnection.SqlScalar("select industry from crm_crosslead where leadid=" + id);
					if (industry.Length > 0)
						dg.Add("CompanyTypeID", industry);

					object newId = dg.Execute("Base_Companies", DigiDapter.Identities.Identity);

					NewCompanyID = Convert.ToInt32(newId);
				}
			}

			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("Name", dr["Name"]);
				dg.Add("Surname", dr["Surname"]);
				dg.Add("OwnerID", dr["OwnerID"]);
				dg.Add("Title", dr["Title"]);
				dg.Add("Address_1", dr["Address"]);
				dg.Add("City_1", dr["City"]);
				dg.Add("Province_1", dr["Province"]);
				dg.Add("State_1", dr["State"]);
				dg.Add("ZIPCode_1", dr["ZIPCode"]);
				dg.Add("VatID", dr["VatID"]);
				dg.Add("TaxIdentificationNumber", dr["TaxIdentificationNumber"]);
				dg.Add("Email", dr["Email"].ToString().Trim(' '));
				dg.Add("Phone_1", dr["Phone"]);
				dg.Add("Fax", dr["Fax"]);
				dg.Add("MobilePhone_1", dr["MobilePhone"]);
				dg.Add("BusinessRole", dr["BusinessRole"]);
				dg.Add("Notes", dr["Notes"]);
				dg.Add("Groups", dr["Groups"]);
				if (newCompany)
					dg.Add("CompanyID", NewCompanyID);
				else
					dg.Add("CompanyID", dr["CompanyID"]);

				dg.Add("BirthDay", dr["BirthDay"]);
				dg.Add("BirthPlace", dr["BirthPlace"]);
				dg.Add("Categories", dr["Categories"]);
				dg.Add("FromLead", id);

				object newId = dg.Execute("Base_Contacts", DigiDapter.Identities.Identity);

				NewContactID = Convert.ToInt32(newId);
			}
			DatabaseConnection.DoCommand("update CRM_Leads set Limbo=1 where id=" + id);
			if (newCompany)
				DatabaseConnection.DoCommand("update CRM_WorkActivity set CompanyID=" + NewCompanyID + ",LeadID=null where LeadID=" + id);
			else
				DatabaseConnection.DoCommand("update CRM_WorkActivity set ReferrerID=" + NewContactID + ",LeadID=null where LeadID=" + id);

			if (newCompany)
			{
				DatabaseConnection.DoCommand("update CRM_OpportunityContact set ContactID=" + NewCompanyID + ", ContactType=0 where ContactType=1 and ContactID=" + id);
				DatabaseConnection.DoCommand("update CRM_CrossOpportunity set ContactID=" + NewCompanyID + ", ContactType=0 where ContactType=1 and ContactID=" + id);
				Session["fromlead"] = NewCompanyID;
				Response.Redirect("/CRM/crm_companies.aspx?m=25&dgb=1&si=29");
			}
			else
			{
				Response.Redirect("/CRM/base_contacts.aspx?action=VIEW&full=" + NewContactID);
			}

		}


		private void FillForm(int id)
		{
			string sqlString;
			sqlString = "SELECT CRM_Leads.*, Base_Companies.CompanyName AS CompanyName2 ";
			sqlString += "FROM CRM_Leads LEFT OUTER JOIN Base_Companies ON CRM_Leads.CompanyID = Base_Companies.ID ";
			sqlString += "where CRM_Leads.id=" + id;
			DataSet ds = DatabaseConnection.CreateDataset(sqlString);
			if (ds.Tables[0].Rows.Count > 0)
			{
				DataRow myDataRow = ds.Tables[0].Rows[0];

				CRM_Leads_ID.Text = myDataRow["ID"].ToString();
				CRM_Leads_CompanyID.Text = myDataRow["CompanyID"].ToString();
				CRM_Leads_CompanyName.Text = myDataRow["CompanyName"].ToString();
				CRM_Leads_Name.Text = myDataRow["Name"].ToString();
				CRM_Leads_Surname.Text = myDataRow["Surname"].ToString();
				CRM_Leads_Title.Text = myDataRow["Title"].ToString();
				CRM_Leads_Address.Text = myDataRow["Address"].ToString();
				CRM_Leads_City.Text = myDataRow["City"].ToString();
				CRM_Leads_Province.Text = myDataRow["Province"].ToString();
				CRM_Leads_ZIPCode.Text = myDataRow["ZIPCode"].ToString();
				CRM_Leads_State.Text = myDataRow["State"].ToString();
				CRM_Leads_EMail.Text = myDataRow["EMail"].ToString();
				CRM_Leads_Phone.Text = myDataRow["Phone"].ToString();
				CRM_Leads_Fax.Text = myDataRow["Fax"].ToString();
				CRM_Leads_MobilePhone.Text = myDataRow["MobilePhone"].ToString();
				CRM_Leads_BusinessRole.Text = myDataRow["BusinessRole"].ToString();
				CRM_Leads_Notes.Text = myDataRow["Notes"].ToString();
				CRM_Leads_BirthPlace.Text = myDataRow["BirthPlace"].ToString();
				CRM_Leads_Categories.Text = myDataRow["Categories"].ToString();
				CRM_Leads_BirthDay.Text = (myDataRow["BirthDay"].ToString().Length > 0) ? ((DateTime) myDataRow["BirthDay"]).ToShortDateString() : "";
				CRM_Leads_WebSite.Text = myDataRow["WebSite"].ToString();
				Groups.SetGroups(myDataRow["Groups"].ToString());

				FillRepCategories();
				CheckFreeFields(id);
				FillCrossLeadDrop();

				FillFormCrossLead(id);
				AddKeepAlive();
			}
			else
				HackLock("Lead:" + UC.UserId + ">" + id);

		}

		private void FillFormCrossLead(int id)
		{
			StringBuilder sqlString = new StringBuilder();
			sqlString.Append("SELECT CRM_CrossLead.*, Base_Companies.CompanyName AS CompanyName, ");
			sqlString.Append("Base_Contacts.Surname + ' ' + Base_Contacts.Name AS ContactName, ");
			sqlString.Append("CRM_Opportunity.Title AS OpportunityName, ");
			sqlString.Append("Account_1.Surname + ' ' + Account_1.Name AS OwnerName, ");
			sqlString.Append("Account_2.Surname + ' ' + Account_2.Name AS SalesPersonName, ");
			sqlString.Append("CompanyType.Description AS IndustryName, ");
			sqlString.Append("CRM_LeadDescription1.Description AS StatusDescription, ");
			sqlString.Append("CRM_LeadDescription2.Description AS RatingDescription, ");
			sqlString.Append("CRM_LeadDescription3.Description AS ProductInterestDescription, ");
			sqlString.Append("CRM_LeadDescription4.Description AS SourceDescription, ");
			sqlString.Append("CRM_LeadDescription5.Description AS LeadCurrencyDescription ");
			sqlString.Append("FROM CRM_CrossLead ");
			sqlString.Append("LEFT OUTER JOIN Account Account_2 ON CRM_CrossLead.SalesPerson = Account_2.UID ");
			sqlString.Append("LEFT OUTER JOIN Account Account_1 ON CRM_CrossLead.LeadOwner = Account_1.UID ");
			sqlString.Append("LEFT OUTER JOIN CRM_Opportunity ON CRM_CrossLead.AssociatedOpportunity = CRM_Opportunity.ID ");
			sqlString.Append("LEFT OUTER JOIN Base_Contacts ON CRM_CrossLead.AssociatedContact = Base_Contacts.ID ");
			sqlString.Append("LEFT OUTER JOIN Base_Companies ON CRM_CrossLead.AssociatedCompany = Base_Companies.ID ");

			sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription1 ON CRM_CrossLead.Status = CRM_LeadDescription1.K_ID and CRM_LeadDescription1.lang='" + UC.Culture.Substring(0, 2) + "' ");
			sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription2 ON CRM_CrossLead.Rating = CRM_LeadDescription2.K_ID and CRM_LeadDescription2.lang='" + UC.Culture.Substring(0, 2) + "' ");
			sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription3 ON CRM_CrossLead.ProductInterest = CRM_LeadDescription3.K_ID and CRM_LeadDescription3.lang='" + UC.Culture.Substring(0, 2) + "' ");
			sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription4 ON CRM_CrossLead.Source = CRM_LeadDescription4.K_ID and CRM_LeadDescription4.lang='" + UC.Culture.Substring(0, 2) + "' ");
			sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription5 ON CRM_CrossLead.LeadCurrency = CRM_LeadDescription5.K_ID and CRM_LeadDescription5.lang='" + UC.Culture.Substring(0, 2) + "' ");

			sqlString.Append("LEFT OUTER JOIN CompanyType ON CRM_CrossLead.Industry = CompanyType.K_ID and CompanyType.lang='" + UC.Culture.Substring(0, 2) + "' ");
			sqlString.AppendFormat("where CRM_CrossLead.LeadID={0}", id);

			DataTable dt = DatabaseConnection.CreateDataset(sqlString.ToString()).Tables[0];
			if (dt.Rows.Count == 0)
				return;
			DataRow dr = dt.Rows[0];
			TextBox tx;
			DropDownList dp;

			tx = (TextBox) referenceForm.FindControl("CrossLead_AssociatedCompany");
			tx.Text = dr["AssociatedCompany"].ToString();
			tx = (TextBox) referenceForm.FindControl("CrossLead_CompanyName");
			tx.Text = dr["CompanyName"].ToString();
			tx = (TextBox) referenceForm.FindControl("CrossLead_AssociatedContact");
			tx.Text = dr["AssociatedContact"].ToString();
			tx = (TextBox) referenceForm.FindControl("CrossLead_ContatcName");
			tx.Text = dr["ContactName"].ToString();
			tx = (TextBox) referenceForm.FindControl("CrossLead_LeadOwner");
			tx.Text = dr["LeadOwner"].ToString();
			tx = (TextBox) referenceForm.FindControl("CrossLead_OwnerName");
			tx.Text = dr["OwnerName"].ToString();
			tx = (TextBox) referenceForm.FindControl("CrossLead_PotentialRevenue");
			tx.Text = (dr["PotentialRevenue"] == DBNull.Value) ? "" : Convert.ToDecimal(dr["PotentialRevenue"]).ToString(@"#.00");
			tx = (TextBox) referenceForm.FindControl("CrossLead_EstimatedCloseDate");
			if (dr["EstimatedCloseDate"] is DateTime)
				tx.Text = ((DateTime) dr["EstimatedCloseDate"]).ToShortDateString();
			tx = (TextBox) referenceForm.FindControl("CrossLead_Campaign");
			tx.Text = dr["Campaign"].ToString();
			tx = (TextBox) referenceForm.FindControl("CrossLead_SalesPerson");
			tx.Text = dr["SalesPerson"].ToString();
			tx = (TextBox) referenceForm.FindControl("crossLead_SalesPersonName");
			tx.Text = dr["SalesPersonName"].ToString();

			dp = (DropDownList) referenceForm.FindControl("CrossLead_Status");
			foreach (ListItem i in dp.Items)
			{
				if (i.Value == dr["Status"].ToString())
				{
					i.Selected = true;
					break;
				}
			}
			dp = (DropDownList) referenceForm.FindControl("CrossLead_Rating");
			foreach (ListItem i in dp.Items)
			{
				if (i.Value == dr["Rating"].ToString())
				{
					i.Selected = true;
					break;
				}
			}
			dp = (DropDownList) referenceForm.FindControl("CrossLead_ProductInterest");
			foreach (ListItem i in dp.Items)
			{
				if (i.Value == dr["ProductInterest"].ToString())
				{
					i.Selected = true;
					break;
				}
			}
			dp = (DropDownList) referenceForm.FindControl("CrossLead_LeadCurrency");
			foreach (ListItem i in dp.Items)
			{
				if (i.Value == dr["LeadCurrency"].ToString())
				{
					i.Selected = true;
					break;
				}
			}
			dp = (DropDownList) referenceForm.FindControl("CrossLead_Source");
			foreach (ListItem i in dp.Items)
			{
				if (i.Value == dr["Source"].ToString())
				{
					i.Selected = true;
					break;
				}
			}
			dp = (DropDownList) referenceForm.FindControl("CrossLead_Industry");
			foreach (ListItem i in dp.Items)
			{
				if (i.Value == dr["Industry"].ToString())
				{
					i.Selected = true;
					break;
				}
			}
		}

		private void FillCrossLeadDrop()
		{
			FillDropDownLead((DropDownList) referenceForm.FindControl("CrossLead_Status"), "1", rm.GetString("Ledtxt21"));
			FillDropDownLead((DropDownList) referenceForm.FindControl("CrossLead_Rating"), "2", rm.GetString("Ledtxt22"));
			FillDropDownLead((DropDownList) referenceForm.FindControl("CrossLead_ProductInterest"), "3", rm.GetString("Ledtxt23"));
			FillDropDownLead((DropDownList) referenceForm.FindControl("CrossLead_Source"), "4", rm.GetString("Ledtxt24"));
			FillDropDownLead((DropDownList) referenceForm.FindControl("CrossLead_Industry"), "6", rm.GetString("Ledtxt25"));

			DropDownList CrossLead_LeadCurrency = (DropDownList) referenceForm.FindControl("CrossLead_LeadCurrency");
			CrossLead_LeadCurrency.DataTextField = "Currency";
			CrossLead_LeadCurrency.DataValueField = "idcur";
			CrossLead_LeadCurrency.DataSource = DatabaseConnection.CreateDataset("select cast(id as varchar(10)) idcur,Currency from CurrencyTable").Tables[0];
			CrossLead_LeadCurrency.DataBind();
		}


		private void ModifyForm(int id)
		{
			using (DigiDapter dg = new DigiDapter("select id from CRM_Leads where id=" + id))
			{
				if (!dg.HasRows)
				{
				}
				dg.Add("CreatedByID", UC.UserId);

				TextBox owner = (TextBox) referenceForm.FindControl("crossLead_leadowner");
				if (owner.Text.Length > 0)
					dg.Add("OwnerID", owner.Text);
				else
					dg.Add("OwnerID", UC.UserId);

				if (CRM_Leads_CompanyID.Text.Length == 0)
					dg.Add("CompanyID", 0);
				else
					dg.Add("CompanyID", CRM_Leads_CompanyID.Text);

				dg.Add("CompanyName", CRM_Leads_CompanyName.Text.Trim());
				dg.Add("Name", CRM_Leads_Name.Text.Trim());
				dg.Add("Surname", CRM_Leads_Surname.Text.Trim());
				dg.Add("Title", CRM_Leads_Title.Text.Trim());
				dg.Add("Address", CRM_Leads_Address.Text.Trim());
				dg.Add("City", CRM_Leads_City.Text.Trim());
				dg.Add("Province", CRM_Leads_Province.Text.Trim());
				dg.Add("ZIPCode", CRM_Leads_ZIPCode.Text.Trim());
				dg.Add("State", CRM_Leads_State.Text.Trim());
				dg.Add("EMail", CRM_Leads_EMail.Text.Trim());
				dg.Add("Phone", CRM_Leads_Phone.Text.Trim());
				dg.Add("Fax", CRM_Leads_Fax.Text.Trim());
				dg.Add("MobilePhone", CRM_Leads_MobilePhone.Text.Trim());
				dg.Add("BusinessRole", CRM_Leads_BusinessRole.Text.Trim());
				dg.Add("Notes", CRM_Leads_Notes.Text.Trim());
				dg.Add("BirthPlace", CRM_Leads_BirthPlace.Text.Trim());

				string cat = "|";
				foreach (RepeaterItem it in RepCategories.Items)
				{
					CheckBox Check = (CheckBox) it.FindControl("Check");
					if (Check.Checked)
						cat += ((Literal) it.FindControl("IDCat")).Text + "|";
				}
				if (cat.Length > 1)
					dg.Add("Categories", cat);
				else
					dg.Add("Categories", DBNull.Value);

				try
				{
					DateTime checkDate = Convert.ToDateTime(CRM_Leads_BirthDay.Text);
					if (checkDate < new DateTime(1910, 1, 1))
						dg.Add("BirthDay", DBNull.Value);
					else
						dg.Add("BirthDay", checkDate);
				}
				catch
				{
					dg.Add("BirthDay", DBNull.Value);
				}

				dg.Add("WebSite", CRM_Leads_WebSite.Text);

				if (Groups.GetValue.Length > 0)
				{
					dg.Add("Groups", Groups.GetValue);
				}
				else
				{
					dg.Add("Groups", "|" + UC.UserGroupId + "|");
				}

				if (dg.HasRows)
				{
					dg.Add("Lastactivity", 1); //MODIFICA
					dg.Add("LastmodifiedDate", DateTime.UtcNow);
					dg.Add("LastmodifiedByID", UC.UserId);
				}

				object newId = dg.Execute("CRM_Leads", "ID=" + id, DigiDapter.Identities.Identity);

				if (id == -1)
				{
					int tempId = int.Parse(newId.ToString());
					ModifyCrossLead(tempId);
					FillFreeFields(tempId);
					DatabaseConnection.CommitTransaction();
					FillView(tempId);
				}
				else
				{
					ModifyCrossLead(id);
					FillFreeFields(id);
					DatabaseConnection.CommitTransaction();
					FillView(id);
				}

			}
		}

		private void ModifyCrossLead(int id)
		{
			using (DigiDapter dg = new DigiDapter())
			{
				dg.AddOrNull("AssociatedCompany", CrossLead_AssociatedCompany.Text);
				dg.AddOrNull("AssociatedContact", CrossLead_AssociatedContact.Text);
				dg.AddOrNull("LeadOwner", CrossLead_LeadOwner.Text);
				dg.Add("Status", CrossLead_Status.SelectedValue);
				dg.Add("Rating", CrossLead_Rating.SelectedValue);
				dg.Add("ProductInterest", CrossLead_ProductInterest.SelectedValue);
				dg.Add("PotentialRevenue", StaticFunctions.FixDecimal(CrossLead_PotentialRevenue.Text));
				if (CrossLead_EstimatedCloseDate.Text.Length > 0)
					dg.Add("EstimatedCloseDate", DateTime.Parse(CrossLead_EstimatedCloseDate.Text));
				else
					dg.Add("EstimatedCloseDate", DBNull.Value);
				dg.Add("LeadCurrency", CrossLead_LeadCurrency.SelectedValue);
				dg.Add("Source", CrossLead_Source.SelectedValue);
				dg.AddOrNull("Campaign", CrossLead_Campaign.Text);
				dg.AddOrNull("Industry", CrossLead_Industry.SelectedValue);
				dg.AddOrNull("SalesPerson", CrossLead_SalesPerson.Text);
				dg.Add("leadid", id);
				dg.Execute("CRM_CrossLead", "LeadID=" + id);
			}
		}

		private void FillFreeFields(int id)
		{
			string sqlStringQuery;
			sqlStringQuery = "select * from addedfields where tablename=" + (byte) CRMTables.CRM_Leads + " order by vieworder";
			DataSet ds = DatabaseConnection.CreateDataset(sqlStringQuery);
			if (ds.Tables[0].Rows.Count > 0)
			{
				foreach (DataRow dr in ds.Tables[0].Rows)
				{
					try
					{
						if (Request.Form["Free_" + dr["name"]].Length > 0)
						{
							string sqlString;
						sqlString = "select id from addedfields_cross where id = " + id + " and idrif=" + dr["id"];
							using (DigiDapter dg = new DigiDapter(sqlString))
							{

								dg.Add("ID", id);
								dg.Add("IDRif", dr["id"]);
								dg.Add("FIELDVAL", Request.Form["Free_" + dr["name"]]);
								if(dg.HasRows)
									dg.Execute("addedfields_cross", "id = " + id + " and idrif=" + dr["id"]);
								else
									dg.Execute("addedfields_cross", "pkey = -1");
							}
						}
						else
						{
						DatabaseConnection.DoCommand("delete from addedfields_cross where id = " + id + " and idrif=" + dr["id"]);
						}
					}catch{}
				}
			}
		}

		private void InitAjax()
		{
			Manager.Register(this, "Ajax.Leads", Debug.None);
		}

		[Method]
		public string CheckDuplicatedLeads(string company, string surname)
		{
			if (company.Length == 0)
				return DatabaseConnection.SqlScalar("select name+'|'+surname as ret from CRM_Leads where surname = '" + DatabaseConnection.FilterInjection(surname) + "'");
			else
				return DatabaseConnection.SqlScalar("select name+'|'+surname as ret from CRM_Leads where CompanyName =  '" + DatabaseConnection.FilterInjection(company) + "' and surname = '" + DatabaseConnection.FilterInjection(surname) + "'");
		}

		public void NewActivity_Click(Object sender, EventArgs e)
		{

				SetGoBack("/crm/CRM_Lead.aspx?m=25&si=53&gb=1", new string[2] {Session["CurrentRefId"].ToString(), "a"});
				Session["AcLeadID"] = Session["CurrentRefId"].ToString();
				switch (((LinkButton) sender).ID)
				{
					case "NewActivityPhone":
						Session["AType"] = 1;
						break;
					case "NewActivityLetter":
						Session["AType"] = 2;
						break;
					case "NewActivityFax":
						Session["AType"] = 3;
						break;
					case "NewActivityMemo":
						Session["AType"] = 4;
						break;
					case "NewActivityEmail":
						Session["AType"] = 5;
						break;
					case "NewActivityVisit":
						Session["AType"] = 6;
						break;
					case "NewActivityGeneric":
						Session["AType"] = 7;
						break;
					case "NewActivitySolution":
						Session["AType"] = 8;
						break;
				}
				Response.Redirect("/WorkingCRM/AllActivity.aspx?m=25&si=38");
		}

		public void btn_Click(Object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "RefreshRepCategories":
					FillRepCategories();
					Page.RegisterClientScriptBlock("xxx", "<script>g_fFieldsChanged=1;</script>");
					break;
			}
		}


		public void RapSubmit_Click(Object sender, EventArgs e)
		{
			if (RapRagSoc.Text.Length > 0)
			{
				using (DigiDapter dg = new DigiDapter())
				{
					dg.Add("CreatedByID", UC.UserId);
					dg.Add("CompanyName", RapRagSoc.Text);
					dg.Add("Phone", RapPhone.Text);
					dg.Add("EMail", RapEmail.Text.Trim(' '));
					dg.Add("OwnerID", UC.UserId);
					dg.Add("Groups", "|" + UC.AdminGroupId + "|" + UC.UserGroupId + "|");
					object newId = dg.Execute("Base_Companies", "ID=-1", DigiDapter.Identities.Identity);

					SetGoBack("/crm/crm_companies.aspx?m=25&si=29&gb=1", new string[] {newId.ToString(), "d"});

					RapInfo.Text = "\"<a href=/crm/crm_companies.aspx?m=25&si=29&gb=1><span class=divautoformRequired>" + RapRagSoc.Text + "</span></a>\" " + rm.GetString("Bcotxt43");
					RapRagSoc.Text = String.Empty;
					RapPhone.Text = String.Empty;
					RapEmail.Text = String.Empty;
				}

			}
			else
			{
				RapInfo.Text = rm.GetString("Bcotxt48");
			}
		}

		private void FillRepeaterActivity(int refID)
		{
			AcCrono.ParentID = refID;
			AcCrono.OpportunityID = 0;
			AcCrono.AcType = (byte) AType.Lead;


			AcCrono.FromSheet = "l";
			AcCrono.Refresh();

			if (AcCrono.ItemCount > 0)
				AcCrono.Visible = true;
			else
			{
				AcCrono.Visible = false;
				RepeaterActivityInfo.Text = rm.GetString("CRMcontxt24");
			}
		}

		public void FileRepDatabound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton Mod = (LinkButton) e.Item.FindControl("Modify");
					Mod.Text = rm.GetString("Dsttxt16");
					LinkButton Rev = (LinkButton) e.Item.FindControl("Revision");
					Rev.Text = rm.GetString("Dsttxt13");

					LinkButton RN = (LinkButton) e.Item.FindControl("ReviewNumber");
					Label LRN = (Label) e.Item.FindControl("LbReviewNumber");

					if (Session["review"].ToString() == "0")
					{
						RN.Visible = (RN.Text != "0");
						Rev.Visible = true;
						LRN.Visible = false;
					}
					else
					{
						RN.Visible = false;
						Rev.Visible = false;
						LRN.Visible = (LRN.Text != "0");
					}
					break;
			}
		}

		private void CheckFreeFields(int id)
		{
			string query = GroupsSecure("groups");
			if (query.Length > 0)
				query = " groups like '%|" + UC.UserGroupId + "|%'";

			string sqlString;
			sqlString = "select * from addedfields where tablename=" + (byte) CRMTables.CRM_Leads + " and (" + query + ") order by vieworder";

			DataSet ds = DatabaseConnection.CreateDataset(sqlString);
			if (ds.Tables[0].Rows.Count > 0)
			{
				StringBuilder S = new StringBuilder();
				S.AppendFormat("<table width=\"100%\"><tr><td class=\"normal Bbot\"><br><b>{0}</b></td></tr></table>", rm.GetString("Bcotxt50"));
				S.Append("<table width=\"45%\" class=\"normal\">");
				foreach (DataRow dr in ds.Tables[0].Rows)
				{
					S.Append(FreeFieldType(dr["type"].ToString(), dr["name"].ToString(), int.Parse(dr["id"].ToString()), id, dr["Items"].ToString()));
				}
				S.Append("</table>");
				FreeFields.Text = S.ToString();
			}
		}


		public string FreeFieldType(string type, string name, int did, int id, string items)
		{
			StringBuilder S = new StringBuilder();
			string pf = String.Empty;
			string pfv = String.Empty;
			bool isParentCrossed = false;
			DataSet Q = DatabaseConnection.CreateDataset("select ParentField,ParentFieldValue from AddedFields where id=" + did);
			pf = Q.Tables[0].Rows[0][0].ToString();
			pfv = Q.Tables[0].Rows[0][1].ToString();
			if (pf.Length > 0 && id != -1)
			{
				IDataReader sqlDr = DatabaseConnection.CreateReader("select " + pf + " from CRM_Leads where id=" + int.Parse(Session["CurrentRefId"].ToString()));
				sqlDr.Read();
				Trace.Warn("PF-PFV", pf + "-" + pfv);
				isParentCrossed = (sqlDr[0].ToString() == pfv);
				Trace.Warn("IsParentCrossed", isParentCrossed.ToString());
				sqlDr.Close();
			}

			if (pf.Length > 0)
			{
				if (isParentCrossed)
					S.AppendFormat("<tr ParentField=\"{1}\" ParentFieldValue=\"{2}\"><td width=\"40%\">{0}</td>", name, pf, pfv);
				else
					S.AppendFormat("<tr ParentField=\"{1}\" ParentFieldValue=\"{2}\" style=\"display:none;\"><td width=\"40%\">{0}</td>", name, pf, pfv);
			}
			else
				S.AppendFormat("<tr><td width=\"40%\">{0}</td>", name);
			switch (type)
			{
				case "1":
				case "2":
				case "3":
					if (id != -1)
					{
						DataSet afCross = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + did + " and id=" + id);
						if (afCross.Tables[0].Rows.Count > 0)
						{
							S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\" value=\"{1}\"></td></tr>", name, afCross.Tables[0].Rows[0][0]);
						}
						else
						{
							S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\"></td></tr>", name);
						}
						afCross.Clear();
					}
					else
					{
						S.AppendFormat("<td><input type=\"Text\" name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\"></td></tr>", name);
					}
					break;
				case "4":
					string[] it = items.Split('|');
					DataSet afCrossS = DatabaseConnection.CreateDataset("select fieldval from addedfields_cross where idrif=" + did + " and id=" + id);
					S.AppendFormat("<td><select old=true name=\"Free_{0}\" id=\"Free_{0}\" class=\"BoxDesign\">", name);

					foreach (string op in it)
					{
						try
						{
							if (op == afCrossS.Tables[0].Rows[0][0].ToString())
							{
								if (op.Length > 0) S.AppendFormat("<option selected>{0}</option>", op);
							}
							else
							{
								if (op.Length > 0) S.AppendFormat("<option>{0}</option>", op);
							}
						}
						catch
						{
							if (op.Length > 0) S.AppendFormat("<option>{0}</option>", op);
						}
					}
					S.Append("</select></td></tr>");
					break;
			}
			return S.ToString();
		}

		private void FillRepCategories()
		{
			FillRepCategories(false);
		}

		private void FillRepCategories(bool newlead)
		{
			DataTable dt;
			dt = DatabaseConnection.CreateDataset("select id,Description,'0' as tocheck from CRM_ReferrerCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + ")) order by FlagPersonal desc").Tables[0];
			if (dt.Rows.Count > 0 && !newlead)
			{
				foreach (DataRow dr in dt.Rows)
				{
					if (CRM_Leads_Categories.Text.IndexOf("|" + dr["id"].ToString() + "|") > -1)
						dr["tocheck"] = "1";
				}
			}
			RepCategories.DataSource = new DataView(dt, "", "tocheck desc", DataViewRowState.CurrentRows);
			RepCategories.DataBind();
		}

		public void RepCategories_DataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Literal IDCat = (Literal) e.Item.FindControl("IDCat");
					if (CRM_Leads_Categories.Text.IndexOf("|" + IDCat.Text + "|") > -1)
					{
						CheckBox Check = (CheckBox) e.Item.FindControl("Check");
						Check.Checked = true;
					}

					DataSet ds = DatabaseConnection.CreateDataset("select id from CRM_Leads where Categories like '%|" + DatabaseConnection.FilterInjection(IDCat.Text) + "|%'");
					if (ds.Tables[0].Rows.Count < 1)
					{
						LinkButton DeleteCat = (LinkButton) e.Item.FindControl("DeleteCat");
						DeleteCat.Text = "<img src='/i/erase.gif' border=0 alt='" + rm.GetString("CRMcontxt49") + "'>";
						DeleteCat.Attributes.Add("onclick", "g_fFieldsChanged=0;return confirm('" + rm.GetString("CRMcontxt50") + "');");
					}
					break;
			}
		}

		public void RepCategories_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "DeleteCat":
					string count = "select count(*) from CRM_Leads where Categories like '|" + int.Parse(((Literal) e.Item.FindControl("IDCat")).Text) + "|'";

					int empty = (int) DatabaseConnection.SqlScalartoObj(count);

					if (empty < 1)
					{
						string sqlString = "delete from CRM_ReferrerCategories where ID =" + int.Parse(((Literal) e.Item.FindControl("IDCat")).Text);
						DatabaseConnection.DoCommand(sqlString);
					}
					FillRepCategories();
					Page.RegisterClientScriptBlock("xxx", "<script>g_fFieldsChanged=1;</script>");
					break;
			}
		}

		public bool NoLength(string tx)
		{
			return false;
		}

		public DataView getLeadInfo(int id)
		{
			string twoLetterCulture = UC.Culture.Substring(0, 2);
			StringBuilder sqlString = new StringBuilder();
			sqlString.Append("SELECT CRM_CrossLead.*, Base_Companies.CompanyName AS CompanyName, ");
			sqlString.Append("Base_Contacts.Surname + ' ' + Base_Contacts.Name AS ContactName, ");
			sqlString.Append("CRM_Opportunity.Title AS OpportunityName, ");
			sqlString.Append("Account_1.Surname + ' ' + Account_1.Name AS OwnerName, ");
			sqlString.Append("Account_2.Surname + ' ' + Account_2.Name AS SalesPersonName, ");
			sqlString.Append("CompanyType.Description AS IndustryName, ");
			sqlString.Append("CRM_LeadDescription1.Description AS StatusDescription, ");
			sqlString.Append("CRM_LeadDescription2.Description AS RatingDescription, ");
			sqlString.Append("CRM_LeadDescription3.Description AS ProductInterestDescription, ");
			sqlString.Append("CRM_LeadDescription4.Description AS SourceDescription, ");
			sqlString.Append("CurrencyTable.Currency AS LeadCurrencyDescription ");
			sqlString.Append("FROM CRM_CrossLead ");
			sqlString.Append("LEFT OUTER JOIN Account Account_2 ON CRM_CrossLead.SalesPerson = Account_2.UID ");
			sqlString.Append("LEFT OUTER JOIN Account Account_1 ON CRM_CrossLead.LeadOwner = Account_1.UID ");
			sqlString.Append("LEFT OUTER JOIN CRM_Opportunity ON CRM_CrossLead.AssociatedOpportunity = CRM_Opportunity.ID ");
			sqlString.Append("LEFT OUTER JOIN Base_Contacts ON CRM_CrossLead.AssociatedContact = Base_Contacts.ID ");
			sqlString.Append("LEFT OUTER JOIN Base_Companies ON CRM_CrossLead.AssociatedCompany = Base_Companies.ID ");

			sqlString.AppendFormat("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription1 ON CRM_CrossLead.Status = CRM_LeadDescription1.K_ID and CRM_LeadDescription1.lang='{0}' ", twoLetterCulture);
			sqlString.AppendFormat("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription2 ON CRM_CrossLead.Rating = CRM_LeadDescription2.K_ID and CRM_LeadDescription2.lang='{0}' ", twoLetterCulture);
			sqlString.AppendFormat("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription3 ON CRM_CrossLead.ProductInterest = CRM_LeadDescription3.K_ID and CRM_LeadDescription3.lang='{0}' ", twoLetterCulture);
			sqlString.AppendFormat("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription4 ON CRM_CrossLead.Source = CRM_LeadDescription4.K_ID and CRM_LeadDescription4.lang='{0}' ", twoLetterCulture);
			sqlString.AppendFormat("LEFT OUTER JOIN CurrencyTable ON CRM_CrossLead.LeadCurrency = CurrencyTable.ID ", twoLetterCulture);

			sqlString.AppendFormat("LEFT OUTER JOIN CompanyType ON CRM_CrossLead.Industry = CompanyType.K_ID and CompanyType.lang='{0}' ", twoLetterCulture);


			DataSet temp = DatabaseConnection.CreateDataset(sqlString.ToString() + "where CRM_CrossLead.LeadID=" + id);
			if (temp.Tables[0].Rows.Count > 0)
				return temp.Tables[0].DefaultView;
			else
			{
				ModifyCrossLead(id);
				return DatabaseConnection.CreateDataset(sqlString.ToString() + "where CRM_CrossLead.LeadID=" + id).Tables[0].DefaultView;
			}
		}

		private void FillDropDownLead(DropDownList st, string type, string noselect)
		{
			DataSet ds;
			switch (type)
			{
				case "6":
					ds = DatabaseConnection.CreateDataset("Select K_ID,Description from CompanyType where lang='" + UC.Culture.Substring(0, 2) + "' order by Description");
					break;
				default:
					ds = DatabaseConnection.CreateDataset("Select K_ID,Description from CRM_LeadDescription where lang='" + UC.Culture.Substring(0, 2) + "' and type=" + type + " order by K_id");
					break;
			}
			st.DataSource = ds;
			st.DataTextField = "Description";
			st.DataValueField = "K_ID";
			st.DataBind();
			st.Items.Insert(0, noselect);
			st.Items[0].Value = "0";
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.SheetP.NextClick += new EventHandler(SheetP_NextClick);
			this.SheetP.PrevClick += new EventHandler(SheetP_PrevClick);
			this.SrcBtn.Click += new EventHandler(srcbtn_Click);
			this.BtnAdvanced.Click += new EventHandler(btnAdvanced_Click);
			this.Load += new EventHandler(this.Page_Load);
			this.LbnNew.Click += new EventHandler(this.NewLead);
			this.BtnSearch.Click += new EventHandler(this.BtnSearch_Click);
			this.BtnGroup.Click += new EventHandler(this.BtnSearch_Click);
			this.RapSubmit.Click += new EventHandler(this.RapSubmit_Click);
			this.SubmitRef.Click += new EventHandler(this.ReferenceFormSubmit);
			this.RefreshRepCategories.Click += new EventHandler(this.btn_Click);
			this.Submit2.Click += new EventHandler(this.ReferenceFormSubmit);
			this.NewActivityPhone.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityLetter.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityFax.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityMemo.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityEmail.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityVisit.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivityGeneric.Click += new EventHandler(this.NewActivity_Click);
			this.NewActivitySolution.Click += new EventHandler(this.NewActivity_Click);
			this.Repeater1.ItemCommand += new RepeaterCommandEventHandler(this.Repeater1_Command);
			this.ViewForm.ItemCommand += new RepeaterCommandEventHandler(this.ViewForm_Command);
			this.RepCategories.ItemCommand += new RepeaterCommandEventHandler(this.RepCategories_Command);
			this.Repeater1.ItemDataBound += new RepeaterItemEventHandler(this.Repeater1_ItemDataBound);
			this.ViewForm.ItemDataBound += new RepeaterItemEventHandler(this.ViewFormOnItemDatabound);

			this.RepCategories.ItemDataBound += new RepeaterItemEventHandler(this.RepCategories_DataBound);

		}

		#endregion

		private void srcbtn_Click(object sender, EventArgs e)
		{
			Trace.Warn("query avanzata", srcComp.GetLeadQuery());
			Repeater1Paging.PageSize = UC.PagingSize;
			Repeater1Paging.RepeaterObj = Repeater1;
			string raq = srcComp.GetLeadQuery();
			InitSheetPaging(raq);
			Repeater1Paging.sqlRepeater = raq;
			Repeater1Paging.BuildGrid();

			if (Repeater1.Items.Count > 0)
			{
				Repeater1.Visible = true;
				RepeaterInfo.Visible = false;
				advancedSearch.Visible = false;
			}
			else
			{
				RepeaterInfo.Text = "<center>" + rm.GetString("Bcotxt41") + "</center>";
				Repeater1.Visible = false;
				RepeaterInfo.Visible = true;
			}

			tabControl.Visible = false;
			referenceForm.Visible = false;
			ViewForm.Visible = false;
		}


		private void InitSheetPaging(string sqlString)
		{
			DataTable dt = DatabaseConnection.CreateDataset(sqlString).Tables[0];
			string[] myarray = new string[dt.Rows.Count];
			if (dt.Rows.Count > 0)
			{
				for (int i = 0; i < dt.Rows.Count; i++)
				{
					myarray[i] = dt.Rows[i]["ID"] + "|" + dt.Rows[i]["Name"] + " " + dt.Rows[i]["SurName"] + " " + dt.Rows[i]["CompanyName"];
				}
			}

			SheetP.IDArray = myarray;
		}

		private void SheetP_NextClick(object sender, EventArgs e)
		{
			FillView(this.SheetP.GetCurrentID);
		}

		private void SheetP_PrevClick(object sender, EventArgs e)
		{
			FillView(this.SheetP.GetCurrentID);
		}

		public void RepCrossLead_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Literal LblPotentialRevenue = (Literal) e.Item.FindControl("LblPotentialRevenue");
					double pr;
					try
					{
						pr = Convert.ToDouble(DataBinder.Eval((DataRowView) e.Item.DataItem, "PotentialRevenue"));
					}
					catch
					{
						pr = 0;
					}
					string sy;
					try
					{
						sy = DatabaseConnection.SqlScalar("select CurrencySymbol from currencytable where id=" + (int) DataBinder.Eval((DataRowView) e.Item.DataItem, "LeadCurrency"));
					}
					catch
					{
						{
							sy = DatabaseConnection.SqlScalar("select CurrencySymbol from currencytable changefromeuro=1 and changetoeuro=1");
						}
					}
					LblPotentialRevenue.Text = sy + " " + Math.Round(pr, 2).ToString();
					break;
			}
		}

		private void btnAdvanced_Click(object sender, EventArgs e)
		{
			Repeater1.Visible = false;
			RepeaterInfo.Visible = false;
			tabControl.Visible = false;
			advancedSearch.Visible = true;
			srcComp.Visible = true;
		}


	}
}
