/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;

using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Common;
using Digita.Tustena.Database;

namespace Digita.Tustena
{
	public class Notes : G
	{
		protected Repeater RepNotes;
		protected RepeaterPaging Repeaterpaging1;
		protected LinkButton BtnSearch;
		protected System.Web.UI.WebControls.TextBox TxtSearch;

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				DeleteGoBack();
				Repeaterpaging1.Visible=false;

				if (!Page.IsPostBack)
				{
					FillRep();
				}


			}
			BtnSearch.Text = rm.GetString("Notetxt4");
		}

		private void FillRep()
		{
			string sqlString = "select Base_notes.*,(Account.Surname+' '+Account.Name) as Owner FROM Base_notes LEFT OUTER JOIN Account ON Base_notes.OwnerID = Account.UID ";

			string qGroup = GroupsSecure("Base_notes.Groups");
			sqlString += "where (" + qGroup + ") or Base_notes.OwnerID=" + UC.UserId.ToString() + " order by Base_notes.CreatedDate desc";

			Repeaterpaging1.PageSize = UC.PagingSize;
			Repeaterpaging1.RepeaterObj = this.RepNotes;
			Repeaterpaging1.sqlRepeater = sqlString.ToString();
			Repeaterpaging1.CurrentPage=0;
			Repeaterpaging1.BuildGrid();


			if (RepNotes.Items.Count > 0)
			{
				RepNotes.Visible = true;
			}
			else
			{
				RepNotes.Visible = false;
			}
		}

		public void ItemDataBound_Repeater(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					ImageButton lk = (ImageButton) e.Item.FindControl("Delete");
					lk.Attributes.Add("onclick", "return confirm('" + rm.GetString("Notetxt8") + "');");

					HtmlContainerControl viewText = (HtmlContainerControl) e.Item.FindControl("viewText");
					viewText.Visible = false;
					break;
			}
		}

		public void ItemCommandRep(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "Delete":
					Delete(int.Parse(((Literal) (e.Item.FindControl("IDApp"))).Text));
					FillRep();
					break;
				case "modifyNote":
					HtmlContainerControl viewText = (HtmlContainerControl) e.Item.FindControl("viewText");
					if (!viewText.Visible)
					{
						viewText.Visible = true;
					}
					else
					{
						viewText.Visible = false;
					}
					break;
				case "noteSubmit":
					Literal IDApp = (Literal) e.Item.FindControl("IDApp");
					TextBox AreaText = (TextBox) e.Item.FindControl("AreaText");
					DatabaseConnection.DoCommand("update Base_Notes set Body = '"+DatabaseConnection.FilterInjection(AreaText.Text)+"' where ID =" + int.Parse("IDApp.Text"));
					FillRep();
					break;
			}
		}

		private void Delete(int id)
		{
			string sqlString = "delete from Base_notes where ID ="+id;
			DatabaseConnection.DoCommand(sqlString);


		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.BtnSearch.Click += new EventHandler(this.BtnSearch_Click);
			this.RepNotes.ItemCommand += new RepeaterCommandEventHandler(this.ItemCommandRep);
			this.RepNotes.ItemDataBound += new RepeaterItemEventHandler(this.ItemDataBound_Repeater);
		}

		#endregion

		public void BtnSearch_Click(object sender, EventArgs e)
		{
			string sqlString = "select Base_notes.*,(Account.Surname+' '+Account.Name) as Owner FROM Base_notes LEFT OUTER JOIN Account ON Base_notes.OwnerID = Account.UID ";
			string qGroup = GroupsSecure("Base_notes.Groups");
			sqlString += "where ((" + qGroup + ") or Base_notes.OwnerID=" + UC.UserId + ")";
			DeleteGoBack(true);
		}
	}


}
