/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Collections;
using System.Data;

using System.Diagnostics;
using System.IO;
using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.DomValidators;
using Digita.Tustena.Base;
using Digita.Tustena.Common;
using Digita.Tustena.Database;
using Digita.Tustena.WorkingCRM;

namespace Digita.Tustena
{
	public class CRMOpportunity : G
	{
		protected HtmlGenericControl FrameForm;
		protected LinkButton BtnFind;
		protected LinkButton BtnNew;
		protected LinkButton Opportunity_Submit;
		protected LinkButton Opportunity_SubmitUP;
		protected LinkButton Opportunity_Modify;
		protected LinkButton Opportunity_NewCo;
		protected LinkButton Opportunity_CompanyList;

		protected LinkButton AddNewCompetitor;
		protected LinkButton SaveCompetitor;
		protected LinkButton CloseCompetitor;
		protected LinkButton AddNewPartner;

		protected TextBox FindTxt;

		protected Label SmallReport;

		protected HtmlTable OpportunityCard;
		protected HtmlGenericControl PopAccount;
		protected HtmlGenericControl Opportunity_Access;

		protected HtmlTable CompetitorCard;


		protected Repeater RepeaterOpportunity;
		protected Repeater RepeaterCompany;
		protected Repeater RepeaterLead;
		protected Label RepeaterOpportunityInfo;

		protected Repeater RepeaterCompetitor;

		protected Label RepeaterCompanyInfo;
		protected Label RepeaterLeadInfo;
		protected Label RepeaterActivityInfo;
		protected TextBox Opportunity_ID;
		protected Literal Tab1Text;
		protected TextBox Opportunity_AdminAccount;

		protected Literal SomeJS;
		protected Label CompetitorInfo;

		protected HtmlTable tabControl;
		protected HtmlInputHidden activeTab;

		protected HtmlTableCell tabControlTab1;
		protected HtmlTableCell tabControlTab2;
		protected HtmlTableCell tabControlTab3;
		protected HtmlTableCell tabControlTab4;


		protected LinkButton Back;


		protected SelectOffice Office;
		protected SelectOffice OfficeBasic;

		protected ActivityChronology AcCrono;
		protected LinkButton NewActivityPhone;
		protected LinkButton NewActivityLetter;
		protected LinkButton NewActivityFax;
		protected LinkButton NewActivityMemo;
		protected LinkButton NewActivityEmail;
		protected LinkButton NewActivityVisit;
		protected LinkButton NewActivityGeneric;
		protected LinkButton NewActivitySolution;

		protected HtmlTable PartnerCard;
		protected TextBox TextboxPartnerOppID;
		protected TextBox TextboxPartnerID;
		protected TextBox TextboxPartner;
		protected TextBox Opportunity_NotePartner;
		protected LinkButton PartnerSubmit;
		protected Repeater RepeaterPartner;
		protected Label RepeaterInfo;
		protected DropDownList Opportunity_Currency;
		protected Label LabelCurrency;

		protected LinkButton Opportunity_NewLead;

		protected Repeater RepeaterEstProduct;

		protected RepeaterPaging RepeaterCompanyPaging;
		protected RepeaterPaging RepeaterLeadPaging;
		protected RepeaterPaging RepeaterOpportunityPaging;

		protected LinkButton FindCompanyButton;
		protected LinkButton FindLeadButton;

		protected LinkButton NewDoc;
		protected Label FileRepInfo;
		protected Repeater FileRep;

		protected SearchLead SrcLead;
		protected SearchCompany SearchCompany;
		protected LinkButton SrcLeadBtn;
		protected LinkButton SearchCompanyBtn;
		protected HtmlTable TblSearchCompany;
		protected HtmlTable TblSrcLead;
		protected LinkButton Opportunity_SrcLead;


		protected LinkButton Opportunity_LoadLead;
		protected LinkButton RefreshRepeaterCompany;
		protected LinkButton RefreshRepeaterLead;
		protected LinkButton RefreshCloseFrame;
		protected LinkButton RefreshRepeaterProducts;
		protected RequiredDomValidator TitleValidator;
		protected TextBox Opportunity_Title;
		protected TextBox Opportunity_OwnerID;
		protected TextBox Opportunity_Owner;
		protected Label Opportunity_ExpectedRevenueSymbol;
		protected TextBox Opportunity_ExpectedRevenue;
		protected Label Opportunity_IncomeProbabilitySymbol;
		protected TextBox Opportunity_IncomeProbability;
		protected Label Opportunity_AmountClosedSymbol;
		protected TextBox Opportunity_AmountClosed;
		protected TextBox Opportunity_CreatedBy;
		protected TextBox Opportunity_LastModifiedBy;
		protected TextBox Opportunity_Description;
		protected TextBox FindCompany;
		protected TextBox FindLead;
		protected LinkButton Opportunity_ElencoLead;
		protected TextBox Competitor_CompetitorID;
		protected TextBox Competitor_CompanyName;
		protected RadioButtonList Competitor_Evaluation;
		protected TextBox Competitor_Description;
		protected TextBox Competitor_Strengths;
		protected TextBox Competitor_Weaknesses;
		protected TextBox Competitor_Note;
		protected TextBox IDCompetitor;
		protected HtmlTableCell tabControlTab6;
		protected HtmlTableCell tabControlTab5;
		protected HtmlTableCell tabControlTab9;
		protected HtmlGenericControl Opportunity_Products;
		protected LinkButton Opportunity_SearchCompany;
		protected System.Web.UI.WebControls.DomValidators.RequiredDomValidator chk_Comp_ID;
		protected LinkButton Opportunity_LoadCompany;

		public void Page_Load(object sender, EventArgs e)
		{
			Trace.Warn("PageLoad");
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				DeleteGoBack();
				RepeaterOpportunityPaging.Visible = false;
				RepeaterLeadPaging.Visible = false;
				RepeaterCompanyPaging.Visible = false;

				Back.Click += new EventHandler(BtnBack_Click);
				Back.CssClass = "Save";
				Back.Text = "&nbsp;&uarr;&nbsp;";
				if (!isGoBack)
					Back.Visible = false;

				BtnFind.Text = rm.GetString("CRMopptxt6");
				BtnNew.Text = rm.GetString("CRMopptxt8");
				Opportunity_Submit.Text = rm.GetString("CRMopptxt18");
				Opportunity_SubmitUP.Text = rm.GetString("CRMopptxt18");
				AddNewPartner.Text = rm.GetString("CRMopptxt69");
				Opportunity_Modify.Text = rm.GetString("CRMopptxt19");
				Opportunity_NewCo.Text = rm.GetString("CRMopptxt30");
				Opportunity_NewLead.Text = rm.GetString("CRMopptxt73");
				Opportunity_CompanyList.Text = rm.GetString("CRMopptxt39");
				FindCompanyButton.Text = rm.GetString("Find");
				FindLeadButton.Text = rm.GetString("Find");
				SrcLeadBtn.Text = rm.GetString("Find");
				SearchCompanyBtn.Text = rm.GetString("Find");
				Opportunity_SearchCompany.Text = rm.GetString("CRMcontxt52");
				Opportunity_SrcLead.Text = rm.GetString("CRMcontxt52");
				Opportunity_LoadLead.Text = rm.GetString("CRMopptxt84");
				Opportunity_LoadCompany.Text = rm.GetString("CRMopptxt85");


				AddNewCompetitor.Text = rm.GetString("CRMopptxt49");
				SaveCompetitor.Text = rm.GetString("CRMopptxt18");
				CloseCompetitor.Text = rm.GetString("CRMopptxt39");



				if (!Page.IsPostBack)
				{
					TblSrcLead.Visible = false;
					TblSearchCompany.Visible = false;

					AcCrono.ParentID = 0;
					AcCrono.OpportunityID = 0;
					AcCrono.AcType = 0;
					FrameForm.Attributes.Add("style", "display:none;");

					NewActivityPhone.Text = rm.GetString("Wortxt6");
					NewActivityLetter.Text = rm.GetString("Wortxt7");
					NewActivityFax.Text = rm.GetString("Wortxt8");
					NewActivityMemo.Text = rm.GetString("Wortxt9");
					NewActivityEmail.Text = rm.GetString("Wortxt10");
					NewActivityVisit.Text = rm.GetString("Wortxt11");
					NewActivityGeneric.Text = rm.GetString("Wortxt12");
					NewActivitySolution.Text = rm.GetString("Wortxt13");

					NewDoc.Text = rm.GetString("CRMrubtxt4");

					OpportunityCard.Visible = false;
					CompetitorCard.Visible = false;
					Opportunity_Access.Visible = false;
					Opportunity_SubmitUP.Visible = false;
					tabControl.Visible = false;


					Opportunity_Currency.DataTextField = "Currency";
					Opportunity_Currency.DataValueField = "idcur";
					Opportunity_Currency.DataSource = DatabaseConnection.CreateDataset("select top 1 cast(id as varchar(10))+'|'+cast(changetoeuro as varchar(10))+'|'+currencysymbol as idcur,Currency from CurrencyTable").Tables[0];
					Opportunity_Currency.DataBind();

					PartnerCard.Visible = false;
					PartnerSubmit.Text = rm.GetString("CRMopptxt70");

					if (Request.Params["o"] != null)
					{
						ViewOpportunity(int.Parse(Request.Params["o"]));
						if (Request.Params["tab"] != null)
						{
							switch (Request.Params["tab"])
							{
								case "0":
									SomeJS.Text = "<script>ViewHideTabs(\"VisAziende\");</script>";
									break;
								case "1":
									SomeJS.Text = "<script>ViewHideTabs(\"VisLead\");</script>";
									break;
							}
						}
					}
					else
						FillRepeaterOpportunity();

					SmallReport.Text = "Stats";

					if (Request.Params["gb"] != null && isGoBack)
					{
						Stack ba = new Stack();
						ba = (Stack) Session["goback1"];
						GoBack gb = new GoBack();
						gb = (GoBack) ba.Pop(); //[ba.Count - 1];
						string[] par = gb.parameter.Split('|');

						if (par[1].Length > 0)
						{
							if (par[1] != "nn")
								ViewOpportunity(int.Parse(par[1]));
						}
						if (par[2].Length > 0)
						{
							switch (par[2])
							{
								case "a":
									SomeJS.Text = "<script>ViewHideTabs(\"visActivity\");</script>";
									break;
								case "d":
									SomeJS.Text = "<script>ViewHideTabs(\"VisDocuments\");</script>";
									break;
								case "fa":
									break;
							}
							activeTab.Value = String.Empty;
						}
						Session["goback1"] = ba;

					}


				}
				else
				{
					if (Request["__EVENTTARGET"] == "Office:Offices" || Request["__EVENTTARGET"] == "OfficeBasic:Offices")
						Page.RegisterStartupScript("HideTabs", "<script>ViewHideTabs(\"VisOpportunity\",1)</script>");

					if (activeTab.Value.Length > 0)
					{
						SomeJS.Text = "<script>ViewHideTabs(\"" + activeTab.Value + "\",0);</script>";
						activeTab.Value = String.Empty;
					}
				}
			}
		}

		public void NewActivity_Click(Object sender, EventArgs e)
		{
			SetGoBack("/CRM/CRM_Opportunity.aspx?m=25&si=37&gb=1", new string[2] {Opportunity_ID.Text, "a"});
			Session["AcOpportunityID"] = Opportunity_ID.Text;
			switch (((LinkButton) sender).ID)
			{
				case "NewActivityPhone":
					Session["AType"] = 1;
					break;
				case "NewActivityLetter":
					Session["AType"] = 2;
					break;
				case "NewActivityFax":
					Session["AType"] = 3;
					break;
				case "NewActivityMemo":
					Session["AType"] = 4;
					break;
				case "NewActivityEmail":
					Session["AType"] = 5;
					break;
				case "NewActivityVisit":
					Session["AType"] = 6;
					break;
				case "NewActivityGeneric":
					Session["AType"] = 7;
					break;
				case "NewActivitySolution":
					Session["AType"] = 8;
					break;
			}
			Response.Redirect("/WorkingCRM/AllActivity.aspx?m=25&si=38");
		}

		public void Btn_Click(Object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "BtnFind":
					FillRepeaterOpportunity();
					SomeJS.Text = String.Empty;
					CompetitorCard.Visible = false;
					break;
				case "BtnNew":
					Opportunity_ID.Text = "-1";
					Session.Remove("newprod");
					EnableModify(true);
					OpportunityCard.Visible = true;
					RepeaterOpportunity.Visible = false;
					tabControl.Visible = true;
					Tab1Text.Text = "<span class=\"normal Mul\">&nbsp;" + rm.GetString("CRMopptxt56") + "&nbsp;</span>";
					SomeJS.Text = "<script>ViewHideTabs(\"VisOpportunity\",1);</script>";
					break;
				case "Opportunity_Submit":
				case "Opportunity_SubmitUP":
					ModifyOpportunity(int.Parse(Opportunity_ID.Text));
					break;
				case "Opportunity_Modify":
					EnableModify(false);
					break;
				case "Opportunity_NewCo":
					string opId = Opportunity_ID.Text;
					string coId = "-1";
					string coCrossId = String.Empty;
					string coName = String.Empty;
					FrameForm.Attributes.Add("src", "/crm/CRM_OppCompany.aspx?render=no&OpID=" + opId + "&CoID=" + coId + "&CoCrossID=" + coCrossId + "&CoName=" + coName);
					FrameForm.Attributes.Add("style", "display:inline;");
					Page.RegisterStartupScript("onload", "<script>tabControl.style.display=\"none\"</script>");
					break;
				case "Opportunity_NewLead":
					string LOpID = Opportunity_ID.Text;
					string LCoID = "-1";
					string LCoCrossID = String.Empty;
					string LCoName = String.Empty;
					FrameForm.Attributes.Add("src", "/crm/CRM_OppLead.aspx?render=no&OpID=" + LOpID + "&CoID=" + LCoID + "&CoCrossID=" + LCoCrossID + "&CoName=" + LCoName);
					FrameForm.Attributes.Add("style", "display:inline;");
					Page.RegisterStartupScript("onload", "<script>tabControl.style.display=\"none\"</script>");
					break;
				case "CompanyNewSubmit":
					break;
				case "HideNewCompany":
					break;
				case "SaveNewReferrer":
					break;
				case "AddNewCompetitor":
					EnableModifyCompetitor(true, true);
					CompetitorCard.Visible = true;
					break;
				case "SaveCompetitor":
					SaveCompetitorFunction();
					CompetitorCard.Visible = false;
					break;
				case "CloseCompetitor":
					RepeaterCompetitor.Visible = true;
					CompetitorCard.Visible = false;
					break;
				case "SubmitCompetitorCrossContact":
					break;
				case "Opportunity_CompanyList":
					Opportunity_NewCo.Visible = true;
					Opportunity_CompanyList.Visible = false;
					RepeaterCompany.Visible = true;
					break;
				case "NewActivityOp":
					Response.Redirect("CRM_Activity.aspx?m=25&si=38&action=new&o=" + Opportunity_ID.Text);
					break;
				case "AddNewPartner":
					TextboxPartnerOppID.Text = "-1";
					TextboxPartnerID.Text = String.Empty;
					TextboxPartner.Text = String.Empty;
					Opportunity_NotePartner.Text = String.Empty;
					PartnerCard.Visible = true;
					break;
				case "PartnerSubmit":
					InsertPartner();
					FillRepeaterPartner();
					PartnerCard.Visible = false;
					break;
				case "FindCompanyButton":
					RepeaterCompanyPaging.PageSize = UC.PagingSize;
					RepeaterCompanyPaging.RepeaterObj = RepeaterCompany;
					string raq = RepeaterCompanyQuery(int.Parse(Opportunity_ID.Text), 0, ((TextBox) Page.FindControl("FindCompany")).Text);
					InitSheetPaging(raq, true);
					RepeaterCompanyPaging.sqlRepeater = raq;
					RepeaterCompanyPaging.BuildGrid();
					if (RepeaterCompany.Items.Count > 0)
					{
						RepeaterCompany.Visible = true;
						RepeaterCompanyInfo.Visible = false;
					}
					else
					{
						RepeaterCompany.Visible = false;
						RepeaterCompanyInfo.Text = rm.GetString("CRMopptxt64");
						RepeaterCompanyInfo.Visible = true;
					}
					FrameForm.Attributes.Add("src", "");
					FrameForm.Attributes.Add("style", "display:none;");
					break;
				case "FindLeadButton":
					RepeaterLeadPaging.PageSize = UC.PagingSize;
					RepeaterLeadPaging.RepeaterObj = RepeaterLead;
					raq = RepeaterCompanyQuery(int.Parse(Opportunity_ID.Text), 1, ((TextBox) Page.FindControl("FindLead")).Text);
					InitSheetPaging(raq, false);
					RepeaterLeadPaging.sqlRepeater = raq;
					RepeaterLeadPaging.BuildGrid();
					if (RepeaterLead.Items.Count > 0)
					{
						RepeaterLead.Visible = true;
						RepeaterLeadInfo.Visible = false;
					}
					else
					{
						RepeaterLead.Visible = false;
						RepeaterLeadInfo.Text = rm.GetString("CRMopptxt64");
						RepeaterLeadInfo.Visible = true;
					}
					FrameForm.Attributes.Add("src", "");
					FrameForm.Attributes.Add("style", "display:none;");
					break;
				case "NewDoc":
					SetGoBack("/CRM/CRM_Opportunity.aspx?m=25&si=37&gb=1", new string[] {Opportunity_ID.Text, "d"});
					Session["OpportunityID"] = Opportunity_ID.Text;
					Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=o");
					break;
				case "Opportunity_SrcLead":
					TblSrcLead.Visible = true;
					RepeaterLead.Visible = false;
					break;
				case "Opportunity_SearchCompany":
					TblSearchCompany.Visible = true;
					RepeaterCompany.Visible = false;
					break;
			}
		}

		public void InsertPartner()
		{
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("CompanyID", TextboxPartnerID.Text);
				dg.Add("OpportunityID", Opportunity_ID.Text);
				dg.Add("Note", Opportunity_NotePartner.Text);
				dg.Execute("CRM_OpportunityPartners", "ID =" + int.Parse(TextboxPartnerOppID.Text));
			}
		}



		private void FillRepeaterOpportunity()
		{
			StringBuilder sqlString = new StringBuilder();
			StringBuilder sqlText = new StringBuilder();
			char[] BuildQuery = new char[4] {'0', '0', '0', '0'};
			if (!Page.IsPostBack)
				sqlString.Append("SELECT ID, Title, Owner ");
			else
				sqlString.Append("SELECT ID, Title, Owner ");

			sqlString.AppendFormat("FROM CRM_Opportunity_View where ((AdminAccount like '%|{0}|%' or BasicAccount like '%|{0}|%' or OwnerID={0} or Groups like '%|{1}|%')) ", UC.UserId.ToString(), UC.UserGroupId.ToString());

			if (FindTxt.Text.Length > 0)
			{
				sqlText.AppendFormat("(Title like '%{0}%' or Description like '%{0}%')", FindTxt.Text);
				BuildQuery[0] = '1';
			}

			Trace.Warn("BuildQuery", String.Concat(BuildQuery.GetValue(0), BuildQuery.GetValue(1), BuildQuery.GetValue(2), BuildQuery.GetValue(3)));

			switch (String.Concat(BuildQuery.GetValue(0), BuildQuery.GetValue(1), BuildQuery.GetValue(2), BuildQuery.GetValue(3)))
			{
				case "1000":
					sqlString.AppendFormat(" and {0}", sqlText.ToString());
					break;

			}

			if (!Page.IsPostBack)
				sqlString.Append(" order by LastModifiedDate desc");

			Trace.Warn("OppQuery>>>", sqlString.ToString());

			Trace.Warn("query opp", sqlString.ToString());


			RepeaterOpportunityPaging.PageSize = UC.PagingSize;
			RepeaterOpportunityPaging.RepeaterObj = RepeaterOpportunity;
			RepeaterOpportunityPaging.sqlRepeater = sqlString.ToString();
			RepeaterOpportunityPaging.BuildGrid();


			if (RepeaterOpportunity.Items.Count > 0)
			{
				RepeaterOpportunity.Visible = true;
				RepeaterOpportunityPaging.Visible = true;
				RepeaterOpportunityInfo.Visible = false;

			}
			else
			{
				RepeaterOpportunityInfo.Text = "<center>" + rm.GetString("CRMopptxt66") + "</center>";
				RepeaterOpportunity.Visible = false;
				RepeaterOpportunityInfo.Visible = true;

			}

			OpportunityCard.Visible = false;
			tabControl.Visible = false;

		}

		private void ModifyOpportunity(int id)
		{
			TextBox txtfield;
			using (DigiDapter dg = new DigiDapter("select * from CRM_Opportunity where id=" + id))
			{
				if (!dg.HasRows)
				{
				}
				for (int i = 0; i < dg.ExternalReader.ItemArray.Length; i++)
				{
					string columnName = dg.ExternalReader.Table.Columns[i].ColumnName.ToString();
					Trace.Warn("before", "Opportunity_" + columnName.ToUpper());

					Debug.Write("dg.Add(\""+columnName+"\",CRM_Leads_" + columnName + ".Text);\r\n");

					switch (columnName)
					{
						case "ID":
							break;
						case "OwnerID":
							txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_" + columnName);
							if (txtfield.Text.Length > 0)
							{
								dg.Add(columnName, txtfield.Text);
							}
							else
							{
								dg.Add(columnName, UC.UserId);
							}
							break;
						case "CreatedByID":
							if (id == -1) dg.Add(columnName, UC.UserId);
							break;
						case "LastModifiedByID":
							dg.Add(columnName, UC.UserId);
							break;
						case "LastModifiedDate":
							dg.Add(columnName, UC.LTZ.ToUniversalTime(DateTime.Now));
							break;
						case "CreatedDate":
							if (id == -1) dg.Add(columnName, UC.LTZ.ToUniversalTime(DateTime.Now));
							break;
						case "AdminAccount":
							if (Office.GetValue.Length > 0)
							{
								dg.Add(columnName, Office.GetValue);
							}
							else
							{
								dg.Add(columnName, "|" + UC.UserId.ToString() + "|");
							}
							break;
						case "BasicAccount":
							if (OfficeBasic.GetValue.Length > 0)
							{
								dg.Add(columnName, OfficeBasic.GetValue);
							}
							else
							{
								dg.Add(columnName, "|" + UC.UserId.ToString() + "|");
							}
							break;
						case "Groups":
							string groupQuery = String.Empty;
							string[] GroupID = Office.GetValue.Split('|');
							foreach (string gr in GroupID)
							{
								if (gr.Length > 0) groupQuery += "uid=" + gr + " or ";
							}
							foreach (string grb in GroupID)
							{
								if (grb.Length > 0) groupQuery += "uid=" + grb + " or ";
							}

							txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_OwnerID");
							if (txtfield.Text.Length > 0)
							{
								groupQuery += "uid=" + int.Parse(txtfield.Text);
							}
							else
							{
								groupQuery += "uid=" + UC.UserId;
							}

							DataSet Group1 = DatabaseConnection.CreateDataset("select distinct groupid from account where " + groupQuery + " group by groupid");
							string arrList = String.Empty;
							foreach (DataRow dr in Group1.Tables[0].Rows)
							{
								DataSet Group2 = DatabaseConnection.CreateDataset("select dependency from groups where id=" + dr[0]);
								if (Group2.Tables[0].Rows.Count > 0)
								{
									arrList += (Convert.ToInt64(dr[0]) == UC.AdminGroupId) ? "|" + UC.AdminGroupId.ToString() + "|" : Group2.Tables[0].Rows[0][0];
								}
							}

							if (arrList.Length > 0)
								dg.Add(columnName, CleanGroups(arrList));
							else
								dg.Add(columnName, CleanGroups("|" + UC.AdminGroupId.ToString() + "|" + UC.UserGroupId.ToString() + "|"));
							break;
						case "Currency":
							dg.Add(columnName, Opportunity_Currency.SelectedValue.Split('|')[0]);
							break;
						case "CurrencyChange":
							dg.Add(columnName, Opportunity_Currency.SelectedValue.Split('|')[1]);
							break;
						case "ExpectedRevenue":
						case "IncomeProbability":
						case "AmountClosed":
							break;
						default:
							if (OpportunityCard.FindControl("Opportunity_" + columnName) != null)
							{
								txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_" + columnName);
								if (txtfield.Text.Length > 0) dg.Add(columnName, txtfield.Text);
							}
							break;
					}
				}

				object newId = dg.Execute("CRM_Opportunity", "ID=" + id, DigiDapter.Identities.Identity);


				if (id == -1)
				{
					ViewOpportunity(Convert.ToInt32(newId));
				}
				else
				{
					ViewOpportunity(id);
				}
			}
		}

		private void ViewOpportunity(int id)
		{
			RefreshOpportunityAmount(id);

			string sqlString = "select * from CRM_Opportunity_View where id=" + id;
			TextBox txtfield = new TextBox();
			DataSet myDataSet = DatabaseConnection.CreateDataset(sqlString);
			foreach (DataColumn cc in myDataSet.Tables[0].Columns)
			{
				if (OpportunityCard.FindControl("Opportunity_" + cc.ColumnName) != null)
				{
					try
					{
						txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_" + cc.ColumnName);
					}
					catch
					{
					}
					switch (cc.ColumnName)
					{
						case "CreatedBy":
							txtfield.Text = myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString() + " - " +
								UC.LTZ.ToLocalTime(Convert.ToDateTime(myDataSet.Tables[0].Rows[0]["CreatedDate"])).ToString();
							break;
						case "LastModifiedBy":
							txtfield.Text = myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString() + " - " +
								UC.LTZ.ToLocalTime(Convert.ToDateTime(myDataSet.Tables[0].Rows[0]["LastModifiedDate"])).ToString();
							break;

						case "AdminAccount":
							Trace.Warn(cc.ColumnName, myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString());
							if (myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString().Length > 1)
							{
								Office.SetAccount(myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString());
							}
							break;
						case "ExpectedRevenue":
						case "IncomeProbability":
						case "AmountClosed":
							Label symbol = (Label) OpportunityCard.FindControl("Opportunity_" + cc.ColumnName + "Symbol");
							symbol.Text = DatabaseConnection.SqlScalar("select currencysymbol from currencytable where id=" + myDataSet.Tables[0].Rows[0]["currency"].ToString());
							decimal change = Convert.ToDecimal(DatabaseConnection.SqlScalar("select changetoeuro from currencytable where id=" + myDataSet.Tables[0].Rows[0]["currency"].ToString()));
							txtfield.Text = (Math.Round(Convert.ToDecimal(myDataSet.Tables[0].Rows[0][cc.ColumnName])*change, 2)).ToString();
							break;
						case "Currency":
							Opportunity_Currency.SelectedIndex = -1;
							foreach (ListItem li in Opportunity_Currency.Items)
							{
								if (myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString() == li.Value.Split('|')[0])
								{
									li.Selected = true;
									LabelCurrency.Text = li.Text;
									break;
								}
							}
							if (LabelCurrency.Text.Length <= 0) LabelCurrency.Text = Opportunity_Currency.Items[0].Text;
							Opportunity_Currency.Visible = false;
							LabelCurrency.Visible = true;
							break;
						case "CurrencyChange":
							break;
						default:
							txtfield.Text = myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString();
							if (cc.ColumnName == "Title")
								Tab1Text.Text = "<span class=\"normal Mul\" onclick=\"ViewHideTabs('VisOpportunity',0);\">&nbsp;" + myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString() + "&nbsp;</span>";
							break;
					}
					txtfield.ReadOnly = true;
					txtfield.CssClass = "OpportunityView";
				}
				else
				{
					switch (cc.ColumnName)
					{
						case "AdminAccount":
							Trace.Warn(cc.ColumnName, myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString());
							if (myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString().Length > 1)
							{
								Office.SetAccount(myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString());
							}
							break;
						case "BasicAccount":
							Trace.Warn(cc.ColumnName, myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString());
							if (myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString().Length > 1)
							{
								OfficeBasic.SetAccount(myDataSet.Tables[0].Rows[0][cc.ColumnName].ToString());
							}
							break;
					}
				}
			}

			OpportunityCard.Visible = true;
			tabControl.Visible = true;

			RepeaterOpportunity.Visible = false;
			Opportunity_Submit.Visible = false;
			Opportunity_SubmitUP.Visible = false;
			PopAccount.Visible = false;
			Opportunity_Access.Visible = false;

			if (myDataSet.Tables[0].Rows[0]["AdminAccount"].ToString().IndexOf("|" + UC.UserId.ToString() + "|") >= 0
				|| myDataSet.Tables[0].Rows[0]["OwnerID"].ToString() == UC.UserId.ToString()
				|| myDataSet.Tables[0].Rows[0]["Groups"].ToString().IndexOf("|" + UC.UserGroupId.ToString() + "|") >= 0)
			{
				Opportunity_Modify.Visible = true;
			}
			else
			{
				Opportunity_Modify.Visible = false;
			}

			RepeaterCompanyPaging.PageSize = UC.PagingSize;
			RepeaterCompanyPaging.RepeaterObj = RepeaterCompany;
			string raq = RepeaterCompanyQuery(id, 0);
			InitSheetPaging(raq, true);
			RepeaterCompanyPaging.sqlRepeater = raq;
			RepeaterCompanyPaging.BuildGrid();


			if (RepeaterCompany.Items.Count > 0)
			{
				RepeaterCompany.Visible = true;
				RepeaterCompanyInfo.Visible = false;
			}
			else
			{
				RepeaterCompany.Visible = false;
				RepeaterCompanyInfo.Text = rm.GetString("CRMopptxt64");
				RepeaterCompanyInfo.Visible = true;
			}

			RepeaterLeadPaging.PageSize = UC.PagingSize;
			RepeaterLeadPaging.RepeaterObj = RepeaterLead;
			raq = RepeaterCompanyQuery(id, 1);
			InitSheetPaging(raq, false);
			RepeaterLeadPaging.sqlRepeater = raq;
			RepeaterLeadPaging.BuildGrid();
			if (RepeaterLead.Items.Count > 0)
			{
				RepeaterLead.Visible = true;
				RepeaterLeadInfo.Visible = false;
			}
			else
			{
				RepeaterLead.Visible = false;
				RepeaterLeadInfo.Text = rm.GetString("CRMopptxt64");
				RepeaterLeadInfo.Visible = true;
			}


			AcCrono.OpportunityID = id;

			AcCrono.FromSheet = "o";
			AcCrono.ViewCompany = true;
			AcCrono.Refresh();

			if (AcCrono.ItemCount == 0)
			{
				AcCrono.Visible = false;
				RepeaterActivityInfo.Visible = true;
				RepeaterActivityInfo.Text = rm.GetString("CRMopptxt59");
			}
			else
			{
				AcCrono.Visible = true;
				RepeaterActivityInfo.Visible = false;
			}

			FillRepeaterCompetitor();
			FillRepeaterPartner();

			Session.Remove("newprod");
			FillRepeaterProducts(id);
			Session["review"] = "0";
			FillFileRep(id);

			SrcLead.OpportunityID = Convert.ToInt64(id);
			SrcLead.FromOpportunity = true;
			SrcLead.FillAdvancedLead();
			Opportunity_LoadLead.Visible=true;
			Opportunity_LoadCompany.Visible=true;

		}

		private void InitSheetPaging(string sqlString, bool x)
		{
			DataTable dt = DatabaseConnection.CreateDataset(sqlString).Tables[0];
			string[] myarray = new string[dt.Rows.Count];
			if (dt.Rows.Count > 0)
			{
				for (int i = 0; i < dt.Rows.Count; i++)
				{
					myarray[i] = dt.Rows[i]["ContactID"] + "|" + dt.Rows[i]["CompanyName"] + "|" + dt.Rows[i]["ID"];
				}
			}

			if (x)
				Session["SheetCompany"] = myarray;
			else
				Session["SheetLead"] = myarray;

		}

		private void FillRepeaterProducts(int id)
		{
			DataTable dt = DatabaseConnection.CreateDataset("select * from CRM_OppProductRows where OpportunityID=" + id + " order by catalogid").Tables[0];

			ArrayList np = new ArrayList();
			long catid = 0;
			foreach (DataRow ddr in dt.Rows)
			{
				DataRow pInfo = DatabaseConnection.CreateDataset("select * from CatalogProducts where id=" + ddr["CatalogID"].ToString()).Tables[0].Rows[0];
				PurchaseProduct newprod = new PurchaseProduct();
				if (catid != (long) ddr["CatalogID"])
				{
					newprod.id = Convert.ToInt64(ddr["CatalogID"]);
					newprod.ShortDescription = pInfo["ShortDescription"].ToString();
					newprod.LongDescription = pInfo["LongDescription"].ToString();
					newprod.UM = pInfo["Unit"].ToString();
					newprod.Qta = (int) ddr["Qta"];
					newprod.UnitPrice = (decimal) ddr["Uprice"];
					newprod.Vat = (pInfo["Vat"] != DBNull.Value) ? Convert.ToDecimal(pInfo["Vat"]) : 0;
					newprod.ListPrice = Math.Round(Convert.ToDecimal(newprod.Qta)*newprod.UnitPrice, 2);
					newprod.FinalPrice = (decimal) ddr["NewUPrice"];
					if ((byte) ddr["Type"] == 0)
					{
						newprod.Contacts = 1;
						newprod.Leads = 0;
					}
					else
					{
						newprod.Leads = 1;
						newprod.Contacts = 0;
					}

					np.Add(newprod);
					catid = (long) ddr["CatalogID"];
				}
				else
				{
					newprod = (PurchaseProduct) np[np.Count - 1];
					newprod.Qta += (int) ddr["Qta"];
					newprod.ListPrice += Math.Round(Convert.ToDecimal(newprod.Qta)*newprod.UnitPrice, 2);

					if ((byte) ddr["Type"] == 0)
						newprod.Contacts += 1;
					else
						newprod.Leads += 1;

					np[np.Count - 1] = newprod;
				}

			}

			Session.Remove("newprod");
			Session["newprod"] = np;

			RepeaterEstProduct.DataSource = np;
			RepeaterEstProduct.DataBind();
			RepeaterEstProduct.Visible = true;
		}

		private void SaveProductOpportunity(int id)
		{
			DatabaseConnection.DoCommand("DELETE FROM CRM_OppProductRows where OpportunityID=" + id);

			ArrayList pp = (ArrayList) Session["newprod"];
			decimal expectedRevenue = 0;
			foreach (PurchaseProduct Pprod in pp)
			{
				using (DigiDapter dg = new DigiDapter())
				{
					dg.Add("OpportunityID", id);
					dg.Add("Description", Pprod.LongDescription);
					dg.Add("UPrice", Pprod.UnitPrice);
					dg.Add("NewUPrice", Pprod.FinalPrice);
					dg.Add("CatalogID", Pprod.id);
					dg.Add("Qta", Pprod.Qta);
					dg.Execute("CRM_OppProductRows");
				}
				expectedRevenue += Pprod.FinalPrice;
			}


			Session.Remove("newprod");

			string sqlString = "select * from CRM_OpportunityContact where opportunityid=" + id;

			DataSet dsContact = new DataSet();
			dsContact = DatabaseConnection.CreateDataset(sqlString);

			foreach (DataRow row in dsContact.Tables[0].Rows)
			{
				using(DigiDapter dg = new DigiDapter())
				{
					dg.Add("ExpectedRevenue", expectedRevenue);

					string percId = DatabaseConnection.SqlScalar("select TableTypeID from CRM_CrossOpportunity where ContactID = " + row["contactid"].ToString() + " and OpportunityID = " + id + " and ContactType=" + row["ContactType"].ToString() + " and Type= 3;");
				if (percId.Length > 0)
				{
					decimal percentage = Convert.ToDecimal(DatabaseConnection.SqlScalar("select percentage from CRM_OpportunityTableType where id=" + percId));
					dg.Add("IncomeProbability", (expectedRevenue*percentage/100));
				}
				else
				{
					dg.Add("IncomeProbability", 0);
				}
			dg.Execute("","id="+row["id"]);
				}

			}

		}

		private void FillRepeaterPartner()
		{
			string sqlQuery = "SELECT CRM_OpportunityPartners.*, Base_Companies.CompanyName AS CompanyName " +
				"FROM CRM_OpportunityPartners LEFT OUTER JOIN " +
				"Base_Companies ON CRM_OpportunityPartners.CompanyID = Base_Companies.ID " +
				"where CRM_OpportunityPartners.OpportunityID=" + int.Parse(Opportunity_ID.Text);
			RepeaterPartner.DataSource = DatabaseConnection.CreateDataset(sqlQuery).Tables[0];
			RepeaterPartner.DataBind();
			if (RepeaterPartner.Items.Count > 0)
			{
				RepeaterPartner.Visible = true;
				RepeaterInfo.Visible = false;
			}
			else
			{
				RepeaterPartner.Visible = false;
				RepeaterInfo.Text = rm.GetString("CRMopptxt71");
				RepeaterInfo.Visible = true;
			}

		}

		public void RepeaterPartner_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "PartnerCommand":
					DataRow dr = DatabaseConnection.CreateDataset("select * from CRM_OpportunityPartners where id=" + int.Parse(((Literal) e.Item.FindControl("PartnerID")).Text)).Tables[0].Rows[0];
					TextboxPartnerOppID.Text = dr["ID"].ToString();
					TextboxPartnerID.Text = dr["CompanyID"].ToString();
					TextboxPartner.Text = ((LinkButton) e.Item.FindControl("PartnerCommand")).Text;
					Opportunity_NotePartner.Text = dr["Note"].ToString();
					RepeaterPartner.Visible = false;
					PartnerCard.Visible = true;
					break;
			}
		}

		public void RepeaterPartnerDatabound(object source, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton PartnerCommand = (LinkButton) e.Item.FindControl("PartnerCommand");
					PartnerCommand.Text = Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName"));
					break;
			}
		}

		private void RefreshOpportunityAmount(int id)
		{
			decimal expectedRevenue = 0;
			decimal amountClosed = 0;
			decimal IncomeProbability = 0;
			try
			{
				expectedRevenue = Convert.ToDecimal(DatabaseConnection.SqlScalar("select sum(expectedRevenue) from CRM_OpportunityContact where OpportunityID=" + id));
			}
			catch
			{
				expectedRevenue = 0;
			}
			try
			{
				amountClosed = Convert.ToDecimal(DatabaseConnection.SqlScalar("select sum(amountClosed) from CRM_OpportunityContact where OpportunityID=" + id));
			}
			catch
			{
				amountClosed = 0;
			}
			try
			{
				IncomeProbability = Convert.ToDecimal(DatabaseConnection.SqlScalar("select sum(IncomeProbability) from CRM_OpportunityContact where OpportunityID=" + id));
			}
			catch
			{
				IncomeProbability = 0;
			}

			DatabaseConnection.DoCommand("update CRM_Opportunity set expectedRevenue='" + expectedRevenue.ToString().Replace(",", ".") + "',amountClosed='" + amountClosed.ToString().Replace(",", ".") + "',IncomeProbability='" + IncomeProbability.ToString().Replace(",", ".") + "' where id=" + id);

			Trace.Warn("querycambio", "select changetoeuro from currencytable where id=" + DatabaseConnection.SqlScalar("select currency from CRM_Opportunity where ID=" + id));
			decimal change = Convert.ToDecimal(DatabaseConnection.SqlScalar("select changetoeuro from currencytable where id=(select top 1 currency from CRM_Opportunity where ID=" + id + ")"));

			((TextBox) OpportunityCard.FindControl("Opportunity_ExpectedRevenue")).Text = (Math.Round(expectedRevenue*change, 2)).ToString();
			((TextBox) OpportunityCard.FindControl("Opportunity_IncomeProbability")).Text = (Math.Round(IncomeProbability*change, 2)).ToString();
			((TextBox) OpportunityCard.FindControl("Opportunity_AmountClosed")).Text = (Math.Round(amountClosed*change, 2)).ToString();
		}

		public void RepeaterOpportunity_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "OpenOP":
					ViewOpportunity(int.Parse(((Literal) e.Item.FindControl("IDOp")).Text));

					break;
				case "DelOP":
					Delete(int.Parse(((Literal) e.Item.FindControl("IDOp")).Text));
					break;
			}
		}

		public void RepeaterOpportunity_Databound(object source, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton DelOP = (LinkButton) e.Item.FindControl("DelOP");
					DelOP.Attributes.Add("onclick", "return confirm('" + rm.GetString("CRMopptxt40") + "');");
					DelOP.Text = rm.GetString("CRMopptxt25");
					break;
				case ListItemType.Footer:
					Literal RepCounter = (Literal) e.Item.FindControl("RepCounter");
					RepCounter.Text = RepeaterOpportunity.Items.Count.ToString();
					if(this.RepeaterOpportunity.Items.Count>=100)
						RepCounter.Text+=" ("+string.Format(rm.GetString("top100"),DatabaseConnection.MaxResult)+")";
					break;
			}
		}

		private void Delete(int id)
		{
			DatabaseConnection.DoCommand("delete from CRM_Opportunity where ID =" + id);
			FillRepeaterOpportunity();
		}

		private void EnableModify(bool newOp)
		{
			TextBox txtfield;

			txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_Title");
			txtfield.ReadOnly = false;
			if (newOp) txtfield.Text = String.Empty;
			txtfield.CssClass = "BoxDesign";
			txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_Owner");
			txtfield.ReadOnly = false;
			if (newOp) txtfield.Text = String.Empty;
			txtfield.CssClass = "BoxDesign";
			Opportunity_Currency.Visible = true;
			LabelCurrency.Visible = false;

			txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_Description");
			txtfield.ReadOnly = false;
			if (newOp) txtfield.Text = String.Empty;
			txtfield.CssClass = "BoxDesign";


			PopAccount.Visible = true;
			if (newOp) txtfield.Text = String.Empty;
			Opportunity_Submit.Visible = true;
			Opportunity_SubmitUP.Visible = true;
			Opportunity_Modify.Visible = false;
			Opportunity_Access.Visible = true;
			Opportunity_LoadLead.Visible=false;
			Opportunity_LoadCompany.Visible=false;
			if (newOp)
			{
				txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_CreatedBy");
				txtfield.Text = String.Empty;
				txtfield = (TextBox) OpportunityCard.FindControl("Opportunity_LastModifiedBy");
				txtfield.Text = String.Empty;
			}
			FillRepeaterProducts(int.Parse(Opportunity_ID.Text));
			AddKeepAlive();
		}

		private string RepeaterCompanyQuery(int id, int contactId)
		{
			return RepeaterCompanyQuery(id, contactId, "");
		}

		private string RepeaterCompanyQuery(int id, int contactId, string find)
		{
			StringBuilder SqlCompanies = new StringBuilder();

			if (contactId == 0)
			{
				SqlCompanies.Append("SELECT CRM_OpportunityContact.ID, CRM_OpportunityContact.OpportunityID, CRM_OpportunityContact.ContactID, CRM_OpportunityContact.IncomeProbability, Account.Surname+' '+Account.Name as SalesPersonName, CRM_OpportunityContact.EstimatedCloseDate, CRM_OpportunityContact.EndDate, Base_Companies.CompanyName,");
				SqlCompanies.Append("(SELECT CRM_OpportunityTableType.Description ");
				SqlCompanies.Append("FROM CRM_CrossOpportunity INNER JOIN ");
				SqlCompanies.Append("CRM_OpportunityTableType ON CRM_CrossOpportunity.TableTypeID = CRM_OpportunityTableType.K_ID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityTableType.Type = 1 AND lang='{2}' AND CRM_CrossOpportunity.ContactType={1} AND CRM_CrossOpportunity.OpportunityID = {0} and CRM_CrossOpportunity.ContactID = CRM_OpportunityContact.ContactID) AS StateDescr,", id, contactId, UC.Culture.Substring(0, 2));
				SqlCompanies.Append("(SELECT CRM_OpportunityTableType.Description ");
				SqlCompanies.Append("FROM CRM_CrossOpportunity INNER JOIN ");
				SqlCompanies.Append("CRM_OpportunityTableType ON CRM_CrossOpportunity.TableTypeID = CRM_OpportunityTableType.K_ID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityTableType.Type = 2 AND lang='{2}' AND CRM_CrossOpportunity.ContactType={1} AND CRM_CrossOpportunity.OpportunityID = {0} and CRM_CrossOpportunity.ContactID = CRM_OpportunityContact.ContactID) AS PhaseDescr ", id, contactId, UC.Culture.Substring(0, 2));
				SqlCompanies.Append("FROM CRM_OpportunityContact ");
				SqlCompanies.Append("INNER JOIN Base_Companies ON CRM_OpportunityContact.ContactID = Base_Companies.ID ");
				SqlCompanies.Append("INNER JOIN Account ON CRM_OpportunityContact.SalesPerson = Account.UID ");
				if (find.Length > 0)
					SqlCompanies.AppendFormat("WHERE Base_Companies.CompanyName like '%{2}%' and CRM_OpportunityContact.OpportunityID={0} AND CRM_OpportunityContact.ContactType={1} order by CRM_OpportunityContact.id desc", id, contactId, DatabaseConnection.FilterInjection(find));
				else
					SqlCompanies.AppendFormat("WHERE CRM_OpportunityContact.OpportunityID={0} AND CRM_OpportunityContact.ContactType={1} order by CRM_OpportunityContact.id desc", id, contactId);


			}
			else
			{
				SqlCompanies.Append("SELECT CRM_OpportunityContact.ID, CRM_OpportunityContact.OpportunityID, CRM_OpportunityContact.ContactID, CRM_OpportunityContact.IncomeProbability, Account.Surname+' '+Account.Name as SalesPersonName, CRM_OpportunityContact.EstimatedCloseDate, CRM_OpportunityContact.EndDate, (isnull(CRM_Leads.CompanyName,'')+' '+isnull(CRM_Leads.Surname,'')+' '+isnull(CRM_Leads.Name,'')) as CompanyName,");
				SqlCompanies.Append("(SELECT CRM_OpportunityTableType.Description ");
				SqlCompanies.Append("FROM CRM_CrossOpportunity INNER JOIN ");
				SqlCompanies.Append("CRM_OpportunityTableType ON CRM_CrossOpportunity.TableTypeID = CRM_OpportunityTableType.K_ID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityTableType.Type = 1 AND lang='{2}' AND CRM_CrossOpportunity.ContactType={1} AND CRM_CrossOpportunity.OpportunityID = {0} and CRM_CrossOpportunity.ContactID = CRM_OpportunityContact.ContactID) AS StateDescr,", id, contactId, UC.Culture.Substring(0, 2));
				SqlCompanies.Append("(SELECT CRM_OpportunityTableType.Description ");
				SqlCompanies.Append("FROM CRM_CrossOpportunity INNER JOIN ");
				SqlCompanies.Append("CRM_OpportunityTableType ON CRM_CrossOpportunity.TableTypeID = CRM_OpportunityTableType.K_ID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityTableType.Type = 2 AND lang='{2}' AND CRM_CrossOpportunity.ContactType={1} AND CRM_CrossOpportunity.OpportunityID = {0} and CRM_CrossOpportunity.ContactID = CRM_OpportunityContact.ContactID) AS PhaseDescr ", id, contactId, UC.Culture.Substring(0, 2));
				SqlCompanies.Append("FROM CRM_OpportunityContact ");
				SqlCompanies.Append("INNER JOIN CRM_Leads ON CRM_OpportunityContact.ContactID = CRM_Leads.ID ");
				SqlCompanies.Append("INNER JOIN Account ON CRM_OpportunityContact.SalesPerson = Account.UID ");
				if (find.Length > 0)
				{
					if (find.StartsWith("$"))
						SqlCompanies.AppendFormat("WHERE ({2}) and CRM_OpportunityContact.OpportunityID={0} AND CRM_OpportunityContact.ContactType={1} order by CRM_OpportunityContact.id desc", id, contactId, find.Substring(1, find.Length - 1));
					else
						SqlCompanies.AppendFormat("WHERE (CRM_Leads.CompanyName like '%{2}%' or CRM_Leads.Surname like '%{2}%' or CRM_Leads.Name like '%{2}%') and CRM_OpportunityContact.OpportunityID={0} AND CRM_OpportunityContact.ContactType={1} order by CRM_OpportunityContact.id desc", id, contactId, find);
				}
				else
					SqlCompanies.AppendFormat("WHERE CRM_OpportunityContact.OpportunityID={0} AND CRM_OpportunityContact.ContactType={1} order by CRM_OpportunityContact.id desc", id, contactId);


			}

			Trace.Warn("aziende", SqlCompanies.ToString());
			return SqlCompanies.ToString();
		}

		protected DataSet FillRepeaterCompany(int id, int contactid)
		{
			StringBuilder SqlCompanies = new StringBuilder();
			if (contactid == 0)
			{
				SqlCompanies.Append("SELECT CRM_OpportunityContact.ID, CRM_OpportunityContact.OpportunityID, CRM_OpportunityContact.ContactID, CRM_OpportunityContact.IncomeProbability, Account.Surname+' '+Account.Name as SalesPersonName, CRM_OpportunityContact.EstimatedCloseDate, Base_Companies.CompanyName,");
				SqlCompanies.Append("(SELECT CRM_OpportunityTableType.Description ");
				SqlCompanies.Append("FROM CRM_CrossOpportunity INNER JOIN ");
				SqlCompanies.Append("CRM_OpportunityTableType ON CRM_CrossOpportunity.TableTypeID = CRM_OpportunityTableType.K_ID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityTableType.Type = 1 AND lang='{2}' AND CRM_CrossOpportunity.ContactType={1} AND CRM_CrossOpportunity.OpportunityID = {0} and CRM_CrossOpportunity.ContactID = CRM_OpportunityContact.ContactID) AS StateDescr,", id, contactid, UC.Culture.Substring(0, 2));
				SqlCompanies.Append("(SELECT CRM_OpportunityTableType.Description ");
				SqlCompanies.Append("FROM CRM_CrossOpportunity INNER JOIN ");
				SqlCompanies.Append("CRM_OpportunityTableType ON CRM_CrossOpportunity.TableTypeID = CRM_OpportunityTableType.K_ID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityTableType.Type = 2 AND lang='{2}' AND CRM_CrossOpportunity.ContactType={1} AND CRM_CrossOpportunity.OpportunityID = {0} and CRM_CrossOpportunity.ContactID = CRM_OpportunityContact.ContactID) AS PhaseDescr ", id, contactid, UC.Culture.Substring(0, 2));
				SqlCompanies.Append("FROM CRM_OpportunityContact ");
				SqlCompanies.Append("INNER JOIN Base_Companies ON CRM_OpportunityContact.ContactID = Base_Companies.ID ");
				SqlCompanies.Append("INNER JOIN Account ON CRM_OpportunityContact.SalesPerson = Account.UID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityContact.OpportunityID={0} AND CRM_OpportunityContact.ContactType={1}", id, contactid);
			}
			else
			{
				SqlCompanies.Append("SELECT CRM_OpportunityContact.ID, CRM_OpportunityContact.OpportunityID, CRM_OpportunityContact.ContactID, CRM_OpportunityContact.IncomeProbability, Account.Surname+' '+Account.Name as SalesPersonName, CRM_OpportunityContact.EstimatedCloseDate, (isnull(CRM_Leads.CompanyName,'')+' '+isnull(CRM_Leads.Surname,'')+' '+isnull(CRM_Leads.Name,'')) as CompanyName,");
				SqlCompanies.Append("(SELECT CRM_OpportunityTableType.Description ");
				SqlCompanies.Append("FROM CRM_CrossOpportunity INNER JOIN ");
				SqlCompanies.Append("CRM_OpportunityTableType ON CRM_CrossOpportunity.TableTypeID = CRM_OpportunityTableType.K_ID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityTableType.Type = 1 AND lang='{2}' AND CRM_CrossOpportunity.ContactType={1} AND CRM_CrossOpportunity.OpportunityID = {0} and CRM_CrossOpportunity.ContactID = CRM_OpportunityContact.ContactID) AS StateDescr,", id, contactid, UC.Culture.Substring(0, 2));
				SqlCompanies.Append("(SELECT CRM_OpportunityTableType.Description ");
				SqlCompanies.Append("FROM CRM_CrossOpportunity INNER JOIN ");
				SqlCompanies.Append("CRM_OpportunityTableType ON CRM_CrossOpportunity.TableTypeID = CRM_OpportunityTableType.K_ID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityTableType.Type = 2 AND lang='{2}' AND CRM_CrossOpportunity.ContactType={1} AND CRM_CrossOpportunity.OpportunityID = {0} and CRM_CrossOpportunity.ContactID = CRM_OpportunityContact.ContactID) AS PhaseDescr ", id, contactid, UC.Culture.Substring(0, 2));
				SqlCompanies.Append("FROM CRM_OpportunityContact ");
				SqlCompanies.Append("INNER JOIN CRM_Leads ON CRM_OpportunityContact.ContactID = CRM_Leads.ID ");
				SqlCompanies.Append("INNER JOIN Account ON CRM_OpportunityContact.SalesPerson = Account.UID ");
				SqlCompanies.AppendFormat("WHERE CRM_OpportunityContact.OpportunityID={0} AND CRM_OpportunityContact.ContactType={1}", id, contactid);
			}

			return DatabaseConnection.CreateDataset(SqlCompanies.ToString());
		}


		public void RepeaterReferrerGeneralDatabound(object source, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					HtmlContainerControl ModifyReferrer = (HtmlContainerControl) e.Item.FindControl("ModifyReferrer");
					ModifyReferrer.Visible = false;
					LinkButton ModReferrer = (LinkButton) e.Item.FindControl("ModReferrer");
					ModReferrer.Text = rm.GetString("CRMopptxt19");
					LinkButton SaveReferrer = (LinkButton) e.Item.FindControl("SaveReferrer");
					SaveReferrer.Text = rm.GetString("CRMopptxt18");
					DropDownList Character = (DropDownList) e.Item.FindControl("Character");

					foreach (ListItem li in Character.Items)
					{
						if (li.Value == DataBinder.Eval((DataRowView) e.Item.DataItem, "CharacterText").ToString())
							li.Selected = true;
					}
					break;
			}
		}

		public void RepeaterReferrerGeneralCommand(object source, RepeaterCommandEventArgs e)
		{
			HtmlContainerControl ModifyReferrer;
			HtmlContainerControl ViewReferrer;
			Trace.Warn("CommandName RepeaterReferrerCommand", e.CommandName);
			switch (e.CommandName)
			{
				case "ModReferrer":
					ModifyReferrer = (HtmlContainerControl) e.Item.FindControl("ModifyReferrer");
					ViewReferrer = (HtmlContainerControl) e.Item.FindControl("ViewReferrer");
					ModifyReferrer.Visible = true;
					ViewReferrer.Visible = false;
					break;
				case "SaveReferrer":
					using (DigiDapter dg = new DigiDapter())
					{
						dg.Add("Role", ((TextBox) e.Item.FindControl("Role")).Text);
						try
						{
							dg.Add("PercDecisional", ((TextBox) e.Item.FindControl("PercDecisional")).Text);
						}
						catch
						{
							dg.Add("PercDecisional", 1);
						}
						dg.Add("CharacterText", ((DropDownList) e.Item.FindControl("Character")).SelectedItem.Value);

						dg.Execute("CRM_CrossOpportunityReferring", "id=" + int.Parse(((TextBox) e.Item.FindControl("CrossID")).Text));
					}
					ModifyReferrer = (HtmlContainerControl) e.Item.FindControl("ModifyReferrer");
					ViewReferrer = (HtmlContainerControl) e.Item.FindControl("ViewReferrer");
					ModifyReferrer.Visible = false;
					ViewReferrer.Visible = true;

					break;
			}

		}

		public void RepeaterCompanyDatabound(object source, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton DelCo = (LinkButton) e.Item.FindControl("DelCo");
					DelCo.Text = rm.GetString("CRMopptxt25");
					DelCo.Attributes.Add("onclick", "return confirm('" + rm.GetString("CRMopptxt29") + "');");
					int opId = int.Parse(Opportunity_ID.Text);
					int coId = int.Parse(((Literal) e.Item.FindControl("IdCompany")).Text);
					int coCrossId = int.Parse(((Literal) e.Item.FindControl("IDCross")).Text);
					Label LabelOpenCompany = (Label) e.Item.FindControl("LabelOpenCompany");
					if (Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "EndDate")).Length > 0)
						LabelOpenCompany.CssClass = "LinethroughGray linked";
					else
						LabelOpenCompany.CssClass = "linked";

					LabelOpenCompany.Attributes.Add("onclick", "OpenCompany('" + opId + "','" + coId + "','" + coCrossId + "')");

					Label IncomeProbabilityLabel = (Label) e.Item.FindControl("IncomeProbabilityLabel");
					decimal change = Convert.ToDecimal(DatabaseConnection.SqlScalar("select changetoeuro from currencytable where id=(select currency from CRM_Opportunity where ID=" + opId + ")"));
					string value = Math.Round((Convert.ToDecimal(DataBinder.Eval((DataRowView) e.Item.DataItem, "IncomeProbability"))*change), 2).ToString();
					IncomeProbabilityLabel.Text = ((Label) OpportunityCard.FindControl("Opportunity_IncomeProbabilitySymbol")).Text + "&nbsp;" + value;

					break;
			}
		}

		public void RepeaterCompanyCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "OpenCompany":
					string opId = Opportunity_ID.Text;
					string coId = ((Literal) e.Item.FindControl("IdCompany")).Text;
					string coCrossId = ((Literal) e.Item.FindControl("IDCross")).Text;
					string coName = ((LinkButton) e.Item.FindControl("OpenCompany")).Text;
					string formLink = "/crm/CRM_OppCompany.aspx?render=no&OpID=" + opId + "&CoID=" + coId + "&CoCrossID=" + coCrossId + "&CoName=" + coName;
					FrameForm.Attributes.Add("src", formLink);
					FrameForm.Attributes.Add("style", "display:inline;");


					break;
				case "DelCompany":
					Literal IdCompany = (Literal) e.Item.FindControl("IdCompany");
					Trace.Warn("Delete Company", IdCompany.Text);
					DeleteCompanyFromOpportunity(IdCompany.Text, "0");

					RepeaterCompanyPaging.PageSize = UC.PagingSize;
					RepeaterCompanyPaging.RepeaterObj = RepeaterCompany;
					string raq = RepeaterCompanyQuery(int.Parse(Opportunity_ID.Text), 1);
					InitSheetPaging(raq, true);
					RepeaterCompanyPaging.sqlRepeater = raq;
					RepeaterCompanyPaging.BuildGrid();
					if (RepeaterCompany.Items.Count > 0)
					{
						RepeaterCompany.Visible = true;
						RepeaterCompanyInfo.Visible = false;
					}
					else
					{
						RepeaterCompany.Visible = false;
						RepeaterCompanyInfo.Text = rm.GetString("CRMopptxt64");
						RepeaterCompanyInfo.Visible = true;
					}
					break;
			}
		}

		private void DeleteCompanyFromOpportunity(string id, string type)
		{
			DatabaseConnection.DoCommand("delete from CRM_OpportunityContact where ContactType=" + type + " and OpportunityID=" + int.Parse(Opportunity_ID.Text) + " and ContactID =" + id);
		}



		private void EnableModifyCompetitor(bool newComp, bool canModify)
		{
			TextBox txtfield;
			txtfield = (TextBox) CompetitorCard.FindControl("Competitor_CompanyName");
			if (canModify) txtfield.ReadOnly = false;
			if (newComp) txtfield.Text = String.Empty;
			txtfield.CssClass = "BoxDesign";
			txtfield = (TextBox) CompetitorCard.FindControl("Competitor_Description");
			if (canModify) txtfield.ReadOnly = false;
			if (newComp) txtfield.Text = String.Empty;
			txtfield.CssClass = "BoxDesign";
			txtfield = (TextBox) CompetitorCard.FindControl("Competitor_Strengths");
			if (canModify) txtfield.ReadOnly = false;
			if (newComp) txtfield.Text = String.Empty;
			txtfield.CssClass = "BoxDesign";
			txtfield = (TextBox) CompetitorCard.FindControl("Competitor_Weaknesses");
			if (canModify) txtfield.ReadOnly = false;
			if (newComp) txtfield.Text = String.Empty;
			txtfield.CssClass = "BoxDesign";
			txtfield = (TextBox) CompetitorCard.FindControl("Competitor_Note");
			if (canModify) txtfield.ReadOnly = false;
			if (newComp) txtfield.Text = String.Empty;
			txtfield.CssClass = "BoxDesign";
			txtfield = (TextBox) CompetitorCard.FindControl("IDCompetitor");
			if (newComp)
				txtfield.Text = "-1";

			RepeaterCompetitor.Visible = false;
			CompetitorInfo.Text = String.Empty;

			RadioButtonList RBL = (RadioButtonList) CompetitorCard.FindControl("Competitor_Evaluation");
			if (canModify)
				RBL.Enabled = true;
			else
				RBL.Enabled = false;

		}

		private void SaveCompetitorFunction()
		{
			int competitorID = int.Parse(((TextBox) OpportunityCard.FindControl("Competitor_CompetitorID")).Text);
			bool newCompetitor;
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("Competitor", 1, 'U');
				dg.Add("CompanyName", ((TextBox) CompetitorCard.FindControl("Competitor_CompanyName")).Text, 'I');
				dg.Add("OwnerID", UC.UserId, 'I');
				dg.Add("Groups", "|" + UC.UserGroupId + "|", 'I');
				dg.Add("Competitor", 1, 'I');
				dg.Add("Description", ((TextBox) CompetitorCard.FindControl("Competitor_Description")).Text, 'I');
				dg.Add("Evaluation", ((RadioButtonList) CompetitorCard.FindControl("Competitor_Evaluation")).SelectedItem.Value);
				object newCompetitorID =  dg.Execute("Base_Companies", "id=" + competitorID, DigiDapter.Identities.Identity);
				newCompetitor = dg.RecordInserted;
				if(newCompetitor)
					competitorID=(int)newCompetitorID;
			}

			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("OpportunityID", Opportunity_ID.Text, 'I');
				dg.Add("CompetitorID", competitorID);
				dg.Add("Strengths", ((TextBox) CompetitorCard.FindControl("Competitor_Strengths")).Text, 'U');
				dg.Add("Weaknesses", ((TextBox) CompetitorCard.FindControl("Competitor_Weaknesses")).Text, 'U');
				dg.Add("Note", ((TextBox) CompetitorCard.FindControl("Competitor_Note")).Text, 'U');
				dg.Execute("CRM_OpportunityCompetitor", "ID=" + int.Parse(((TextBox) OpportunityCard.FindControl("IDCompetitor")).Text));
				if (dg.RecordInserted)
					newCompetitor = true;
			}
			if (newCompetitor)
			{
				DataTable dtCross = DatabaseConnection.CreateDataset("select contactid,contacttype from CRM_OpportunityContact where opportunityid=" + int.Parse(Opportunity_ID.Text)).Tables[0];
				foreach (DataRow d in dtCross.Rows)
				{
					DatabaseConnection.DoCommand("insert into CRM_CrossContactCompetitor (competitorid,contactid,contacttype) values (" + competitorID + "," + d[0].ToString() + "," + d[1].ToString() + ")");
				}
			}

			FillRepeaterCompetitor();
		}

		private void FillRepeaterCompetitor()
		{
			RepeaterCompetitor.DataSource = DatabaseConnection.CreateDataset("select id,competitorID,Evaluation,CompanyName from OpportunityCompetitor_View where OpportunityID=" + int.Parse(Opportunity_ID.Text));
			RepeaterCompetitor.DataBind();
			if (RepeaterCompetitor.Items.Count > 0)
			{
				RepeaterCompetitor.Visible = true;
				CompetitorInfo.Text = String.Empty;
			}
			else
			{
				RepeaterCompetitor.Visible = false;
				CompetitorInfo.Text = rm.GetString("CRMopptxt50");
			}
		}

		public void RepeaterCompetitor_Command(Object sender, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "OpenComp":
					FillCompetitorCard(int.Parse(((TextBox) e.Item.FindControl("CompetitorID")).Text));
					CompetitorCard.Visible = true;
					RepeaterCompetitor.Visible = false;
					break;
				case "DeleteCompetitor":
					deletecompetitor(int.Parse(((TextBox) e.Item.FindControl("CompetitorID")).Text));
					break;
			}
		}

		private void deletecompetitor(int id)
		{
			DatabaseConnection.DoCommand("delete from CRM_OpportunityCompetitor where competitorID=" + id);
			DatabaseConnection.DoCommand("delete from CRM_CrossContactCompetitor where competitorID=" + id);
			FillRepeaterCompetitor();
		}

		public void RepeaterCompetitorDatabound(object source, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton OpenCompetitor = (LinkButton) e.Item.FindControl("OpenCompetitor");
					OpenCompetitor.Text = DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName").ToString();
					LinkButton DeleteCompetitor = (LinkButton) e.Item.FindControl("DeleteCompetitor");
					DeleteCompetitor.Text = rm.GetString("CRMopptxt25");
					DeleteCompetitor.Attributes.Add("onclick", "return confirm('" + rm.GetString("CRMopptxt65") + "');");

					Label CompetitorStars = (Label) e.Item.FindControl("CompetitorStars");
					byte iStars = Convert.ToByte(DataBinder.Eval((DataRowView) e.Item.DataItem, "Evaluation"));

					if (iStars > 0)
					{
						bool halfStar = false;
						if (iStars%2 > 0)
						{
							halfStar = true;
							iStars--;
						}
						iStars = (byte) (iStars/2);
						CompetitorStars.Text = String.Empty;
						for (int i = 0; i < iStars; i++)
							CompetitorStars.Text += "<img src='/images/starfull.gif'>";
						if (halfStar == true)
						{
							CompetitorStars.Text += "<img src='/images/starthalf.gif'>";
							iStars++;
						}
						for (int i = iStars + 1; i <= 5; i++)
							CompetitorStars.Text += "<img src='/images/starnone.gif'>";
					}
					break;
			}
		}

		private void FillCompetitorCard(int id)
		{
			TextBox txtfield;
			DataSet CompCard = DatabaseConnection.CreateDataset("select * from OpportunityCompetitor_View where competitorID=" + id + " and OpportunityID=" + Opportunity_ID.Text);

			foreach (DataColumn cc in CompCard.Tables[0].Columns)
			{
				switch (cc.ColumnName)
				{
					case "Evaluation":
						RadioButtonList Evaluation = (RadioButtonList) CompetitorCard.FindControl("Competitor_Evaluation");
						foreach (ListItem li in Evaluation.Items)
						{
							if (li.Value == CompCard.Tables[0].Rows[0][cc.ColumnName].ToString())
							{
								li.Selected = true;
								break;
							}
						}
						break;
					case "ID":
						txtfield = (TextBox) CompetitorCard.FindControl("IDCompetitor");
						txtfield.Text = CompCard.Tables[0].Rows[0][cc.ColumnName].ToString();
						break;
					default:
						try
						{
							txtfield = (TextBox) CompetitorCard.FindControl("Competitor_" + cc.ColumnName);
							txtfield.Text = CompCard.Tables[0].Rows[0][cc.ColumnName].ToString();
						}
						catch
						{
						}
						break;
				}
			}
			CompCard.Clear();
			EnableModifyCompetitor(false, true);
			SaveCompetitor.Visible = true;
		}


		public void RepeaterLeadDatabound(object source, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton DelCo = (LinkButton) e.Item.FindControl("DelCo");
					DelCo.Text = rm.GetString("CRMopptxt25");
					DelCo.Attributes.Add("onclick", "return confirm('" + rm.GetString("CRMopptxt29") + "');");
					int opId = int.Parse(Opportunity_ID.Text);
					int coId = int.Parse(((Literal) e.Item.FindControl("IdCompany")).Text);
					int coCrossId = int.Parse(((Literal) e.Item.FindControl("IDCross")).Text);
					Label LabelOpenCompany = (Label) e.Item.FindControl("LabelOpenCompany");
					if (Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "EndDate")).Length > 0)
						LabelOpenCompany.CssClass = "LinethroughGray linked";
					else
						LabelOpenCompany.CssClass = "linked";
					LabelOpenCompany.Attributes.Add("onclick", "OpenLead('" + opId + "','" + coId + "','" + coCrossId + "')");

					Label IncomeProbabilityLabel = (Label) e.Item.FindControl("IncomeProbabilityLabel");
					decimal change = Convert.ToDecimal(DatabaseConnection.SqlScalar("select changetoeuro from currencytable where id=" + DatabaseConnection.SqlScalar("select currency from CRM_Opportunity where ID=" + opId)));
					string value = Math.Round((Convert.ToDecimal(DataBinder.Eval((DataRowView) e.Item.DataItem, "IncomeProbability"))*change), 2).ToString();
					IncomeProbabilityLabel.Text = ((Label) OpportunityCard.FindControl("Opportunity_IncomeProbabilitySymbol")).Text + "&nbsp;" + value;
					break;
			}
		}

		public void RepeaterLeadCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "OpenCompany":
					string opId = Opportunity_ID.Text;
					string coId = ((Literal) e.Item.FindControl("IdCompany")).Text;
					string coCrossId = ((Literal) e.Item.FindControl("IDCross")).Text;
					string coName = ((LinkButton) e.Item.FindControl("OpenCompany")).Text;
					FrameForm.Attributes.Add("src", "/crm/CRM_OppLead.aspx?render=no&OpID=" + opId + "&CoID=" + coId + "&CoCrossID=" + coCrossId + "&CoName=" + coName);
					FrameForm.Attributes.Add("style", "display:inline;");
					break;
				case "DelCompany":
					Literal IdCompany = (Literal) e.Item.FindControl("IdCompany");
					Trace.Warn("Delete Company", IdCompany.Text);
					DeleteCompanyFromOpportunity(IdCompany.Text, "1");

					RepeaterLeadPaging.PageSize = UC.PagingSize;
					RepeaterLeadPaging.RepeaterObj = RepeaterLead;
					string raq = RepeaterCompanyQuery(int.Parse(Opportunity_ID.Text), 1);
					InitSheetPaging(raq, false);
					RepeaterLeadPaging.sqlRepeater = raq;
					RepeaterLeadPaging.BuildGrid();

					if (RepeaterLead.Items.Count > 0)
					{
						RepeaterLead.Visible = true;
						RepeaterLeadInfo.Visible = false;
					}
					else
					{
						RepeaterLead.Visible = false;
						RepeaterLeadInfo.Text = rm.GetString("CRMopptxt64");
						RepeaterLeadInfo.Visible = true;
					}
					break;
			}
		}


		public void RefreshOpp(object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "RefreshRepeaterProducts":
					FillRepeaterProducts(int.Parse(Opportunity_ID.Text));
					break;
				case "RefreshRepeaterCompany":

					RepeaterCompanyPaging.PageSize = UC.PagingSize;
					RepeaterCompanyPaging.RepeaterObj = RepeaterCompany;
					string raq = RepeaterCompanyQuery(int.Parse(Opportunity_ID.Text), 0);
					InitSheetPaging(raq, true);
					RepeaterCompanyPaging.sqlRepeater = raq;
					RepeaterCompanyPaging.BuildGrid();


					if (RepeaterCompany.Items.Count > 0)
					{
						RepeaterCompany.Visible = true;
						RepeaterCompanyInfo.Visible = false;
					}
					else
					{
						RepeaterCompany.Visible = false;
						RepeaterCompanyInfo.Text = rm.GetString("CRMopptxt64");
						RepeaterCompanyInfo.Visible = true;
					}
					FrameForm.Attributes.Add("src", "");
					FrameForm.Attributes.Add("style", "display:none;");
					FillRepeaterProducts(int.Parse(Opportunity_ID.Text));
					break;
				case "RefreshCloseFrame":
					FrameForm.Attributes.Add("src", "");
					FrameForm.Attributes.Add("style", "display:none;");
					break;
				case "RefreshRepeaterLead":
					RepeaterLeadPaging.PageSize = UC.PagingSize;
					RepeaterLeadPaging.RepeaterObj = RepeaterLead;
					raq = RepeaterCompanyQuery(int.Parse(Opportunity_ID.Text), 1);
					InitSheetPaging(raq, false);
					RepeaterLeadPaging.sqlRepeater = raq;
					RepeaterLeadPaging.BuildGrid();

					if (RepeaterLead.Items.Count > 0)
					{
						RepeaterLead.Visible = true;
						RepeaterLeadInfo.Visible = false;
					}
					else
					{
						RepeaterLead.Visible = false;
						RepeaterLeadInfo.Text = rm.GetString("CRMopptxt64");
						RepeaterLeadInfo.Visible = true;
					}
					FrameForm.Attributes.Add("src", "");
					FrameForm.Attributes.Add("style", "display:none;");
					break;
			}
			RefreshOpportunityAmount(int.Parse(Opportunity_ID.Text));
		}

		private void btnAddProduct_Click(object sender, EventArgs e)
		{
			PurchaseProduct newprod = new PurchaseProduct();
			newprod.id = Convert.ToInt64(((TextBox) Page.FindControl("EstProductID")).Text);
			newprod.ShortDescription = ((TextBox) Page.FindControl("EstProduct")).Text;
			newprod.LongDescription = ((TextBox) Page.FindControl("EstDescription2")).Text;
			newprod.UM = ((TextBox) Page.FindControl("EstUm")).Text;
			newprod.Qta = Convert.ToInt32(((TextBox) Page.FindControl("EstQta")).Text);

			decimal chFrom = (1/Convert.ToDecimal(Opportunity_Currency.SelectedValue.Split('|')[1]));
			newprod.UnitPrice = Math.Round(StaticFunctions.FixDecimal(((TextBox) Page.FindControl("EstUp")).Text)*chFrom, 2);
			newprod.Vat = (((TextBox) Page.FindControl("EstVat")).Text.Length > 0) ? Convert.ToDecimal(((TextBox) Page.FindControl("EstVat")).Text) : 0;
			newprod.ListPrice = Math.Round(StaticFunctions.FixDecimal(((TextBox) Page.FindControl("EstPl")).Text)*chFrom, 2);
			newprod.FinalPrice = Math.Round(StaticFunctions.FixDecimal(((TextBox) Page.FindControl("EstPf")).Text)*chFrom, 2);

			ArrayList np = new ArrayList();
			if (Session["newprod"] != null)
				np = (ArrayList) Session["newprod"];

			newprod.ObId = np.Count;

			np.Add(newprod);
			Session["newprod"] = np;

			RepeaterEstProduct.DataSource = np;
			RepeaterEstProduct.DataBind();
			RepeaterEstProduct.Visible = true;
			Session["prodchange"] = "true";
		}

		private void btnCalcPrice_Click(object sender, EventArgs e)
		{
			TextBox EstPl = (TextBox) Page.FindControl("EstPl");
			TextBox EstPf = (TextBox) Page.FindControl("EstPf");
			TextBox EstQta = (TextBox) Page.FindControl("EstQta");
			TextBox EstUp = (TextBox) Page.FindControl("EstUp");
			EstPl.Text = Convert.ToString(Math.Round((Convert.ToDecimal(EstQta.Text)*Convert.ToDecimal(EstUp.Text)), 2));
			EstPf.Text = EstPl.Text;
		}

		private void RepeaterEstProduct_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Label ShortDescription = (Label) e.Item.FindControl("ShortDescription");
					Label UM = (Label) e.Item.FindControl("UM");
					Label Qta = (Label) e.Item.FindControl("Qta");
					Label UnitPrice = (Label) e.Item.FindControl("UnitPrice");
					Label NCompany = (Label) e.Item.FindControl("NCompany");
					Label Nlead = (Label) e.Item.FindControl("Nlead");
					PurchaseProduct newprod = (PurchaseProduct) e.Item.DataItem;
					ShortDescription.Text = newprod.ShortDescription;
					UM.Text = newprod.UM.ToString();
					Qta.Text = newprod.Qta.ToString();

					NCompany.Text = newprod.Contacts.ToString();
					Nlead.Text = newprod.Leads.ToString();

					string sy = Opportunity_Currency.SelectedValue.Split('|')[2];
					decimal chTo = Convert.ToDecimal(Opportunity_Currency.SelectedValue.Split('|')[1].Replace(".", ","));

					UnitPrice.Text = sy + " " + Math.Round((newprod.UnitPrice*chTo), 2).ToString();


					break;
			}
		}

		private void RepeaterEstProduct_ItemCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "DelPurPro":
					break;
			}
		}

		public void FillFileRep(int id)
		{
			string sqlString = "select filemanager.*, filescategories.description as catdesc,(Account.Name+' '+Account.Surname) as owner from filemanager ";
			sqlString += "left outer join filescategories on filemanager.type=filescategories.id ";
			sqlString += "left outer join FileCrossTables on filemanager.id=FileCrossTables.IDFile ";
			sqlString += "left outer join Account on filemanager.OwnerID=Account.uid ";
			sqlString += "where IsReview=0 and FileCrossTables.TableName='CRM_Opportunity' and FileCrossTables.IDRif=" + id;

			FileRep.DataSource = DatabaseConnection.CreateDataset(sqlString);
			FileRep.DataBind();
			if (FileRep.Items.Count > 0)
			{
				FileRepInfo.Visible = false;
				FileRep.Visible = true;
			}
			else
			{
				FileRepInfo.Visible = true;
				FileRep.Visible = false;
				FileRepInfo.Text = rm.GetString("CRMcontxt61");
			}

		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
		}

		private void InitializeComponent()
		{
			this.BtnNew.Click += new System.EventHandler(this.Btn_Click);
			this.BtnFind.Click += new System.EventHandler(this.Btn_Click);
			this.Opportunity_SubmitUP.Click += new System.EventHandler(this.Btn_Click);
			this.RepeaterEstProduct.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.RepeaterEstProduct_ItemDataBound);
			this.RepeaterEstProduct.ItemCommand += new System.Web.UI.WebControls.RepeaterCommandEventHandler(this.RepeaterEstProduct_ItemCommand);
			this.Opportunity_Submit.Click += new System.EventHandler(this.Btn_Click);
			this.Opportunity_LoadLead.Click += new System.EventHandler(this.Opportunity_LoadLead_Click);
			this.Opportunity_LoadCompany.Click += new System.EventHandler(this.Opportunity_LoadCompany_Click);
			this.Opportunity_Modify.Click += new System.EventHandler(this.Btn_Click);
			this.FindCompanyButton.Click += new System.EventHandler(this.Btn_Click);
			this.Opportunity_NewCo.Click += new System.EventHandler(this.Btn_Click);
			this.Opportunity_SearchCompany.Click += new System.EventHandler(this.Btn_Click);
			this.Opportunity_CompanyList.Click += new System.EventHandler(this.Btn_Click);
			this.SearchCompanyBtn.Click += new System.EventHandler(this.SearchCompanyBtn_Click);
			this.RepeaterCompany.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.RepeaterCompanyDatabound);
			this.RepeaterCompany.ItemCommand += new System.Web.UI.WebControls.RepeaterCommandEventHandler(this.RepeaterCompanyCommand);
			this.FindLeadButton.Click += new System.EventHandler(this.Btn_Click);
			this.Opportunity_NewLead.Click += new System.EventHandler(this.Btn_Click);
			this.Opportunity_SrcLead.Click += new System.EventHandler(this.Btn_Click);
			this.Opportunity_ElencoLead.Click += new System.EventHandler(this.Btn_Click);
			this.RepeaterLead.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.RepeaterLeadDatabound);
			this.RepeaterLead.ItemCommand += new System.Web.UI.WebControls.RepeaterCommandEventHandler(this.RepeaterLeadCommand);
			this.NewActivityPhone.Click += new System.EventHandler(this.NewActivity_Click);
			this.NewActivityLetter.Click += new System.EventHandler(this.NewActivity_Click);
			this.NewActivityFax.Click += new System.EventHandler(this.NewActivity_Click);
			this.NewActivityMemo.Click += new System.EventHandler(this.NewActivity_Click);
			this.NewActivityEmail.Click += new System.EventHandler(this.NewActivity_Click);
			this.NewActivityVisit.Click += new System.EventHandler(this.NewActivity_Click);
			this.NewActivityGeneric.Click += new System.EventHandler(this.NewActivity_Click);
			this.NewActivitySolution.Click += new System.EventHandler(this.NewActivity_Click);
			this.AddNewPartner.Click += new System.EventHandler(this.Btn_Click);
			this.PartnerSubmit.Click += new System.EventHandler(this.Btn_Click);
			this.RepeaterPartner.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.RepeaterPartnerDatabound);
			this.RepeaterPartner.ItemCommand += new System.Web.UI.WebControls.RepeaterCommandEventHandler(this.RepeaterPartner_Command);
			this.AddNewCompetitor.Click += new System.EventHandler(this.Btn_Click);
			this.CloseCompetitor.Click += new System.EventHandler(this.Btn_Click);
			this.SaveCompetitor.Click += new System.EventHandler(this.Btn_Click);
			this.NewDoc.Click += new System.EventHandler(this.Btn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}

		#endregion

		private void FileRep_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton Mod = (LinkButton) e.Item.FindControl("Modify");
					Mod.Text = rm.GetString("Dsttxt16");
					LinkButton Rev = (LinkButton) e.Item.FindControl("Revision");
					Rev.Text = rm.GetString("Dsttxt13");

					LinkButton RN = (LinkButton) e.Item.FindControl("ReviewNumber");
					Literal LRN = (Literal) e.Item.FindControl("LbReviewNumber");
					if (Session["review"].ToString() == "0")
					{
						RN.Visible = (RN.Text != "0");
						Rev.Visible = true;
						LRN.Visible = false;
					}
					else
					{
						RN.Visible = false;
						Rev.Visible = false;
						LRN.Visible = (LRN.Text != "0");
					}

					break;
			}
		}

		private void FileRep_ItemCommand(object source, RepeaterCommandEventArgs e)
		{
			Literal FileId = (Literal) e.Item.FindControl("FileId");
			switch (e.CommandName)
			{
				case "Down":

					DataSet ds = DatabaseConnection.CreateDataset("select * from filemanager where id=" + int.Parse(FileId.Text));

					string filename;
					filename = ConfigSettings.DataStoragePath + Path.DirectorySeparatorChar + ds.Tables[0].Rows[0]["guid"];
					string realFileName = ds.Tables[0].Rows[0]["filename"].ToString();
					try
					{
						string downFile = filename + Path.GetExtension(realFileName);
						if (File.Exists(downFile))
						{
							Response.AddHeader("Content-Disposition", "attachment; filename=" + realFileName);
							Response.ContentType = "application/octet-stream";
							Response.TransmitFile(downFile);
							Response.Flush();
							Response.End();
							return;
						}
						else if (File.Exists(filename))
						{
							File.Move(filename, downFile);
							Response.AddHeader("Content-Disposition", "attachment; filename=" + realFileName);
							Response.ContentType = "application/octet-stream";
							Response.TransmitFile(downFile);
							Response.Flush();
							Response.End();
							return;
						}
						else
						{
							G.SendError("File lost", downFile);
						}


					}
					catch
					{
					}
					break;
				case "Modify":
				case "Revision":
					Session["IdDoc"] = FileId.Text;
					SetGoBack("/CRM/CRM_Opportunity.aspx?m=25&si=37&gb=1", new string[2] {Opportunity_ID.Text, "d"});
					if (e.CommandName == "Modify")
						Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=m");
					else
						Response.Redirect("/DataStorage/DataStorage.aspx?action=NEW&t=e");
					break;
				case "ReviewNumber":
					Session["review"] = "1";
					StringBuilder sqlString = new StringBuilder();

					int fileID = int.Parse(((Literal) e.Item.FindControl("FileId")).Text);

					sqlString.Append("select filemanager.*, filescategories.description as catdesc,(Account.Name+' '+Account.Surname) as owner from filemanager ");
					sqlString.Append("left outer join filescategories on filemanager.type=filescategories.id ");
					sqlString.Append("left outer join Account on filemanager.OwnerID=Account.uid ");
					sqlString.Append("where (filemanager.ownerid=" + UC.UserId + " or " + GroupsSecure("FileManager.Groups") + ") ");
					sqlString.Append("and (filemanager.id=" + fileID + " or filemanager.IsReview=" + fileID + ") ");
					sqlString.Append("order by ReviewNumber desc");

					FileRep.DataSource = DatabaseConnection.CreateDataset(sqlString.ToString());
					FileRep.DataBind();
					break;
			}
		}

		private void SearchCompanyBtn_Click(object sender, EventArgs e)
		{
			DataTable dt = this.SearchCompany.GetCompanyTable();
			if (dt.Rows.Count > 0)
			{
				string find = "$";
				foreach (DataRow dr in dt.Rows)
				{
					find += "CRM_OpportunityContact.ContactID=" + dr["id"].ToString() + " or ";
				}
				RepeaterCompanyPaging.PageSize = UC.PagingSize;
				RepeaterCompanyPaging.RepeaterObj = RepeaterLead;
				string raq = RepeaterCompanyQuery(int.Parse(Opportunity_ID.Text), 1, find.Substring(0, find.Length - 3));
				InitSheetPaging(raq, false);
				RepeaterCompanyPaging.sqlRepeater = raq;
				RepeaterCompanyPaging.BuildGrid();

				if (RepeaterCompany.Items.Count > 0)
				{
					RepeaterCompany.Visible = true;
					RepeaterCompanyInfo.Visible = false;
					TblSearchCompany.Visible = false;
				}
				else
				{
					RepeaterCompany.Visible = false;
					RepeaterCompanyInfo.Text = rm.GetString("CRMopptxt64");
					RepeaterCompanyInfo.Visible = true;
				}
			}
			else
			{
				RepeaterCompany.Visible = false;
				RepeaterCompanyInfo.Text = rm.GetString("CRMopptxt64");
				RepeaterCompanyInfo.Visible = true;
			}
			FrameForm.Attributes.Add("src", "");
			FrameForm.Attributes.Add("style", "display:none;");
		}

		private void SrcLeadBtn_Click(object sender, EventArgs e)
		{
			DataTable dt = this.SrcLead.GetLeadTable();
			if (dt.Rows.Count > 0)
			{
				string find = "$";
				foreach (DataRow dr in dt.Rows)
				{
					find += "CRM_OpportunityContact.ContactID=" + dr["id"].ToString() + " or ";
				}
				RepeaterLeadPaging.PageSize = UC.PagingSize;
				RepeaterLeadPaging.RepeaterObj = RepeaterLead;
				string raq = RepeaterCompanyQuery(int.Parse(Opportunity_ID.Text), 1, find.Substring(0, find.Length - 3));
				InitSheetPaging(raq, false);
				RepeaterLeadPaging.sqlRepeater = raq;
				RepeaterLeadPaging.BuildGrid();

				if (RepeaterLead.Items.Count > 0)
				{
					RepeaterLead.Visible = true;
					RepeaterLeadInfo.Visible = false;
					TblSrcLead.Visible = false;
				}
				else
				{
					RepeaterLead.Visible = false;
					RepeaterLeadInfo.Text = rm.GetString("CRMopptxt64");
					RepeaterLeadInfo.Visible = true;
				}
			}
			else
			{
				RepeaterLead.Visible = false;
				RepeaterLeadInfo.Text = rm.GetString("CRMopptxt64");
				RepeaterLeadInfo.Visible = true;
			}
			FrameForm.Attributes.Add("src", "");
			FrameForm.Attributes.Add("style", "display:none;");
		}

		private void Opportunity_LoadLead_Click(object sender, EventArgs e)
		{
			Session["FromOpp"] = this.Opportunity_ID.Text;
			Response.Redirect("/common/opploadfromlead.aspx?m=25&si=37");
		}

		private void Opportunity_LoadCompany_Click(object sender, EventArgs e)
		{
			Session["FromOpp"] = this.Opportunity_ID.Text;
			Response.Redirect("/common/opploadfromcompany.aspx?m=25&si=37");
		}
	}
}

