/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>


using System;
using System.Data;

using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena
{
	public class CRMToDoList : G
	{
		protected Repeater RepTask;
		protected Repeater RepTask2;
		protected LinkButton NewTask;
		protected Label RepeaterInfo;
		protected Label RepeaterInfo2;
		protected HtmlTable TaskCard;
		protected TextBox ToDoList_OwnerID;
		protected TextBox ToDoList_Owner;
		protected TextBox ToDoList_ExpirationDate;
		protected TextBox ToDoList_CompanyID;
		protected TextBox ToDoList_CompanyName;
		protected TextBox ToDoList_OpportunityID;
		protected TextBox ToDoList_OpportunityTitle;
		protected TextBox ToDoList_Task;
		protected TextBox ToDoList_Outcome;
		protected LinkButton SaveTask;
		protected Literal TaskID;
		protected System.Web.UI.HtmlControls.HtmlGenericControl PopAccount;
		protected System.Web.UI.HtmlControls.HtmlGenericControl PopAccount2;
		protected System.Web.UI.HtmlControls.HtmlGenericControl PopAccount3;
		protected System.Web.UI.HtmlControls.HtmlGenericControl PopAccount4;
		protected LinkButton BtnSearch;
		protected System.Web.UI.WebControls.DomValidators.RequiredDomValidator OwnerValidator;
		protected System.Web.UI.WebControls.CompareValidator CvDateFine;
		protected System.Web.UI.WebControls.DomValidators.RequiredDomValidator ExpirationDateValidator;
		protected System.Web.UI.WebControls.Label LinkOpportunity;
		protected TextBox FindTxt;

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				NewTask.Text = rm.GetString("Tdltxt2");
				BtnSearch.Text = rm.GetString("CRMopptxt6");
				SaveTask.Text = rm.GetString("CRMTodtxt8");
				PopAccount.Visible = true;
				PopAccount2.Visible = true;
				PopAccount3.Visible = true;
				PopAccount4.Visible = true;

				if (!Page.IsPostBack)
				{
					TaskCard.Visible = false;
					FillRepTask();
				}
			}
		}

		public void Btn_Click(Object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "NewTask":
					RepTask.Visible = false;
					TaskCard.Visible = true;
					CleanForm();
					break;
				case "SaveTask":
					ModifyTask();
					RepTask.Visible = true;
					TaskCard.Visible = false;
					FillRepTask();
					break;
				case "BtnSearch":
					string find = DatabaseConnection.FilterInjection(FindTxt.Text);
					FillRepTask("select * from CRM_ToDoList_View where " +
						"(OwnerID=" + UC.UserId + ") " +
						"and (Task like '%" + find + "%' or outcome like '%" + find + "%')" +
						" order by ExpirationDate asc;",
					            "select * from CRM_ToDoList_View where " +
					            	"(CreatedByID=" + UC.UserId +
					            	" and OwnerID<>" + UC.UserId + ") " +
					            	"and (Task like '%" + find + "%' or outcome like '%" + find + "%')" +
					            	"order by ExpirationDate asc;");
					break;
			}
		}

		private void FillRepTask(string sqlstring, string sqlstring2)
		{
			RepTask.DataSource = DatabaseConnection.CreateDataset(sqlstring);
			RepTask.DataBind();
			if (RepTask.Items.Count == 0)
			{
				RepeaterInfo.Text = rm.GetString("CRMTodtxt6");
				RepeaterInfo.Visible = true;
				RepTask.Visible = false;
			}
			RepTask2.DataSource = DatabaseConnection.CreateDataset(sqlstring2);
			RepTask2.DataBind();
			if (RepTask2.Items.Count == 0)
			{
				RepeaterInfo2.Text = rm.GetString("CRMTodtxt6");
				RepeaterInfo2.Visible = true;
				RepTask2.Visible = false;
			}
			Session["TaskFromFind"] = 1;
		}

		private void FillRepTask()
		{
			RepTask.DataSource = DatabaseConnection.CreateDataset("select * from CRM_ToDoList_View where (Expirationdate>='" +UC.LTZ.ToUniversalTime(DateTime.Now).ToString(@"yyyyMMdd") + "' or (Expirationdate<'" +UC.LTZ.ToUniversalTime(DateTime.Now).ToString(@"yyyyMMdd") + "' and FlagExecuted=0)) and OwnerID=" + UC.UserId + " order by ExpirationDate asc;");
			RepTask.DataBind();
			if (RepTask.Items.Count == 0)
			{
				RepeaterInfo.Text = rm.GetString("CRMTodtxt6");
				RepeaterInfo.Visible = true;
				RepTask.Visible = false;
			}
			RepTask2.DataSource = DatabaseConnection.CreateDataset("select * from CRM_ToDoList_View where (Expirationdate>='" +UC.LTZ.ToUniversalTime(DateTime.Now).ToString(@"yyyyMMdd") + "' or (Expirationdate<'" +UC.LTZ.ToUniversalTime(DateTime.Now).ToString(@"yyyyMMdd") + "' and FlagExecuted=0)) and (CreatedByID=" + UC.UserId + " and OwnerID<>" + UC.UserId + ") order by ExpirationDate asc;");
			RepTask2.DataBind();
			if (RepTask2.Items.Count == 0)
			{
				RepeaterInfo2.Text = rm.GetString("CRMTodtxt6");
				RepeaterInfo2.Visible = true;
				RepTask2.Visible = false;
			}
			Session["TaskFromFind"] = null;
		}

		public void RepTask_OnItemDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					LinkButton DelTask = (LinkButton) e.Item.FindControl("DelTask");
					DelTask.Attributes.Add("onclick", "return confirm('" + rm.GetString("CRMTodtxt10") + "');");
					DelTask.Text = rm.GetString("CRMTodtxt9");
					if (Convert.ToInt64(DataBinder.Eval((DataRowView) e.Item.DataItem, "CreatedByID")) != UC.UserId)
						DelTask.Visible = false;

					LinkButton ModTask = (LinkButton) e.Item.FindControl("ModTask");
					ModTask.Text = rm.GetString("CRMTodtxt11");

					bool es = (bool) DataBinder.Eval((DataRowView) e.Item.DataItem, "FlagExecuted");
					ImageButton Check = (ImageButton) e.Item.FindControl("Check");
					if (es)
					{
						Check.ImageUrl = "/i/checkon.gif";
					}
					else
					{
						Check.ImageUrl = "/i/checkoff.gif";
					}

					break;
			}

		}

		public void RepTask_Command(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "DelTask":
					DeleteTask(int.Parse(((Literal) (e.Item.FindControl("TaskID"))).Text));
					if (Session["TaskFromFind"] != null)
					{
						string find = DatabaseConnection.FilterInjection(FindTxt.Text);
						FillRepTask("select * from CRM_ToDoList_View where " +
							"(OwnerID=" + UC.UserId + ") " +
							"and Task like '%" + find + "%'" +
							" order by ExpirationDate asc;",
							"select * from CRM_ToDoList_View where " +
							"(CreatedByID=" + UC.UserId +
							" and OwnerID<>" + UC.UserId + ") " +
							"and Task like '%" + find + "%'" +
							"order by ExpirationDate asc;");
					}
					else
						FillRepTask();
					break;
				case "ModTask":
					DataSet ds = DatabaseConnection.CreateDataset("select * from CRM_ToDoList_View where ID =" + int.Parse(((Literal) (e.Item.FindControl("TaskID"))).Text));
					TaskID.Text = ds.Tables[0].Rows[0]["ID"].ToString();
					ToDoList_OwnerID.Text = ds.Tables[0].Rows[0]["OwnerID"].ToString();
					ToDoList_Owner.Text = ds.Tables[0].Rows[0]["OwnerName"].ToString();
					ToDoList_ExpirationDate.Text =UC.LTZ.ToLocalTime(Convert.ToDateTime(ds.Tables[0].Rows[0]["ExpirationDate"])).ToShortDateString();
					ToDoList_CompanyID.Text = ds.Tables[0].Rows[0]["CompanyID"].ToString();
					ToDoList_CompanyName.Text = ds.Tables[0].Rows[0]["CompanyName"].ToString();
					ToDoList_OpportunityID.Text = ds.Tables[0].Rows[0]["OpportunityID"].ToString();
					ToDoList_OpportunityTitle.Text = ds.Tables[0].Rows[0]["OpportunityTitle"].ToString();
					ToDoList_Task.Text = ds.Tables[0].Rows[0]["Task"].ToString();
					ToDoList_Outcome.Text = ds.Tables[0].Rows[0]["Outcome"].ToString();
					if (Convert.ToInt64(ds.Tables[0].Rows[0]["CreatedByID"]) != UC.UserId)
					{
						ToDoList_Owner.ReadOnly = true;
						ToDoList_ExpirationDate.ReadOnly = true;
						ToDoList_Task.ReadOnly = true;
						PopAccount.Visible = false;
						PopAccount2.Visible = false;
						PopAccount3.Visible = false;
						PopAccount4.Visible = false;
					}
					TaskCard.Visible = true;
					RepTask.Visible = false;
					break;
				case "CheckEseguito":
					FinitiClick(int.Parse(((Literal) (e.Item.FindControl("TaskID"))).Text));
					if (Session["TaskFromFind"] != null)
					{
						string find = DatabaseConnection.FilterInjection(FindTxt.Text);
						FillRepTask("select top 10 * from CRM_ToDoList_View where " +
							"(OwnerID=" + UC.UserId + ") " +
							"and Task like '%" + find + "%'" +
							" order by ExpirationDate asc;",
							"select top 10 * from CRM_ToDoList_View where " +
							"(CreatedByID=" + UC.UserId +
							" and OwnerID<>" + UC.UserId + ") " +
							"and Task like '%" + find + "%'" +
							"order by ExpirationDate asc;");
					}
					else
						FillRepTask();
					break;
			}
		}

		public void DeleteTask(int id)
		{
			DatabaseConnection.DoCommand("delete CRM_ToDolist where ID =" + id);
		}

		public void FinitiClick(int id)
		{
			DatabaseConnection.DoCommand("update CRM_ToDolist set FlagExecuted = " + ((bool)DatabaseConnection.SqlScalartoObj("select * from todolist where ID =" + id)?0:1));
		}


		private void ModifyTask()
		{
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("CreatedByID", UC.UserId, 'I');
				dg.Add("LastModifiedDate", DateTime.UtcNow, 'I');
				dg.Add("LastModifiedByID", UC.UserId, 'I');

				try
				{
					dg.Add("OwnerID", Convert.ToInt64(ToDoList_OwnerID.Text));
				}
				catch
				{
					dg.Add("OwnerID", UC.UserId);
				}

				dg.Add("ExpirationDate", ToDoList_ExpirationDate.Text);
				if (ToDoList_CompanyID.Text.Length > 0) dg.Add("CompanyID", ToDoList_CompanyID.Text);
				if (ToDoList_OpportunityID.Text.Length > 0) dg.Add("OpportunityID", ToDoList_OpportunityID.Text);
				dg.Add("Task", ToDoList_Task.Text);
				dg.Add("Outcome", ToDoList_Outcome.Text);
				dg.Add("Groups", UC.UserGroupId);
				dg.Add("LastModifiedDate", DateTime.UtcNow, 'U');
				dg.Add("LastModifiedByID", UC.UserId, 'U');
				dg.Execute("CRM_ToDolist","id=" + int.Parse(TaskID.Text));
			}
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.NewTask.Click += new EventHandler(this.Btn_Click);
			this.BtnSearch.Click += new EventHandler(this.Btn_Click);
			this.SaveTask.Click += new EventHandler(this.Btn_Click);
			this.RepTask.ItemCommand += new RepeaterCommandEventHandler(this.RepTask_Command);
			this.RepTask2.ItemCommand += new RepeaterCommandEventHandler(this.RepTask_Command);
			this.RepTask.ItemDataBound += new RepeaterItemEventHandler(this.RepTask_OnItemDataBound);
			this.RepTask2.ItemDataBound += new RepeaterItemEventHandler(this.RepTask_OnItemDataBound);
		}

		#endregion

		private void CleanForm()
		{
			ToDoList_OwnerID.Text = String.Empty;
			ToDoList_Owner.Text = String.Empty;
			ToDoList_ExpirationDate.Text = String.Empty;
			ToDoList_CompanyID.Text = String.Empty;
			ToDoList_CompanyName.Text = String.Empty;
			ToDoList_OpportunityID.Text = String.Empty;
			ToDoList_OpportunityTitle.Text = String.Empty;
			ToDoList_Task.Text = String.Empty;
			ToDoList_Outcome.Text = String.Empty;
			TaskID.Text = "-1";
			ToDoList_Owner.ReadOnly = false;
			ToDoList_ExpirationDate.ReadOnly = false;
			ToDoList_Task.ReadOnly = false;
		}
	}
}
