/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Digita.Tustena.Database;

namespace Digita.Tustena.CRM
{
	public class PopConvertLead : G
	{
		protected System.Web.UI.WebControls.TextBox TextboxSearchCompanyID;
		protected System.Web.UI.WebControls.TextBox TextboxSearchCompany;
		protected System.Web.UI.WebControls.RadioButtonList RadioButtonList1;
		protected Repeater RepCompany;
		protected LinkButton BtnConvert;
		protected System.Web.UI.HtmlControls.HtmlTable SearchTable;
		protected LinkButton FindCompany;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!Login())
			{
				Page.RegisterStartupScript("redirect", "<script>window.opener.location.href=window.opener.location.href;self.close();</script>");
			}
			else
			{
				if (!Page.IsPostBack)
				{
					int id = int.Parse(Request["id"]);
					Session["Ltocovert"]=id;
					DataRow drLead=DatabaseConnection.CreateDataset("select companyname,surname from crm_leads where id=" + id).Tables[0].Rows[0];
					if(drLead[0].ToString().Length > 0)
						RadioButtonList1.Items.Add(new ListItem(rm.GetString("Ledtxt30"),"0"));

					if(drLead[1].ToString().Length > 0 && drLead[1].ToString().ToLower()!="n/a")
					{
						RadioButtonList1.Items.Add(new ListItem(rm.GetString("Ledtxt31"),"1"));
						RadioButtonList1.Items.Add(new ListItem(rm.GetString("Ledtxt32"),"2"));
						RadioButtonList1.Items.Add(new ListItem(rm.GetString("Ledtxt33"),"3"));
						SearchTable.Visible=true;
					}else
					{
						SearchTable.Visible=false;
					}
					RadioButtonList1.SelectedIndex=0;
					BtnConvert.Text = rm.GetString("Ledtxt34");
					BtnConvert.Attributes.Add("onclick","return CheckConvert();");
					FindCompany.Text = rm.GetString("Find");
				}
			}
		}

		#region Codice generato da Progettazione Web Form
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.BtnConvert.Click += new System.EventHandler(this.btnConvert_Click);
			this.RepCompany.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.RepCompany_ItemDataBound);
			this.FindCompany.Click += new System.EventHandler(this.FindCompany_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ConvertLead(string id, string type)
		{
			bool isNewCompany = ((DatabaseConnection.SqlScalar("select companyname from crm_leads where id=" + id)).Length > 0);
			Session.Remove("Ltocovert");
			DataRow dr = DatabaseConnection.CreateDataset("select * from crm_leads where id=" + id).Tables[0].Rows[0];
			string NewCompanyID = String.Empty;
			string NewContactID = String.Empty;

			if (isNewCompany && (type=="0" || type=="1"))
			{
				using (DigiDapter dg = new DigiDapter())
				{
					dg.Add("OwnerID", dr["OwnerID"]);
					dg.Add("CreatedByID", UC.UserId);
					dg.Add("CompanyName", dr["CompanyName"]);

					dg.Add("Phone", dr["Phone"]);
					dg.Add("Fax", dr["Fax"]);
					dg.Add("EMail", dr["email"].ToString().Trim(' '));

					dg.Add("InvoicingAddress", dr["Address"]);
					dg.Add("InvoicingCity", dr["City"]);
					dg.Add("InvoicingStateProvince", dr["Province"]);
					dg.Add("InvoicingState", dr["State"]);
					dg.Add("InvoicingZIPCode", dr["ZIPCode"]);
					dg.Add("Description", dr["Notes"]);
					dg.Add("Groups", dr["Groups"]);
					dg.Add("FromLead", id);

					string industry = DatabaseConnection.SqlScalar("select industry from crm_crosslead where leadid=" + id);
					if (industry.Length > 0)
						dg.Add("CompanyTypeID", industry);

					object newId = dg.Execute("Base_Companies", DigiDapter.Identities.Identity);

					NewCompanyID = newId.ToString();
				}
			}

			if(type=="1" || type=="2" || type=="3")
			{
				using (DigiDapter dg = new DigiDapter())
				{
					dg.Add("Name", dr["Name"]);
					dg.Add("Surname", dr["Surname"]);
					dg.Add("OwnerID", dr["OwnerID"]);
					dg.Add("Title", dr["Title"]);
					dg.Add("Address_1", dr["Address"]);
					dg.Add("City_1", dr["City"]);
					dg.Add("Province_1", dr["Province"]);
					dg.Add("State_1", dr["State"]);
					dg.Add("ZIPCode_1", dr["ZIPCode"]);
					dg.Add("VatID", dr["VatID"]);
					dg.Add("TaxIdentificationNumber", dr["TaxIdentificationNumber"]);
					dg.Add("Email", dr["Email"].ToString().Trim(' '));
					dg.Add("Phone_1", dr["Phone"]);
					dg.Add("Fax", dr["Fax"]);
					dg.Add("MobilePhone_1", dr["MobilePhone"]);
					dg.Add("BusinessRole", dr["BusinessRole"]);
					dg.Add("Notes", dr["Notes"]);
					dg.Add("Groups", dr["Groups"]);

					if(type=="1" || type=="3")
					{
						switch(type)
						{
							case "1":
								if (isNewCompany)
									dg.Add("CompanyID", NewCompanyID);
								else
									dg.Add("CompanyID", dr["CompanyID"]);
								break;
							case "3":
								if(TextboxSearchCompanyID.Text.Length>0)
									dg.Add("CompanyID", TextboxSearchCompanyID.Text);
								break;
						}
					}
					dg.Add("BirthDay", dr["BirthDay"]);
					dg.Add("BirthPlace", dr["BirthPlace"]);
					dg.Add("Categories", dr["Categories"]);
					dg.Add("FromLead", id);

					object newId = dg.Execute("Base_Contacts", DigiDapter.Identities.Identity);

					NewContactID = newId.ToString();
				}
			}
			DatabaseConnection.DoCommand("update CRM_Leads set Limbo=1 where id=" + id);
			if (isNewCompany && (type=="0" || type=="1"))
				DatabaseConnection.DoCommand("update CRM_WorkActivity set CompanyID=" + NewCompanyID + ",LeadID=null where LeadID=" + id);
			else
				DatabaseConnection.DoCommand("update CRM_WorkActivity set ReferrerID=" + NewContactID + ",LeadID=null where LeadID=" + id);

			if (isNewCompany && (type=="0" || type=="1"))
			{
				DatabaseConnection.DoCommand("update CRM_OpportunityContact set ContactID=" + NewCompanyID + ", ContactType=0 where ContactType=1 and ContactID=" + id);
				DatabaseConnection.DoCommand("update CRM_CrossOpportunity set ContactID=" + NewCompanyID + ", ContactType=0 where ContactType=1 and ContactID=" + id);
				Session["fromlead"] = NewCompanyID;

				Page.RegisterStartupScript("redir","<script>parent.location.href='/CRM/crm_companies.aspx?m=25&dgb=1&si=29';</script>");
			}
			else
			{

				Page.RegisterStartupScript("redir","<script>parent.location.href='/CRM/base_contacts.aspx?m=25&si=31&action=VIEW&full=" + NewContactID +"';</script>");
			}

		}

		private void btnConvert_Click(object sender, EventArgs e)
		{
			ConvertLead(Session["Ltocovert"].ToString(),RadioButtonList1.SelectedValue);
		}

		private void RepCompany_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					HtmlContainerControl Company = (HtmlContainerControl) e.Item.FindControl("CompanyRep");
					Company.InnerHtml = (string) DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName");
					if (Company.InnerHtml.Length > 40)
					{
						Regex rx = new Regex(@"(?s)\b.{1,39}\b");
						Company.Attributes.Add("title", Company.InnerHtml);
						Company.InnerHtml = rx.Match(Company.InnerHtml) + "&hellip;";
						Company.Attributes.Add("style", "cursor:help;");
					}

					string setRef = "SetCompany('" + G.ParseJSString(Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName"))) +
						"','" + Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "ID")) +
						"')";

					Company.Attributes.Add("onclick", setRef);

					break;
			}
		}

		private void FindCompany_Click(object sender, EventArgs e)
		{
			string fullText = "%";

			StringBuilder sb = new StringBuilder();
			sb.Append("select Base_Companies.id,Base_Companies.CompanyName from Base_Companies ");
			sb.AppendFormat("where (Limbo=0 and ({1})) and (Base_Companies.CompanyName like '{0}%' or Base_Companies.Phone like '{0}%' or Base_Companies.Email like '{0}%') order by Base_Companies.CompanyName", fullText + DatabaseConnection.FilterInjection(TextboxSearchCompany.Text), CheckGroup("Base_Companies", UC.GroupDependency));

			RepCompany.DataSource = DatabaseConnection.CreateDataset(sb.ToString());
			RepCompany.DataBind();
		}
	}
}
