/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Collections;
using System.Data;

using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena
{
	public class QueryBuilder : G
	{
		protected DropDownList All_Tables;
		protected HtmlTable QBSearchStep1;

		protected TextBox QBQueryName;
		protected TextBox QBQueryDescription;
		protected Label QBSaveInfo;
		protected Literal HelpLabel;
		protected ListBox QBFieldsFrom;
		protected ListBox QBFieldsTo;
		protected TextBox QBLink;
		protected TextBox QBLinkValue;
		protected TextBox QBGroup;
		protected DropDownList QBGroupValue;
		protected ListBox QBFieldsFromP;
		protected ListBox QBFieldsToP;
		protected System.Web.UI.HtmlControls.HtmlGenericControl tabprinc;
		protected System.Web.UI.HtmlControls.HtmlGenericControl fieldagg;
		protected System.Web.UI.WebControls.DomValidators.RequiredDomValidator QBQueryNameValidator;
		protected System.Web.UI.WebControls.LinkButton MoveForward;
		protected System.Web.UI.WebControls.LinkButton MoveBack;
		protected System.Web.UI.WebControls.LinkButton MoveUp;
		protected System.Web.UI.WebControls.LinkButton MoveDown;
		protected System.Web.UI.WebControls.LinkButton MoveForwardP;
		protected System.Web.UI.WebControls.LinkButton MoveBackP;
		protected System.Web.UI.WebControls.LinkButton QBSaveFinal;
		protected DropDownList QBFirstTable;


		public void Page_Load(object sender, EventArgs e)
		{
			DeleteGoBack();

			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				if (!Page.IsPostBack)
				{
					fieldagg.Visible = false;
					tabprinc.Visible = false;
					HelpLabel.Text = FillHelp("qbilder_step1");
					QBSearchStep1.Visible = true;
					FillTables();
				}
			}
		}

		private void FillTables()
		{
			DataSet ds = DatabaseConnection.CreateDataset("select id,rmVAlue from QB_All_Tables where selectable=1");
			foreach (DataRow dr in ds.Tables[0].Rows)
			{
				ListItem li = new ListItem();
				li.Text = rm.GetString("QBTxt" + dr["rmVAlue"].ToString());
				li.Value = dr["id"].ToString();
				All_Tables.Items.Add(li);
			}
			All_Tables.Items.Insert(0, rm.GetString("QBUtxt1"));
			All_Tables.Items[0].Value = "0";
		}

		public void All_Tables_Change(object sender, EventArgs e)
		{
			switch (((DropDownList) sender).ID)
			{
				case "All_Tables":
					DataSet ds = DatabaseConnection.CreateDataset("select id,FieldType,Field,rmVAlue,flagparam from QB_All_Fields where TableID=" + int.Parse(All_Tables.SelectedValue));

					QBFieldsFrom.Items.Clear();
					QBFieldsFromP.Items.Clear();
					foreach (DataRow d in ds.Tables[0].Rows)
					{
						ListItem i = new ListItem();
						i.Value = All_Tables.SelectedValue.ToString() + "|" + d[0].ToString() + "|" + d[1].ToString();
						i.Text = All_Tables.SelectedItem.Text + "-" + rm.GetString("QBTxt" + d["rmVAlue"].ToString());
						if (d[1].ToString() != "8")
							QBFieldsFrom.Items.Add(i);
						QBFieldsFromP.Items.Add(i);
					}
					ds.Clear();
					ds = DatabaseConnection.CreateDataset("select * from addedfields where TableName=" + int.Parse(All_Tables.SelectedValue.ToString()));
					if (ds.Tables[0].Rows.Count > 0)
					{
						foreach (DataRow d in ds.Tables[0].Rows)
						{
							ListItem i = new ListItem();
							i.Value = "-" + All_Tables.SelectedValue.ToString() + "|" + d["ID"].ToString();
							i.Text = All_Tables.SelectedItem.Text + "-" + d["name"].ToString();
							QBFieldsFrom.Items.Add(i);
						}
					}
					break;
			}
		}

		public void Btn_Click(Object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "QBSaveFinal":
					SaveCustomerQuery();
					break;
				case "MoveForward":
					foreach (ListItem i in QBFieldsFrom.Items)
					{
						if (i.Selected)
						{
							bool exists = false;
							foreach (ListItem ito in QBFieldsTo.Items)
							{
								if (ito.Value == i.Value)
								{
									exists = true;
									break;
								}
							}
							if (!exists) QBFieldsTo.Items.Add(i);
						}
					}

					bool sum = false;
					foreach (ListItem ito in QBFieldsTo.Items)
					{
						string[] t = ito.Value.Split('|');
						if (t[2] == "7")
						{
							sum = true;

							string[] aggfields = DatabaseConnection.SqlScalar("select aggregatefields from qb_all_fields where id=" + int.Parse(t[1])).Split(',');
							string aggQuery = String.Empty;
							foreach (string af in aggfields)
							{
								aggQuery += "id=" + af + " or ";
							}

							DataTable aggDt = DatabaseConnection.CreateDataset("select id,FieldType,Field,rmVAlue,flagparam,TableID from QB_All_Fields where " + aggQuery.Substring(0, aggQuery.Length - 3)).Tables[0];
							QBGroupValue.Items.Clear();
							foreach (DataRow d in aggDt.Rows)
							{
								ListItem i = new ListItem();
								string iValue = d["TableID"].ToString() + "|" + d[0].ToString() + "|" + d[1].ToString();
								foreach (ListItem li in QBFieldsTo.Items)
								{
									if (li.Value == iValue)
									{
										i.Value = d["TableID"].ToString() + "|" + d[0].ToString() + "|" + d[1].ToString();
										i.Text = rm.GetString("QBTxt" + d["rmVAlue"].ToString());
										QBGroupValue.Items.Add(i);
									}
								}
							}
						}
						bool es = false;
						foreach (ListItem i in QBFirstTable.Items)
						{
							if (i.Value == t[0])
							{
								es = true;
								break;
							}
						}
						if (!es)
						{
							string[] tt = ito.Text.Split('-');
							QBFirstTable.Items.Add(new ListItem(tt[0], t[0]));
						}
					}

					if (QBFirstTable.Items.Count > 1)
					{
						QBFirstTable.Items[0].Selected = true;
						tabprinc.Visible = true;
					}

					if (sum)
					{
						fieldagg.Visible = true;
					}
					else
					{
						fieldagg.Visible = false;
					}
					break;
				case "MoveBack":
					ListItem ttt = QBFieldsTo.SelectedItem;
					QBFieldsTo.Items.Remove(QBFieldsTo.SelectedItem);
					sum = false;
					foreach (ListItem ito in QBFieldsTo.Items)
					{
						string[] t = ito.Value.Split('|');
						if (t[2] == "7")
						{
							foreach (ListItem i in QBFieldsToP.Items)
							{
								if (i.Value == ttt.Value)
								{
									QBFieldsToP.Items.Remove(i);
									break;
								}
							}

							sum = true;

							string[] aggfields = DatabaseConnection.SqlScalar("select aggregatefields from qb_all_fields where id=" + t[1]).Split(',');
							string aggQuery = String.Empty;
							foreach (string af in aggfields)
							{
								aggQuery += "id=" + af + " or ";
							}

							DataTable aggDt = DatabaseConnection.CreateDataset("select id,FieldType,Field,rmVAlue,flagparam,TableID from QB_All_Fields where " + aggQuery.Substring(0, aggQuery.Length - 3)).Tables[0];
							QBGroupValue.Items.Clear();
							foreach (DataRow d in aggDt.Rows)
							{
								ListItem i = new ListItem();
								string iValue = d["TableID"].ToString() + "|" + d[0].ToString() + "|" + d[1].ToString();
								foreach (ListItem li in QBFieldsTo.Items)
								{
									if (li.Value == iValue)
									{
										i.Value = d["TableID"].ToString() + "|" + d[0].ToString() + "|" + d[1].ToString();
										i.Text = rm.GetString("QBTxt" + d["rmVAlue"].ToString());
										QBGroupValue.Items.Add(i);
									}
								}
							}
						}
					}
					if (sum)
					{
						fieldagg.Visible = true;


					}
					else
					{
						fieldagg.Visible = false;
						QBGroupValue.Items.Clear();
					}
					break;
				case "MoveQBLink":
					foreach (ListItem i in QBFieldsFrom.Items)
					{
						if (i.Selected)
						{
							QBLink.Text = i.Text;
							QBLinkValue.Text = i.Value;
						}
					}
					break;
				case "MoveForwardP":
					sum = false;
					foreach (ListItem ito in QBFieldsTo.Items)
					{
						string[] t = ito.Value.Split('|');
						if (t[2] == "7")
						{
							sum = true;
							break;
						}
					}
					foreach (ListItem i in QBFieldsFromP.Items)
					{
						if (i.Selected)
						{
							bool exists = false;
							foreach (ListItem ito in QBFieldsToP.Items)
							{
								if (ito.Value == i.Value)
								{
									exists = true;
									break;
								}
							}
							if (!exists) QBFieldsToP.Items.Add(i);

							if (sum)
							{
								bool existsSum = false;
								foreach (ListItem ito in QBFieldsTo.Items)
								{
									if (i.Value == ito.Value)
									{
										existsSum = true;
										break;
									}
								}
								if (!existsSum) QBFieldsTo.Items.Add(i);
							}
						}
					}
					break;
				case "MoveBackP":
					QBFieldsToP.Items.Remove(QBFieldsToP.SelectedItem);
					break;
			}
		}


		private void SaveCustomerQuery()
		{
			object newId;
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("Title", QBQueryName.Text);
				dg.Add("Description", QBQueryDescription.Text);

				dg.Add("CreatedByID", UC.UserId);
				dg.Add("Groups", "|" + UC.UserGroupId + "|");

				if (QBGroupValue.Items.Count > 0) dg.Add("GroupBy", QBGroupValue.SelectedValue);
				newId = dg.Execute("QB_CustomerQuery", "id=-1", DigiDapter.Identities.Identity);
			}

			ArrayList tt = new ArrayList();

			if (QBFirstTable.Items.Count > 1)
			{
				tt.Add(QBFirstTable.SelectedValue);
			}

			foreach (ListItem i in QBFieldsTo.Items)
			{
				bool exists = false;
				string[] t = i.Value.Split('|');
				foreach (string x in tt)
				{
					if (x == t[0])
					{
						exists = true;
						break;
					}
				}
				if (!exists) tt.Add(t[0]);
			}
			string sqlTables = "select * from QB_CustomerQueryTables where id=-1";
			DataSet myDataSetTables = DatabaseConnection.CreateDataset(sqlTables);
			bool first = true;
			foreach (string x in tt)
			{
				using(DigiDapter dg = new DigiDapter())
			    {
					dg.InsertOnly();
					dg.Add("IDQuery", Convert.ToInt64(newId.ToString()));
					dg.Add("IDTable", Convert.ToInt32(x));
					if (first)
					{
						dg.Add("MainTable", true);
						first = false;
					}
				dg.Execute("myDataSetTables");
				}
			}

			string sqlFields = "select * from QB_CustomerQueryFields where id=-1";
			DataSet myDataSetFields = DatabaseConnection.CreateDataset(sqlFields);
			if (QBLinkValue.Text.Length > 0)
			{
				using(DigiDapter dg = new DigiDapter())
				{
					string[] t = QBLinkValue.Text.Split('|');
					dg.Add("IDQuery", Convert.ToInt64(newId.ToString()));
					dg.Add("IDTable", Convert.ToInt32(t[0]));
					dg.Add("IDField", Convert.ToInt32(t[1]));
					dg.Add("FieldVisible", false);
					dg.Execute("QB_CustomerQueryFields");
				}
			}
			foreach (ListItem i in QBFieldsTo.Items)
			{
				string[] t = i.Value.Split('|');
				using(DigiDapter dg = new DigiDapter())
				{
						dg.Add("IDQuery", Convert.ToInt64(newId.ToString()));
					dg.Add("IDTable", Convert.ToInt32(t[0]));
					dg.Add("IDField", Convert.ToInt32(t[1]));
					dg.Add("FieldVisible", true);
					dg.Execute("QB_CustomerQueryFields");
				}
			}

			string sqlParam = "select * from QB_CustomerQueryParamFields where id=-1";
			DataSet myDataSetParam = DatabaseConnection.CreateDataset(sqlParam);
				foreach (ListItem i in QBFieldsToP.Items)
				{
					string[] t = i.Value.Split('|');
					using(DigiDapter dg = new DigiDapter())
					{
						dg.Add("IDQuery", Convert.ToInt64(newId.ToString()));
						dg.Add("IDTable", Convert.ToInt32(t[0]));
						dg.Add("IDField", Convert.ToInt32(t[1]));
						dg.Execute("QB_CustomerQueryFields");
					}
				}

			QBSearchStep1.Visible = false;

			QBSaveInfo.Text = "Interrogazione '" + QBQueryName.Text + "' salvata";

		}


		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.MoveForward.Click += new EventHandler(this.Btn_Click);
			this.MoveBack.Click += new EventHandler(this.Btn_Click);
			this.MoveUp.Click += new EventHandler(this.MoveItem);
			this.MoveDown.Click += new EventHandler(this.MoveItem);
			this.QBSaveFinal.Click += new EventHandler(this.Btn_Click);
		}

		#endregion

		public void MoveItem(object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "MoveUp":
					int selected = QBFieldsTo.SelectedIndex;
					string moveText1 = QBFieldsTo.Items[selected - 1].Text;
					string moveText2 = QBFieldsTo.Items[selected].Text;
					string moveValue1 = QBFieldsTo.Items[selected - 1].Value;
					string moveValue2 = QBFieldsTo.Items[selected].Value;
					QBFieldsTo.Items[selected].Text = moveText1;
					QBFieldsTo.Items[selected].Value = moveValue1;
					QBFieldsTo.Items[selected - 1].Text = moveText2;
					QBFieldsTo.Items[selected - 1].Value = moveValue2;
					QBFieldsTo.SelectedIndex = selected - 1;
					break;
				case "MoveDown":
					selected = QBFieldsTo.SelectedIndex;
					moveText1 = QBFieldsTo.Items[selected + 1].Text;
					moveText2 = QBFieldsTo.Items[selected].Text;
					moveValue1 = QBFieldsTo.Items[selected + 1].Value;
					moveValue2 = QBFieldsTo.Items[selected].Value;
					QBFieldsTo.Items[selected].Text = moveText1;
					QBFieldsTo.Items[selected].Value = moveValue1;
					QBFieldsTo.Items[selected + 1].Text = moveText2;
					QBFieldsTo.Items[selected + 1].Value = moveValue2;
					QBFieldsTo.SelectedIndex = selected + 1;
					break;
			}
		}

	}

}
