/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;
using System.IO;
using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.DomValidators;
using Digita.Tustena.Base;
using Digita.Tustena.Common;
using Digita.Tustena.Database;
using Microsoft.Web.UI.WebControls;


namespace Digita.Tustena.Catalog
{
	public class CatalogProducts : G
	{
		protected Label Result;
		protected Literal Legend;

		protected TextBox Search;
		protected LinkButton FindProduct;
		protected LinkButton AddProduct;
		protected LinkButton AddProduct2;
		protected Repeater ProductRepeater;
		protected RepeaterPaging Repeaterpaging1;
		protected HtmlTable ProductTable;
		protected TreeView tvCategoryTree;
		protected TreeView tvCategoryTreeSearch;
		protected TextBox TxtTextCategory;
		protected TextBox TxtIdCategory;
		protected Label CurrentCurrency;
		protected RadioButtonList RadioActive;
		protected Label LblInfo;
		protected LinkButton BtnSubmit;

		protected HtmlTable GraphResult;
		protected RequiredDomValidator ValtxtIdCategory;
		protected TextBox TxtId;
		protected TextBox TxtCode;
		protected RequiredDomValidator ValtxtShortDescription;
		protected TextBox TxtShortDescription;
		protected TextBox TxtLongDescription;
		protected TextBox TxtUnit;
		protected RequiredDomValidator ValtxtQta;
		protected TextBox TxtQta;
		protected TextBox TxtQtaBlister;
		protected RequiredDomValidator ValtxtUnitPrice;
		protected TextBox TxtUnitPrice;
		protected TextBox TxtVat;
		protected Label RepeaterInfo;
		protected Brettle.Web.NeatUpload.InputFile ProductImage;
		protected Brettle.Web.NeatUpload.InputFile ProductDocument;
		protected Brettle.Web.NeatUpload.ProgressBar inlineProgressBar;
		protected TextBox FindCatID;
		protected Label ViewImage;

		private void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Response.Redirect("/login.aspx");
			}
			else
			{
				if (!Page.IsPostBack)
				{
					GraphStart();
					GraphResult.Visible = true;
					this.Repeaterpaging1.Visible=false;

					CreaTree(tvCategoryTree, 0);
					CreaTree(tvCategoryTreeSearch, 0, true);
					FindProduct.Text = rm.GetString("Captxt12");
					AddProduct.Text = rm.GetString("Captxt13");
					AddProduct2.Text = rm.GetString("Captxt13");
					BtnSubmit.Text = rm.GetString("Captxt14");
					BtnSubmit.Attributes.Add("onclick","ShowProgressBar()");
					ProductTable.Visible = false;


					RadioActive.Items.Add(new ListItem(rm.GetString("Captxt19"), "1"));
					RadioActive.Items.Add(new ListItem(rm.GetString("Captxt20"), "0"));
					CurrentCurrency.Text = DatabaseConnection.SqlScalar("select currencysymbol from currencytable where changetoeuro=1 and changefromeuro=1");
				}
				else
				{
					GraphResult.Visible = false;
				}
			}
		}

		private void GraphStart()
		{
			DataTable dt;
			dt = DatabaseConnection.CreateDataset("select distinct top 10 productID,count(*) as ntimes from crm_billrows group by productID").Tables[0];
			string res = String.Empty;
			foreach (DataRow dr in dt.Rows)
			{
				if (dr[0].ToString() != "0")
					res += DatabaseConnection.SqlScalar("select ShortDescription from CatalogProducts where id=" + dr[0].ToString()) + "|" + dr[1].ToString() + "|";
				else
					res += rm.GetString("Cahtxt3") + "|" + dr[1].ToString() + "|";
			}

			if (res.Length > 0)
				Result.Text = string.Format("<img src=\"/chart/pie.aspx?data={0}\">", res.Substring(0, res.Length - 1));
			else
				Result.Text = rm.GetString("Cahtxt4");

			StringBuilder legend = new StringBuilder();

			legend.Append("<table cellSpacing=0 cellPadding=2 border=0 style=\"border:1px solid black\">");
			legend.Append("<tr><td style=\"border-bottom:1px solid black;font-size:1px;\">&nbsp;</td><td style=\"border-bottom:1px solid black\">&nbsp;</td><td class=normal style=\"border-bottom:1px solid black\" width=\"50px\">n</td></tr>");
			Pie_chart pc = new Pie_chart();
			for (int i = 0; i < dt.Rows.Count; i++)
			{
				string title = DatabaseConnection.SqlScalar("select ShortDescription from CatalogProducts where id=" + dt.Rows[i][0].ToString());
				if (title.Length == 0) title = rm.GetString("Cahtxt3");
				legend.AppendFormat("<tr><td width=\"10px\" style=\"border-bottom:1px solid black;border-right:1px solid black\"><table cellpadding=0 cellspacing=0 width=\"10px\"><tr><td bgcolor=\"{0}\" style=\"font-size:9px\">&nbsp;</td></tr></table></td><td class=normal style=\"border-bottom:1px solid black\">{1}</td>", pc.color[i].Name, title);
				legend.AppendFormat("<td class=normal style=\"border-bottom:1px solid black\">{0}</td></tr>", dt.Rows[i][1].ToString());
			}
			pc.Dispose();
			legend.Append("</table");
			Legend.Text = legend.ToString();

		}

		public void CreaTree(TreeView tree, int open)
		{
			CreaTree(tree, open, false);
		}

		public void CreaTree(TreeView tree, int open, bool search)
		{
			string queryCat;
			queryCat = "SELECT * FROM CatalogCategories WHERE ParentID = 0";
			DataSet dsC = DatabaseConnection.CreateDataset(queryCat);

			foreach (DataRow dr in dsC.Tables[0].Rows)
			{
				TreeNode tv = new TreeNode();
				if (search)
					tv.Text = "<a href=\"javascript:copyDataS('" + dr["Id"].ToString() + "', '" + dr["Description"].ToString() + "')\" style=\"color:black;text-decoration:none\">" + dr["Description"].ToString() + "</a>";
				else
					tv.Text = "<a href=\"javascript:copyData('" + dr["Id"].ToString() + "', '" + dr["Description"].ToString() + "')\" style=\"color:black;text-decoration:none\">" + dr["Description"].ToString() + "</a>";
				tv.NodeData = dr["Id"].ToString();

				tv.Expanded = FillCategoryTree(Convert.ToInt32(dr["Id"]), tv, open, search); // Chiamata ricorsiva per fare le foglie

				tree.Nodes.Add(tv);
			}
			tree.CssClass = "normal";

		}

		public bool FillCategoryTree(int parent, TreeNode tvUp, int open, bool search)
		{
			string queryCat;
			queryCat = "SELECT * FROM CatalogCategories WHERE ParentID = " + parent;
			DataSet dsC = DatabaseConnection.CreateDataset(queryCat);
			bool toExpand = false;
			foreach (DataRow dr in dsC.Tables[0].Rows)
			{
				TreeNode tv = new TreeNode();
				if (search)
					tv.Text = "<a href=\"javascript:copyDataS('" + dr["Id"].ToString() + "', '" + dr["Description"].ToString() + "')\" style=\"color:black;text-decoration:none\">" + dr["Description"].ToString() + "</a>";
				else
					tv.Text = "<a href=\"javascript:copyData('" + dr["Id"].ToString() + "', '" + dr["Description"].ToString() + "')\" style=\"color:black;text-decoration:none\">" + dr["Description"].ToString() + "</a>";
				tv.NodeData = dr["Id"].ToString();
				if (!toExpand)
					toExpand = (open == Convert.ToInt32(dr["id"]));
				tv.Expanded = FillCategoryTree(Convert.ToInt32(dr["Id"]), tv, open, search); // Chiamata ricorsiva per fare le foglie
				if (tv.Expanded) toExpand = true;
				tvUp.Nodes.Add(tv);
			}
			return toExpand;
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.FindProduct.Click += new System.EventHandler(this.FindProduct_Click);
			this.AddProduct.Click += new System.EventHandler(this.AddProduct_Click);
			this.AddProduct2.Click += new System.EventHandler(this.AddProduct_Click);
			this.BtnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.ProductRepeater.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.ProductRepeater_ItemDataBound);
			this.ProductRepeater.ItemCommand += new System.Web.UI.WebControls.RepeaterCommandEventHandler(this.ProductRepeater_ItemCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}

		#endregion

		private void ProductRepeater_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Label LblCategory = (Label) e.Item.FindControl("LblCategory");
					int cat = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "Category"));
					string c = String.Empty;
					FillCatLabel(cat, ref c);
					if (c.Length > 3)
						LblCategory.Text = c.Substring(0, c.Length - 3);
					else
						LblCategory.Text = c;
					if (!(bool) DataBinder.Eval(e.Item.DataItem, "Active"))
					{
						LblCategory.CssClass = "LinethroughGray";
						((Label) e.Item.FindControl("LblCode")).CssClass = "LinethroughGray";
						((LinkButton) e.Item.FindControl("BtnProduct")).CssClass = "LinethroughGray";
					}

					LinkButton del = (LinkButton) e.Item.FindControl("DelProduct");
					if (Convert.ToInt32(DatabaseConnection.SqlScalar("select count(*) from CRM_BillRows where productid=" + int.Parse(((Literal) e.Item.FindControl("LblID")).Text))) > 0)
					{
						del.Visible = false;
					}
					else
					{
						del.Visible = true;
						del.Attributes.Add("onclick", "return confirm('" + rm.GetString("Captxt22") + "');");
					}
					LinkButton Down = (LinkButton) e.Item.FindControl("Down");
					Down.Visible=false;
					Down.ToolTip=rm.GetString("Captxt25");
					if((DataBinder.Eval((DataRowView) e.Item.DataItem, "Document")).ToString().Length>0)
					{
						string pathTemplate;
						pathTemplate = ConfigSettings.DataStoragePath+Path.DirectorySeparatorChar + "Catalog";
						if(File.Exists(Path.Combine(pathTemplate,(DataBinder.Eval((DataRowView) e.Item.DataItem, "Document")).ToString())))
						{
							Down.Visible=true;
						}
					}


					break;
			}
		}

		private void FillCatLabel(int id, ref string c)
		{
			DataTable catname = DatabaseConnection.CreateDataset("select parentid,Description from catalogcategories where id=" + id).Tables[0];
			if (catname.Rows.Count > 0)
			{
				DataRow cc = catname.Rows[0];

				c = cc[1].ToString() + "-->" + c;
				if (cc[0].ToString() != "0")
					FillCatLabel(int.Parse(cc[0].ToString()), ref c);
			}
			else
				c = String.Empty;
		}

		private void FillQueryCategories(int id, ref string c)
		{
			c += "category=" + id + " or ";
			DataTable cat = DatabaseConnection.CreateDataset("select id from catalogcategories where parentid=" + id).Tables[0];
			if (cat.Rows.Count > 0)
			{
				foreach (DataRow d in cat.Rows)
				{
					FillQueryCategories(int.Parse(d[0].ToString()), ref c);
				}
			}
		}

		private void FindProduct_Click(object sender, EventArgs e)
		{
			FindProductQuery();
		}

		private void FindProductQuery()
		{
			string search = DatabaseConnection.FilterInjection(Search.Text);
			StringBuilder q = new StringBuilder();

			if (FindCatID.Text.Length > 0)
			{
				string c = String.Empty;
				FillQueryCategories(int.Parse(FindCatID.Text), ref c);
				c = c.Substring(0, c.Length - 3);
				q.AppendFormat("select * from catalogproducts where ({0}) and (", c);
				q.AppendFormat("ShortDescription like '{0}%' or ", search);
				q.AppendFormat("LongDescription like '{0}%' or ", search);
				q.AppendFormat("Code like '{0}%') ", search);
				q.Append("order by category");

			}
			else
			{
				q.AppendFormat("select * from catalogproducts where (");
				q.AppendFormat("ShortDescription like '{0}%' or ", search);
				q.AppendFormat("LongDescription like '{0}%' or ", search);
				q.AppendFormat("Code like '{0}%') ", search);
				q.Append("order by category");


			}

			Repeaterpaging1.PageSize = UC.PagingSize;
			Repeaterpaging1.RepeaterObj = ProductRepeater;
			Repeaterpaging1.sqlRepeater = q.ToString();
			Repeaterpaging1.CurrentPage=0;
			Repeaterpaging1.BuildGrid();

			if (ProductRepeater.Items.Count > 0)
			{
				ProductRepeater.Visible = true;
			}
			else
			{
				ProductRepeater.Visible = false;
			}
			ProductTable.Visible = false;

		}

		private void ProductRepeater_ItemCommand(object source, RepeaterCommandEventArgs e)
		{
			switch (e.CommandName)
			{
				case "Down":
					Literal FileId = (Literal) e.Item.FindControl("LblID");
					DataSet ds = DatabaseConnection.CreateDataset("select Document from CatalogProducts where id=" + int.Parse(FileId.Text));

					string filename;
					filename = ConfigSettings.DataStoragePath + Path.DirectorySeparatorChar + "Catalog" + Path.DirectorySeparatorChar + ds.Tables[0].Rows[0]["Document"].ToString();
					string realFileName = "ProductInfo" + Path.GetExtension(filename);

					string downFile = filename;

					if (File.Exists(downFile))
					{
						Response.AddHeader("Content-Disposition", "attachment; filename=" + realFileName);
						Response.ContentType = "application/octet-stream";
						Response.TransmitFile(downFile);
						Response.Flush();
						Response.End();
						return;

					}
					else if (File.Exists(filename))
					{
						File.Move(filename, downFile);
						Response.AddHeader("Content-Disposition", "attachment; filename=" + realFileName);
						Response.ContentType = "application/octet-stream";
						Response.TransmitFile(downFile);
						Response.Flush();
						Response.End();
						return;
					}
					else
					{
						G.SendError("File lost", downFile);
					}
					break;
				case "DelProduct":
					DatabaseConnection.DoCommand("delete from CatalogProducts where id=" + int.Parse(((Literal) e.Item.FindControl("LblID")).Text));
					FindProductQuery();
					break;
				case "BtnProduct":
					InitProgressBar();
					LblInfo.Text = String.Empty;
					DataTable d = DatabaseConnection.CreateDataset("select * from CatalogProducts where id=" + int.Parse(((Literal) e.Item.FindControl("LblID")).Text)).Tables[0];
					foreach (DataColumn cc in d.Columns)
					{
						switch (cc.ColumnName)
						{
							case "Category":
								((TextBox) ProductTable.FindControl("TxtIdCategory")).Text = d.Rows[0][cc.ColumnName].ToString();
								((TextBox) ProductTable.FindControl("TxtTextCategory")).Text = DatabaseConnection.SqlScalar("select Description from catalogcategories where id=" + d.Rows[0][cc.ColumnName].ToString());
								break;
							case "Active":
								if ((bool) d.Rows[0][cc.ColumnName])
								{
									RadioActive.Items[0].Selected = true;
								}
								else
								{
									RadioActive.Items[1].Selected = true;
								}
								break;
							case "UnitPrice":
								try
								{
									((TextBox) ProductTable.FindControl("txt" + cc.ColumnName)).Text = Convert.ToDecimal(d.Rows[0][cc.ColumnName]).ToString();
								}
								catch
								{
								}
								break;
							case "Image":
								if(d.Rows[0][cc.ColumnName].ToString().Length>0)
								{
									this.ViewImage.Text="<img src=/i/PhotoProduct.gif border=0 style='cursor:pointer'>";
									this.ViewImage.Attributes.Add("onclick","NewWindow('/imageRepath.aspx/Catalog/"+d.Rows[0][cc.ColumnName].ToString()+"','PrintProduct',400,400,'no')");
								}
								break;
							default:
								try
								{
									((TextBox) ProductTable.FindControl("txt" + cc.ColumnName)).Text = d.Rows[0][cc.ColumnName].ToString();
								}
								catch
								{
								}
								break;

						}

					}

					ProductTable.Visible = true;
					ProductRepeater.Visible = false;
					break;
			}
		}

		private void btnSubmit_Click(object sender, EventArgs e)
		{
			SaveProduct();

		}

		private void SaveProduct()
		{
			if (Page.IsValid)
			{

				{
					int id = int.Parse(((TextBox) ProductTable.FindControl("TxtId")).Text);
					string sqlString = "select id from CatalogProducts where id = " + id;
					using (DigiDapter dg = new DigiDapter(sqlString))
					{
						if (!dg.HasRows)
						{
						}
						dg.Add("Category", ((TextBox) ProductTable.FindControl("TxtIdCategory")).Text);
						dg.Add("Code", ((TextBox) ProductTable.FindControl("TxtCode")).Text);
						dg.Add("ShortDescription", ((TextBox) ProductTable.FindControl("TxtShortDescription")).Text);
						dg.Add("LongDescription", ((TextBox) ProductTable.FindControl("TxtLongDescription")).Text);
						dg.Add("Unit", ((TextBox) ProductTable.FindControl("TxtUnit")).Text);
						dg.Add("Qta", ((TextBox) ProductTable.FindControl("TxtQta")).Text);
						if (((TextBox) ProductTable.FindControl("TxtQtaBlister")).Text.Length > 0)
							dg.Add("QtaBlister", ((TextBox) ProductTable.FindControl("TxtQtaBlister")).Text);
						dg.Add("UnitPrice", StaticFunctions.FixDecimal(((TextBox) ProductTable.FindControl("TxtUnitPrice")).Text));
						if (((TextBox) ProductTable.FindControl("TxtVat")).Text.Length > 0)
							dg.Add("Vat", StaticFunctions.FixDecimal(((TextBox) ProductTable.FindControl("TxtVat")).Text));
						dg.Add("Active", (RadioActive.SelectedValue == "1"));


						Guid gProductImage = Guid.NewGuid();
						Guid gProductDocument = Guid.NewGuid();
						string newFileNameImage=string.Empty;
						string newFileNameDocument=string.Empty;
						if(this.ProductImage.TmpFile!=null)
						{
							newFileNameImage = gProductImage.ToString()+ Path.GetExtension(ProductImage.FileName);
							dg.Add("Image", newFileNameImage);
						}
						if(this.ProductDocument.TmpFile!=null)
						{
							newFileNameDocument = gProductDocument.ToString()+ Path.GetExtension(ProductDocument.FileName);
							dg.Add("Document", newFileNameDocument);
						}

						if(newFileNameImage.Length>0 || newFileNameDocument.Length>0)
						{
								if (FileFunctions.CheckDir(ConfigSettings.DataStoragePath, true))
								{
									string pathTemplate;
									pathTemplate = ConfigSettings.DataStoragePath+Path.DirectorySeparatorChar + "catalog";

									FileFunctions.CheckDir(pathTemplate, true);
									if(this.ProductImage.FileName!=null && this.ProductImage.TmpFile!=null)
									{
										this.ProductImage.TmpFile.MoveTo(Path.Combine(pathTemplate, newFileNameImage));
									}
									if(this.ProductDocument.FileName!=null && this.ProductDocument.TmpFile!=null)
									{
										this.ProductDocument.TmpFile.MoveTo(Path.Combine(pathTemplate, newFileNameDocument));
									}
									InitProgressBar();
								}
							}

						dg.Execute("CatalogProducts", "id=" + id);
					}

					LblInfo.Text = string.Format(rm.GetString("Captxt15"), ((TextBox) ProductTable.FindControl("TxtShortDescription")).Text);
					EraseForm();
				}


			}
			else
			{
				LblInfo.Text = rm.GetString("Captxt17");
			}
		}

		private void AddProduct_Click(object sender, EventArgs e)
		{
			EraseForm();
			LblInfo.Text = String.Empty;
			InitProgressBar();
		}

		private void InitProgressBar()
		{
			inlineProgressBar.AddTrigger(BtnSubmit);
		}

		private void EraseForm()
		{
			((TextBox) ProductTable.FindControl("TxtId")).Text = "-1";
			((TextBox) ProductTable.FindControl("TxtIdCategory")).Text = String.Empty;
			((TextBox) ProductTable.FindControl("TxtTextCategory")).Text = String.Empty;
			((TextBox) ProductTable.FindControl("TxtCode")).Text = String.Empty;
			((TextBox) ProductTable.FindControl("TxtShortDescription")).Text = String.Empty;
			((TextBox) ProductTable.FindControl("TxtLongDescription")).Text = String.Empty;
			((TextBox) ProductTable.FindControl("TxtUnit")).Text = String.Empty;
			((TextBox) ProductTable.FindControl("TxtQta")).Text = "1";
			((TextBox) ProductTable.FindControl("TxtQtaBlister")).Text = String.Empty;
			((TextBox) ProductTable.FindControl("TxtUnitPrice")).Text = String.Empty;
			((TextBox) ProductTable.FindControl("TxtVat")).Text = String.Empty;

			RadioActive.Items[0].Selected = true;
			ProductTable.Visible = true;
			ProductRepeater.Visible = false;
		}
	}
}
