/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;

using System.Text;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena.Common
{
	public class LeadInfo : G
	{
		protected Repeater RepCrossLead;

		private void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Page.RegisterStartupScript("", "<script>opener.location.href=opener.location.href;self.close();</script>");
			}
			else
			{
				StringBuilder sqlString = new StringBuilder();
				sqlString.Append("SELECT CRM_CrossLead.*, Base_Companies.CompanyName AS CompanyName, ");
				sqlString.Append("Base_Contacts.Surname + ' ' + Base_Contacts.Name AS ContactName, ");
				sqlString.Append("CRM_Opportunity.Title AS OpportunityName, ");
				sqlString.Append("Account_1.Surname + ' ' + Account_1.Name AS OwnerName, ");
				sqlString.Append("Account_2.Surname + ' ' + Account_2.Name AS SalesPersonName, ");
				sqlString.Append("CompanyType.Description AS IndustryName, ");
				sqlString.Append("CRM_LeadDescription1.Description AS StatusDescription, ");
				sqlString.Append("CRM_LeadDescription2.Description AS RatingDescription, ");
				sqlString.Append("CRM_LeadDescription3.Description AS ProductInterestDescription, ");
				sqlString.Append("CRM_LeadDescription4.Description AS SourceDescription, ");
				sqlString.Append("CRM_LeadDescription5.Description AS LeadCurrencyDescription ");
				sqlString.Append("FROM CRM_CrossLead ");
				sqlString.Append("LEFT OUTER JOIN Account Account_2 ON CRM_CrossLead.SalesPerson = Account_2.UID ");
				sqlString.Append("LEFT OUTER JOIN Account Account_1 ON CRM_CrossLead.LeadOwner = Account_1.UID ");
				sqlString.Append("LEFT OUTER JOIN CRM_Opportunity ON CRM_CrossLead.AssociatedOpportunity = CRM_Opportunity.ID ");
				sqlString.Append("LEFT OUTER JOIN Base_Contacts ON CRM_CrossLead.AssociatedContact = Base_Contacts.ID ");
				sqlString.Append("LEFT OUTER JOIN Base_Companies ON CRM_CrossLead.AssociatedCompany = Base_Companies.ID ");

				sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription1 ON CRM_CrossLead.Status = CRM_LeadDescription1.K_ID and CRM_LeadDescription1.lang='" + UC.Culture.Substring(0, 2) + "' ");
				sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription2 ON CRM_CrossLead.Rating = CRM_LeadDescription2.K_ID and CRM_LeadDescription2.lang='" + UC.Culture.Substring(0, 2) + "' ");
				sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription3 ON CRM_CrossLead.ProductInterest = CRM_LeadDescription3.K_ID and CRM_LeadDescription3.lang='" + UC.Culture.Substring(0, 2) + "' ");
				sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription4 ON CRM_CrossLead.Source = CRM_LeadDescription4.K_ID and CRM_LeadDescription4.lang='" + UC.Culture.Substring(0, 2) + "' ");
				sqlString.Append("LEFT OUTER JOIN CRM_LeadDescription CRM_LeadDescription5 ON CRM_CrossLead.LeadCurrency = CRM_LeadDescription5.K_ID and CRM_LeadDescription5.lang='" + UC.Culture.Substring(0, 2) + "' ");

				sqlString.AppendFormat("LEFT OUTER JOIN CompanyType ON CRM_CrossLead.Industry = CompanyType.K_ID and CompanyType.lang='{0}'",UC.Culture.Substring(0, 2));

				DbSqlParameterCollection p = new DbSqlParameterCollection();
				p.Add(new DbSqlParameter("@LEADID", int.Parse(Request.Params["id"])));

				RepCrossLead.DataSource = DatabaseConnection.SecureCreateDataset(sqlString.ToString() + "where CRM_CrossLead.LeadID=@LEADID and Account_1.customerid=@CUSTOMERID ", p).Tables[0].DefaultView;
				RepCrossLead.DataBind();
			}
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
		}

		#endregion
	}
}
