/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena.Common
{
	public class PopCatalog : G
	{
		protected TextBox Search;
		protected DropDownList FindCat;
		protected LinkButton FindProduct;
		protected Repeater ProductRepeater;
		private decimal ch = 1;

		private void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Page.RegisterStartupScript("redirect", "<script>opener.location.href=opener.location.href;self.close();</script>");
			}
			else
			{
				if (!Page.IsPostBack)
				{
					FindProduct.Text = rm.GetString("Captxt12");
					FindCat.DataTextField = "Description";
					FindCat.DataValueField = "id";
					FindCat.DataSource = DatabaseConnection.CreateDataset("select id,description from CatalogCategories order by parentid").Tables[0];
					FindCat.DataBind();
					FindCat.Items.Insert(0, new ListItem(rm.GetString("Cattxt5"), "0"));
				}

				string js;
				string ptx = Request.QueryString["ptx"].ToString();
				string pid = (Request.QueryString["pid"] != null) ? Request.QueryString["pid"].ToString() : "";
				string um = (Request.QueryString["um"] != null) ? Request.QueryString["um"].ToString() : "";
				string qta = (Request.QueryString["qta"] != null) ? Request.QueryString["qta"].ToString() : "";
				string up = (Request.QueryString["up"] != null) ? Request.QueryString["up"].ToString() : "";
				string vat = (Request.QueryString["vat"] != null) ? Request.QueryString["vat"].ToString() : "";
				string pl = (Request.QueryString["pl"] != null) ? Request.QueryString["pl"].ToString() : "";
				string pf = (Request.QueryString["pf"] != null) ? Request.QueryString["pf"].ToString() : "";
				ch = (Request.QueryString["ch"] != null) ? Convert.ToDecimal(Request.QueryString["ch"].Replace(".", ",")) : 1;

				js = "<script>" + Environment.NewLine;
				js += "function SetRef(ptx,pid,um,qta,up,vat,pl){" + Environment.NewLine;
				js += "	dynaret('" + ptx + "').value=ptx;" + Environment.NewLine;
				if (pid.Length > 0) js += "	dynaret('" + pid + "').value=pid;" + Environment.NewLine;
				if (um.Length > 0) js += "	dynaret('" + um + "').value=um;" + Environment.NewLine;
				if (qta.Length > 0) js += "	dynaret('" + qta + "').value=qta;" + Environment.NewLine;
				if (up.Length > 0) js += "	dynaret('" + up + "').value=up;" + Environment.NewLine;
				if (vat.Length > 0) js += "	dynaret('" + vat + "').value=vat;" + Environment.NewLine;
				if (pl.Length > 0) js += "	dynaret('" + pl + "').value=pl;" + Environment.NewLine;
				if (pf.Length > 0) js += "	dynaret('" + pf + "').value=pl;" + Environment.NewLine;
				js += "	self.close();" + Environment.NewLine;
				js += "	parent.HideBox();}" + Environment.NewLine;
				js += "</script>" + Environment.NewLine;

				Page.RegisterClientScriptBlock("PopupScript", js);

			}
		}

		private void FindProduct_Click(object sender, EventArgs e)
		{
			FindProductQuery();
		}

		private void FillQueryCategories(int id, ref string c)
		{
			c += "category=" + id + " or ";
			DataTable cat = DatabaseConnection.CreateDataset("select id from catalogcategories where parentid=" + id).Tables[0];
			if (cat.Rows.Count > 0)
			{
				foreach (DataRow d in cat.Rows)
				{
					FillQueryCategories(int.Parse(d[0].ToString()), ref c);
				}
			}
		}

		private void FindProductQuery()
		{
			StringBuilder q = new StringBuilder();
			if (FindCat.SelectedIndex > 0)
			{
				string c = String.Empty;
				FillQueryCategories(int.Parse(FindCat.SelectedValue), ref c);
				c = c.Substring(0, c.Length - 3);
				q.AppendFormat("select * from catalogproducts where ({0}) and (", c);
				q.AppendFormat("ShortDescription like '{0}%' or LongDescription like '{0}%' or Code like '{0}%') ", DatabaseConnection.FilterInjection(Search.Text));
				q.Append("and Active=1 order by category");
			}
			else
			{
				q.Append("select * from catalogproducts where (");
				q.AppendFormat("ShortDescription like '{0}%' or LongDescription like '{0}%' or Code like '{0}%') ", DatabaseConnection.FilterInjection(Search.Text));
				q.AppendFormat("and Active=1 order by category");
			}

			ProductRepeater.DataSource = DatabaseConnection.CreateDataset(q.ToString());
			ProductRepeater.DataBind();

			ProductRepeater.Visible = (ProductRepeater.Items.Count > 0);

		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.FindProduct.Click += new System.EventHandler(this.FindProduct_Click);
			this.ProductRepeater.ItemDataBound += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.ProductRepeater_ItemDataBound);
			this.ProductRepeater.ItemCommand += new System.Web.UI.WebControls.RepeaterCommandEventHandler(this.ProductRepeater_ItemCommand);
			this.Load += new System.EventHandler(this.Page_Load);

		}

		#endregion

		private void ProductRepeater_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Literal BtnProduct = (Literal) e.Item.FindControl("BtnProduct");
					string p1 = Convert.ToString(DataBinder.Eval(e.Item.DataItem, "ShortDescription"));
					string p2 = Convert.ToString(DataBinder.Eval(e.Item.DataItem, "id"));
					string p3 = Convert.ToString(DataBinder.Eval(e.Item.DataItem, "Unit"));
					string p4 = Convert.ToString(DataBinder.Eval(e.Item.DataItem, "Qta"));
					string p5 = Convert.ToString(Math.Round(Convert.ToDecimal(DataBinder.Eval(e.Item.DataItem, "UnitPrice"))*ch, 2));
					string p6 = Convert.ToString((DataBinder.Eval(e.Item.DataItem, "Vat")==System.DBNull.Value)?0:Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "Vat")));
					string p7 = Convert.ToString(Math.Round(Convert.ToDecimal(DataBinder.Eval(e.Item.DataItem, "Qta"))*((decimal) DataBinder.Eval(e.Item.DataItem, "UnitPrice"))*ch, 2));

					BtnProduct.Text = "<span class=normal style=\"cursor:pointer\" onclick=\"SetRef('" + p1 + "','" + p2 + "','" + p3 + "','" + p4 + "','" + p5 + "','" + p6 + "','" + p7 + "')\">" +
						Convert.ToString(DataBinder.Eval(e.Item.DataItem, "ShortDescription")) + "</span>";
					break;
			}
		}

		private void ProductRepeater_ItemCommand(object source, System.Web.UI.WebControls.RepeaterCommandEventArgs e)
		{

		}
	}
}
