/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;
using System.Text;
using System.Text.RegularExpressions;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena
{
	public class PopAziende : G
	{
		protected Repeater CompaniesRep;
		protected TextBox FindIt;
		protected LinkButton BtnFind;
		protected LinkButton NewCompany;
		protected LinkButton ViewAdvanced;
		protected HtmlTable NewCompanyTable;
		protected HtmlTable ReSearchAdvanced;
		protected HtmlTable ReSearchSimple;
		protected TextBox RapRagSoc;
		protected TextBox RapPhone;
		protected TextBox RapEmail;
		protected LinkButton RapSubmit;
		protected RadioButtonList RadioList1;
		protected TextBox Advanced_CompanyName;
		protected TextBox Advanced_Address;
		protected TextBox Advanced_City;
		protected TextBox Advanced_State;
		protected TextBox Advanced_Zip;
		protected TextBox Advanced_Phone;
		protected TextBox Advanced_Fax;
		protected TextBox Advanced_Email;
		protected TextBox Advanced_Site;
		protected TextBox Advanced_Code;
		protected DropDownList Advanced_CompanyType;
		protected DropDownList Advanced_ContactType;
		protected RadioButtonList Advanced_BillCheck;
		protected TextBox Advanced_Billed;
		protected RadioButtonList Advanced_EmployeesCheck;
		protected TextBox Advanced_Employees;
		protected DropDownList Advanced_Estimate;
		protected DropDownList Advanced_Category;
		protected LinkButton SearchAdvanced;
		protected RadioButtonList NRes;

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Page.RegisterStartupScript("redirect", "<script>window.opener.location.href=window.opener.location.href;self.close();</script>");
			}
			else
			{
				if (!Page.IsPostBack)
				{
					RadioList1.Items.Add(new ListItem(rm.GetString("Paztxt4")));
					RadioList1.Items.Add(new ListItem(rm.GetString("Paztxt5")));
					RadioList1.Items[0].Selected = true;
					NRes.RepeatDirection = RepeatDirection.Horizontal;
					NRes.RepeatColumns = 2;
					ReSearchAdvanced.Visible = false;
				}

				string js;
				string control = Request.QueryString["textbox"].ToString();
				string control2 = (Request.QueryString["textbox2"] != null) ? Request.QueryString["textbox2"].ToString() : "";
				string ind = (Request.QueryString["ind"] != null) ? Request.QueryString["ind"].ToString() : "";
				string cit = (Request.QueryString["cit"] != null) ? Request.QueryString["cit"].ToString() : "";
				string prov = (Request.QueryString["prov"] != null) ? Request.QueryString["prov"].ToString() : "";
				string cap = (Request.QueryString["cap"] != null) ? Request.QueryString["cap"].ToString() : "";
				string tel = (Request.QueryString["tel"] != null) ? Request.QueryString["tel"].ToString() : "";
				js = "<script>" + Environment.NewLine;
				js += "function SetRef(tx,az,ind,cit,prov,cap,tel,email){" + Environment.NewLine;
				if (Request.QueryString["email"] != null)
					js += "dynaret('" + control + "').value=email;" + Environment.NewLine;
				else
					js += "dynaret('" + control + "').value=tx;" + Environment.NewLine;

				if (control2.Length > 0) js += "	dynaret('" + control2 + "').value=az;" + Environment.NewLine;
				if (ind.Length > 0) js += "	dynaret('" + ind + "').value=ind;" + Environment.NewLine;
				if (cit.Length > 0) js += "	dynaret('" + cit + "').value=cit;" + Environment.NewLine;
				if (prov.Length > 0) js += "	dynaret('" + prov + "').value=prov;" + Environment.NewLine;
				if (cap.Length > 0) js += "	dynaret('" + cap + "').value=cap;" + Environment.NewLine;
				if (tel.Length > 0) js += "	dynaret('" + tel + "').value=tel;" + Environment.NewLine;
				js += "window.onload=null;self.close();parent.HideBox();" + Environment.NewLine;
				if (Request.QueryString["change"] != null) js += "	parent.PopChange('" + control2 + "');" + Environment.NewLine;
				js += "}</script>" + Environment.NewLine;
				Page.RegisterStartupScript("PopupScript", js);
				BtnFind.Text = rm.GetString("Prftxt5");
				NewCompany.Text = rm.GetString("Paztxt2");
				ViewAdvanced.Text = rm.GetString("Paztxt9");
				NewCompanyTable.Visible = false;
				if (Request.QueryString["current"] != null)
					if (Request.QueryString["current"].Length > 0)
						Findcompany(DatabaseConnection.FilterInjection(Request.QueryString["current"].ToString()), true);
			}
		}

		public void New_Click(object sender, EventArgs e)
		{
			NewCompanyTable.Visible = true;
			CompaniesRep.Visible = false;
		}


		public void RapSubmit_Click(Object sender, EventArgs e)
		{
			if (RapRagSoc.Text.Length > 0)
			{
				using (DigiDapter dg = new DigiDapter())
				{

					dg.InsertOnly();
					dg.Add("CreatedByID", UC.UserId, 'I');
					dg.Add("CompanyName", RapRagSoc.Text);
					dg.Add("Phone", RapPhone.Text);
					dg.Add("EMail", RapEmail.Text);
					dg.Add("OwnerID", UC.UserId);
					dg.Add("Groups", "|" + UC.AdminGroupId + "|" + UC.UserGroupId + "|");
					object newId = dg.Execute("Base_Companies", DigiDapter.Identities.Identity);
					string setRef = "SetRef('" + RapRagSoc.Text +
						"','" + newId.ToString() +
						"','','','',''," +
						"'" + RapPhone.Text +
						"','" + RapEmail.Text + "');";

					Page.RegisterStartupScript("start", "<script>" + setRef + "</script>");
				}
			}
		}

		public void Find_Click(object sender, EventArgs e)
		{
			Findcompany(DatabaseConnection.FilterInjection(FindIt.Text));
		}

		private void Findcompany(string name)
		{
			Findcompany(name, false);
		}

		private void Findcompany(string name, bool full)
		{
			string fullText = String.Empty;
			if (RadioList1.Items[1].Selected || full) fullText = "%";
			StringBuilder sb = new StringBuilder();
			sb.AppendFormat("select top {0} Base_Companies.id,Base_Companies.CompanyName, Base_Companies.InvoicingAddress, Base_Companies.InvoicingCity, Base_Companies.InvoicingStateProvince, Base_Companies.InvoicingZIPCode, Base_Companies.Phone, Base_Companies.Email from Base_Companies ", NRes.SelectedValue);
			sb.AppendFormat("where (Limbo=0 and ({1})) and (Base_Companies.CompanyName like '{0}%' or Base_Companies.Phone like '{0}%' or Base_Companies.Email like '{0}%') order by Base_Companies.CompanyName", fullText + name, CheckGroup("Base_Companies", UC.GroupDependency));
			CompaniesRep.DataSource = DatabaseConnection.CreateDataset(sb.ToString());
			CompaniesRep.DataBind();
		}

		public void CompaniesDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					HtmlContainerControl Company = (HtmlContainerControl) e.Item.FindControl("CompanyRep");
					Company.InnerHtml = (string) DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName");
					if (Company.InnerHtml.Length > 40)
					{
						Regex r = new Regex(@"(?s)\b.{1,39}\b");
						Company.Attributes.Add("title", Company.InnerHtml);
						Company.InnerHtml = r.Match(Company.InnerHtml) + "&hellip;";
						Company.Attributes.Add("style", "cursor:help;");
					}

					string setRef = "SetRef('" + G.ParseJSString(Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "CompanyName"))) +
						"','" + Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "ID")) +
						"','" + G.ParseJSString(Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "InvoicingAddress"))) +
						"','" + G.ParseJSString(Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "InvoicingCity"))) +
						"','" + G.ParseJSString(Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "InvoicingStateProvince"))) +
						"','" + G.ParseJSString(Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "InvoicingZIPCode"))) +
						"','" + G.ParseJSString(Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Phone"))) +
						"','" + G.ParseJSString(Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Email"))) + "')";

					Company.Attributes.Add("onclick", setRef);

					break;
			}
		}

		public void ViewAdvanced_click(object sender, EventArgs e)
		{
			PrepareAdvanced();
		}

		public void btn_Click(object sender, EventArgs e)
		{
			StringBuilder sqlMaster = new StringBuilder();
			StringBuilder sqlString = new StringBuilder();
			bool avBool = false;
			sqlMaster.Append("select Base_Companies.id,Base_Companies.CompanyName, Base_Companies.InvoicingAddress, Base_Companies.InvoicingCity, Base_Companies.InvoicingStateProvince, Base_Companies.InvoicingZIPCode, Base_Companies.Phone, Base_Companies.Email from Base_Companies ");

			sqlMaster.Append("LEFT OUTER JOIN Account ON Base_Companies.OwnerID = Account.UID ");
			sqlMaster.AppendFormat("WHERE Limbo=0 ");

			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_CompanyName")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.CompanyName LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_CompanyName")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Address")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.InvoicingAddress LIKE '%{0}%' or Base_Companies.ShipmentAddress LIKE '%{0}%' or Base_Companies.WarehouseAddress LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Address")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_City")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.InvoicingCity LIKE '%{0}%' or Base_Companies.ShipmentCity LIKE '%{0}%' or Base_Companies.WarehouseCity LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_City")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_State")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.InvoicingStateProvince LIKE '%{0}%' or Base_Companies.ShipmentStateProvince LIKE '%{0}%' or Base_Companies.WarehouseStateProvince LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_State")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Zip")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.InvoicingZIPCode LIKE '%{0}%' or Base_Companies.ShipmentZIPCode LIKE '%{0}%' or Base_Companies.WarehouseZIPCode LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Zip")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Zip")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.InvoicingZIPCode LIKE '%{0}%' or Base_Companies.ShipmentZIPCode LIKE '%{0}%' or Base_Companies.WarehouseZIPCode LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Zip")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Phone")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.Phone LIKE '%{0}%' or Base_Companies.ShipmentPhone LIKE '%{0}%' or Base_Companies.WarehousePhone LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Phone")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Fax")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.Fax LIKE '%{0}%' or Base_Companies.ShipmentFax LIKE '%{0}%' or Base_Companies.WarehouseFax LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Fax")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Email")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.Email LIKE '%{0}%' or Base_Companies.ShipmentEmail LIKE '%{0}%' or Base_Companies.WarehouseEmail LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Email")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Site")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.WebSite LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Site")).Text);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Code")).Text.Length > 0)
			{
				sqlString.AppendFormat("(Base_Companies.CompanyCode LIKE '%{0}%') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Code")).Text);
				avBool = true;
			}
			if (((DropDownList) ReSearchAdvanced.FindControl("Advanced_CompanyType")).SelectedIndex > 0)
			{
				sqlString.AppendFormat("(Base_Companies.CompanyTypeID = '{0}') and ", ((DropDownList) ReSearchAdvanced.FindControl("Advanced_CompanyType")).SelectedValue);
				avBool = true;
			}
			if (((DropDownList) ReSearchAdvanced.FindControl("Advanced_ContactType")).SelectedIndex > 0)
			{
				sqlString.AppendFormat("(Base_Companies.ContactTypeID = '{0}') and ", ((DropDownList) ReSearchAdvanced.FindControl("Advanced_ContactType")).SelectedValue);
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Billed")).Text.Length > 0)
			{
				RadioButtonList Advanced_BillCheck = (RadioButtonList) ReSearchAdvanced.FindControl("Advanced_BillCheck");
				switch (Advanced_BillCheck.SelectedValue)
				{
					case "1":
						sqlString.AppendFormat("(Base_Companies.Billed = '{0}') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Billed")).Text);
						break;
					case "2":
						sqlString.AppendFormat("(Base_Companies.Billed < '{0}') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Billed")).Text);
						break;
					case "3":
						sqlString.AppendFormat("(Base_Companies.Billed > '{0}') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Billed")).Text);
						break;
				}
				avBool = true;
			}
			if (((TextBox) ReSearchAdvanced.FindControl("Advanced_Employees")).Text.Length > 0)
			{
				RadioButtonList Advanced_EmployeesCheck = (RadioButtonList) ReSearchAdvanced.FindControl("Advanced_EmployeesCheck");
				switch (Advanced_EmployeesCheck.SelectedValue)
				{
					case "1":
						sqlString.AppendFormat("(Base_Companies.Billed = '{0}') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Employees")).Text);
						break;
					case "2":
						sqlString.AppendFormat("(Base_Companies.Billed < '{0}') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Employees")).Text);
						break;
					case "3":
						sqlString.AppendFormat("(Base_Companies.Billed > '{0}') and ", ((TextBox) ReSearchAdvanced.FindControl("Advanced_Employees")).Text);
						break;
				}
				avBool = true;
			}
			if (((DropDownList) ReSearchAdvanced.FindControl("Advanced_Estimate")).SelectedIndex > 0)
			{
				sqlString.AppendFormat("(Base_Companies.Estimate = {0}) and ", ((DropDownList) ReSearchAdvanced.FindControl("Advanced_Estimate")).SelectedValue);
				avBool = true;
			}
			if (((DropDownList) ReSearchAdvanced.FindControl("Advanced_Category")).SelectedIndex > 0)
			{
				sqlString.AppendFormat("(Base_Companies.Categories LIKE '%|{0}|%') and ", ((DropDownList) ReSearchAdvanced.FindControl("Advanced_Category")).SelectedValue);
				avBool = true;
			}

			if (sqlString.ToString().Length > 0)
			{
				string sqlAv = sqlString.ToString();
				if (avBool)
				{
					sqlAv = sqlAv.Substring(0, sqlAv.Length - 4);
				}
				CompaniesRep.DataSource = DatabaseConnection.CreateDataset(sqlMaster.ToString() + " and (" + sqlAv + ")" + " ORDER BY Base_Companies.CompanyName");
			}
			else
			{
				CompaniesRep.DataSource = DatabaseConnection.CreateDataset(sqlMaster.ToString() + " ORDER BY Base_Companies.CompanyName");
			}


			CompaniesRep.DataBind();

			if (CompaniesRep.Items.Count > 0)
			{
				CompaniesRep.Visible = true;
				ReSearchAdvanced.Visible = false;
				ReSearchSimple.Visible = true;
			}
			else
			{
				CompaniesRep.Visible = false;
			}

		}

		private void PrepareAdvanced()
		{
			DropDownList Advanced_CompanyType = (DropDownList) ReSearchAdvanced.FindControl("Advanced_CompanyType");
			DropDownList Advanced_ContactType = (DropDownList) ReSearchAdvanced.FindControl("Advanced_ContactType");
			DropDownList Advanced_Estimate = (DropDownList) ReSearchAdvanced.FindControl("Advanced_Estimate");
			DropDownList Advanced_Category = (DropDownList) ReSearchAdvanced.FindControl("Advanced_Category");

			Fill_Sectors(Advanced_CompanyType);
			Fill_ContactType(Advanced_ContactType);
			Fill_Evaluation(Advanced_Estimate);

			Advanced_Category.DataTextField = "Description";
			Advanced_Category.DataValueField = "id";
			Advanced_Category.DataSource = DatabaseConnection.CreateDataset("select id,Description from CRM_ContactCategories where (FlagPersonal=0 or (FlagPersonal=1 and CreatedByID=" + UC.UserId + "))");
			Advanced_Category.DataBind();
			Advanced_Category.Items.Insert(0, rm.GetString("CRMcontxt53"));
			Advanced_Category.Items[0].Value = "0";

			CompaniesRep.Visible = false;
			ReSearchSimple.Visible = false;
			ReSearchAdvanced.Visible = true;

		}

		private void Fill_Sectors(DropDownList st)
		{
			DataSet ds;
			ds = DatabaseConnection.CreateDataset("Select K_ID,Description from CompanyType where lang='" + UC.Culture.Substring(0, 2) + "' order by Description");
			st.DataSource = ds;
			st.DataTextField = "Description";
			st.DataValueField = "K_ID";
			st.DataBind();
			st.Items.Insert(0, rm.GetString("CRMcontxt13"));
			st.Items[0].Value = "0";
		}

		private void Fill_ContactType(DropDownList ct)
		{
			DataSet ds;
			ds = DatabaseConnection.CreateDataset("Select K_ID,ContactType from ContactType where lang='" + UC.Culture.Substring(0, 2) + "' order by ContactType");
			ct.DataSource = ds;
			ct.DataTextField = "ContactType";
			ct.DataValueField = "K_ID";
			ct.DataBind();
			ct.Items.Insert(0, rm.GetString("CRMcontxt14"));
			ct.Items[0].Value = "0";
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
		this.Load += new EventHandler(this.Page_Load);
					this.BtnFind.Click += new EventHandler(this.Find_Click);
			this.ViewAdvanced.Click += new EventHandler(this.ViewAdvanced_click);
			this.NewCompany.Click += new EventHandler(this.New_Click);
			this.RapSubmit.Click += new EventHandler(this.RapSubmit_Click);
			this.SearchAdvanced.Click += new EventHandler(this.btn_Click);
			this.CompaniesRep.ItemDataBound += new RepeaterItemEventHandler(this.CompaniesDataBound);
		}

		#endregion

		private void Fill_Evaluation(DropDownList ct)
		{
			DataSet ds;
			ds = DatabaseConnection.CreateDataset("Select K_ID,Estimate from ContactEstimate where lang='" + UC.Culture.Substring(0, 2) + "' order by FieldOrder");
			ct.DataSource = ds;
			ct.DataTextField = "Estimate";
			ct.DataValueField = "K_ID";
			ct.DataBind();
			ct.Items.Insert(0, rm.GetString("CRMcontxt15"));
			ct.Items[0].Value = "0";
		}
	}
}
