/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena
{
	public class PopContacts : G
	{
		protected Repeater ContactReferrer;
		protected TextBox FindIt;
		protected Literal SomeJS;
		protected LinkButton Find;
		protected LinkButton NewRef;

		protected HtmlTable NewReferrer;
		protected TextBox Name;
		protected TextBox Surname;
		protected LinkButton RapSubmit;
		protected RadioButtonList RadioList1;
		protected RadioButtonList NRes;


			#region Codice generato da Progettazione Web Form

			protected override void OnInit(EventArgs e)
			{
				InitializeComponent();
				base.OnInit(e);
			}

			private void InitializeComponent()
			{
				this.Load += new EventHandler(this.Page_Load);
			this.Find.Click += new EventHandler(this.Find_Click);
			this.NewRef.Click += new EventHandler(this.Find_Click);
			this.RapSubmit.Click += new EventHandler(this.RapSubmit_Click);

			}
		#endregion

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				SomeJS.Text = "<script>window.opener.location.href=window.opener.location.href;self.close();</script>";
			}
			else
			{
				if (!Page.IsPostBack)
				{
					RadioList1.Items.Add(new ListItem(rm.GetString("Paztxt4")));
					RadioList1.Items.Add(new ListItem(rm.GetString("Paztxt5")));
					RadioList1.Items[0].Selected = true;
					NRes.RepeatDirection = RepeatDirection.Horizontal;
					NRes.RepeatColumns = 2;
				}

				NewReferrer.Visible = false;
				NewRef.Text = rm.GetString("Prftxt11");
				RapSubmit.Text = rm.GetString("Prftxt12");
				string js;
				string control = Request.QueryString["textbox"].ToString();
				if (Request.QueryString["CompanyID"] != null)
				{
					if (Request.QueryString["CompanyID"].ToString().Length > 0)
						FindCompany(int.Parse(Request.QueryString["CompanyID"]));
				}
				string control2 = (Request.QueryString["textbox2"] != null) ? Request.QueryString["textbox2"].ToString() : "";
				string control3 = (Request.QueryString["textboxID"] != null) ? Request.QueryString["textboxID"].ToString() : "";
				string control4 = (Request.QueryString["textboxCompanyID"] != null) ? Request.QueryString["textboxCompanyID"].ToString() : "";
				js = "<script>" + Environment.NewLine;
				js += "function SetRef(tx,az,id,cid,email){" + Environment.NewLine;

				if(Request.QueryString["email"] != null)
					js += "dynaret('" + control + "').value=email;" + Environment.NewLine;
				else
					js += "dynaret('" + control + "').value=tx;" + Environment.NewLine;


				if (control2.Length > 0) js += "dynaret('" + control2 + "').value=az;" + Environment.NewLine;
				if (control3.Length > 0) js += "dynaret('" + control3 + "').value=id;" + Environment.NewLine;
				if (control4.Length > 0) js += "dynaret('" + control4 + "').value=cid;" + Environment.NewLine;
				js += "	window.onload=null;self.close();" + Environment.NewLine;
				js += "	parent.HideBox();" + Environment.NewLine;
				if (Request.QueryString["change"] != null) js += "	parent.PopChange('" + control3 + "');" + Environment.NewLine;
				js += "}</script>" + Environment.NewLine;

				Page.RegisterStartupScript("PopupScript", js);
				Find.Text = rm.GetString("Prftxt5");
			}
		}

		private void FindCompany(int cID)
		{
			string sqlString = "select Base_Contacts.id,(Base_Contacts.Surname+' '+isnull(Base_Contacts.Name,'')) as referente,Base_Companies.CompanyName, Base_Companies.ID as companyid, Base_Contacts.Email from Base_Contacts ";
				sqlString+= "LEFT OUTER JOIN Base_Companies ON Base_Contacts.CompanyID = Base_Companies.ID where Base_Contacts.limbo=0 and (Base_Contacts.CompanyID=" + cID + ") order by referente";
			ContactReferrer.DataSource = DatabaseConnection.CreateDataset(sqlString);
			ContactReferrer.DataBind();
		}

		public void Find_Click(object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "Find":
					string top = String.Empty;
					string fullText = String.Empty;
					if (RadioList1.Items[1].Selected) fullText = "%";
					top = "top " + NRes.SelectedValue;
					string sqlString = "select " + top + " Base_Contacts.id,(Base_Contacts.Surname+' '+isnull(Base_Contacts.Name,'')) as referente,Base_Companies.CompanyName, Base_Companies.ID as companyid, Base_Contacts.Email from Base_Contacts ";
						sqlString+= "LEFT OUTER JOIN Base_Companies ON Base_Contacts.CompanyID = Base_Companies.ID where Base_Contacts.limbo=0 and (" + CheckGroup("Base_Contacts", UC.GroupDependency) + ") and (Base_Contacts.Name like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%' or Base_Contacts.Surname like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%' or Base_Contacts.Phone_1 like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%' or Base_Contacts.MobilePhone_1 like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%') order by referente";
					ContactReferrer.DataSource = DatabaseConnection.CreateDataset(sqlString);
					ContactReferrer.DataBind();
					break;
				case "NewRef":
					Find.Visible = false;
					FindIt.Visible = false;
					ContactReferrer.Visible = false;
					NewReferrer.Visible = true;
					break;
			}
		}

		public void RapSubmit_Click(object sender, EventArgs e)
		{
			object newId;
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("OwnerID", UC.UserId);
				dg.Add("CreatedByID", UC.UserId);
				dg.Add("CreatedDate", DateTime.UtcNow);
				dg.Add("LastmodifiedDate", DateTime.UtcNow);
				dg.Add("LastmodifiedByID", UC.UserId);
				dg.Add("Name", Name.Text);
				dg.Add("Surname", Surname.Text);
				dg.Add("Groups", "|" + UC.UserGroupId + "|");

				newId = dg.Execute("Base_Contacts", "ID=-1", DigiDapter.Identities.Identity);
			}

			string js;
			string control = Request.QueryString["textbox"].ToString();
			string control3 = (Request.QueryString["textboxID"] != null) ? Request.QueryString["textboxID"].ToString() : "";
			js = "<script>";
			js += "	dynaret('" + control + "').value='" + Name.Text + " " + Surname.Text + "';";
			if (control3.Length > 0) js += "	dynaret('" + control3 + "').value=" + newId.ToString() + ";";
			js += "	window.onload=null;self.close();";
			js += "	parent.HideBox();";
			js += "</script>";
			SomeJS.Text = js;

		}

	}
}
