/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;

using System.Text;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;
using Microsoft.Web.UI.WebControls;

namespace Digita.Tustena
{
	public class PopFile : G
	{
		protected Repeater FileRep;
		protected TextBox FindIt;
		protected LinkButton Find;
		protected TreeView tvCategoryTreeSearch;
		protected TextBox CategoryIdSearch;

		private void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Page.RegisterStartupScript("", "<script>opener.location.href=opener.location.href;self.close();</script>");
			}
			else
			{
				string js;
				string control = Request.QueryString["textbox"].ToString();
				string control2 = Request.QueryString["textboxID"].ToString();

				js = "<script>";
				js += "function SetRef(id,tx){";
				if (Request.QueryString["frame"] != null)
				{
					js += "	opener.SetParams('" + control + "',tx);";
					js += "	opener.SetParams('" + control2 + "',id);";
				}
				else
				{
					js += "	dynaret('" + control + "').value=tx;";
					js += "	dynaret('" + control2 + "').value=id;";
				}
				js += "	self.close();";
				js += "	parent.HideBox();}";
				js += "</script>";
				Page.RegisterStartupScript("", js);
				Find.Text = rm.GetString("Prftxt5");
				if(!Page.IsPostBack)
					CreaTree(tvCategoryTreeSearch, 0, 1);
			}
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.Find.Click += new EventHandler(Find_Click);
		}

		#endregion

		private void Find_Click(object sender, EventArgs e)
		{
			StringBuilder sb = new StringBuilder();
			sb.Append("select filemanager.id, filemanager.FileName, filemanager.ReviewNumber, filemanager.description from filemanager ");
			sb.Append("left outer join filescategories on filemanager.type=filescategories.id ");
			sb.AppendFormat("where (filemanager.filename like '%{0}%' or filemanager.description like '%{0}%')",DatabaseConnection.FilterInjection(FindIt.Text));
			if (CategoryIdSearch.Text.Length > 0)
			{
				sb.AppendFormat(" and type={0}", int.Parse(CategoryIdSearch.Text));
				CategoryIdSearch.Text = String.Empty;
			}

			sb.AppendFormat(" and (filemanager.ownerid={0} or {1}) and IsReview=0", UC.UserId, GroupsSecure("FileManager.Groups"));

			FileRep.DataSource = DatabaseConnection.CreateDataset(sb.ToString());
			FileRep.DataBind();
		}

		public void CreaTree(TreeView tree, int open, byte qualetree)
		{
string queryCat;
queryCat = "SELECT * FROM FilesCategories WHERE ParentID = 0";
			DataSet dsC = DatabaseConnection.CreateDataset(queryCat);
			TreeNode tv1 = new TreeNode();

			switch (qualetree)
			{
				case 0:
					tv1.Text = "<a href=\"javascript:copyData('', '','CategoryText','Categoryid')\" style=\"color:black;text-decoration:none\">" + rm.GetString("Dsttxt21") + "</a>";
					break;
				case 1:
					tv1.Text = "<a href=\"javascript:copyData('', '','CategoryTextSearch','CategoryIDSearch','Find')\" style=\"color:black;text-decoration:none\">" + rm.GetString("Dsttxt21") + "</a>";
					break;
			}

			tree.Nodes.Add(tv1);
			foreach (DataRow dr in dsC.Tables[0].Rows)
			{
				TreeNode tv = new TreeNode();


				switch (qualetree)
				{
					case 0:
						tv.Text = "<a href=\"javascript:copyData('" + dr["Id"].ToString() + "', '" + dr["Description"].ToString() + "','CategoryText','Categoryid')\" style=\"color:black;text-decoration:none\">" + dr["Description"].ToString() + "</a>";
						break;
					case 1:
						tv.Text = "<a href=\"javascript:copyData('" + dr["Id"].ToString() + "', '" + dr["Description"].ToString() + "','CategoryTextSearch','CategoryIDSearch','Find')\" style=\"color:black;text-decoration:none\">" + dr["Description"].ToString() + "</a>";
						break;
				}

				tv.NodeData = dr["Id"].ToString();

				tv.Expanded = FillCategoryTree(Convert.ToInt32(dr["Id"]), tv, open, qualetree); // Chiamata ricorsiva per fare le foglie
				tv.ImageUrl = "/webctrl_client/1_0/treeimages/folder.gif";
				tv.ExpandedImageUrl = "/webctrl_client/1_0/treeimages/folderopen.gif";
				tree.Nodes.Add(tv);
			}
			tree.CssClass = "normal";

		}

		public bool FillCategoryTree(int parent, TreeNode tvUp, int open, byte qualetree)
		{
string queryCat;
queryCat = "SELECT * FROM FilesCategories WHERE ParentID = " + parent;
			DataSet dsC = DatabaseConnection.CreateDataset(queryCat);
			bool toExpand = false;
			foreach (DataRow dr in dsC.Tables[0].Rows)
			{
				TreeNode tv = new TreeNode();
				switch (qualetree)
				{
					case 0:
						tv.Text = "<a href=\"javascript:copyData('" + dr["Id"].ToString() + "', '" + dr["Description"].ToString() + "','CategoryText','Categoryid')\" style=\"color:black;text-decoration:none\">" + dr["Description"].ToString() + "</a>";
						break;
					case 1:
						tv.Text = "<a href=\"javascript:copyData('" + dr["Id"].ToString() + "', '" + dr["Description"].ToString() + "','CategoryTextSearch','CategoryIDSearch','Find')\" style=\"color:black;text-decoration:none\">" + dr["Description"].ToString() + "</a>";
						break;
				}
				tv.NodeData = dr["Id"].ToString();
				if (!toExpand)
					toExpand = (open == Convert.ToInt32(dr["id"]));
				tv.Expanded = FillCategoryTree(Convert.ToInt32(dr["Id"]), tv, open, qualetree); // Chiamata ricorsiva per fare le foglie
				if (tv.Expanded) toExpand = true;
				tv.ImageUrl = "/webctrl_client/1_0/treeimages/folder.gif";
				tv.ExpandedImageUrl = "/webctrl_client/1_0/treeimages/folderopen.gif";

				tvUp.Nodes.Add(tv);
			}
			return toExpand;
		}
	}
}
