/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;

using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena.Common
{
	public class PopLead : G
	{
		protected Repeater ContactReferrer;
		protected TextBox FindIt;
		protected Literal SomeJS;
		protected LinkButton Find;
		protected LinkButton NewRef;

		protected HtmlTable NewReferrer;
		protected TextBox Name;
		protected TextBox Surname;
		protected TextBox CompanyName;
		protected LinkButton RapSubmit;
		protected RadioButtonList RadioList1;
		protected RadioButtonList NRes;

		public void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				SomeJS.Text = "<script>opener.location.href=opener.location.href;self.close();</script>";
			}
			else
			{
				if (!Page.IsPostBack)
				{
					RadioList1.Items.Add(new ListItem(rm.GetString("Paztxt4")));
					RadioList1.Items.Add(new ListItem(rm.GetString("Paztxt5")));
					RadioList1.Items[0].Selected = true;
					NRes.RepeatDirection = RepeatDirection.Horizontal;
					NRes.RepeatColumns = 2;
				}

				NewReferrer.Visible = false;
				NewRef.Text = rm.GetString("Pldtxt1");
				RapSubmit.Text = rm.GetString("Prftxt12");
				string js;
				string control = Request.QueryString["textbox"].ToString();
				if (Request.QueryString["CompanyID"] != null)
				{
					if (Request.QueryString["CompanyID"].ToString().Length > 0)
						FindCompany(int.Parse(Request.QueryString["CompanyID"].ToString()));
				}
				string control2 = (Request.QueryString["textbox2"] != null) ? Request.QueryString["textbox2"].ToString() : "";
				string control3 = (Request.QueryString["textboxID"] != null) ? Request.QueryString["textboxID"].ToString() : "";
				string control4 = (Request.QueryString["textboxCompanyID"] != null) ? Request.QueryString["textboxCompanyID"].ToString() : "";
				js = "<script>";
				js += "function SetRef(tx,az,id,cid,email){";

				if (Request.QueryString["email"] != null)
					js += "dynaret('" + control + "').value=email;" + Environment.NewLine;
				else
					js += "dynaret('" + control + "').value=tx;" + Environment.NewLine;

				if (control2.Length > 0) js += "dynaret('" + control2 + "').value=az;";
				if (control3.Length > 0) js += "dynaret('" + control3 + "').value=id;";
				if (control4.Length > 0) js += "dynaret('" + control4 + "').value=cid;";


				js += "self.close();";
				js += "parent.HideBox();";
				if (Request.QueryString["change"] != null) js += "	parent.PopChange('" + control3 + "');" + Environment.NewLine;
				js += "}</script>";
				SomeJS.Text = js;
				Find.Text = rm.GetString("Prftxt5");
			}
		}

		private void FindCompany(int cID)
		{
			string sqlString = "select CRM_Leads.id,(CRM_Leads.Surname+' '+isnull(CRM_Leads.Name,'')) as referente,CRM_Leads.CompanyName, CRM_Leads.CompanyID, CRM_Leads.email from CRM_Leads "
				+ "where (CRM_Leads.CustomerID=@CUSTOMERID and CRM_Leads.limbo=0 and Active=1 and ((" + CheckGroup("CRM_Leads", UC.GroupDependency) + ") or CRM_Leads.OwnerID=" + UC.UserId + ")) and (CRM_Leads.CompanyID=@COMPANYID) order by referente";
			DbSqlParameterCollection par = new DbSqlParameterCollection();
			par.Add(new DbSqlParameter("@COMPANYID", cID));
			ContactReferrer.DataSource = DatabaseConnection.SecureCreateDataset(sqlString, par);
			ContactReferrer.DataBind();
		}

		public void Find_Click(object sender, EventArgs e)
		{
			switch (((LinkButton) sender).ID)
			{
				case "Find":
					string top = String.Empty;
					string fullText = String.Empty;
					if (RadioList1.Items[1].Selected) fullText = "%";
					top = "top " + NRes.SelectedValue;
					string sqlString = "select " + top + " CRM_Leads.id,(CRM_Leads.Surname+' '+isnull(CRM_Leads.Name,'')) as referente,CRM_Leads.CompanyName, CRM_Leads.CompanyID, CRM_Leads.email from CRM_Leads ";
					sqlString += "where (CRM_Leads.limbo=0 and Active=1 and ((" + CheckGroup("CRM_Leads", UC.GroupDependency) + ") or CRM_Leads.OwnerID=" + UC.UserId + ")) and (CRM_Leads.Name like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%' or CRM_Leads.Surname like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%' or CRM_Leads.Phone like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%' or CRM_Leads.MobilePhone like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%' or CRM_Leads.CompanyName like '" + fullText + DatabaseConnection.FilterInjection(FindIt.Text) + "%') order by referente";
					ContactReferrer.DataSource = DatabaseConnection.CreateDataset(sqlString);
					ContactReferrer.DataBind();
					break;
				case "NewRef":
					Find.Visible = false;
					FindIt.Visible = false;
					ContactReferrer.Visible = false;
					NewReferrer.Visible = true;
					break;
			}
		}

		public void RapSubmit_Click(object sender, EventArgs e)
		{
			string newId = String.Empty;
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("OwnerID", UC.UserId);
				dg.Add("CreatedByID", UC.UserId);
				dg.Add("CreatedDate", DateTime.UtcNow);
				dg.Add("LastmodifiedDate", DateTime.UtcNow);
				dg.Add("LastmodifiedByID", UC.UserId);
				dg.Add("Name", Name.Text);
				dg.Add("Surname", Surname.Text);
				dg.Add("CompanyName", CompanyName.Text);
				dg.Add("Groups", "|" + UC.UserGroupId + "|");
				object obNewId = dg.Execute("CRM_Leads", "ID=-1", DigiDapter.Identities.Identity);
				newId = obNewId.ToString();
			}
			DatabaseConnection.DoCommand("insert into CRM_CrossLead (LeadID) values (" + newId + ")");

			string js;
			string control = Request.QueryString["textbox"].ToString();
			string control3 = (Request.QueryString["textboxID"] != null) ? Request.QueryString["textboxID"].ToString() : "";
			js = "<script>";
			js += "	dynaret('" + control + "').value='" + Name.Text + " " + Surname.Text + "';";
			if (control3.Length > 0) js += "	dynaret('" + control3 + "').value=" + newId + ";";
			js += "	self.close();";
			js += "	parent.HideBox();";
			js += "</script>";
			SomeJS.Text = js;

		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
			this.Find.Click += new EventHandler(this.Find_Click);
			this.NewRef.Click += new EventHandler(this.Find_Click);
			this.RapSubmit.Click += new EventHandler(this.RapSubmit_Click);

		}

		#endregion
	}
}
