/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;

using System.Text.RegularExpressions;
using System.Web.UI;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena.Common
{
	public class ViewContact : G
	{
		protected Repeater Repeater1;

		private void Page_Load(object sender, EventArgs e)
		{
			if (Login())
			{
				Repeater1.DataSource = DatabaseConnection.SecureCreateDataset("select * from Base_Contacts where id=@ID and (" + CheckGroup(null, UC.GroupDependency) + ")", new DbSqlParameter("@ID", Request.Params["id"].ToString()));
				Repeater1.DataBind();
			}
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.Repeater1.ItemDataBound +=new RepeaterItemEventHandler(Repeater1_ItemDataBound);
		}

		#endregion

		private void Repeater1_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					Literal VoipCallPhone_1 = (Literal) e.Item.FindControl("VoipCallPhone_1");
					Literal VoipCallPhone_2 = (Literal) e.Item.FindControl("VoipCallPhone_2");
					Literal VoipCallMobilePhone_1 = (Literal) e.Item.FindControl("VoipCallMobilePhone_1");
					Literal VoipCallMobilePhone_2 = (Literal) e.Item.FindControl("VoipCallMobilePhone_2");

						if((DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE_1")).ToString().Length>0)
						{
							string ph = Regex.Replace((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE_1"),@"[^0-9]","");
							VoipCallPhone_1.Text=MakeVoipString(ph);
						}
						if((DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE_2")).ToString().Length>0)
						{
							string ph = Regex.Replace((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "PHONE_2"),@"[^0-9]","");
							VoipCallPhone_2.Text=MakeVoipString(ph);
						}
						if((DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone_1")).ToString().Length>0)
						{
							string ph = Regex.Replace((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone_1"),@"[^0-9]","");
							VoipCallMobilePhone_1.Text=MakeVoipString(ph);
						}
						if((DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone_2")).ToString().Length>0)
						{
							string ph = Regex.Replace((string) DataBinder.Eval((DataRowView) e.Item.DataItem, "MobilePhone_2"),@"[^0-9]","");
							VoipCallMobilePhone_2.Text=MakeVoipString(ph);
						}
					break;
			}
		}
	}
}
