/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Diagnostics;
using System.IO;
using System.Text.RegularExpressions;
using System.Threading;
using System.Xml;

namespace TustenaXsender
{
	public class Engine
	{
		private string XMailSpool = String.Empty;
		private string TustenaOrigin = String.Empty;




		void ProcessXMLSpoolFile(string xmlpath)
		{
			try
			{
				XmlTextReader reader = new XmlTextReader(xmlpath);
				reader.WhitespaceHandling = WhitespaceHandling.None;
				string _message=String.Empty;
				string _to = String.Empty;
				string _refid = String.Empty;
				bool hasread = false;
				reader.ReadStartElement("ml");

				hasread = reader.Read();
				if (reader.NodeType == XmlNodeType.CDATA && reader.HasValue)
					_message = reader.Value;
				else
				{
					return;
				}
				while(!(reader.NodeType == XmlNodeType.Element &&
					reader.Name == "mailing" && hasread))
					hasread = reader.Read();
				hasread = reader.Read();
				while(reader.NodeType == XmlNodeType.Element &&
					reader.Name == "mail" && hasread)
				{
					if (reader.AttributeCount == 3)
					{
						_to = reader.GetAttribute("to");
						_refid = reader.GetAttribute("refid");
						hasread = reader.Read();
						string tempmessage=_message;
						while(reader.NodeType == XmlNodeType.Element &&
							reader.Name == "field" && hasread)
						{
							if (reader.NodeType == XmlNodeType.Element &&
								reader.Name == "field" &&
								reader.AttributeCount == 2)
							{
								string searchvalue = reader.GetAttribute(0);
								string replacevalue = reader.GetAttribute(1);

								tempmessage = Regex.Replace(tempmessage,searchvalue,replacevalue,RegexOptions.IgnoreCase | RegexOptions.Multiline);
							}
							hasread = reader.Read();
						}
						tempmessage = Regex.Replace(tempmessage,"to@to.to",_to,RegexOptions.IgnoreCase | RegexOptions.Multiline);
						tempmessage = Regex.Replace(tempmessage,"Tustena.RefId",_refid,RegexOptions.IgnoreCase | RegexOptions.Multiline);

						writefile(Path.Combine(XMailSpool,Guid.NewGuid().ToString("N") + ".xmailspool"),tempmessage);
						if(reader.NodeType == XmlNodeType.EndElement)
							hasread = reader.Read();
					}
				}
				reader.ReadEndElement();
				reader.Close();
			}
			catch{}


		}

		private void writefile(string filename, string text)
		{
			try
			{
				using(StreamWriter tw = new StreamWriter(filename,false))
				{
					tw.Write(text);
				}
			}
			catch
			{
			}
		}

	}
}
