/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;
using System.Text;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;

namespace Digita.Tustena.MailingList.webmail
{
	public class VerifyMailInML : G
	{
		protected Label MLSendError;

		private void Page_Load(object sender, EventArgs e)
		{
			if (!Login())
			{
				Page.RegisterStartupScript("","<script>opener.location.href=opener.location.href;self.close();</script>");
			}
			else
			{
				NewMailingList nm = new NewMailingList(UC);
				int mlId = int.Parse(Request.QueryString["id"]);
				string queryCompany = nm.GetCompanyQuery(mlId);
				string queryContact = nm.GetContactQuery(mlId);
				string queryLead = nm.GetLeadQuery(mlId);
				string queryCompanyFixed = String.Empty;
				if(nm.FixedMailQuery(mlId,"company",out queryCompanyFixed)&& queryCompanyFixed.Length>0)
				{
					queryCompanyFixed="select cast(Base_Companies.ID as varchar(12))+'|'+case when isnull(Base_Companies.MLEmail,'')='' then isnull(Base_Companies.EMail,'') else Base_Companies.MLEmail end+'|'+Base_Companies.CompanyName as IDMAIL,companyname from Base_Companies where " + queryCompanyFixed.Substring(0, queryCompanyFixed.Length - 3);
				}
				string queryContactFixed = String.Empty;
				if(nm.FixedMailQuery(mlId,"contact",out queryContactFixed)&& queryContactFixed.Length>0)
				{
					queryContactFixed="select cast(Base_Contacts.ID as varchar(12))+'|'+case when isnull(Base_Contacts.MLEmail,'')='' then isnull(Base_Contacts.EMail,'') else Base_Contacts.MLEmail end+'|'+Base_Contacts.Name+' '+Base_Contacts.Surname as IDMAIL,isnull(name,'')+' '+isnull(surname,'') as companyname from Base_Contacts where " + queryContactFixed.Substring(0, queryContactFixed.Length - 3);
				}
				string queryLeadFixed = String.Empty;
				if(nm.FixedMailQuery(mlId,"lead",out queryLeadFixed)&& queryLeadFixed.Length>0)
				{
					queryLeadFixed="select cast(CRM_Leads.ID as varchar(12))+'|'+isnull(CRM_Leads.Email,'')+'|'+isnull(CRM_Leads.CompanyName,'')+' '+isnull(CRM_Leads.Name,'')+' '+isnull(CRM_Leads.Surname,'') as IDMAIL,isnull(name,'')+' '+isnull(surname,'')+' '+isnull(companyname,'') as companyname2 from crm_leads where " + queryLeadFixed.Substring(0, queryLeadFixed.Length - 3);
				}
				StringBuilder queryChain = new StringBuilder();
				if(queryCompany.Length>0)queryChain.AppendFormat("{0};",queryCompany);
				if(queryContact.Length>0)queryChain.AppendFormat("{0};",queryContact);
				if(queryLead.Length>0)queryChain.AppendFormat("{0};",queryLead);
				if(queryCompanyFixed.Length>0)queryChain.AppendFormat("{0};",queryCompanyFixed);
				if(queryContactFixed.Length>0)queryChain.AppendFormat("{0};",queryContactFixed);
				if(queryLeadFixed.Length>0)queryChain.AppendFormat("{0};",queryLeadFixed);
				if(queryChain.Length==0)
				{
					MLSendError.Text=rm.GetString("NoMail");
						return;
				}
				DataSet ds =DatabaseConnection.CreateDataset(queryChain.ToString());

				StringBuilder er = new StringBuilder();
				er.Append("<table class=normal cellspacing=3 cellpadding=0>");
				bool found = false;
				foreach(DataTable dt in ds.Tables)
				{
					foreach(DataRow dr in dt.Rows)
					{
						try
						{
							found=true;
							string[] xm = dr[0].ToString().Split('|');
							if(xm.Length>1&&xm[1].Length<=0)
								er.AppendFormat("<tr><td style=\"color:red\">{0}</td><td style=\"color:red\">{1}</td></tr>",xm[2],rm.GetString("MLtxt31"));
							else
								er.AppendFormat("<tr><td style=\"color:black\">{0}</td><td style=\"color:black\">{1}</td></tr>",xm[2],"Mail OK");
						}catch{}

					}
				}
				er.Append("</table>");
				if(found)
					MLSendError.Text = er.ToString();
				else
					MLSendError.Text=rm.GetString("NoMail");
			}
		}

		#region Codice generato da Progettazione Web Form
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
