/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>


namespace Digita.Tustena.TustenaWebService
{
	using System.Diagnostics;
	using System.Xml.Serialization;
	using System;
	using System.Web.Services.Protocols;
	using System.ComponentModel;
	using System.Web.Services;


	[System.Diagnostics.DebuggerStepThroughAttribute()]
	[System.ComponentModel.DesignerCategoryAttribute("code")]
	[System.Web.Services.WebServiceBindingAttribute(Name="ServiceLeadInsertSoap", Namespace="http://tempuri.org/")]
	public class ServiceLeadInsert : System.Web.Services.Protocols.SoapHttpClientProtocol
	{

		public AuthHeader AuthHeaderValue;

		public ServiceLeadInsert()
		{
			this.Url = "http://crm.tustena.com/tustenawebservices/leadinsert.asmx";
		}

		[System.Web.Services.Protocols.SoapHeaderAttribute("AuthHeaderValue")]
		[System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://tempuri.org/StoreLead", RequestNamespace="http://tempuri.org/", ResponseNamespace="http://tempuri.org/", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
		public bool StoreLead(
			string name,
			string surname,
			string companyName,
			string title,
			string address,
			string city,
			string province,
			string zipCode,
			string state,
			string vatID,
			string eMail,
			string phone,
			string fax,
			string mobilePhone,
			string notes,
			string userName,
			string userPassword)
		{
			object[] results = this.Invoke("StoreLead", new object[] {
																		 name,
																		 surname,
																		 companyName,
																		 title,
																		 address,
																		 city,
																		 province,
																		 zipCode,
																		 state,
																		 vatID,
																		 eMail,
																		 phone,
																		 fax,
																		 mobilePhone,
																		 notes,
																		 userName,
																		 userPassword});
			return ((bool)(results[0]));
		}

		public System.IAsyncResult BeginStoreLead(
			string name,
			string surname,
			string companyName,
			string title,
			string address,
			string city,
			string province,
			string zIPCode,
			string state,
			string vatID,
			string eMail,
			string phone,
			string fax,
			string mobilePhone,
			string notes,
			string userName,
			string userPassword,
			System.AsyncCallback callback,
			object asyncState)
		{
			return this.BeginInvoke("StoreLead", new object[] {
																  name,
																  surname,
																  companyName,
																  title,
																  address,
																  city,
																  province,
																  zIPCode,
																  state,
																  vatID,
																  eMail,
																  phone,
																  fax,
																  mobilePhone,
																  notes,
																  userName,
																  userPassword}, callback, asyncState);
		}

		public bool EndStoreLead(System.IAsyncResult asyncResult)
		{
			object[] results = this.EndInvoke(asyncResult);
			return ((bool)(results[0]));
		}
	}

	[System.Xml.Serialization.XmlTypeAttribute(Namespace="http://tempuri.org/")]
	[System.Xml.Serialization.XmlRootAttribute(Namespace="http://tempuri.org/", IsNullable=false)]
	public class AuthHeader : System.Web.Services.Protocols.SoapHeader
	{

		public string UserName;

		public string Password;

		public string CompanyCode;
	}
}
