/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>


namespace Digita.Tustena.smscontentservice {
    using System.Diagnostics;
    using System.Xml.Serialization;
    using System;
    using System.Web.Services.Protocols;
    using System.ComponentModel;
    using System.Web.Services;


    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Web.Services.WebServiceBindingAttribute(Name="SendContentServiceSoap", Namespace="com.esendex.ems.soapinterface")]
    public class SendContentService : System.Web.Services.Protocols.SoapHttpClientProtocol {

        public MessengerHeader MessengerHeaderValue;

        public SendContentService() {
            this.Url = "https://www.esendex.com/secure/messenger/soap/SendContentService.asmx";
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendWAPPush", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string SendWAPPush(string recipient, string href, string text) {
            object[] results = this.Invoke("SendWAPPush", new object[] {
                        recipient,
                        href,
                        text});
            return ((string)(results[0]));
        }

        public System.IAsyncResult BeginSendWAPPush(string recipient, string href, string text, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendWAPPush", new object[] {
                        recipient,
                        href,
                        text}, callback, asyncState);
        }

        public string EndSendWAPPush(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string)(results[0]));
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendWAPPushFull", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string SendWAPPushFull(string originator, string recipient, string href, string text, int validityperiod) {
            object[] results = this.Invoke("SendWAPPushFull", new object[] {
                        originator,
                        recipient,
                        href,
                        text,
                        validityperiod});
            return ((string)(results[0]));
        }

        public System.IAsyncResult BeginSendWAPPushFull(string originator, string recipient, string href, string text, int validityperiod, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendWAPPushFull", new object[] {
                        originator,
                        recipient,
                        href,
                        text,
                        validityperiod}, callback, asyncState);
        }

        public string EndSendWAPPushFull(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string)(results[0]));
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendWAPPushMultipleRecipients", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string[] SendWAPPushMultipleRecipients(string[] recipients, string href, string text) {
            object[] results = this.Invoke("SendWAPPushMultipleRecipients", new object[] {
                        recipients,
                        href,
                        text});
            return ((string[])(results[0]));
        }

        public System.IAsyncResult BeginSendWAPPushMultipleRecipients(string[] recipients, string href, string text, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendWAPPushMultipleRecipients", new object[] {
                        recipients,
                        href,
                        text}, callback, asyncState);
        }

        public string[] EndSendWAPPushMultipleRecipients(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string[])(results[0]));
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendWAPPushMultipleRecipientsFull", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string[] SendWAPPushMultipleRecipientsFull(string originator, string[] recipients, string href, string text, int validityPeriod) {
            object[] results = this.Invoke("SendWAPPushMultipleRecipientsFull", new object[] {
                        originator,
                        recipients,
                        href,
                        text,
                        validityPeriod});
            return ((string[])(results[0]));
        }

        public System.IAsyncResult BeginSendWAPPushMultipleRecipientsFull(string originator, string[] recipients, string href, string text, int validityPeriod, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendWAPPushMultipleRecipientsFull", new object[] {
                        originator,
                        recipients,
                        href,
                        text,
                        validityPeriod}, callback, asyncState);
        }

        public string[] EndSendWAPPushMultipleRecipientsFull(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string[])(results[0]));
        }
    }

    [System.Xml.Serialization.XmlTypeAttribute(Namespace="com.esendex.ems.soapinterface")]
    [System.Xml.Serialization.XmlRootAttribute(Namespace="com.esendex.ems.soapinterface", IsNullable=false)]
    public class MessengerHeader : System.Web.Services.Protocols.SoapHeader {

        public string Username;

        public string Password;

        public string Account;
    }
}
