/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>


namespace Digita.Tustena.smsmessenger {
    using System.Diagnostics;
    using System.Xml.Serialization;
    using System;
    using System.Web.Services.Protocols;
    using System.ComponentModel;
    using System.Web.Services;


    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Web.Services.WebServiceBindingAttribute(Name="SendServiceSoap", Namespace="com.esendex.ems.soapinterface")]
    public class SendService : System.Web.Services.Protocols.SoapHttpClientProtocol {

        public MessengerHeader MessengerHeaderValue;

        public SendService() {
            this.Url = "https://www.esendex.com/secure/messenger/soap/sendservice.asmx";
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendMessage", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string SendMessage(string recipient, string body, MessageType type) {
            object[] results = this.Invoke("SendMessage", new object[] {
                        recipient,
                        body,
                        type});
            return ((string)(results[0]));
        }

        public System.IAsyncResult BeginSendMessage(string recipient, string body, MessageType type, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendMessage", new object[] {
                        recipient,
                        body,
                        type}, callback, asyncState);
        }

        public string EndSendMessage(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string)(results[0]));
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendMessageFull", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string SendMessageFull(string originator, string recipient, string body, MessageType type, int validityperiod) {
            object[] results = this.Invoke("SendMessageFull", new object[] {
                        originator,
                        recipient,
                        body,
                        type,
                        validityperiod});
            return ((string)(results[0]));
        }

        public System.IAsyncResult BeginSendMessageFull(string originator, string recipient, string body, MessageType type, int validityperiod, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendMessageFull", new object[] {
                        originator,
                        recipient,
                        body,
                        type,
                        validityperiod}, callback, asyncState);
        }

        public string EndSendMessageFull(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string)(results[0]));
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendMessageMultipleRecipients", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string[] SendMessageMultipleRecipients(string[] recipients, string body, MessageType type) {
            object[] results = this.Invoke("SendMessageMultipleRecipients", new object[] {
                        recipients,
                        body,
                        type});
            return ((string[])(results[0]));
        }

        public System.IAsyncResult BeginSendMessageMultipleRecipients(string[] recipients, string body, MessageType type, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendMessageMultipleRecipients", new object[] {
                        recipients,
                        body,
                        type}, callback, asyncState);
        }

        public string[] EndSendMessageMultipleRecipients(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string[])(results[0]));
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendMessageMultipleRecipientsFull", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string[] SendMessageMultipleRecipientsFull(string originator, string[] recipients, string body, MessageType type, int validityperiod) {
            object[] results = this.Invoke("SendMessageMultipleRecipientsFull", new object[] {
                        originator,
                        recipients,
                        body,
                        type,
                        validityperiod});
            return ((string[])(results[0]));
        }

        public System.IAsyncResult BeginSendMessageMultipleRecipientsFull(string originator, string[] recipients, string body, MessageType type, int validityperiod, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendMessageMultipleRecipientsFull", new object[] {
                        originator,
                        recipients,
                        body,
                        type,
                        validityperiod}, callback, asyncState);
        }

        public string[] EndSendMessageMultipleRecipientsFull(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string[])(results[0]));
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/SendMessageBatch", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string[] SendMessageBatch(messagesubmission[] messages) {
            object[] results = this.Invoke("SendMessageBatch", new object[] {
                        messages});
            return ((string[])(results[0]));
        }

        public System.IAsyncResult BeginSendMessageBatch(messagesubmission[] messages, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("SendMessageBatch", new object[] {
                        messages}, callback, asyncState);
        }

        public string[] EndSendMessageBatch(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string[])(results[0]));
        }

        [System.Web.Services.Protocols.SoapHeaderAttribute("MessengerHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("com.esendex.ems.soapinterface/GetMessageStatus", RequestNamespace="com.esendex.ems.soapinterface", ResponseNamespace="com.esendex.ems.soapinterface", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public MessageStatusCode GetMessageStatus(string id) {
            object[] results = this.Invoke("GetMessageStatus", new object[] {
                        id});
            return ((MessageStatusCode)(results[0]));
        }

        public System.IAsyncResult BeginGetMessageStatus(string id, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("GetMessageStatus", new object[] {
                        id}, callback, asyncState);
        }

        public MessageStatusCode EndGetMessageStatus(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((MessageStatusCode)(results[0]));
        }
    }

    [System.Xml.Serialization.XmlTypeAttribute(Namespace="com.esendex.ems.soapinterface")]
    [System.Xml.Serialization.XmlRootAttribute(Namespace="com.esendex.ems.soapinterface", IsNullable=false)]
    public class MessengerHeader : System.Web.Services.Protocols.SoapHeader {

        public string Username;

        public string Password;

        public string Account;
    }

    [System.Xml.Serialization.XmlTypeAttribute(Namespace="com.esendex.ems.soapinterface")]
    public class messagesubmission {

        public string originator;

        public string recipient;

        public string body;

        public MessageType type;

        public int validityperiod;
    }

    [System.Xml.Serialization.XmlTypeAttribute(Namespace="com.esendex.ems.soapinterface")]
    public enum MessageType {

        Text,

        Binary,

        SmartMessage,

        Unicode,
    }

    [System.Xml.Serialization.XmlTypeAttribute(Namespace="com.esendex.ems.soapinterface")]
    public enum MessageStatusCode {

        Queued,

        Sent,

        Delivered,

        Failed,
    }
}
