/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Web.UI;
using Digita.Tustena.TustenaWebService;

namespace Digita.Tustena.WebGate
{
	public class LeadField
	{
		public string CompanyName;
		public string Name;
		public string Surname;
		public string Title;
		public string Address;
		public string City;
		public string Province;
		public string ZIPCode;
		public string Nation;
		public string VAT;
		public string Email;
		public string Phone;
		public string Fax;
		public string MobilePhone;
		public string Notes;
	}

	public class GetLead : Page
	{
		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				ServiceLeadInsert sl = new ServiceLeadInsert();
				AuthHeader Credentials = new AuthHeader();

				Credentials.UserName = (Request["Tustena_UserName"] != null && Request["Tustena_UserName"].Length > 0) ? Request["Tustena_UserName"] : "";
				Credentials.Password = (Request["Tustena_Password"] != null && Request["Tustena_Password"].Length > 0) ? Request["Tustena_Password"] : "";
				if (Request["CompanyCode"] != null)
					Credentials.CompanyCode = Request["Tustena_CompanyCode"];
				else
					new Exception("CompanyCode missing");

				sl.AuthHeaderValue = Credentials;

				LeadField lf = new LeadField();
				lf.CompanyName = (Request["Tustena_CompanyName"] != null && Request["Tustena_CompanyName"].Length > 0) ? Request["Tustena_CompanyName"] : "";
				lf.Name = (Request["Tustena_Name"] != null && Request["Tustena_Name"].Length > 0) ? Request["Tustena_Name"] : "";
				lf.Surname = (Request["Tustena_Surname"] != null && Request["Tustena_Surname"].Length > 0) ? Request["Tustena_Surname"] : "";
				lf.Title = (Request["Tustena_Title"] != null && Request["Tustena_Title"].Length > 0) ? Request["Tustena_Title"] : "";
				lf.Address = (Request["Tustena_Address"] != null && Request["Tustena_Address"].Length > 0) ? Request["Tustena_Address"] : "";
				lf.City = (Request["Tustena_City"] != null && Request["Tustena_City"].Length > 0) ? Request["Tustena_City"] : "";
				lf.Province = (Request["Tustena_Province"] != null && Request["Tustena_Province"].Length > 0) ? Request["Tustena_Province"] : "";
				lf.ZIPCode = (Request["Tustena_ZIPCode"] != null && Request["Tustena_ZIPCode"].Length > 0) ? Request["Tustena_ZIPCode"] : "";
				lf.Nation = (Request["Tustena_Nation"] != null && Request["Tustena_Nation"].Length > 0) ? Request["Tustena_Nation"] : "";
				lf.VAT = (Request["Tustena_VAT"] != null && Request["Tustena_VAT"].Length > 0) ? Request["Tustena_VAT"] : "";
				lf.Email = (Request["Tustena_Email"] != null && Request["Tustena_Email"].Length > 0) ? Request["Tustena_Email"] : "";
				lf.Phone = (Request["Tustena_Phone"] != null && Request["Tustena_Phone"].Length > 0) ? Request["Tustena_Phone"] : "";
				lf.Fax = (Request["Tustena_Fax"] != null && Request["Tustena_Fax"].Length > 0) ? Request["Tustena_Fax"] : "";
				lf.MobilePhone = (Request["Tustena_MobilePhone"] != null && Request["Tustena_MobilePhone"].Length > 0) ? Request["Tustena_MobilePhone"] : "";
				lf.Notes = (Request["Tustena_Notes"] != null && Request["Tustena_Notes"].Length > 0) ? Request["Tustena_Notes"] : "";

				bool st = sl.StoreLead(lf.Name,
				                       lf.Surname,
				                       lf.CompanyName,
				                       lf.Title,
				                       lf.Address,
				                       lf.City,
				                       lf.Province,
				                       lf.ZIPCode,
				                       lf.Nation,
				                       lf.VAT,
				                       lf.Email,
				                       lf.Phone,
				                       lf.Fax,
				                       lf.MobilePhone,
				                       lf.Notes,
				                       "", "");

				if (st)
					Response.Redirect(Request["Tustena_thankspage"]);
				else
					Response.Write("Write error in webservice");

			}
			catch
			{
				Response.Write("Write error.");
			}
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
		}

		#endregion
	}
}
