/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;
using System.Globalization;
using System.Resources;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.DomValidators;
using Digita.Tustena.Base;
using Digita.Tustena.Database;

namespace Digita.Tustena.WorkingCRM
{
	public delegate void OnSaveActivity(bool saved);

	public class ActivityForm : UserControl
	{
		public event OnSaveActivity OnSaveActivity;

		protected Literal LabelTypeActivity;
		protected RadioButtonList Activity_InOut;
		protected RadioButtonList Activity_ToDo;
		protected CheckBox SendMail;
		protected Literal ActivityID;
		protected TextBox TextboxCompanyID;
		protected TextBox TextboxCompany;
		protected DropDownList DropDownListClassification;
		protected TextBox TextboxContactID;
		protected TextBox TextboxContact;
		protected TextBox TextboxParentID;
		protected TextBox TextboxParent;
		protected TextBox TextboxLeadID;
		protected TextBox TextboxLead;
		protected DropDownList ChildType;
		protected LinkButton ChildAction;
		protected Panel PanelChild;
		protected TextBox TextboxOpportunityID;
		protected TextBox TextboxOpportunity;
		protected TextBox DocumentDescription;
		protected TextBox IDDocument;
		protected LinkButton LinkDocument;
		protected DropDownList DropDownListStatus;
		protected DropDownList DropDownListPriority;
		protected TextBox TextboxObject;
		protected Panel PanelActivity;
		protected HtmlInputText destinationEmail;
		protected HtmlImage IMGAvailability;
		protected CheckBox CheckToBill;
		protected CheckBox CheckCommercial;
		protected CheckBox CheckTechnical;
		protected LinkButton SubmitBtn;
		protected LinkButton SubmitBtnDoc;
		protected HtmlGenericControl Appointmenthours;
		protected TextBox TextBoxDataQuoteExpire;
		protected TextBox Activity_QuoteNumber;
		protected TextBox TextBoxData;
		protected TextBox TextBoxHour;
		protected TextBox TextboxOwnerID;
		protected TextBox TextboxOwner;
		protected TextBox TextboxDescription;
		protected TextBox TextboxDescription2;
		protected TextBox TextBoxDurationM;
		protected TextBox TextBoxDurationH;
		protected DropDownList DropDownListPreAlarm;
		protected TextBox F_StartHour;
		protected TextBox F_EndHour;
		protected TextBox IdCompanion;
		protected TextBox Companion;
		protected Panel PanelOwner;
		protected Panel SecondDescription;
		protected PlaceHolder IMGAvailability_holder;
		protected HtmlTable HourPanel;
		protected HtmlTable tblQuoteStage;
		protected Panel PanelQuoteExpire;
		protected Label LabelData;
		protected Label LabelDescription;
		protected Label LabelDescription2;

		protected HtmlTableRow MoveLog;
		protected PlaceHolder MoveLogTable;

		public DateTimeFormatInfo DBCult = CultureInfo.InvariantCulture.DateTimeFormat; //new CultureInfo("en-US").DateTimeFormat;

		private UserConfig UC = new UserConfig();
		protected DropDownList Activity_QuoteStage;
		protected DropDownList Activity_Document;
		protected LinkButton DocGen;
		protected RequiredDomValidator DataValidator;
		protected RequiredDomValidator StartHourValidator;
		protected RequiredDomValidator EndHourValidator;
		protected Label ActivityInfo;
		protected HtmlGenericControl convertpurchase;
		protected CompareDomValidator CvRecDate;
		public static ResourceManager rm = (ResourceManager) HttpContext.Current.Application["RM"];


		public ActivityForm()
		{
			if (HttpContext.Current.Session.IsNewSession)
				HttpContext.Current.Response.Redirect("/login.aspx");
			UC = (UserConfig) HttpContext.Current.Session["UserConfig"];
		}

		public string GetContactLeadID
		{
			get
			{
				string o = string.Empty;
				if (TextboxContactID.Text.Length > 0)
					o = "C" + TextboxContactID.Text;
				else if (TextboxLeadID.Text.Length > 0)
					o = "L" + TextboxLeadID.Text;

				return o;
			}
		}

		public string Activity
		{
			get
			{
				object o = this.ViewState["_ActivityID" + this.ID];
				if (o == null)
					return null;
				else
					return o.ToString();
			}
			set { this.ViewState["_ActivityID" + this.ID] = value; }
		}

		private void Page_Load(object sender, EventArgs e)
		{
			MoveLog.Visible = false;
			if (!Page.IsPostBack)
			{
				CheckToBill.Text = rm.GetString("Acttxt52");
				CheckCommercial.Text = rm.GetString("Acttxt53");
				CheckTechnical.Text = rm.GetString("Acttxt54");

				Activity_InOut.Items.Add(new ListItem(String.Format("<img src=/i/incoming.gif alt=\"{0}\">", rm.GetString("AcTooltip1")), "1"));
				Activity_InOut.Items.Add(new ListItem(String.Format("<img src=/i/outcoming.gif alt=\"{0}\">", rm.GetString("AcTooltip2")), "0"));
				Activity_InOut.Items[1].Selected = true;

				ChildAction.Text = "<img src=\"/i/newevent.gif\" alt=\"" + rm.GetString("AcTooltip20") + "\" border=0 style=\"cursor:pointer\">";

				Activity_ToDo.Items.Add(new ListItem(rm.GetString("Acttxt71"), "1"));
				Activity_ToDo.Items.Add(new ListItem(rm.GetString("Acttxt72"), "0"));
				Activity_ToDo.Items.Add(new ListItem(rm.GetString("Acttxt103"), "2"));
				Activity_ToDo.RepeatDirection = RepeatDirection.Horizontal;
				Activity_ToDo.RepeatColumns = 3;


				IMGAvailability.Alt = rm.GetString("Evnttxt42");

				SubmitBtn.Text = rm.GetString("Acttxt87");
				SubmitBtnDoc.Text = rm.GetString("Acttxt88");
				if (this.Activity.Length > 0)
					this.FillForm();
			}
		}

		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.SubmitBtn.Click += new EventHandler(this.SubmitBtn_Click);
			this.SubmitBtnDoc.Click += new EventHandler(this.SubmitBtn_Click);
			this.Load += new EventHandler(this.Page_Load);

		}

		#endregion

		public void FillForm()
		{
			ActivityID.Text = Activity;
			DataSet ds = DatabaseConnection.CreateDataset("select * from CRM_Working_View where id=" + Activity);
			DataRow dr = ds.Tables[0].Rows[0];

			ViewAcType((int) dr["type"]);

			if ((int) dr["type"] == 6 && dr["VisitID"] != DBNull.Value)
			{
				try
				{
					DataRow drHours = DatabaseConnection.CreateDataset("select startdate,enddate,SecondUID,UID from base_calendar where id=" + dr["VisitID"].ToString()).Tables[0].Rows[0];
					F_StartHour.Text = UC.LTZ.ToLocalTime(Convert.ToDateTime(drHours["startdate"])).ToShortTimeString();
					F_EndHour.Text = UC.LTZ.ToLocalTime(Convert.ToDateTime(drHours["enddate"])).ToShortTimeString();
					if (drHours["SecondUID"] != drHours["UID"])
					{
						IdCompanion.Text = drHours["SecondUID"].ToString();
						Companion.Text = DatabaseConnection.SqlScalar("select Name+' '+Surname from account where uid=" + drHours["SecondUID"].ToString());
					}
				}
				catch
				{
				}
			}


			TextboxObject.Text = dr["Subject"].ToString();

			Activity_InOut.SelectedIndex = -1;
			if ((bool) dr["InOut"])
				Activity_InOut.SelectedIndex = 0;
			else
				Activity_InOut.SelectedIndex = 1;


			switch (Convert.ToInt32(dr["ToDo"]))
			{
				case 0:
					Activity_ToDo.SelectedIndex = 1;
					break;
				case 1:
					Activity_ToDo.SelectedIndex = 0;
					break;
				case 2:
					Activity_ToDo.SelectedIndex = 2;
					break;
			}


			if ((int) dr["type"] == 6 && Convert.ToInt32(dr["ToDo"]) != 0)
				Appointmenthours.Attributes.Add("style", "display:none");

			TextBoxData.Text = UC.LTZ.ToLocalTime(Convert.ToDateTime(dr["ActivityDate"], UC.myDTFI)).ToShortDateString();
			TextBoxHour.Text = UC.LTZ.ToLocalTime(Convert.ToDateTime(dr["ActivityDate"], UC.myDTFI)).ToShortTimeString();


			DropDownListStatus.SelectedIndex = -1;
			foreach (ListItem li in DropDownListStatus.Items)
			{
				if (li.Value == dr["State"].ToString())
				{
					li.Selected = true;
					break;
				}
			}


			DropDownListPriority.SelectedIndex = -1;
			foreach (ListItem li in DropDownListPriority.Items)
			{
				if (li.Value == dr["Priority"].ToString())
				{
					li.Selected = true;
					break;
				}
			}

			TextboxCompanyID.Text = dr["CompanyID"].ToString();
			TextboxCompany.Text = dr["CompanyName"].ToString();
			TextboxLeadID.Text = dr["LeadID"].ToString();
			TextboxLead.Text = (dr["LeadName"].ToString().Length > 3) ? dr["LeadName"].ToString() : "";
			TextboxOwnerID.Text = dr["OwnerID"].ToString();
			TextboxOwner.Text = dr["OwnerName"].ToString();
			CheckToBill.Checked = (bool) dr["ToBill"];
			CheckCommercial.Checked = (bool) dr["Commercial"];
			CheckTechnical.Checked = (bool) dr["Technical"];


			DropDownListPreAlarm.SelectedIndex = -1;
			foreach (ListItem li in DropDownListPreAlarm.Items)
			{
				if (li.Value == dr["DaysAllarm"].ToString())
				{
					li.Selected = true;
					break;
				}
			}

			TextboxContactID.Text = dr["ReferrerID"].ToString();
			TextboxContact.Text = dr["ContactName"].ToString();

			TextboxOpportunityID.Text = dr["OpportunityID"].ToString();
			TextboxOpportunity.Text = dr["OpportunityDescription"].ToString();


			DropDownListClassification.SelectedIndex = -1;
			foreach (ListItem li in DropDownListClassification.Items)
			{
				if (li.Value == dr["Classification"].ToString())
				{
					li.Selected = true;
					break;
				}
			}

			TextboxParentID.Text = dr["ParentID"].ToString();
			TextboxParent.Text = dr["ParentSubject"].ToString();
			TextboxDescription.Text = dr["Description"].ToString();
			TextboxDescription2.Text = dr["Description2"].ToString();

			if ((int) dr["Duration"] > 0)
			{
				if ((int) dr["Duration"] < 60)
				{
					TextBoxDurationM.Text = dr["Duration"].ToString();
				}
				else
				{
					int dur = (int) dr["Duration"];
					TextBoxDurationH.Text = Convert.ToInt32(dur/60).ToString();
					TextBoxDurationM.Text = Convert.ToInt32(dur%60).ToString();
				}
			}



			if (dr["DocID"] != DBNull.Value)
			{
				DataTable dtDoc = DatabaseConnection.CreateDataset("select FileCrossTables.idfile,filemanager.filename from FileCrossTables left outer join filemanager on FileCrossTables.idfile=filemanager.id where filemanager.id=" + dr["DocID"].ToString()).Tables[0];

				if (dtDoc.Rows.Count > 0)
				{
					((TextBox) Page.FindControl("IDDocument")).Text = dtDoc.Rows[0]["idfile"].ToString();
					DocumentDescription.Text = dtDoc.Rows[0]["filename"].ToString();
				}
				else
				{
					try
					{
						using (DigiDapter dg = new DigiDapter())
						{
							dg.Add("IDFile", dr["DocID"]);
							dg.Add("TableName", "CRM_WorkActivity");
							dg.Add("IDrif", Convert.ToInt64(Activity));

							dg.Execute("FileCrossTables");
						}
						DataTable tDocNew = DatabaseConnection.CreateDataset("select FileCrossTables.idfile,filemanager.filename from FileCrossTables left outer join filemanager on FileCrossTables.idfile=filemanager.id where filemanager.id=" + dr["DocID"].ToString()).Tables[0];
						IDDocument.Text = tDocNew.Rows[0]["idfile"].ToString();
						DocumentDescription.Text = tDocNew.Rows[0]["filename"].ToString();
					}
					catch
					{
					}
				}
			}

			if (IDDocument.Text.Length > 0)
				LinkDocument.Visible = true;
			else
				LinkDocument.Visible = false;


			GetLog(Activity);


		}

		private void GetLog(string id)
		{
			DataTable dtLog = DatabaseConnection.CreateDataset("SELECT MoveDate,ActionType,PrevValue,NextValue, Account.Name+' '+Account.Surname AS OwnerName FROM ActivityMoveLog LEFT OUTER JOIN Account ON ActivityMoveLog.OwnerID = Account.UID where ActivityMoveLog.acId=" + id).Tables[0];
			if (dtLog.Rows.Count > 0)
			{
				Table LogTable = new Table();
				int i = 0;
				LogTable.ID = "LogTable";
				LogTable.Width = Unit.Percentage(100);
				LogTable.Attributes.Add("style", "display:none");
				TableRow trTitle = new TableRow();
				TableCell tdtitle = new TableCell();
				tdtitle.CssClass = "GridTitle";
				tdtitle.Text = StaticFunctions.Capitalize(rm.GetString("Acttxt11"));
				trTitle.Cells.Add(tdtitle);

				tdtitle = new TableCell();
				tdtitle.CssClass = "GridTitle";
				tdtitle.Text = StaticFunctions.Capitalize(rm.GetString("Acttxt110"));
				trTitle.Cells.Add(tdtitle);

				tdtitle = new TableCell();
				tdtitle.CssClass = "GridTitle";
				tdtitle.Text = StaticFunctions.Capitalize(rm.GetString("Acttxt111"));
				trTitle.Cells.Add(tdtitle);

				tdtitle = new TableCell();
				tdtitle.CssClass = "GridTitle";
				tdtitle.Text = StaticFunctions.Capitalize(rm.GetString("Acttxt112"));
				trTitle.Cells.Add(tdtitle);

				tdtitle = new TableCell();
				tdtitle.CssClass = "GridTitle";
				tdtitle.Text = StaticFunctions.Capitalize(rm.GetString("Acttxt113"));
				trTitle.Cells.Add(tdtitle);

				LogTable.Rows.Add(trTitle);
				foreach (DataRow drlog in dtLog.Rows)
				{
					i++;
					TableRow tr = new TableRow();
					for (int cell = 0; cell < 5; cell++)
					{
						TableCell td = new TableCell();
						td.CssClass = ((i%2) == 0) ? "GridItem" : "GridItemAltern";
						switch (cell)
						{
							case 0:
								td.Text = ((DateTime) drlog[0]).ToShortDateString();
								break;
							case 1:
								switch ((ActivityMoveLog) drlog[1])
								{
									case ActivityMoveLog.MoveOwner:
										td.Text = rm.GetString("Acttxt104");
										break;
									case ActivityMoveLog.MoveDate:
										td.Text = rm.GetString("Acttxt105");
										break;
									case ActivityMoveLog.MoveCompany:
										td.Text = rm.GetString("Acttxt106");
										break;
									case ActivityMoveLog.MoveContact:
										td.Text = rm.GetString("Acttxt107");
										break;
									case ActivityMoveLog.MoveLead:
										td.Text = rm.GetString("Acttxt108");
										break;
									case ActivityMoveLog.MoveDone:
										td.Text = rm.GetString("Acttxt109");
										break;
									case ActivityMoveLog.MailSent:
										td.Text = rm.GetString("Acttxt119");
										break;
								}
								break;
							case 2:
								switch ((ActivityMoveLog) drlog[1])
								{
									case ActivityMoveLog.MoveOwner:
										td.Text = DatabaseConnection.SqlScalar("select (isnull(Name,'')+' '+isnull(surname,'')) as AccountName from Account where uid=" + drlog[2].ToString());
										break;
									case ActivityMoveLog.MoveDate:
										DateTime dt;
										if (drlog[2].ToString().Length > 8)
											dt = DateTime.ParseExact((string) drlog[2], @"yyyyMMdd H.mm", null);
										else
											dt = DateTime.ParseExact((string) drlog[2], @"yyyyMMdd", null);
										td.Text = dt.ToString("g");
										break;
									case ActivityMoveLog.MoveCompany:
										td.Text = DatabaseConnection.SqlScalar("select CompanyName from Base_Companies where id=" + drlog[2].ToString());
										break;
									case ActivityMoveLog.MoveContact:
										td.Text = DatabaseConnection.SqlScalar("select (isnull(Name,'')+' '+isnull(surname,'')) as ContactName from Base_Contacts where id=" + drlog[2].ToString());
										break;
									case ActivityMoveLog.MoveLead:
										td.Text = DatabaseConnection.SqlScalar("select (isnull(Name,'')+' '+isnull(surname,'')+' '+isnull(companyname,'')) as LeadName from CRM_Leads where id=" + drlog[2].ToString());
										break;
									case ActivityMoveLog.MoveDone:
										switch (drlog[2].ToString())
										{
											case "0":
												td.Text = rm.GetString("Acttxt72");
												break;
											case "1":
												td.Text = rm.GetString("Acttxt71");
												break;
											case "2":
												td.Text = rm.GetString("Acttxt103");
												break;
										}
										break;
									case ActivityMoveLog.MailSent:
										td.Text = drlog[2].ToString();
										break;
								}

								break;
							case 3:
								switch ((ActivityMoveLog) drlog[1])
								{
									case ActivityMoveLog.MoveOwner:
										td.Text = DatabaseConnection.SqlScalar("select (isnull(Name,'')+' '+isnull(surname,'')) as AccountName from Account where uid=" + drlog[3].ToString());
										break;
									case ActivityMoveLog.MoveDate:

										DateTime dt;
										if (drlog[3].ToString().Length > 8)
											dt = DateTime.ParseExact((string) drlog[3], @"yyyyMMdd H.mm", null);
										else
											dt = DateTime.ParseExact((string) drlog[3], @"yyyyMMdd", null);

										td.Text = dt.ToString("g");
										break;
									case ActivityMoveLog.MoveCompany:
										td.Text = DatabaseConnection.SqlScalar("select CompanyName from Base_Companies where id=" + drlog[3].ToString());
										break;
									case ActivityMoveLog.MoveContact:
										td.Text = DatabaseConnection.SqlScalar("select (isnull(Name,'')+' '+isnull(surname,'')) as ContactName from Base_Contacts where id=" + drlog[3].ToString());
										break;
									case ActivityMoveLog.MoveLead:
										td.Text = DatabaseConnection.SqlScalar("select (isnull(Name,'')+' '+isnull(surname,'')+' '+isnull(companyname,'')) as LeadName from CRM_Leads where id=" + drlog[3].ToString());
										break;
									case ActivityMoveLog.MoveDone:
										switch (drlog[3].ToString())
										{
											case "0":
												td.Text = rm.GetString("Acttxt72");
												break;
											case "1":
												td.Text = rm.GetString("Acttxt71");
												break;
											case "2":
												td.Text = rm.GetString("Acttxt103");
												break;
										}
										break;
									case ActivityMoveLog.MailSent:
										td.Text = drlog[3].ToString();
										break;
								}
								break;
							case 4:
								td.Text = drlog[4].ToString();
								break;
						}
						tr.Cells.Add(td);
					}
					LogTable.Rows.Add(tr);
				}
				MoveLogTable.Controls.Add(LogTable);
				MoveLogTable.EnableViewState = false;
				MoveLog.Visible = true;
			}

		}

		private void ViewAcType(int type)
		{
			LabelTypeActivity.Text = type.ToString();
			switch (type)
			{
				case (int) ActivityTypeN.PhoneCall:
					FillDropDown("1");
					PanelOwner.Visible = true;
					CheckToBill.Visible = true;
					CheckCommercial.Visible = true;
					CheckTechnical.Visible = true;
					SecondDescription.Visible = false;
					LabelData.Text = rm.GetString("Acttxt38");
					LabelDescription.Text = rm.GetString("Acttxt86");

					IMGAvailability_holder.Visible = false;
					Appointmenthours.Visible = false;
					HourPanel.Visible = true;
					PanelQuoteExpire.Visible = false;
					tblQuoteStage.Visible = false;
					break;
				case (int) ActivityTypeN.Letter:
					FillDropDown("2");
					PanelOwner.Visible = true;
					CheckToBill.Visible = true;
					CheckCommercial.Visible = true;
					CheckTechnical.Visible = true;
					SecondDescription.Visible = false;
					LabelData.Text = rm.GetString("Acttxt38");
					LabelDescription.Text = rm.GetString("Acttxt86");

					IMGAvailability_holder.Visible = false;
					Appointmenthours.Visible = false;
					HourPanel.Visible = true;
					PanelQuoteExpire.Visible = false;
					tblQuoteStage.Visible = false;
					break;
				case (int) ActivityTypeN.Fax:
					FillDropDown("3");
					PanelOwner.Visible = true;
					CheckToBill.Visible = true;
					CheckCommercial.Visible = true;
					CheckTechnical.Visible = true;
					SecondDescription.Visible = false;
					LabelData.Text = rm.GetString("Acttxt38");
					LabelDescription.Text = rm.GetString("Acttxt86");

					IMGAvailability_holder.Visible = false;
					Appointmenthours.Visible = false;
					HourPanel.Visible = true;
					PanelQuoteExpire.Visible = false;
					tblQuoteStage.Visible = false;
					break;
				case (int) ActivityTypeN.Memo:
					FillDropDown("4");
					PanelOwner.Visible = true;
					CheckToBill.Visible = false;
					CheckCommercial.Visible = false;
					CheckTechnical.Visible = false;
					SecondDescription.Visible = false;
					LabelData.Text = rm.GetString("Acttxt38");
					LabelDescription.Text = rm.GetString("Acttxt86");

					IMGAvailability_holder.Visible = false;
					Appointmenthours.Visible = false;
					HourPanel.Visible = true;
					PanelQuoteExpire.Visible = false;
					tblQuoteStage.Visible = false;
					break;
				case (int) ActivityTypeN.Email:
					FillDropDown("5");
					PanelOwner.Visible = true;
					CheckToBill.Visible = true;
					CheckCommercial.Visible = true;
					CheckTechnical.Visible = true;
					SecondDescription.Visible = false;

					LabelData.Text = rm.GetString("Acttxt38");
					LabelDescription.Text = rm.GetString("Acttxt86");

					IMGAvailability.Visible = false;
					Appointmenthours.Visible = false;
					HourPanel.Visible = true;
					PanelQuoteExpire.Visible = false;
					tblQuoteStage.Visible = false;
					break;
				case (int) ActivityTypeN.Visit:
					FillDropDown("6");
					PanelOwner.Visible = true;
					CheckToBill.Visible = true;
					CheckCommercial.Visible = true;
					CheckTechnical.Visible = true;
					SecondDescription.Visible = false;
					LabelData.Text = rm.GetString("Acttxt38");
					LabelDescription.Text = rm.GetString("Acttxt86");

					IMGAvailability_holder.Visible = true;
					IMGAvailability.Visible = true;
					Appointmenthours.Visible = true;
					HourPanel.Visible = false;
					Activity_ToDo.Attributes.Add("onclick", "ActivateHours()");
					PanelQuoteExpire.Visible = false;
					tblQuoteStage.Visible = false;
					break;
				case (int) ActivityTypeN.Generic:
					FillDropDown("7");
					PanelOwner.Visible = true;
					CheckToBill.Visible = true;
					CheckCommercial.Visible = true;
					CheckTechnical.Visible = true;
					SecondDescription.Visible = false;
					LabelData.Text = rm.GetString("Acttxt74");
					LabelDescription.Text = rm.GetString("Acttxt86");

					IMGAvailability.Visible = false;
					Appointmenthours.Visible = false;
					HourPanel.Visible = true;
					PanelQuoteExpire.Visible = false;
					tblQuoteStage.Visible = false;
					break;
				case (int) ActivityTypeN.CaseSolution:
					FillDropDown("8");
					PanelOwner.Visible = true;
					CheckToBill.Visible = true;
					CheckCommercial.Visible = false;
					CheckTechnical.Visible = false;
					LabelData.Text = rm.GetString("Acttxt38");
					LabelDescription.Text = rm.GetString("Acttxt75");
					LabelDescription2.Text = rm.GetString("Acttxt76");
					SecondDescription.Visible = true;

					IMGAvailability_holder.Visible = false;
					Appointmenthours.Visible = false;
					HourPanel.Visible = true;
					PanelQuoteExpire.Visible = false;
					tblQuoteStage.Visible = false;
					break;
				case (int) ActivityTypeN.Quote:
					FillDropDown("8");
					PanelOwner.Visible = true;
					CheckToBill.Visible = false;
					CheckCommercial.Visible = false;
					CheckTechnical.Visible = false;
					LabelData.Text = rm.GetString("Acttxt38");
					LabelDescription.Text = rm.GetString("Acttxt75");
					LabelDescription2.Text = rm.GetString("Acttxt76");
					SecondDescription.Visible = false;

					IMGAvailability_holder.Visible = false;
					Appointmenthours.Visible = false;
					HourPanel.Visible = false;

					PanelQuoteExpire.Visible = true;
					tblQuoteStage.Visible = true;

					break;
			}

		}

		protected void FillDropDown(string a)
		{
			DropDownList dp = DropDownListStatus;
			dp.Items.Clear();
			dp.Items.Add(new ListItem(rm.GetString("Wortxt0"), "0"));
			dp.Items.Add(new ListItem(rm.GetString("Wortxt1"), "1"));
			dp.Items.Add(new ListItem(rm.GetString("Wortxt2"), "2"));
			dp.Items[0].Selected = true;
			dp = DropDownListPriority;
			dp.Items.Clear();
			dp.Items.Add(new ListItem(rm.GetString("Wortxt3"), "0"));
			dp.Items.Add(new ListItem(rm.GetString("Wortxt4"), "1"));
			dp.Items.Add(new ListItem(rm.GetString("Wortxt5"), "2"));
			dp.Items[0].Selected = true;
			dp = DropDownListClassification;
			dp.Items.Clear();
			DataSet wc = DatabaseConnection.CreateDataset("select ID,Description from CRMWorkingClassification where type=" + a + " and lang='" + UC.Culture.Substring(0, 2) + "' order by DropPosition");
			if (wc.Tables[0].Rows.Count > 0)
			{
				dp.DataTextField = "Description";
				dp.DataValueField = "ID";
				dp.DataSource = wc;
				dp.DataBind();
				dp.Items[0].Selected = true;
			}

			dp = DropDownListPreAlarm;
			dp.Items.Clear();
			for (int i = 0; i < 6; i++)
			{
				dp.Items.Add(new ListItem(i.ToString() + " " + rm.GetString("Acttxt124"), i.ToString()));
			}
			dp.Items[0].Selected = true;


		}

		private bool SaveActivity(string sender)
		{
			string newId = ActivityID.Text;
			string modified1 = ModifyActivity(int.Parse(LabelTypeActivity.Text), int.Parse(newId));

			if (newId != ActivityID.Text)
				newId = ActivityID.Text;

			if (IDDocument.Text.Length > 0)
				LinkDocument.Visible = true;
			else
				LinkDocument.Visible = false;

			bool modified = true;
			if (modified1 == "0")
				ActivityInfo.Text = rm.GetString("Acttxt92");
			else
			{
				modified = false;
				if (modified1 == "1")
					ActivityInfo.Text = rm.GetString("Acttxt93");
				else
					ActivityInfo.Text = modified1;
			}

			if (modified)
			{
				if (Activity_ToDo.SelectedIndex == 0)
				{
					DateTime activityDate = UC.LTZ.ToUniversalTime(Convert.ToDateTime(TextBoxData.Text, UC.myDTFI));
					if (TextboxCompanyID.Text.Length > 0)
						InsertLastContact(TextboxCompanyID.Text, 0, activityDate);
					if (TextboxContactID.Text.Length > 0)
						InsertLastContact(TextboxContactID.Text, 1, activityDate);
					if (TextboxLeadID.Text.Length > 0)
						InsertLastContact(TextboxLeadID.Text, 2, activityDate);
				}
				if (LabelTypeActivity.Text == "6")
				{
					if (Activity_ToDo.Items[1].Selected)
					{
						DataRow dract = DatabaseConnection.CreateDataset("select * from CRM_WorkActivity where id=" + newId).Tables[0].Rows[0];
						string appId = AppointmentUpdate((dract["VisitID"] == DBNull.Value) ? "-1" : dract["VisitID"].ToString(),
						                                 dract["OwnerID"].ToString(),
						                                 TextBoxData.Text,
						                                 F_StartHour.Text,
						                                 F_EndHour.Text,
						                                 TextboxContact.Text,
						                                 TextboxContactID.Text,
						                                 TextboxCompany.Text,
						                                 TextboxCompanyID.Text,
						                                 TextboxObject.Text,
						                                 (dract["VisitID"] == DBNull.Value) ? "-1" : dract["VisitID"].ToString());
						DatabaseConnection.DoCommand("update CRM_WorkActivity set VisitID='" + appId + "' where id='" + newId + "'");
						if (IdCompanion.Text.Length > 0)
						{
							string newAppId = DatabaseConnection.SqlScalar("select SencondIDOwner from base_calendar where id=" + appId);
							if (newAppId.Length <= 0) newAppId = "-1";
							string crossId = AppointmentUpdate(newAppId,
							                                   IdCompanion.Text,
							                                   TextBoxData.Text,
							                                   F_StartHour.Text,
							                                   F_EndHour.Text,
							                                   TextboxContact.Text,
							                                   TextboxContactID.Text,
							                                   TextboxCompany.Text,
							                                   TextboxCompanyID.Text,
							                                   TextboxObject.Text,
							                                   appId);
							DatabaseConnection.DoCommand("update base_calendar set SencondIDOwner=" + crossId + " where id=" + appId);
						}
					}
				}



			}


			if (TextboxOpportunityID.Text.Length > 0)
			{
				if (TextboxCompanyID.Text.Length > 0)
				{
					int checkCross = Convert.ToInt32(DatabaseConnection.SqlScalar(string.Format("select count(*) from CRM_OpportunityContact where ContactType=0 and ContactID = {0} and OpportunityID = {1};", TextboxCompanyID.Text, TextboxOpportunityID.Text)));
					if (checkCross <= 0)
					{
						InsertNewOpportunity(TextboxOpportunityID.Text, TextboxCompanyID.Text, "0");
					}
				}
				if (TextboxLeadID.Text.Length > 0)
				{
					int checkCross = Convert.ToInt32(DatabaseConnection.SqlScalar(string.Format("select count(*) from CRM_OpportunityContact where ContactType=1 and ContactID = {0} and OpportunityID = {1};", TextboxLeadID.Text, TextboxOpportunityID.Text)));
					if (checkCross <= 0)
					{
						InsertNewOpportunity(TextboxOpportunityID.Text, TextboxLeadID.Text, "1");
					}
				}
			}

			if (SendMail.Checked && destinationEmail.Value.Length > 0)
			{
				string notifyEmail = DatabaseConnection.SqlScalar("select notifyEmail from account where uid=" + UC.UserId);
				MessagesHandler.SendMail(destinationEmail.Value,
				                         (notifyEmail.Length > 0) ? notifyEmail : UC.UserName,
				                         TextboxObject.Text,
				                         TextboxDescription.Text);
			}

			GetLog(newId);

			return modified;
		}

		protected virtual string ModifyActivity(int a, int id)
		{
			{
				bool PageValid = true;
				string errorCode = String.Empty;
				if (Activity_ToDo.Items[1].Selected && a == 6)
				{
					if (!StartHourValidator.IsValid ||
						!EndHourValidator.IsValid)
					{
						PageValid = false;
						errorCode = "1";
					}
				}
				if (!DataValidator.IsValid)
				{
					PageValid = false;
					errorCode += "2";
				}

				if (TextboxObject.Text.Length <= 0)
				{
					PageValid = false;
					errorCode += "3";
				}

				if (PageValid &&
					(TextboxCompanyID.Text.Length > 0 ||
						TextboxContactID.Text.Length > 0 ||
						TextboxLeadID.Text.Length > 0))
				{
					DigiDapter dg = new DigiDapter();

					dg.Add("Type", a, 'I');
					dg.Add("CreatedDate", DateTime.UtcNow, 'I');
					dg.Add("CreatedByID", UC.UserId, 'I');


					dg.Add("OwnerID", TextboxOwnerID.Text);

					if (TextboxCompanyID.Text.Length > 0)
						dg.Add("CompanyID", TextboxCompanyID.Text);
					else
						dg.Add("CompanyID", DBNull.Value);

					if (TextboxContactID.Text.Length > 0)
						dg.Add("ReferrerID", TextboxContactID.Text);
					else
						dg.Add("ReferrerID", DBNull.Value);

					if (TextboxLeadID.Text.Length > 0)
						dg.Add("LeadID", TextboxLeadID.Text);
					else
						dg.Add("LeadID", DBNull.Value);

					if (TextboxOpportunityID.Text.Length > 0)
						if (DatabaseConnection.SqlScalar("select count(id) from crm_Opportunity where id=" + TextboxOpportunityID.Text) != "0")
							dg.Add("OpportunityID", TextboxOpportunityID.Text);
						else
							dg.Add("OpportunityID", DBNull.Value);
					else
						dg.Add("OpportunityID", DBNull.Value);

					if (IDDocument.Text.Length > 0)
						dg.Add("DocID", IDDocument.Text);
					else
						dg.Add("DocID", DBNull.Value);

					dg.Add("Subject", TextboxObject.Text);
					dg.Add("Description", TextboxDescription.Text);
					dg.Add("Description2", TextboxDescription2.Text);

					dg.Add("Groups", "|" + UC.UserGroupId.ToString() + "|");
					dg.Add("LastModifiedDate", DateTime.UtcNow);
					dg.Add("LastModifiedByID", UC.UserId.ToString());
					dg.Add("InOut", (Activity_InOut.SelectedValue == "1") ? true : false);
					dg.Add("ToDo", Activity_ToDo.SelectedValue);

					if (F_StartHour.Text.Length > 0)
						TextBoxHour.Text = F_StartHour.Text;


					dg.Add("ActivityDate", UC.LTZ.ToUniversalTime(Convert.ToDateTime(TextBoxData.Text + " " + TextBoxHour.Text, UC.myDTFI)));
					if (DropDownListClassification.SelectedIndex != -1)
						dg.Add("Classification", DropDownListClassification.SelectedValue);
					if (TextboxParentID.Text.Length > 0)
						dg.Add("ParentID", TextboxParentID.Text);
					else
						dg.Add("ParentID", 0);
					dg.Add("State", DropDownListStatus.SelectedValue);
					dg.Add("Priority", DropDownListPriority.SelectedValue);

					dg.Add("ToBill", CheckToBill.Checked);
					dg.Add("Commercial", CheckCommercial.Checked);
					dg.Add("Technical", CheckTechnical.Checked);

					if (DropDownListPreAlarm.SelectedIndex > 0)
					{
						dg.Add("Allarm", UC.LTZ.ToUniversalTime(Convert.ToDateTime(TextBoxData.Text, UC.myDTFI)));
						dg.Add("DaysAllarm", DropDownListPreAlarm.SelectedValue);
					}

					int duration = 0;
					if (TextBoxDurationH.Text.Length > 0)
					{
						try
						{
							duration += Convert.ToInt32(TextBoxDurationH.Text)*60;
						}
						catch
						{
							duration += 0;
						}
					}

					if (TextBoxDurationM.Text.Length > 0)
					{
						try
						{
							duration += Convert.ToInt32(TextBoxDurationM.Text);
						}
						catch
						{
							duration += 0;
						}
					}
					dg.Add("Duration", duration);

					dg.Execute("CRM_WorkActivity", "ID=" + id, DigiDapter.Identities.Row);

					DataRow myDataRow = dg.GetNewRow;
					DataRow oldData = dg.GetOriginalRow;

					if (SendMail.Checked && destinationEmail.Value.Length > 0)
					{
						if (dg.RecordInserted)
							DatabaseConnection.DoCommand("INSERT INTO ActivityMoveLog (acId, ActionType, PrevValue, NextValue, MoveDate, OwnerID) VALUES   ('" + myDataRow["ID"].ToString() + "', " + (byte) ActivityMoveLog.MailSent + ", '" + UC.UserName + "', '" + destinationEmail.Value + "', getdate(), '" + UC.UserId + "')");
						else
							DatabaseConnection.DoCommand("INSERT INTO ActivityMoveLog (acId, ActionType, PrevValue, NextValue, MoveDate, OwnerID) VALUES   (" + id + ", " + (byte) ActivityMoveLog.MailSent + ", '" + UC.UserName + "', '" + destinationEmail.Value + "', getdate(), '" + UC.UserId + "')");
					}


					ActivityID.Text = myDataRow["ID"].ToString();
					string newId = myDataRow["ID"].ToString();
					if (Activity_ToDo.SelectedValue == "0" || DropDownListPreAlarm.SelectedValue.Length > 0)
						ModifyReminderActivity(newId, TextBoxData.Text);

					if (dg.RecordInserted)
					{
						string oId = TextboxOwnerID.Text;
						if (TextboxCompanyID.Text.Length > 0)
						{
							string acId = DatabaseConnection.SqlScalar("select id from LastContact where TableID=0 and Account=" + oId + " and CrossID=" + TextboxCompanyID.Text);
							if (acId.Length > 0)
								DatabaseConnection.DoCommand("update LastContact set ActivityID=" + newId + ",ActivityDate=getdate() where ID=" + acId);
							else
								DatabaseConnection.DoCommand("insert into LastContact (Account,ActivityID,CrossID,TableID) values (" + oId + "," + newId + "," + TextboxCompanyID.Text + ",0)");
						}
						if (TextboxContactID.Text.Length > 0)
						{
							string acId = DatabaseConnection.SqlScalar("select id from LastContact where TableID=1 and Account=" + oId + " and CrossID=" + TextboxContactID.Text);
							if (acId.Length > 0)
								DatabaseConnection.DoCommand("update LastContact set ActivityID=" + newId + ",ActivityDate=getdate() where ID=" + acId);
							else
								DatabaseConnection.DoCommand("insert into LastContact (Account,ActivityID,CrossID,TableID) values (" + oId + "," + newId + "," + TextboxContactID.Text + ",1)");
						}
						if (TextboxLeadID.Text.Length > 0)
						{
							string acId = DatabaseConnection.SqlScalar("select id from LastContact where TableID=2 and Account=" + oId + " and CrossID=" + TextboxLeadID.Text);
							if (acId.Length > 0)
								DatabaseConnection.DoCommand("update LastContact set ActivityID=" + newId + ",ActivityDate=getdate() where ID=" + acId);
							else
								DatabaseConnection.DoCommand("insert into LastContact (Account,ActivityID,CrossID,TableID) values (" + oId + "," + newId + "," + TextboxLeadID.Text + ",2)");
						}
					}

					if (Activity_ToDo.Items[0].Selected && a == 6)
						Appointmenthours.Attributes.Add("style", "display:none");


					if (dg.recordUpdated)
					{
						if (oldData["OwnerID"].ToString() != myDataRow["OwnerID"].ToString())
							DatabaseConnection.DoCommand("INSERT INTO ActivityMoveLog (acId, ActionType, PrevValue, NextValue, MoveDate, OwnerID) VALUES   (" + id + ", " + (byte) ActivityMoveLog.MoveOwner + ", '" + oldData["OwnerID"].ToString() + "', '" + myDataRow["OwnerID"].ToString() + "', getdate(), '" + UC.UserId + "')");

						if (oldData["ActivityDate"].ToString() != myDataRow["ActivityDate"].ToString())
							DatabaseConnection.DoCommand("INSERT INTO ActivityMoveLog (acId, ActionType, PrevValue, NextValue, MoveDate, OwnerID) VALUES   (" + id + ", " + (byte) ActivityMoveLog.MoveDate + ", '" + (UC.LTZ.ToLocalTime((DateTime) oldData["ActivityDate"])).ToString(@"yyyyMMdd H.mm") + "', '" + (UC.LTZ.ToLocalTime((DateTime) myDataRow["ActivityDate"])).ToString(@"yyyyMMdd H.mm") + "', getdate(), '" + UC.UserId + "')");

						if (oldData["CompanyID"].ToString() != myDataRow["CompanyID"].ToString())
							DatabaseConnection.DoCommand("INSERT INTO ActivityMoveLog (acId, ActionType, PrevValue, NextValue, MoveDate, OwnerID) VALUES   (" + id + ", " + (byte) ActivityMoveLog.MoveCompany + ", '" + oldData["CompanyID"].ToString() + "', '" + myDataRow["CompanyID"].ToString() + "', getdate(), '" + UC.UserId + "')");

						if (oldData["ReferrerID"].ToString() != myDataRow["ReferrerID"].ToString())
							DatabaseConnection.DoCommand("INSERT INTO ActivityMoveLog (acId, ActionType, PrevValue, NextValue, MoveDate, OwnerID) VALUES   (" + id + ", " + (byte) ActivityMoveLog.MoveContact + ", '" + oldData["ReferrerID"].ToString() + "', '" + myDataRow["ReferrerID"].ToString() + "', getdate(), '" + UC.UserId + "')");

						if (oldData["LeadID"].ToString() != myDataRow["LeadID"].ToString())
							DatabaseConnection.DoCommand("INSERT INTO ActivityMoveLog (acId, ActionType, PrevValue, NextValue, MoveDate, OwnerID) VALUES   (" + id + ", " + (byte) ActivityMoveLog.MoveLead + ", '" + oldData["LeadID"].ToString() + "', '" + myDataRow["LeadID"].ToString() + "', getdate(), '" + UC.UserId + "')");

						if (oldData["ToDo"].ToString() != myDataRow["ToDo"].ToString())
							DatabaseConnection.DoCommand("INSERT INTO ActivityMoveLog (acId, ActionType, PrevValue, NextValue, MoveDate, OwnerID) VALUES   (" + id + ", " + (byte) ActivityMoveLog.MoveDone + ", '" + oldData["ToDo"].ToString() + "', '" + myDataRow["ToDo"].ToString() + "', getdate(), '" + UC.UserId + "')");
					}

					return "0";
				}
				else
				{
					string error = String.Empty;
					if (errorCode.IndexOf("1") > 0 || errorCode.IndexOf("2") > 0)
						error += rm.GetString("Acttxt101") + "<br>";

					if (!(TextboxObject.Text.Length > 0))
						error += rm.GetString("Acttxt100") + "<br>";

					if (!(TextboxCompanyID.Text.Length > 0) &&
						!(TextboxContactID.Text.Length > 0))
						error += rm.GetString("Acttxt102") + "<br>";

					if (Activity_ToDo.Items[0].Selected && a == 6)
						Appointmenthours.Attributes.Add("style", "display:none");

					return error;
				}
			}
		}

		private void ModifyReminderActivity(string id, string data)
		{
			using (DigiDapter dg = new DigiDapter())
			{
				dg.Add("OwnerID", TextboxOwnerID.Text, 'I');
				dg.Add("K_ID", id);
				dg.Add("TableName", "CRM_WorkActivity", 'I');

				dg.Add("ReminderDate", UC.LTZ.ToUniversalTime(Convert.ToDateTime(data, UC.myDTFI)));
				dg.Add("Note", TextboxObject.Text);
				dg.Add("AdvanceRemind", (DropDownListPreAlarm.SelectedValue.Length > 0) ? DropDownListPreAlarm.SelectedValue : "0");
				dg.Execute("CRM_Reminder", "K_ID =" + id + " and TableName='CRM_WorkActivity' and OwnerID=" + int.Parse(TextboxOwnerID.Text));
			}
		}

		public void InsertNewOpportunity(string opid, string id, string type)
		{
			StringBuilder sqlString = new StringBuilder();

			sqlString.AppendFormat("select * from CRM_OpportunityContact where id=-1");
			using (DigiDapter dg = new DigiDapter())
			{

				dg.Add("OpportunityID", opid);
				dg.Add("ContactID", id);
				dg.Add("ContactType", type);

				dg.Add("ExpectedRevenue", 0);
				dg.Add("AmountClosed", 0);
				dg.Add("IncomeProbability", 0);


				dg.Add("Note", String.Empty);
				dg.Add("StartDate", DateTime.Now);
				dg.Add("EstimatedCloseDate", DateTime.Now.AddDays(Convert.ToDouble(DatabaseConnection.SqlScalar("select top 1 EstimatedDateDays from Tustena_Data"))));

				dg.Add("EndDate", DBNull.Value);

				dg.Add("SalesPerson", TextboxOwnerID.Text);

				dg.Add("CreatedByID", UC.UserId);
				dg.Add("CreatedDate", UC.LTZ.ToUniversalTime(DateTime.Now));
				dg.Add("LastModifiedByID", UC.UserId);
				dg.Add("LastModifiedDate", UC.LTZ.ToUniversalTime(DateTime.Now));
				dg.Execute("CRM_OpportunityContact");
			}
			DataTable dtCross = DatabaseConnection.CreateDataset("select competitorid from CRM_OpportunityCompetitor where opportunityid=" + opid).Tables[0];
			foreach (DataRow dr in dtCross.Rows)
			{
				if (Convert.ToInt32(DatabaseConnection.SqlScalar("select count(*) from CRM_CrossContactCompetitor where contacttype=" + type + " and CompetitorID=" + dr[0].ToString() + " and ContactID=" + id)) == 0)
				{
					DatabaseConnection.DoCommand("insert into CRM_CrossContactCompetitor (competitorid,contactid,contacttype) values (" + dr[0].ToString() + "," + id + "," + type + ")");
				}
			}
		}

		internal string AppointmentUpdate(string appId,
		                                  string uID,
		                                  string dt,
		                                  string fromhour,
		                                  string tohour,
		                                  string contactname,
		                                  string contactID,
		                                  string companyname,
		                                  string companyID,
		                                  string note,
		                                  string newId)
		{
			object InsertedID;
			DigiDapter dg = new DigiDapter();
			dg.Add("UID", uID);
			dg.Add("UIDINS", UC.UserId);
			dg.Add("StartDate", UC.LTZ.ToUniversalTime(Convert.ToDateTime(dt + " " + fromhour, UC.myDTFI)));
			dg.Add("ENDDATE", UC.LTZ.ToUniversalTime(Convert.ToDateTime(dt + " " + tohour, UC.myDTFI)));
			dg.Add("CONTACT", contactname);
			dg.Add("Company", companyname);
			if (companyID.Length > 0) dg.Add("CompanyID", companyID);
			if (contactID.Length > 0) dg.Add("ContactID", contactID);


			dg.Add("Note", note);
			if (appId == newId)
				dg.Where = "id=" + appId;
			else
				dg.Where = "uid=" + uID + " and SencondIDOwner=" + newId;

			if (IdCompanion.Text.Length > 0)
			{
				if (uID == IdCompanion.Text)
					dg.Add("SecondUID", uID);
				else
					dg.Add("SecondUID", IdCompanion.Text);
			}
			if (appId != newId)
				dg.Add("SencondIDOwner", newId);

			InsertedID = dg.Execute("BASE_CALENDAR", DigiDapter.Identities.Identity);

			if (appId == "-1") appId = InsertedID.ToString();

			return appId;


		}

		private void InsertLastContact(string iD, byte type, DateTime data)
		{
			string tb = String.Empty;
			switch (type)
			{
				case 0:
					tb = "Base_Companies";
					break;
				case 1:
					tb = "Base_Contacts";
					break;
				case 2:
					tb = "crm_leads";
					break;
			}

			try
			{
				DateTime oldDate = Convert.ToDateTime(DatabaseConnection.SqlScalar("select lastcontact from " + tb + " where id=" + iD));
				if (oldDate < data)
					DatabaseConnection.DoCommand("update " + tb + " set lastcontact='" + data.ToString(@"yyyyMMdd") + "' where id=" + iD);
			}
			catch
			{
				DatabaseConnection.DoCommand("update " + tb + " set lastcontact=getdate() where id=" + iD);
			}
		}

		private void SubmitBtn_Click(object sender, EventArgs e)
		{
			bool saved = SaveActivity(((LinkButton) sender).ID);
			if (saved)
				this.OnSaveActivity(true);

		}
	}
}
