/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Digita.Tustena.Database;
using Digita.Tustena.WorkingCRM;

namespace Digita.Tustena
{
	public class qactivity : G
	{
		protected Repeater RepeaterActivityDay;
		protected Label LitRepeaterActivityDayInfo;

		private void Page_Load(object sender, EventArgs e)
		{

			if (!Login())
			{
				Page.RegisterStartupScript("nologin","<script>parent.location.href=parent.location.href;</script>");
			}
			else
			{
				Response.Cache.SetCacheability(HttpCacheability.NoCache);
				if(!Page.IsPostBack)
				{
					if(Request["Action"]!=null && Request["Action"].Length>0)
						SwitchAction(Request["Action"]);
				}
			}
		}

		private void SwitchAction(string action)
		{
			int contactID=0;
			int leadId=0;
			int companyID=0;
			QuickLog ql = new QuickLog();
			if(Request["contactID"]!=null && Request["contactID"].Length>0)
					{
						switch(Request["contactID"].Substring(0,1))
						{
							case "C":
								contactID = int.Parse(Request["contactID"].Substring(1));
								ql.InsertLog(0,contactID,(long)UC.UserId);
								break;
							case "L":
								leadId = int.Parse(Request["contactID"].Substring(1));
								ql.InsertLog(1,leadId,(long)UC.UserId);
								break;
							case "A":
								companyID = int.Parse(Request["contactID"].Substring(1));
								ql.InsertLog(2,companyID,(long)UC.UserId);
								break;
						}
					}
			switch(action)
			{
				case "ViewActivity":
					if(Request["contactID"]!=null && Request["contactID"].Length>0)
					{
						FillRepeaterActivityDayFromSearch(Request["contactID"]);
					}
					break;
				case "PhoneIn":
					InsertQuickActivity((int)ActivityTypeN.PhoneCall,contactID,leadId,companyID,rm.GetString("Quicktxt1"),true);
					FillRepeaterActivityDayFromSearch(Request["contactID"],"CreatedDate");
					break;
				case "PhoneOut":
					InsertQuickActivity((int)ActivityTypeN.PhoneCall,contactID,leadId,companyID,rm.GetString("Quicktxt2"),false);
					FillRepeaterActivityDayFromSearch(Request["contactID"],"CreatedDate");
					break;
				case "Fax":
					InsertQuickActivity((int)ActivityTypeN.Fax,contactID,leadId,companyID,rm.GetString("Quicktxt3"),false);
					FillRepeaterActivityDayFromSearch(Request["contactID"],"CreatedDate");
					break;
				case "Letter":
					InsertQuickActivity((int)ActivityTypeN.Letter,contactID,leadId,companyID,rm.GetString("Quicktxt4"),false);
					FillRepeaterActivityDayFromSearch(Request["contactID"],"CreatedDate");
					break;
				case "Generic":
					InsertQuickActivity((int)ActivityTypeN.Generic,contactID,leadId,companyID,rm.GetString("Quicktxt5"),false);
					FillRepeaterActivityDayFromSearch(Request["contactID"],"CreatedDate");
					break;
				case "TodayActivity":
					FillRepeaterActivityDay(true);
					break;
				case "TodoActivity":
					FillRepeaterActivityLost(true);
					break;
			}
			Page.RegisterStartupScript("log","<script>refreshlog();</script>");
		}

		private void FillRepeaterActivityLost(bool onlyMy)
		{
			DateTime today = new DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day,0,0,0);
			DataTable dtA = new DataTable();

			if(!onlyMy)
			{
				dtA = DatabaseConnection.CreateDataset("select top 10 * from CRM_WorkActivitySearch_View where ToDo=0 and ActivityDate< '"+UC.LTZ.ToUniversalTime(today).ToString(@"yyyyMMdd HH.mm.ss").Replace('.',':')+"' and (("+GroupsSecure()+") or OwnerID="+UC.UserId+") order by ActivityDate").Tables[0];
			}
			else
			{
				dtA = DatabaseConnection.CreateDataset("select top 10 * from CRM_WorkActivitySearch_View where ToDo=0 and ActivityDate< '"+UC.LTZ.ToUniversalTime(today).ToString(@"yyyyMMdd HH.mm.ss").Replace('.',':')+"' and (OwnerID=" + UC.UserId + ") order by ActivityDate").Tables[0];
			}
			if(dtA.Rows.Count>0)
			{
				RepeaterActivityDay.DataSource = dtA;
				RepeaterActivityDay.DataBind();
				LitRepeaterActivityDayInfo.Visible=false;
			}
			else
			{
				LitRepeaterActivityDayInfo.Text=rm.GetString("Acttxt40");
				LitRepeaterActivityDayInfo.Visible=true;
				RepeaterActivityDay.Visible=false;
			}
		}

		private void InsertQuickActivity(int type, int contactID, int leadId, int companyID, string subject, bool inOut)
		{
			ActivityInsert ai = new ActivityInsert();
			ai.InsertActivity(type.ToString(), string.Empty, UC.UserId.ToString(), (contactID==0)?string.Empty:contactID.ToString(), (companyID==0)?string.Empty:companyID.ToString(), (leadId==0)?string.Empty:leadId.ToString(), subject, string.Empty, UC.LTZ.ToUniversalTime(DateTime.Now), UC, 0, inOut, 0 , 0);
		}

		private void FillRepeaterActivityDayFromSearch(string contactID)
		{
			FillRepeaterActivityDayFromSearch(contactID,"activitydate");
		}

		private void FillRepeaterActivityDayFromSearch(string contactID,string order)
		{
			string query = string.Empty;
			switch(contactID.Substring(0,1))
			{
				case "C":
					if(Request["oppID"]!=null && Request["oppID"].Length>0)
					{
						query = "select * from CRM_WorkActivitySearch_View where OpportunityID=" + Request["oppID"] + " and ReferrerID=" + contactID.Substring(1) + " order by "+order+" desc";
					}
					else
					{
						query = "select * from CRM_WorkActivitySearch_View where ReferrerID=" + contactID.Substring(1) + " order by "+order+" desc";
					}
						break;
						case "L":
							if(Request["oppID"]!=null && Request["oppID"].Length>0)
							{
						query = "select * from CRM_WorkActivitySearch_View where OpportunityID=" + Request["oppID"] + " and LeadID=" + contactID.Substring(1) + "  order by "+order+" desc";
							}
							else
							{
						query = "select * from CRM_WorkActivitySearch_View where LeadID=" + contactID.Substring(1) + "  order by "+order+" desc";
							}
							break;
								case "A":
									if(Request["oppID"]!=null && Request["oppID"].Length>0)
									{
						query = "select * from CRM_WorkActivitySearch_View where OpportunityID=" + Request["oppID"] + " and CompanyID=" + contactID.Substring(1) + "  order by "+order+" desc";
									}
									else
									{
						query = "select * from CRM_WorkActivitySearch_View where CompanyID=" + contactID.Substring(1) + " order by "+order+" desc";
									}
								break;
							}

			DataTable dtA = DatabaseConnection.CreateDataset(query).Tables[0];
			if(dtA.Rows.Count>0)
			{
				RepeaterActivityDay.DataSource = dtA;
				RepeaterActivityDay.DataBind();
				LitRepeaterActivityDayInfo.Visible=false;
			}
			else
			{
				LitRepeaterActivityDayInfo.Text=rm.GetString("Acttxt40");
				LitRepeaterActivityDayInfo.Visible=true;
				RepeaterActivityDay.Visible=false;
			}
		}

		private void FillRepeaterActivityDay(bool my)
		{

			DateTime fromToday = new DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day,0,0,0,0);
			DateTime today = fromToday.AddMinutes(1439);
			DataTable dtA;

			string fromDate =UC.LTZ.ToUniversalTime(fromToday).ToString(@"yyyyMMdd HH:mm:ss").Replace('.',':');
			string toDate =UC.LTZ.ToUniversalTime(today).ToString(@"yyyyMMdd HH:mm:ss").Replace('.',':');

			string tempQuery = String.Format("(ActivityDate between '{0}' and '{1}')",fromDate,toDate);

			Trace.Warn("actoday","select * from CRM_WorkActivitySearch_View where ToDo=0 and ("+tempQuery+") and ((" + GroupsSecure() + ") or OwnerID=" + UC.UserId + ") order by activitydate");

			if(my)
			{
				dtA = DatabaseConnection.CreateDataset("select * from CRM_WorkActivitySearch_View where ToDo=0 and ("+tempQuery+") and ((" + GroupsSecure() + ") or OwnerID=" + UC.UserId + ") order by activitydate").Tables[0];
			}
			else
			{
				dtA = DatabaseConnection.CreateDataset("select * from CRM_WorkActivitySearch_View where ToDo=0 and ("+tempQuery+") and (OwnerID=" + UC.UserId + ") order by activitydate").Tables[0];
			}
				if(dtA.Rows.Count>0)
				{
					RepeaterActivityDay.DataSource = dtA;
					RepeaterActivityDay.DataBind();
					LitRepeaterActivityDayInfo.Visible=false;
				}
				else
				{
					LitRepeaterActivityDayInfo.Text=rm.GetString("Acttxt40");
					LitRepeaterActivityDayInfo.Visible=true;
					RepeaterActivityDay.Visible=false;
				}

			}

		public void RepeaterSearchDataBound(Object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					string id = Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "id"));

					Literal Subject = (Literal) e.Item.FindControl("Subject");
					int aType = (int) DataBinder.Eval((DataRowView) e.Item.DataItem, "Type");
					Subject.Text = "<a href=/WorkingCRM/AllActivity.aspx?m=25&si=38&Ac=" + id + ">" + Today.ImgType(aType) + "</a>&nbsp;";
					string sub = Convert.ToString(DataBinder.Eval((DataRowView) e.Item.DataItem, "Subject"));

					Subject.Text += "&nbsp;<a href='javascript:OpenActivity(" + id + ")'>" + sub + "</a>";

					Literal AcDate = (Literal) e.Item.FindControl("AcDate");
					AcDate.Text =UC.LTZ.ToLocalTime(Convert.ToDateTime(DataBinder.Eval((DataRowView) e.Item.DataItem, "ActivityDate"),UC.myDTFI)).ToString("g");

					break;

			}
		}



		#region Codice generato da Progettazione Web Form

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new EventHandler(this.Page_Load);
			this.RepeaterActivityDay.ItemDataBound += new RepeaterItemEventHandler(this.RepeaterSearchDataBound);

		}

		#endregion
	}
}
