/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Digita.Tustena.Database;

namespace Digita.Tustena
{
	public class contactsearch : G
	{
		protected Repeater QuickRepeater;
		protected Label LitquickRepeaterInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!Login())
			{
				Page.RegisterStartupScript("nologin","<script>parent.location.href=parent.location.href;</script>");
			}
			else
			{
				if(Request["searchText"]!=null && Request["searchText"].Length>0)
				{
					FillquickRepeater();
				}else if(Request["searchFromLetter"]!=null && Request["searchFromLetter"].Length>0)
				{
					FillquickRepeaterFromLetter(DatabaseConnection.FilterInjection(Request["searchFromLetter"]));
				}
			}
		}

		private void FillquickRepeaterFromLetter(string letter)
		{
			StringBuilder sbSearch = new StringBuilder();
			sbSearch.Append("select isnull(Base_Contacts.name,'')+' '+isnull(Base_Contacts.surname,'') as quickName,");
			sbSearch.Append("Base_Companies.CompanyName as quickCompany,");
			sbSearch.Append("Base_Contacts.Phone_1 as quickPhone,");
			sbSearch.Append("Base_Contacts.email as quickemail, ");
			sbSearch.Append("'C'+cast(Base_Contacts.ID as varchar) as quickId ");
			sbSearch.Append("from Base_Contacts left outer join Base_Companies on Base_Companies.id=Base_Contacts.CompanyID ");
			sbSearch.AppendFormat("where (Base_Contacts.name like '{0}%' or Base_Contacts.surname like '{0}%') ",letter);
			DataTable dtContacts = DatabaseConnection.CreateDataset(sbSearch.ToString()).Tables[0];

			sbSearch.Length=0;
			sbSearch.Append("select isnull(CRM_Leads.name,'')+' '+isnull(CRM_Leads.surname,'') as quickName,");
			sbSearch.Append("CRM_Leads.CompanyName as quickCompany,");
			sbSearch.Append("CRM_Leads.Phone as quickPhone,");
			sbSearch.Append("CRM_Leads.email as quickemail, ");
			sbSearch.Append("'L'+cast(CRM_Leads.ID as varchar) as quickId ");
			sbSearch.Append("from CRM_Leads ");
			sbSearch.AppendFormat("where (CRM_Leads.name like '{0}%' or CRM_Leads.surname like '{0}%') ",letter);
			DataTable dtLead = DatabaseConnection.CreateDataset(sbSearch.ToString()).Tables[0];



			DataTable dtComplete = DataManipulation.Union(dtContacts,dtLead);
			dtComplete.DefaultView.Sort="quickName Asc";
			QuickRepeater.DataSource = dtComplete;
			QuickRepeater.DataBind();
		}

		private void FillquickRepeater()
		{
			StringBuilder sbSearch = new StringBuilder();
			DataTable dtContacts = new DataTable();
			DataTable dtLead = new DataTable();
			DataTable dtCompany = new DataTable();

			if(!(Request["oppID"]!=null && Request["oppID"].Length>0))
			{
				if(Request["searchtype"]=="0"||Request["searchtype"]=="1")
				{
					sbSearch.Append("select isnull(Base_Contacts.name,'')+' '+isnull(Base_Contacts.surname,'') as quickName,");
					sbSearch.Append("Base_Companies.CompanyName as quickCompany,");
					sbSearch.Append("Base_Contacts.Phone_1 as quickPhone,");
					sbSearch.Append("Base_Contacts.email as quickemail, ");
					sbSearch.Append("'C'+cast(Base_Contacts.ID as varchar) as quickId ");
					sbSearch.Append("from Base_Contacts left outer join Base_Companies on Base_Companies.id=Base_Contacts.CompanyID ");
					sbSearch.AppendFormat("where (Base_Contacts.name like '%{0}%' or Base_Contacts.surname like '%{0}%' ",Request["searchText"]);
					sbSearch.AppendFormat("or Base_Contacts.Phone_1 like '%{0}%' or Base_Contacts.email like '%{0}%' ",Request["searchText"]);
					sbSearch.AppendFormat("or Base_Companies.CompanyName like '%{0}%')",Request["searchText"]);
					dtContacts = DatabaseConnection.CreateDataset(sbSearch.ToString()).Tables[0];
				}
			}

			if(Request["searchtype"]=="0"||Request["searchtype"]=="2")
			{
				sbSearch.Length=0;
				sbSearch.Append("select isnull(CRM_Leads.name,'')+' '+isnull(CRM_Leads.surname,'') as quickName,");
				sbSearch.Append("CRM_Leads.CompanyName as quickCompany,");
				sbSearch.Append("CRM_Leads.Phone as quickPhone,");
				sbSearch.Append("CRM_Leads.email as quickemail, ");
				sbSearch.Append("'L'+cast(CRM_Leads.ID as varchar) as quickId ");
				sbSearch.Append("from CRM_Leads ");
				if(Request["oppID"]!=null && Request["oppID"].Length>0)
					sbSearch.AppendFormat("inner join CRM_OpportunityContact on CRM_OpportunityContact.ContactID = CRM_Leads.ID and CRM_OpportunityContact.ContactType=0 and CRM_OpportunityContact.OpportunityID={0} ",Request["oppID"]);
				sbSearch.AppendFormat("where (CRM_Leads.name like '%{0}%' or CRM_Leads.surname like '%{0}%' ",Request["searchText"]);
				sbSearch.AppendFormat("or CRM_Leads.Phone like '%{0}%' or CRM_Leads.email like '%{0}%' ",Request["searchText"]);
				sbSearch.AppendFormat("or CRM_Leads.CompanyName like '%{0}%')",Request["searchText"]);
				dtLead = DatabaseConnection.CreateDataset(sbSearch.ToString()).Tables[0];
			}

			if(Request["searchtype"]=="0"||Request["searchtype"]=="3")
			{
				sbSearch.Length=0;
				sbSearch.Append("select Base_Companies.CompanyName as quickName,");
				sbSearch.Append("Base_Companies.CompanyName as quickCompany,");
				sbSearch.Append("Base_Companies.Phone as quickPhone,");
				sbSearch.Append("Base_Companies.email as quickemail, ");
				sbSearch.Append("'A'+cast(Base_Companies.ID as varchar) as quickId ");
				sbSearch.Append("from Base_Companies ");
				if(Request["oppID"]!=null && Request["oppID"].Length>0)
					sbSearch.AppendFormat("inner join CRM_OpportunityContact on CRM_OpportunityContact.ContactID = Base_Companies.ID and CRM_OpportunityContact.ContactType=0 and CRM_OpportunityContact.OpportunityID={0} ",Request["oppID"]);
				sbSearch.AppendFormat("where (Base_Companies.Phone like '%{0}%' or Base_Companies.email like '%{0}%' ",Request["searchText"]);
				sbSearch.AppendFormat("or Base_Companies.CompanyName like '%{0}%')",Request["searchText"]);
				dtCompany = DatabaseConnection.CreateDataset(sbSearch.ToString()).Tables[0];
			}

			DataTable dtTemp = new DataTable();
			DataTable dtComplete = new DataTable();
			switch(Request["searchtype"])
			{
				case "0":
					if(!(Request["oppID"]!=null && Request["oppID"].Length>0))
					{
						dtTemp = DataManipulation.Union(dtContacts,dtLead);
						dtComplete = DataManipulation.Union(dtTemp,dtCompany);
					}else
					{
						dtComplete = DataManipulation.Union(dtLead,dtCompany);
					}
					break;
				case "1":
					dtComplete = dtContacts.Copy();
					break;
				case "2":
					dtComplete = dtLead.Copy();
					break;
				case "3":
					dtComplete = dtCompany.Copy();
					break;
			}

			if(dtComplete.Rows.Count>0)
			{
				dtComplete.DefaultView.Sort="quickName Asc";
				QuickRepeater.DataSource = dtComplete;
				QuickRepeater.DataBind();
			}else
				LitquickRepeaterInfo.Text = rm.GetString("Quicktxt12");
		}

		#region Codice generato da Progettazione Web Form
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
			this.QuickRepeater.ItemDataBound+=new RepeaterItemEventHandler(quickRepeater_ItemDataBound);
		}
		#endregion

		private void quickRepeater_ItemDataBound(object sender, RepeaterItemEventArgs e)
		{
			switch (e.Item.ItemType)
			{
				case ListItemType.Item:
				case ListItemType.AlternatingItem:
					HtmlImage imgType = (HtmlImage)e.Item.FindControl("imgType");

					string quickId = DataBinder.Eval((DataRowView) e.Item.DataItem, "quickID").ToString();
					if(quickId.Substring(0,1)=="C")
					{
						imgType.Src = "/quick/i/contact.gif";
						imgType.Alt = rm.GetString("Quicktxt8");
					}
					else if(quickId.Substring(0,1)=="L")
					{
						imgType.Src = "/quick/i/lead.gif";
						imgType.Alt = rm.GetString("Quicktxt9");
					}
					else if(quickId.Substring(0,1)=="A")
					{
						imgType.Src = "/quick/i/act.gif";
						imgType.Alt = rm.GetString("Quicktxt10");
					}
					break;
			}
		}
	}
}
