/// <license>TUSTENA PUBLIC LICENSE v1.0</license>
/// <copyright>
/// Portions Copyright (c) 2003-2005 Digita S.r.l. All Rights Reserved.
///
/// Tustena CRM is a trademark of:
/// Digita S.r.l.
/// Viale Enrico Fermi 14/z
/// 31011 Asolo (Italy)
/// Tel. +39-0423-951251
/// Mail. info@digita.it
///
/// This file contains Original Code and/or Modifications of Original Code
/// as defined in and that are subject to the Tustena Public Source License
/// Version 1.0 (the 'License'). You may not use this file except in
/// compliance with the License. Please obtain a copy of the License at
/// http://www.tustena.com/TPL/ and read it before using this
// file.
///
/// The Original Code and all software distributed under the License are
/// distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
/// EXPRESS OR IMPLIED, AND DIGITA S.R.L. HEREBY DISCLAIMS ALL SUCH WARRANTIES,
/// INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
/// FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
/// Please see the License for the specific language governing rights and
/// limitations under the License.
///
/// YOU MAY NOT REMOVE OR ALTER THIS COPYRIGHT NOTICE!
/// </copyright>

using System;
using System.Collections;
using System.Data;
using System.Text;
using System.Web;
using System.Web.Mobile;
using System.Web.UI.MobileControls;
using System.Web.UI.MobileControls.Adapters;
using Digita.Tustena.Base;
using Digita.Tustena.Database;

namespace Digita.Tustena.Wap
{
	public class Mobile : SimpleG
	{
		protected Label Text;
		protected Label LError;
		protected Label L1;
		protected TextBox Tusername;
		protected Label L2;
		protected TextBox Tpassword;
		protected Command Blogin;
		protected Panel LoginPanel;
		protected Label Lwelcome;
		protected Label Lwelcome2;
		protected Command CalToday;
		protected Command CalTomorrow;
		protected Command CallCal;
		protected Command Contacts;
		protected Command Boff;
		protected Panel MenuPanel;
		protected Panel CalPanel;
		protected Command Bback;
		protected Form TustenaWL;
		protected System.Web.UI.MobileControls.Calendar MobileCalendar;
		protected Panel ContactPanel;
		protected Label ContLabel;
		protected TextBox ContQuery;
		protected Command ContSearch;
		protected Command ContSearchAz;
		protected Command ContSearchLe;
		protected Label SearchInfo;
		protected Form Form1;
		protected ObjectListCommand Command1;
		protected Label CompanyTitle;
		protected ObjectList CompanyList;
		protected Panel CompanyPanel;
		protected Label ContactTitle;
		protected ObjectList ContactList;
		protected Label LeadTitle;
		protected Panel LeadPanel;
		protected Panel SearchPanel;
		protected ObjectList LeadList;
		protected Label AppTitle;
		protected ObjectList AppList;
		protected Panel AppPanel;


		private void Page_Load(object sender, EventArgs e)
		{

			if(!((UC = (UserConfig)Session["UserConfig"])!=null && UC.Logged!=LoggedStatus.no))
			{
				if (!base.Device.IsMobileDevice)
				{
					LError.Text = "no mobile";
					LError.Visible = true;
				}
				if ((Request.Params["u"] != null) && (Request.Params["p"] != null))
				{
					login(Request.Params["u"].ToString(), Request.Params["p"].ToString());
				}
				else
				{
					HttpCookie Rcookie = Request.Cookies["WapLogin"];

					if (Rcookie != null && !Page.IsPostBack && Rcookie.HasKeys)
					{
						login(Rcookie["u"].ToString(), Rcookie["p"].ToString());
					}
				}
			}

			if (!Page.IsPostBack)
			{
				ContLabel.Text = SimpleG.rm.GetString("WAPtxt8");
				ContSearchAz.Text = SimpleG.rm.GetString("WAPtxt9");
				ContSearch.Text = SimpleG.rm.GetString("WAPtxt10");
				ContSearchLe.Text = SimpleG.rm.GetString("WAPtxt11");

			}
		}

		#region Web Form Designer generated code

		protected override void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}

		private void InitializeComponent()
		{
			this.Blogin.Click += new EventHandler(this.Blogin_Click);
			this.CalToday.Click += new EventHandler(this.CalToday_Click);
			this.CalTomorrow.Click += new EventHandler(this.CalTomorrow_Click);
			this.CallCal.Click += new EventHandler(this.CallCal_Click);
			this.Contacts.Click += new EventHandler(this.Contacts_Click);
			this.Boff.Click += new EventHandler(this.Boff_Click);
			this.MobileCalendar.SelectionChanged += new EventHandler(this.Calendar_SelectionChanged);
			this.ContSearchAz.Click += new EventHandler(this.ContSearchAz_Click);
			this.ContSearch.Click += new EventHandler(this.ContSearch_Click);
			this.ContSearchLe.Click += new EventHandler(this.ContSearchLe_Click);
			this.Bback.Click += new EventHandler(this.Bback_Click);
			this.Load += new EventHandler(this.Page_Load);

		}

		#endregion

		public string sError = "";

		private void Blogin_Click(object sender, EventArgs e)
		{
			HttpCookie cookie = new HttpCookie("WapLogin");
			cookie["u"] = Tusername.Text;
			cookie["p"] = Tpassword.Text;
			cookie.Expires = DateTime.Now.AddMonths(12);
			Response.Cookies.Add(cookie);
			login(Tusername.Text, Tpassword.Text);
		}

		private void login(string username, string password)
		{
			if (Authenticate(username.ToLower(), password.ToLower()))
			{
				Clearpanels();
				MenuPanel.Visible = true;
				Lwelcome.Text = SimpleG.rm.GetString("WAPtxt1") + " " + username;
				Lwelcome2.Text = SimpleG.rm.GetString("WAPtxt2");
			}
			else
			{
				LError.Text = sError;
				LError.Visible = true;
			}
		}

		private bool Authenticate(string userName, string passWord)
		{
			UserConfig UC = UserData.LoadPersonalData(userName, passWord, -1);
			if(UC.Logged==LoggedStatus.yes)
			{
				Session["UserConfig"] = UC;
				return true;
			}
			return false;

		}

		private void CalToday_Click(object sender, EventArgs e)
		{
			Appointments(DateTime.Now);
		}

		private void CalTomorrow_Click(object sender, EventArgs e)
		{
			Appointments(DateTime.Now.AddDays(1));
		}

		private void Appointments(DateTime Day)
		{
			AppTitle.Text = SimpleG.rm.GetString("WAPtxt6") + " " + Day.ToShortDateString();
			Agenda calwap = new Agenda();
			Clearpanels();
			AppPanel.Visible = true;
			Bback.Visible = true;
			AppList.Fields.Clear();
			DataTable CalendarDataTable = calwap.FillDayWap(Day, UC);
			foreach (DataRow d in CalendarDataTable.Rows)
			{
				d["StartDate"] = Convert.ToDateTime(d["StartDate"]).AddHours(UC.HTimeZone);
			}
			AppList.DataSource = CalendarDataTable;
			ObjectListField ListField1 = new ObjectListField();
			ListField1.DataField = "Contact";
			ListField1.Visible = false;
			ListField1.Title = SimpleG.rm.GetString("WAPtxt3").ToUpper();
			AppList.Fields.Add(ListField1);
			ListField1 = new ObjectListField();
			ListField1.DataField = "Company";
			ListField1.Title = SimpleG.rm.GetString("WAPtxt4").ToUpper();
			AppList.Fields.Add(ListField1);
			ListField1 = new ObjectListField();
			ListField1.DataField = "StartDate";
			ListField1.Title = SimpleG.rm.GetString("WAPtxt5").ToUpper();
			AppList.Fields.Add(ListField1);
			ListField1 = new ObjectListField();
			ListField1.DataField = "Note";
			ListField1.Title = "Note";
			AppList.Fields.Add(ListField1);
			ListField1 = new ObjectListField();
			ListField1.DataField = "Phone";
			ListField1.Title = "Phone";
			AppList.Fields.Add(ListField1);

			ListField1 = new ObjectListField();
			ListField1.DataField = "Room";
			ListField1.Title = SimpleG.rm.GetString("Evnttxt11").ToUpper();
			AppList.Fields.Add(ListField1);
			ListField1 = new ObjectListField();
			ListField1.DataField = "Address";
			ListField1.Title = SimpleG.rm.GetString("Evnttxt12").ToUpper();
			AppList.Fields.Add(ListField1);
			ListField1 = new ObjectListField();
			ListField1.DataField = "City";
			ListField1.Title = SimpleG.rm.GetString("Evnttxt13").ToUpper();
			AppList.Fields.Add(ListField1);
			ListField1 = new ObjectListField();
			ListField1.DataField = "Province";
			ListField1.Title = SimpleG.rm.GetString("Evnttxt14").ToUpper();
			AppList.Fields.Add(ListField1);
			ListField1 = new ObjectListField();
			ListField1.DataField = "Cap";
			ListField1.Title = SimpleG.rm.GetString("Evnttxt15").ToUpper();
			AppList.Fields.Add(ListField1);


			AppList.AutoGenerateFields = false;
			AppList.ItemsPerPage = 5;
			AppList.DataBind();
			AppList.Visible = true;
		}

		private void Bback_Click(object sender, EventArgs e)
		{
			Clearpanels();
			if (Session["UserConfig"] == null)
				LoginPanel.Visible = true;
			else
				MenuPanel.Visible = true;
		}


		private void test()
		{
			MobileCapabilities capabilities = new MobileCapabilities();
			capabilities = (MobileCapabilities) Request.Browser;
			LError.Text = " ScreenCharactersWidth:" + capabilities.ScreenCharactersWidth;
			LError.Text += " ScreenCharactersHeight:" + capabilities.ScreenCharactersHeight;
			LError.Text += " PreferredImageMime:" + capabilities.PreferredImageMime;
			LError.Text += " preferredRenderingMime:" + capabilities.PreferredRenderingMime;
			LError.Text += " PreferredRenderingType:" + capabilities.PreferredRenderingType;
			LError.Visible = true;
		}

		private void Boff_Click(object sender, EventArgs e)
		{
			Clearpanels();
			LoginPanel.Visible = true;
			Session.Abandon();
		}

		public void Calendar_SelectionChanged(object sender, EventArgs e)
		{
			Clearpanels();
			Appointments(MobileCalendar.SelectedDate);
		}

		private void CallCal_Click(object sender, EventArgs e)
		{
			Clearpanels();
			CalPanel.Visible = true;
			Bback.Visible = true;
		}

		private void Contacts_Click(object sender, EventArgs e)
		{
			Clearpanels();
			SearchPanel.Visible = true;
		}

		private string GroupsSecure(string table)
		{
			string[] ArryD = UC.GroupDependency.Split('|');
			string qgruppo = "";
			foreach (string ut in ArryD)
			{
				if (ut.Length > 0) qgruppo += table + ".Groups like '%|" + ut + "|%' or ";
			}
			if (qgruppo.Length > 0) qgruppo = qgruppo.Substring(0, qgruppo.Length - 3);
			return qgruppo;
		}

		private void ContSearchAz_Click(object sender, EventArgs e)
		{
			CompanyList.Fields.Clear();
			CompanyList.DataSource = null;
			StringBuilder query = new StringBuilder();
			query.Append("select id,companyname,InvoicingAddress,InvoicingCity,InvoicingStateProvince,InvoicingState,InvoicingZIPCode,Phone,Fax,Email ");
			query.AppendFormat("from Base_Companies where (limbo=0 and ({0})) ", (GroupsSecure("Base_Companies").Length > 0) ? GroupsSecure("Base_Companies") : "Base_Companies.groups like '%|" + UC.UserGroupId + "|%'");
			query.AppendFormat("and (companyname like '%{0}%' or phone like '%{0}%')", ContQuery.Text);
			DataTable dt = DatabaseConnection.CreateDataset(query.ToString()).Tables[0];

			if (dt.Rows.Count > 0)
			{
				CompanyList.DataSource = dt;
				ObjectListField ListField1 = new ObjectListField();
				ListField1.DataField = "companyname";
				ListField1.Visible = false;
				ListField1.Title = SimpleG.rm.GetString("Bcotxt17");
				CompanyList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "Phone";
				ListField1.Name = "CALL";
				ListField1.Title = SimpleG.rm.GetString("Bcotxt20");
				CompanyList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "InvoicingAddress";
				ListField1.Title = SimpleG.rm.GetString("Bcotxt26");
				CompanyList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "InvoicingCity";
				ListField1.Title = SimpleG.rm.GetString("Bcotxt27");
				CompanyList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "InvoicingStateProvince";
				ListField1.Title = SimpleG.rm.GetString("Bcotxt28");
				CompanyList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "InvoicingState";
				ListField1.Title = SimpleG.rm.GetString("Bcotxt53");
				CompanyList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "InvoicingZIPCode";
				ListField1.Title = SimpleG.rm.GetString("Bcotxt29");
				CompanyList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "Fax";
				ListField1.Title = SimpleG.rm.GetString("Bcotxt21");
				CompanyList.Fields.Add(ListField1);
				ListField1.DataField = "Email";
				ListField1.Name = "MAIL";
				ListField1.Title = SimpleG.rm.GetString("Bcotxt22");
				CompanyList.Fields.Add(ListField1);
				CompanyList.AutoGenerateFields = false;
				CompanyList.ItemsPerPage = 5;
				CompanyList.DataBind();
				CompanyList.Visible = true;
				Clearpanels();
				CompanyPanel.Visible = true;
				Bback.Visible = true;
				SearchInfo.Visible = false;
			}
			else
			{
				SearchInfo.Text = SimpleG.rm.GetString("WAPtxt7");
				SearchInfo.Visible = true;
			}
		}

		private void ContSearch_Click(object sender, EventArgs e)
		{
			ContactList.Fields.Clear();
			ContactList.DataSource = null;

			StringBuilder sql = new StringBuilder();
			sql.Append("SELECT Base_Contacts.ID,isnull(Base_Contacts.Name,'')+' '+isnull(Base_Contacts.Surname,'') as ContactName, Base_Contacts.Phone_1, Base_Contacts.MobilePhone_1,Base_Contacts.Address_1,Base_Contacts.City_1,Base_Contacts.Province_1,Base_Contacts.ZIPCode_1,Base_Contacts.State_1, Base_Companies.CompanyName AS AZIENDATX ");
			sql.Append("FROM Base_Contacts LEFT OUTER JOIN Base_Companies ON Base_Contacts.CompanyID = Base_Companies.ID ");
			sql.AppendFormat("where (Base_Contacts.Limbo=0 and ({1})) and (Base_Contacts.Surname like '%{0}%' or ", ContQuery.Text, (GroupsSecure("Base_Contacts").Length > 0) ? GroupsSecure("Base_Contacts") : "Base_Companies.groups like '%|" + UC.UserGroupId + "|%'");
			sql.AppendFormat("Base_Contacts.Name like '%{0}%' or ", ContQuery.Text);
			sql.AppendFormat("Base_Contacts.Phone_1 like '%{0}%' or ", ContQuery.Text);
			sql.AppendFormat("Base_Contacts.MobilePhone_1 like '%{0}%' or ", ContQuery.Text);
			sql.AppendFormat("Base_Companies.CompanyName like '%{0}%') ", ContQuery.Text);
			DataTable dt = DatabaseConnection.CreateDataset(sql.ToString()).Tables[0];
			if (dt.Rows.Count > 0)
			{
				ContactList.DataSource = dt;
				ObjectListField ListField1 = new ObjectListField();
				ListField1.DataField = "ContactName";
				ListField1.Visible = false;
				ListField1.Title = SimpleG.rm.GetString("Reftxt9");
				ContactList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "Phone_1";
				ListField1.Name = "CALL";
				ListField1.Title = SimpleG.rm.GetString("Reftxt11");
				ContactList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "MobilePhone_1";
				ListField1.Name = "CALL";
				ListField1.Title = SimpleG.rm.GetString("Reftxt12");
				ContactList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "Address_1";
				ListField1.Title = SimpleG.rm.GetString("Reftxt28");
				ContactList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "City_1";
				ListField1.Title = SimpleG.rm.GetString("Reftxt29");
				ContactList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "Province_1";
				ListField1.Title = SimpleG.rm.GetString("Reftxt30");
				ContactList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "ZIPCode_1";
				ListField1.Title = SimpleG.rm.GetString("Reftxt31");
				ContactList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "State_1";
				ListField1.Title = SimpleG.rm.GetString("Reftxt53");
				ContactList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "AZIENDATX";
				ListField1.Title = SimpleG.rm.GetString("Reftxt10");
				ContactList.Fields.Add(ListField1);
				ContactList.AutoGenerateFields = false;
				ContactList.ItemsPerPage = 5;
				ContactList.DataBind();
				ContactList.Visible = true;

				Clearpanels();
				ContactPanel.Visible = true;
				Bback.Visible = true;
				SearchInfo.Visible = false;


			}
			else
			{
				SearchInfo.Text = SimpleG.rm.GetString("WAPtxt7");
				SearchInfo.Visible = true;
			}
		}

		private void Clearpanels()
		{
			LoginPanel.Visible = false;
			AppPanel.Visible = false;
			CompanyPanel.Visible = false;
			ContactPanel.Visible = false;
			LeadPanel.Visible = false;
			MenuPanel.Visible = false;
			CalPanel.Visible = false;
			SearchPanel.Visible = false;
			Bback.Visible = false;
		}

		private void ContSearchLe_Click(object sender, EventArgs e)
		{
			LeadList.Fields.Clear();
			LeadList.DataSource = null;

			StringBuilder sql = new StringBuilder();
			sql.Append("SELECT ID,isnull(Name,'')+' '+isnull(Surname,'') as ContactName, Phone, MobilePhone, Address, City, Province, ZIPCode, State, CompanyName ");
			sql.Append("FROM CRM_Leads ");
			sql.AppendFormat("where (Limbo=0 and ({1})) and (Surname like '%{0}%' or ", ContQuery.Text, (GroupsSecure("CRM_Leads").Length > 0) ? GroupsSecure("CRM_Leads") : "Base_Companies.groups like '%|" + UC.UserGroupId + "|%'");
			sql.AppendFormat("Name like '%{0}%' or ", ContQuery.Text);
			sql.AppendFormat("Phone like '%{0}%' or ", ContQuery.Text);
			sql.AppendFormat("MobilePhone like '%{0}%' or ", ContQuery.Text);
			sql.AppendFormat("CompanyName like '%{0}%') ", ContQuery.Text);
			DataTable dt = DatabaseConnection.CreateDataset(sql.ToString()).Tables[0];
			if (dt.Rows.Count > 0)
			{
				LeadList.DataSource = dt;
				ObjectListField ListField1 = new ObjectListField();
				ListField1.DataField = "ContactName";
				ListField1.Visible = false;
				ListField1.Title = SimpleG.rm.GetString("Reftxt9");
				LeadList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "CompanyName";
				ListField1.Title = SimpleG.rm.GetString("Reftxt10");
				LeadList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "Phone";
				ListField1.Name = "CALL";
				ListField1.Title = SimpleG.rm.GetString("Reftxt11");
				LeadList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "MobilePhone";
				ListField1.Name = "CALL";
				ListField1.Title = SimpleG.rm.GetString("Reftxt12");
				LeadList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "Address";
				ListField1.Title = SimpleG.rm.GetString("Reftxt28");
				LeadList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "City";
				ListField1.Title = SimpleG.rm.GetString("Reftxt29");
				LeadList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "Province";
				ListField1.Title = SimpleG.rm.GetString("Reftxt30");
				LeadList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "ZIPCode";
				ListField1.Title = SimpleG.rm.GetString("Reftxt31");
				LeadList.Fields.Add(ListField1);
				ListField1 = new ObjectListField();
				ListField1.DataField = "State";
				ListField1.Title = SimpleG.rm.GetString("Reftxt53");
				LeadList.Fields.Add(ListField1);

				LeadList.AutoGenerateFields = false;
				LeadList.ItemsPerPage = 5;
				LeadList.DataBind();
				LeadList.Visible = true;
				Clearpanels();
				LeadPanel.Visible = true;
				Bback.Visible = true;
				SearchInfo.Visible = false;
			}
			else
			{
				SearchInfo.Text = SimpleG.rm.GetString("WAPtxt7");
				SearchInfo.Visible = true;
			}
		}
	}


	public class MyFormAdapter : HtmlFormAdapter
	{
		protected override void RenderBodyTag(HtmlMobileTextWriter
			writer, IDictionary attributes)
		{
			writer.WriteBeginTag("body");
			foreach (DictionaryEntry entry in attributes)
			{
				writer.WriteAttribute((string) entry.Key, (string)
					entry.Value);
			}
			writer.WriteAttribute("leftmargin", "0");
			writer.WriteLine(">");
		}
	}


}
